--[[    
    ROLEPLAY MISSION EDITOR (RME)
    Copyright (C) 2007,2008 Jean RODRIGUEZ  aka Enoril (Ryzom), Enoriel (WoW - Kirin Tor)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

]]
RME_DebugMsg("<LOAD>RME.lua",3);

	--[[  SLASH COMMANDS  ]]--
	function RME_Command(msg)
		
		RME_DebugMsg("RME_Command(" .. msg .. ")",4);
		
		if (string.lower(msg) == RME_LOCALE["RME_LOCALE_SLASH_HELP_OPTION"].text) then
			RME_DisplayMessage(RME_LOCALE["RME_LOCALE_SLASH_HELP"].text);
			return
		end
		
		if string.find(msg, "/all") then --Emote gnrale
			msg = string.gsub(msg, "/all", "")
			msg = strtrim(msg, " ")
			RME_Comm_SEND_GM_PLAYER_EMOTE(msg)
			return
		end
		
		
		if RME_TARGET_INFO.Name then
			-- Il s'agit d'un texte de PNJ pour la cible
			-- on tente de voir le type de message
			local msgtype = "RME_GM_NPC_TALK_SAY"
			
			if string.find(msg, "/em") then
				msgtype = "RME_GM_NPC_TALK_EMOTE"
				msg = string.gsub(msg, "/em", "")
			end
			if string.find(msg, "/y") then
				msgtype = "RME_GM_NPC_TALK_SHOUT"
				msg = string.gsub(msg, "/y", "")
			end
			msg = strtrim(msg, " ")
			RME_Comm_SEND_GM_NPC_TALK(RME_TARGET_INFO.Name,msg,msgtype)
			return
		end
	
		
		--/on toggle la fenetre
		RME_PanelFrame_Toggle()
		
	end
 
 
	--[[  LOAD UI  ]]--
	function RME_OnLoad()
		
		RME_DebugMsg("RME_OnLoad()",4);
		-- Basic
		this:RegisterEvent("VARIABLES_LOADED");
		this:RegisterEvent("PLAYER_TARGET_CHANGED");
		this:RegisterEvent("ZONE_CHANGED_NEW_AREA");
		this:RegisterEvent("PLAYER_ENTERING_WORLD");		
		this:RegisterEvent("PLAYER_ALIVE");
		this:RegisterEvent("PLAYER_DEAD");		
		this:RegisterEvent("PLAYER_UNGHOST");
		this:RegisterEvent("PLAYER_LOGOUT");
		-- Si objectif mission exploration
		this:RegisterEvent("ZONE_CHANGED");
		this:RegisterEvent("ZONE_CHANGED_INDOORS");
		-- Si objectif ne pas utiliser taxi
		this:RegisterEvent("TAXIMAP_CLOSED");			
		-- si objectif ne pas utiliser de monture ou utilisation objet "use"
		this:RegisterEvent("PLAYER_AURAS_CHANGED");
		-- Si objectif kill mob
		this:RegisterEvent("CHAT_MSG_SYSTEM");
		this:RegisterEvent("COMBAT_LOG_EVENT");
		
		-- si ITEM USE_ON_MOB
		this:RegisterEvent("UNIT_SPELLCAST_START");
		this:RegisterEvent("UNIT_SPELLCAST_CHANNEL_START");
		-- Si MJ
		this:RegisterEvent("RAID_ROSTER_UPDATE");
		this:RegisterEvent("PARTY_MEMBERS_CHANGED");
		this:RegisterEvent("PARTY_LEADER_CHANGED");
		this:RegisterEvent("PARTY_MEMBER_ENABLE");
		this:RegisterEvent("PARTY_MEMBER_DISABLE");
		
		-- ******************** GESTION COMMANDES SLASH ******************** --
		SLASH_RME1 = "/RME";
		SLASH_RME2 = "/rme";		
		SLASH_RME3 = "/eno";
		
		SlashCmdList["RME"] = RME_Command;
		
	end


	--[[  GESTION DES EVENTS  ]]--
	function RME_OnEvent(event)
		
		RME_DebugMsg("RME_OnEvent("..event..","..tostring(arg1)..","..tostring(arg2)..","..tostring(arg3)..","..tostring(arg4)..","..tostring(arg5)..","..tostring(arg6)..","..tostring(arg7)..","..tostring(arg8)..","..tostring(arg9)..","..tostring(arg10)..")",4);	

		if (event == "VARIABLES_LOADED") then
			RME_Initialize(); --Chargement de l'application
			return
		end
		
		if not RME_UI_LOADED then
			return -- Inutile de continuer si l'addon n'est pas totalement initalis
		end

		--[[ GESTION TARGET]]
		if (event == "PLAYER_TARGET_CHANGED" ) then	
			RME_TARGET_INFO:Update("target")
			
			-- Si on tait en train de caster, on arrete
			if RME_CastingBarFrame:IsShown() then 
				RME_CastingBarFrame_OnEvent("STOP_CASTING")
			end		
			
			-- Si il s'agit d'un npc dclar RME, on stock ses donnes pour pouvoir interargir (affichage mission, check distance joueur<>npc, etc)
			if not RME_TARGET_INFO.Name then -- Plus de cible !
				-- Buttons lis au cible
				RME_QuestEditorFrame_Objective_Type_KILL_MOB_SelectTarget:Disable()
				RME_QuestEditorFrame_NPC_Add:Disable()
				RME_QuestEditorFrame_Objective_Type_CONDITION_Escort_VIP_SelectTarget:Disable()
				RME_QuestEditorFrame_Item_Type_USE_ON_MOB_MobName_SelectTarget:Disable()
				RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_SelectTarget:Disable()
				
				-- Si gossip visible
				if RME_GossipFrame:IsShown() then -- Fermeture gossip (interaction target)
					RME_GossipFrame:Hide()
					RME_UpdateGossipOnglets()
				end
				
			else
				-- Buttons lis au cible
				RME_QuestEditorFrame_Objective_Type_KILL_MOB_SelectTarget:Enable()
				RME_QuestEditorFrame_NPC_Add:Enable()
				RME_QuestEditorFrame_Objective_Type_CONDITION_Escort_VIP_SelectTarget:Enable()
				RME_QuestEditorFrame_Item_Type_USE_ON_MOB_MobName_SelectTarget:Enable()
				RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_SelectTarget:Enable()
			end
			
			
			if not RME_TARGET_INFO.IsNPC then
				--joueur RME ?
				if RME_COMM_ADDON_USERS_LIST[RME_TARGET_INFO.Name] and UnitInParty("target") then
					--RME_PanelFrame_Mission_GM_PushInPartyTitle:SetText(format(RME_LOCALE["RME_PanelFrame_Mission_GM_PushInPlayer"].text,RME_TARGET_INFO.Name))
					RME_PanelFrame_Mission_GM_PushInParty2Title:SetText(format(RME_LOCALE["RME_PanelFrame_Mission_GM_PushInPlayer"].text,RME_TARGET_INFO.Name))
				else
					--RME_PanelFrame_Mission_GM_PushInPartyTitle:SetText(RME_LOCALE["RME_PanelFrame_Mission_GM_PushInParty"].text)
					RME_PanelFrame_Mission_GM_PushInParty2Title:SetText(RME_LOCALE["RME_PanelFrame_Mission_GM_PushInParty"].text)
				end
			else
				--RME_PanelFrame_Mission_GM_PushInPartyTitle:SetText(RME_LOCALE["RME_PanelFrame_Mission_GM_PushInParty"].text)
			end
			
			
			if RME_TARGET_INFO.IsAnNpcMission then 
				
				if table.getn(RME_TARGET_INFO.NpcMissionsList) > 1 then
					PlaySound("MapPing")
					RME_PlayerNotify(format(RME_LOCALE["RME_LOCALE_NPC_HAVE_MISSION"].text,RME_TARGET_INFO.Name,table.getn(RME_TARGET_INFO.NpcMissionsList)),0.5)
					
				elseif table.getn(RME_TARGET_INFO.NpcMissionsList) == 1 then					
					PlaySound("MapPing")
					RME_PlayerNotify(format(RME_LOCALE["RME_LOCALE_NPC_HAVE_MISSION_ONE"].text,RME_TARGET_INFO.Name,table.getn(RME_TARGET_INFO.NpcMissionsList)),0.5)
					
				end
				
			end
			return
		end
		
		-- [[ Changement de zone ]]--
		if (event == "PLAYER_ENTERING_WORLD"  or event == "ZONE_CHANGED_NEW_AREA") then
			RME_PLAYER_INFO:Update("player") -- MAJ info player
			-- Chargement des missions dispo dans la zone (uniquement si le joueur ne vole pas (inutile de charger les zones si il n'y atterrit pas)
			if not RME_PLAYER_INFO.UnitOnTaxi then
				RME_Load_Available_Mission(RME_PLAYER_INFO.Location_RealZone)
				RME_Check_Mission_Event("EXPLORATION",RME_PLAYER_INFO.Location_RealZone,RME_PLAYER_INFO.Location_SubZone,RME_PLAYER_INFO.Location_MinimapZone)
			end
			return
		end
		
		--[[ ]]--
		if (event == "RAID_ROSTER_UPDATE" or event == "PARTY_MEMBERS_CHANGED" or event == "PARTY_LEADER_CHANGED" or event == "PARTY_MEMBER_ENABLE" or event == "PARTY_MEMBER_DISABLE" )then -- 
			RME_PanelFrame_GM_Players_Update_Listing()
			RME_PanelFrame_GM_Players_Update()
		end	
		
		-- on check ceci uniquement si le joueur a une mission en cours
		if RME_PLAYER_HAVE_MISSION_IN_PROGRESS then
			
			-- [[ Changement de subZone]]--
			if (event == "ZONE_CHANGED" or event == "ZONE_CHANGED_INDOORS" or event == "PLAYER_ALIVE" or event == "PLAYER_DEAD" or event == "PLAYER_UNGHOST") then
				RME_PLAYER_INFO:Update("player") -- MAJ info player
				RME_Check_Mission_Event("EXPLORATION",RME_PLAYER_INFO.Location_RealZone,RME_PLAYER_INFO.Location_SubZone)
				-- Cet event ne doit etre propag dans l'quipe
				return
			end
			--[[ Cast joueur pendant une utilisation d'un objet ]]-- -- Attention apparement si notre cible lance un sort, cet event se dclenche aussi !!! il faut donc checker si casteur = joueur 
			if (event == "UNIT_SPELLCAST_START" or event == "UNIT_SPELLCAST_CHANNEL_START" ) and arg1 == "player" then
				if RME_CastingBarFrame:IsShown() then -- Si on tait en train de caster, on arrete
					RME_CastingBarFrame_OnEvent("STOP_CASTING")
				end		
				return
			end

			-- [[Detection joueur en Taxi]]--
			if event == "TAXIMAP_CLOSED" then
				-- On regarde si le joueur est en taxi dans quelques secondes (le temps du lag entre validation du vol et le debut effectif du vol)
				RME_EventManager_AddEvent("CHECK_TAXI",5,"RME_Check_PlayerOnTaxi("..tostring(RME_PLAYER_INFO.UnitOnTaxi)..")",true)
				return
			end
			
			-- [[Detection joueur sur monture ou attaqu]]--
			if event == "PLAYER_AURAS_CHANGED" then
				-- On regarde si le joueur est en taxi dans quelques secondes (le temps du lag entre validation du vol et le debut effectif du vol)
				RME_Check_PlayerOnMount(RME_PLAYER_INFO.UnitOnMount)
				return
			end
			
			-- [[ Detection creature morte ]]
			if event == "COMBAT_LOG_EVENT" then
				if arg2=="UNIT_DIED" then -- Haha unit morte ! J'espere que c'tait pas la cible a protger !
					
					if RME_getn(RME_VIP_ESCORT_LIST)> 0 then
						-- On a une escorte en cours (escorte d'un pnj), il faut rcuperer son nom
						if RME_VIP_ESCORT_LIST[arg7] then
							RME_Check_Mission_Event("VIP_DEAD",arg7)
							RME_Party_Mission_Event("VIP_DEAD",arg7) -- Cet event doit etre propag dans l'quipe
						end
					end
					return
				end
				if arg2=="PARTY_KILL" and arg4==RME_PLAYER_INFO.Name then -- Le joueur  a tu quelqu'un
				
					if RME_getn(RME_VIP_ESCORT_LIST)> 0 then -- il arrive des fois qu'on tue nous meme la cible ^^
						-- On a une escorte en cours (escorte d'un pnj), il faut rcuperer son nom
						if RME_VIP_ESCORT_LIST[arg7] then
							RME_Check_Mission_Event("VIP_DEAD",arg7)
							RME_Party_Mission_Event("VIP_DEAD",arg7) -- Cet event doit etre propag dans l'quipe
						end
					end				
				
					RME_Check_Mission_Event("KILL_MOB",arg7)
					RME_Party_Mission_Event("KILL_MOB",arg7) -- Cet event doit etre propag dans l'quipe
					return
				end
			end
			-- [[ Detection duel perdu ]]
			if event == "CHAT_MSG_SYSTEM" then -- duel gagn joueur?
				-- On ne check le nom du joueur que si c'est le joueur qui l'a tu (en se basant sur le pattern SELFKILLOTHER, on retrouve le nom du joueur tu) 
				-- note : CHAT_MSG_COMBAT_HOSTILE_DEATH et CHAT_MSG_COMBAT_FRIENDLY_DEATH ont le meme pattern
				local a,b, creatureName,creatureName2 = string.find( arg1,RME_CHAT_PATTERN["CHAT_MSG_SYSTEM"])
				if creatureName2 and creatureName and creatureName == RME_PLAYER_INFO.Name  then
					RME_Check_Mission_Event("KILL_MOB",creatureName2)	
					RME_Party_Mission_Event("KILL_MOB",creatureName) -- Cet event doit etre propag dans l'quipe										
				end
				return				
			end

		end

	--[[  GESTION DECO  ]]--
		-- Deconnexion du joueur
		if (event == "PLAYER_LOGOUT" and RME_UI_LOADED) then
			RME_Save_and_Unload();--Sauvegarde
		end
		
	end

	
	--[[ INIT UI ]]--
	function RME_Initialize ()
		
		RME_DebugMsg("RME_Initialize()",4);
		
		-- Rattachement  la fenetre de quest
		getglobal("QuestLogFrame"):SetScript("OnShow", 	function() 
													QuestLog_OnShow() 
													if  RME_QuestLogFrame:IsShown() then
														HideUIPanel(RME_QuestLogFrame);
													end
													if  RME_GossipFrame:IsShown() then
														HideUIPanel(RME_GossipFrame);
													end	
													if  RME_QuestFrame:IsShown() then
														HideUIPanel(RME_QuestFrame);
													end														
													PlaySound("igCharacterInfoTab");
													RME_UpdateMainOnglets()												
												end)
		getglobal("QuestLogFrame"):SetScript("OnHide", function() 
													QuestLog_OnHide() 
													RME_UpdateMainOnglets()
													PlaySound("igCharacterInfoTab");													
												end)
		-- Rattachement  la fenetre gossip
		getglobal("GossipFrame"):SetScript("OnShow", 	function() 
													PlaySound("igQuestListOpen");
													if ( StaticPopup_Visible("XP_LOSS") ) then
														StaticPopup_Hide("XP_LOSS");
													end
													if  RME_GossipFrame:IsShown() then
														HideUIPanel(RME_GossipFrame);
													end
													if  RME_QuestLogFrame:IsShown() then
														HideUIPanel(RME_QuestLogFrame);
													end
													if  RME_QuestFrame:IsShown() then
														HideUIPanel(RME_QuestFrame);
													end													
													PlaySound("igCharacterInfoTab");
													RME_UpdateGossipOnglets();
												end)
		getglobal("GossipFrame"):SetScript("OnHide", function() 
													PlaySound("igQuestListClose");
													CloseGossip();
													PlaySound("igCharacterInfoTab");													
													RME_UpdateGossipOnglets();
												end)

		-- Chargement info joueur
		RME_PLAYER_INFO = RME_CLASS_PLAYER("player")
		RME_TARGET_INFO = RME_CLASS_TARGET("target")

		-- On met en forme les pattern
		for idx, scanString in pairs(RME_CHAT_PATTERN) do
			scanString = string.gsub(scanString, "%(", "%%%(")
			scanString = string.gsub(scanString, "%)", "%%%)")
			scanString = string.gsub(scanString, "(%%s)", "%(%.%+%)")
			scanString = string.gsub(scanString, "(%%%d$s)", "%(%.%+%)")
			scanString = string.gsub(scanString, "(%%d)", "%(%%%d%+%)")
			scanString = string.gsub(scanString, "(%%%d$d)", "%(%%%d%+%)")
			RME_CHAT_PATTERN[idx] = scanString
		end
		
		-- On charge les missions existante dans la base
		RME_InitLoadVariables()
		-- On charge le sac de l'utilisateur
		RME_InitLoadBag()
		-- On check les timers des missions sauvegardes en cours
		RME_CheckMissionsTimer()
		-- Minimap/Map
		RME_Astrolabe = AceLibrary:GetInstance("Astrolabe-GM-0.2");
		
		-- On active le mode rception des donnes 
		Telepathy.registerListener(RME_COMM_ADDON_GUID, { "GLOBAL", "WHISPER", "PARTY", "RAID", "GUILD" }, 
			function(msg, sender) 
				RME_Comm_Event(msg,sender)
			end	
		);
			
		-- On lance l'UPDATE qui permet la mise a jour des missions, des infos users utilisant cet addon
		RME_EventManager_AddEvent("WHO",45,"ListChannelByName('Telepathy.GLOBAL_CHANNEL')")		
		RME_EventManager_AddEvent("UPDATE",60,"RME_Comm_SEND_UPDATE()")
		--On met a jour  les missions disponibles dans la zone 
		RME_Mega_Update(true)
		RME_EventManager_AddEvent("MEGA_UPDATE",60,"RME_Mega_Update(true)")
		RME_PanelFrame_General_UpdateMissions:Disable()
		ListChannelByName(Telepathy.GLOBAL_CHANNEL)
		
		-- On met a jour les boutons li aux targets
		RME_QuestEditorFrame_Objective_Type_KILL_MOB_SelectTarget:Disable()
		RME_QuestEditorFrame_NPC_Add:Disable()
		RME_QuestEditorFrame_Objective_Type_CONDITION_Escort_VIP_SelectTarget:Disable()		
		RME_QuestEditorFrame_Item_Type_USE_ON_MOB_MobName_SelectTarget:Disable()		
		RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_SelectTarget:Disable()		
		--RME_ChooseMission_Cancel:Hide()
		
		-- On affiche le bouton dans la minimap
		RME_Minimap_Button_IconFrame_MoveIcon()
		
		--On informe que le module est charg
		RME_DisplayMessage(RME_LOCALE["RME_LOCALE_ADDON_LOADED"].text)
		RME_UI_LOADED = true

	end
	
	--[[ LOAD UI ]]--
	function RME_InitLoadVariables()
	
		-- Liste de toute les missions existantes
		if RME_GLOBAL_MISSIONS_SAVE and type(RME_GLOBAL_MISSIONS_SAVE) == "table" then
			RME_LOAD_MISSIONS(RME_GLOBAL_MISSIONS_SAVE,RME_MISSIONS_LIST)			
		else
			RME_GLOBAL_MISSIONS_SAVE = {} -- On rinit la liste
			RME_MISSIONS_LIST = {}
		end
		
		-- Liste de toutes les mission en cours d'excution par le joueur
		if RME_GLOBAL_PLAYER_MIP and type(RME_GLOBAL_PLAYER_MIP) == "table" then
			RME_LOAD_MISSIONS(RME_GLOBAL_PLAYER_MIP,RME_IN_PROGRESS_MISSIONS_LIST)
		else
			RME_GLOBAL_PLAYER_MIP = {} -- On rinit la liste
			RME_IN_PROGRESS_MISSIONS_LIST = {}
		end	
		
		-- Liste de toutes les missions termin par le joueur (contient uniquement l'ID)
		if RME_GLOBAL_MISSIONS_FINISH_LIST and type(RME_GLOBAL_MISSIONS_FINISH_LIST) == "table" then
			RME_LOAD_MISSIONS_ID_ONLY(RME_GLOBAL_MISSIONS_FINISH_LIST,RME_COMPLETED_MISSIONS_LIST)
		else
			RME_COMPLETED_MISSIONS_LIST = {}
			RME_GLOBAL_MISSIONS_FINISH_LIST = {} -- On rinit la liste
		end	
		
		-- Charge la liste des mission actuellement dite mais non publie
		if RME_GLOBAL_MISSIONS_EDITOR_LIST and type(RME_GLOBAL_MISSIONS_EDITOR_LIST) == "table" then
			RME_LOAD_MISSIONS(RME_GLOBAL_MISSIONS_EDITOR_LIST,RME_MISSION_EDITOR_LIST)			
		else
			RME_GLOBAL_MISSIONS_EDITOR_LIST = {} -- On rinit la liste
			RME_MISSION_EDITOR_LIST = {}
		end
		-- Contient la mission actuellement dite
		if RME_GLOBAL_MISSION_EDITION and type(RME_GLOBAL_MISSION_EDITION) == "table" then
			RME_MISSION_EDITION	 = RME_CLASS_MISSION(RME_GLOBAL_MISSION_EDITION.ID)
			RME_MISSION_EDITION:Load(RME_GLOBAL_MISSION_EDITION)
		else
			RME_MISSION_EDITION = nil
			RME_GLOBAL_MISSION_EDITION = {}
		end
		
		-- Global RME_GLOBAL_ADDON_CONFIG
		if RME_GLOBAL_ADDON_CONFIG and type(RME_GLOBAL_ADDON_CONFIG) == "table" then
			RME_ADDON_CONFIG = RME_GLOBAL_ADDON_CONFIG
		else
			RME_ADDON_CONFIG = {}
			RME_GLOBAL_ADDON_CONFIG = {}
		end
		if not RME_ADDON_CONFIG["UniqueID"] then
			RME_ADDON_CONFIG["UniqueID"] = RME_Generate_New_GUID()
		end

		-- Contient la liste des users utilisant ce chan
		-- Utilis pour la mise a jour et propagation des missions
		local player_name = RME_Translate_To_UTF8(UnitName('player'))
		
		if not RME_MISSION_EDITION then -- Cration mission par defaut
			RME_MISSION_EDITION	 = RME_CLASS_MISSION(RME_GLOBAL_MISSION_EDITION.ID)
			
				RME_MISSION_EDITION.Title				=	RME_LOCALE["RME_LOCALE_EDITOR_NEED_TITLE"].text
				RME_MISSION_EDITION.IsPrivate 			=	true
				RME_MISSION_EDITION.Locked 				=	true
				RME_MISSION_EDITION.EditorLoad_Lock 		=	true
				RME_MISSION_EDITION.Publication_Lock 		=	true
				RME_MISSION_EDITION.CreateBy			= 	player_name
				RME_MISSION_EDITION.CreateByID			= 	RME_ADDON_CONFIG["UniqueID"]
				RME_MISSION_EDITION.CreateInServer		= 	RME_PLAYER_INFO.Server
				RME_MISSION_EDITION.CreateDate			= 	time()
				RME_MISSION_EDITION.NeedSave			=	true	
				RME_MISSION_EDITION.ID					=	RME_Generate_New_GUID()
				RME_MISSION_EDITOR_LIST[RME_MISSION_EDITION.ID] = RME_MISSION_EDITION -- On place cette mission dans la liste des missions dites
			
		end
		
		if RME_GLOBAL_ADDON_USERS_LIST and type(RME_GLOBAL_ADDON_USERS_LIST) == "table" then
			RME_LOAD_USERS(RME_GLOBAL_ADDON_USERS_LIST,RME_COMM_ADDON_USERS_LIST)	
			if not RME_COMM_ADDON_USERS_LIST[player_name] then
				local USER = RME_CLASS_USER(player_name)
				RME_COMM_ADDON_USERS_LIST[player_name] = USER
			end
			RME_COMM_ADDON_USERS_LIST[player_name].Version = RME_VERSION_NUMBER
			RME_COMM_ADDON_USERS_LIST[player_name].Status = "IDLE"
		else
			RME_GLOBAL_ADDON_USERS_LIST = {}
			RME_COMM_ADDON_USERS_LIST = {}			
			local USER = RME_CLASS_USER(player_name)
			RME_COMM_ADDON_USERS_LIST[player_name] = USER
			RME_COMM_ADDON_USERS_LIST[player_name].Version = RME_VERSION_NUMBER
			RME_COMM_ADDON_USERS_LIST[player_name].Status = "IDLE"			
		end
		
		if RME_GLOBAL_CONFIG and type(RME_GLOBAL_CONFIG) == "table" then
			RME_CONFIG = RME_GLOBAL_CONFIG
		else
			RME_CONFIG = {}
			RME_GLOBAL_CONFIG = {}
		end
		
		
	end
	
	function RME_InitLoadBag()
		if RME_GLOBAL_BAG and type(RME_GLOBAL_BAG) == "table" then
			RME_LOAD_BAG(RME_GLOBAL_BAG,RME_PLAYER_BAG)			
		else
			RME_GLOBAL_BAG = {} -- On rinit la liste
			RME_PLAYER_BAG = {}
		end
	end
	
	--[[ UNLOAD UI ]]--
	function RME_Save_and_Unload()
		-- A voir 	--Sea.string.objectToString(object)
				--Sea.string.stringToObject(string)
				-- Scuriser la sauvegarde > si un idiot s'amuse a tout supprimer il ne faudrait pas enregistrer les missions car elle serait perdu
				
		RME_DebugMsg("RME_Save_and_Unload()",4)
		-- On sauvegarde le listing de mission dans une variable globale qui sera automatiqement sauvegarde
		RME_GLOBAL_MISSIONS_SAVE = {}
		RME_GLOBAL_MISSIONS_SAVE = RME_MISSIONS_LIST
		-- On sauvegarde les MIP du player dans une variable globale (variable / personnage)
		RME_GLOBAL_PLAYER_MIP = {}
		RME_GLOBAL_PLAYER_MIP = RME_IN_PROGRESS_MISSIONS_LIST
		-- On sauvegarde les missions termines
		RME_GLOBAL_MISSIONS_FINISH_LIST= {}
		RME_GLOBAL_MISSIONS_FINISH_LIST = RME_COMPLETED_MISSIONS_LIST
		-- On sauvegarde la mission actuellement dite
		RME_GLOBAL_MISSION_EDITION = {}
		RME_GLOBAL_MISSION_EDITION = RME_MISSION_EDITION
		-- On sauvegarde la mission actuellement dite
		RME_GLOBAL_MISSION_EDITION = {}
		RME_GLOBAL_MISSION_EDITION = RME_MISSION_EDITION
		-- On sauvegarde la listes des mission actuellement dite
		RME_GLOBAL_MISSIONS_EDITOR_LIST = {}
		RME_GLOBAL_MISSIONS_EDITOR_LIST = RME_MISSION_EDITOR_LIST
		-- On sauvegarde le sac
		RME_GLOBAL_BAG = {}
		RME_GLOBAL_BAG = RME_PLAYER_BAG
		--On sauvegarde la liste des users
		RME_GLOBAL_ADDON_USERS_LIST = {}
		RME_GLOBAL_ADDON_USERS_LIST = RME_COMM_ADDON_USERS_LIST
		-- Parametres user
		RME_GLOBAL_CONFIG = RME_CONFIG
		RME_GLOBAL_ADDON_CONFIG = RME_ADDON_CONFIG
		
		RME_DebugMsg("RME_Save_and_Unload() DONE !",4)

	end

	
-- Fin du chargement des fonctions et du fichier
RME_DebugMsg("<LOAD>RME.lua "..RME_Return_ColoredText("DONE !","ok"),3)