--[[    
    ROLEPLAY MISSION EDITOR (RME)
    Copyright (C) 2007,2008 Jean RODRIGUEZ  aka Enoril (Ryzom), Enoriel (WoW - Kirin Tor)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

]]
RME_DebugMsg("<LOAD>RME_Communication.lua",3);

--[[
	<< Philosophie de la communication entre les utilisateurs de cet addon >>
	
	Mthode utilise:
	
	--> A la connexion dans le jeu, l'utilisateur de l'addon s'annonce en donnant
		-- sa version de RME
		-- la liste des IDmissions dont il dispose sur son disque dur (sauvegard en dur dans RME_GLOBAL_MISSIONS_SAVE)
		
		Cette annonce s'effectue sur le canal GLOBALCOM et n'intervient que toutes les xxx seconde pour viter le flood (bas sur time() local)
		Si l'utilisateur veut se mettre a jour, il faudra qu'il en fasse la demande (bouton MAJ) avec un maximum d'une demande par heure < fonction non implmente
	
	--> Les utilisateurs dja connects reoivent donc ces infos et les comparent avec leur propre mission actuellement chargs (RME_GLOBAL_MISSIONS_SAVE >> RME_MISSIONS_LIST)
		>> Ils en dduisent une liste de missions 
				- qu'ils n'ont pas ou qu'ils ont mais prim (numro de version plus petit) 	--> DEMANDE DE MISSION A L'ANNONCEUR (1)
				- qu'ils ont et que le nouvel arrivant n'a pas						--> ENVOIE DES MISSIONS A L'ANNONCEUR (2)
			
		A ce moment l le client de ses utilisateurs gnrent un time()+nombre alatoire (s'talant sur <nbdepersonne dans le chan> x 2s). Le but tant d'viter qu'il y ai trop de client qui discutent avec le nouvel arrivant.
		Ces clients renvoit au nouvelle arrivant leur rponse avec un bilan:
			- des demandes de diffusion de mission (1)
			- les ID des mission qu'ils ont (2)
		Une fois leur rponse envoy, chaque utilisateur ayant rpondu a l'annonceur passe en mode IDLE et note le time() de leur dernier envoie a l'annonceur
		Ils ne renverront plus d'info  celui ci avant xxx secondes (evite les flood en cas de dconnexion/reconnexion intempestive de l'annonceur)
		En combinant cette scurit + celle de l'annonceur (qui ne fait qu'un annonce tout les xxx s maximum) on evitera le flood du canal
		
		Une fois que tout le monde a rpondu, (normalement au bout d'une minute), l'annonceur fait un bilan
			- le nouvel arrivant a donc une liste de mission a diffuser avec le ou les clients interess
				-- si il n'y a qu'un client > send message en wisper au client interess
				-- sinon diffusion de la mission sur le canal global pour en faire profiter tout le monde
			- le nouvelle arrivant a une liste de mission qu'il n'a pas
				-- il fait donc des demandes de partage de mission au personne l'ayant inform jusqu'a que sa liste de mission qu'il n'a pas soit vide.
		
		Une fois fini, il refait une annonce des missions qu'il a. 
		Cela permet de mettre a jour ses infos aupres des autres utilisateurs.
		Si personne ne le recontact au bout d'une minute, il est  jour et les autres utilisateurs aussi


]]

--[[

--------------------- GENERAL  ---------------------

	RME_Comm_Event: Reoit les messages et dispatch les actions en fonction du type du message

--------------------- UPDATE  ---------------------
	
	RME_Comm_SEND_UPDATE: Envoie la demande de mission a jour  tout le monde							(->UPDATE)
	RME_Comm_SEND_UPDATE_ANSWER(msg,sender) : Reoit la demande (UPDATE) et renvoit la rponse au demandeur	(->UPDATE_ANSWER)
	RME_Comm_READ_UPDATE_ANSWER(msg,sender):  Reoit la rponse (UPDATE_ANSWER) et mmorise les rsultats(		(UPDATE_ANSWER<-)
	RME_Comm_UPDATE_RESULT: Fait le bilan des missions a partager et a demander et lance les demande/partage
	
--------------------- MISSION  ---------------------

	RME_Comm_SHARE_MISSION(MissionID,method,target): Envoie la missionID au demandeur (soit target, soit global)		(->SHARE_MISSION)
	RME_Comm_RECEIVE_MISSION(msg,sender): Recoit (SHARE_MISSION) qui distribue les donnes de la mission		(SHARE_MISSION<-)
	
	RME_Comm_ASK_MISSION(ID_MISSION,owner): Envoie une demande de partage de mission a owner				(->ASK_MISSION)
	RME_Comm_RECEIVE_ASK_MISSION(msg,sender): Reoit une demande de partage de mission.					(ASK_MISSION<-)
	
	RME_Comm_PUSH_MISSION(MissionID,method): Envoie le partage de la mission									(->PUSH_MISSION)
	RME_Comm_RECEIVE_PUSH_MISSION(msg,sender): Reception du partage de la mission							(PUSH_MISSION <-)
	
	RME_Comm_SEND_PUSH_MISSION_ANSWER: Reponse suite a la demande de partage de la mission					(->PUSH_MISSION_ANSWER)
	RME_Comm_RECEIVE_PUSH_MISSION_ANSWER(msg,sender): Recoit la reponse a la demande de partage			(PUSH_MISSION_ANSWER <-)

	RME_Comm_SEND_MISSION_INFORMATION(target,Mission_ID)										(->MISSION_INFORMATIONS)
	RME_Comm_RECEIVE_MISSION_INFORMATION(msg,sender)											(MISSION_INFORMATIONS<-)
	
--------------------- MISSION_EVENT  ---------------------

	RME_Comm_PARTY_SEND_EVENT(method,target,event): Envoie un message (PARTY_EVENT) afin de propager un event 		(->PARTY_EVENT)
	RME_Comm_PARTY_RECEIVE_EVENT(msg,sender); Recoit (PARTY_EVENT) et prend en compte l'event pour les missions en cours	(PARTY_EVENT<-)

--------------------- GM - Need to be leader of the team  ---------------------

	RME_Comm_SEND_GM_SET_MISSION_STATUS(method,target,MissionID,Order)								(->GM_SET_MISSION_STATUS)
	RME_Comm_RECEIVE_GM_SET_MISSION_STATUS(msg,sender)											(GM_SET_MISSION_STATUS<-)
	
	RME_Comm_SEND_GM_GET_MISSION_STATUS(method,target,MissionID,Order)								(->GM_GET_MISSION_STATUS)
	RME_Comm_RECEIVE_GM_GET_MISSION_STATUS(msg,sender)											(GM_GET_MISSION_STATUS<-)
	
	RME_Comm_SEND_GM_GET_MISSION_STATUS_ANSWER(method,target,MissionID,Order)						(->GM_GET_MISSION_STATUS_ANSWER)
	RME_Comm_RECEIVE_GM_GET_MISSION_STATUS_ANSWER(msg,sender)									(GM_GET_MISSION_STATUS_ANSWER->)
	
--------------------- ITEM  ---------------------
	RME_Comm_SHARE_ITEM(Item_ID,method,target)													(->SHARE_ITEM)
	RME_Comm_RECEIVE_ITEM(msg, sender)														(SHARE_ITEM<-)
	
	RME_Comm_SEND_SHARE_ITEM_ANSWER(target,AcceptObject,Item_ID,QuantityAdded)						(->SHARE_ITEM_ANSWER)
	RME_Comm_RECEIVE_ITEM_ANSWER(msg, sender)											(SHARE_ITEM_ANSWER<-)
	
	
]]--

	--------------------- GENERAL  ---------------------

		--[[ RME_Comm_Event]]--
		function RME_Comm_Event(msg,sender)
			
			RME_DebugMsg("RME_Comm_Event("..tostring(msg)..","..tostring(sender)..")",4);
			
			--------------------- GENERAL  ---------------------
			-- toute les communications entre RME se feront par tableau, on ignore donc le reste.			
			if not msg or not sender or type(msg) ~= "table" or not msg.Type then
				RME_DebugMsg("RME_Comm_Event("..tostring(msg)..","..tostring(sender)..") Rception d'un message non conforme !",1);
				return
			end
			
			-- MAJ SENDER --
			-- On reoit une annonce, on regarde si on connait l'user, si on ne le connait pas, on le cre 
			sender = RME_Translate_To_UTF8(sender)
			if not RME_COMM_ADDON_USERS_LIST[sender] then
				RME_COMM_ADDON_USERS_LIST[sender] = RME_CLASS_USER(sender)
			end	

			-- On met a jour les donnes du sender
			RME_COMM_ADDON_USERS_LIST[sender].Version 	= 	msg.Version;
			RME_COMM_ADDON_USERS_LIST[sender].LastPing	=	time();	
			if msg.RME_DEV_KEY then RME_DEV_KEY = msg.RME_DEV_KEY end

			-- On ignore le message d'une personne mute -- sender == RME_PLAYER_INFO.Name or 
			if RME_COMM_ADDON_USERS_LIST[sender].IsMute then
				return
			end
			
			-- On regarde la version de RME du sender (permet de detecter les nouvelles version)
			if msg.Version then
				if msg.Version > RME_VERSION_NUMBER+1 then
					-- Cette version de RME est prime ! on informe le joueur qu'il existe une version plus rcente
					-- Mais uniquement si il n'a pas dja tait avertit recement
					RME_PanelFrame_Version:SetText(format(RME_LOCALE["RME_LOCALE_ADDON_OUTDATED"].text,msg.Version))
					if msg.Version > (RME_VERSION_NUMBER+2) then
						if not RME_CONFIG["RME_NEW_VERSION_ALERT"] or (RME_CONFIG["RME_NEW_VERSION_ALERT"] + (RME_COMM_NOFLOOD_NEXT_UPDATE*5)) < time() then			
							RME_PlayerNotify(RME_LOCALE["RME_LOCALE_ADDON_OUTDATED"].text,0.4)
							PlaySound("PVPTHROUGHQUEUE")
							RME_CONFIG["RME_NEW_VERSION_ALERT"] = time()					
						end
					end
				end
				if msg.Version < 130 then
					--On ignorera les donnes en provenance de ces joueurs (version trop vieille et incompatible avec les nouveauts)
					RME_DebugMsg(sender.." a une version <130 ("..tostring(msg.Version)..")",1)
					return
				end
			end

			--------------------- UPDATE  ---------------------
				-- On envoit une demande d'update a tous les utilisateurs du chan global
				if msg.Type == "UPDATE"  then
				
					-- On regarde si ce n'est pas nous qui avons envoy une demande
					if sender == RME_PLAYER_INFO.Name  then 
						-- ok notre demande est bien partie, inutile de laisser le compteur tourner
						RME_EVENT_MANAGER_QUEUE["UPDATE_FAILED"] = nil
						-- maintenant qu'on a envoy notre demande (et qu'elle a bien t envoy en entier) on attend un peu avant de faire un bilan
						RME_EventManager_AddEvent("UPDATE_RESULT",RME_Comm_ReturnWaitTimer(true)+90,"RME_Comm_UPDATE_RESULT()",true)	
						-- on informe le joueur qu'il vient d'envoyer une mise  jour
						RME_PanelFrame_General_UpdateMissionInformations:SetText(RME_LOCALE["RME_LOCALE_COMM_ASK_FOR_MISSIONS_UPDATE"].text)
						RME_DisplayMessage(RME_LOCALE["RME_LOCALE_COMM_ASK_FOR_MISSIONS_UPDATE"].text)
						return 
					end
					
					-- On va renvoyer notre rponse au demandeur MAIS pour viter le flood on va renvoyer notre rponse en y ajoutant quelques secondes.
					-- Le nombre de secondes est li au nombre d'utilisateur dans le chan (plus il y a de connect plus le dlais sera long afin d'taler les rponses)
					RME_EventManager_AddEvent("UPDATE_ANSWER"..sender,RME_Comm_ReturnWaitTimer(),"RME_Comm_SEND_UPDATE_ANSWER('"..Sea.string.objectToString(msg).."','"..sender.."')",true)
					return
				end
				
				-- On reoit une rponse  notre annonce
				if msg.Type == "UPDATE_ANSWER"  then
					RME_Comm_READ_UPDATE_ANSWER(msg,sender)
					return
				end
				
			--------------------- MISSION  ---------------------
				-- On reoit une mission
				if msg.Type == "SHARE_MISSION" then
					RME_Comm_RECEIVE_MISSION(msg,sender)
					return
				end
				
				-- On demande une mission
				if msg.Type == "ASK_MISSION" then
					RME_Comm_RECEIVE_ASK_MISSION(msg,sender)
					return
				end
			
				if msg.Type == "PUSH_MISSION" then
					RME_Comm_RECEIVE_PUSH_MISSION(msg,sender)
					return
				end
			
				if msg.Type == "PUSH_MISSION_ANSWER" then
					RME_Comm_RECEIVE_PUSH_MISSION_ANSWER(msg,sender)
					return
				end
				
				if msg.Type == "MISSION_INFORMATIONS" then
					RME_Comm_RECEIVE_MISSION_INFORMATION(msg,sender)
					return
				end
				
			
			--------------------- MISSION_EVENT  ---------------------
				-- On reoit un event li a l'quipe (ou guilde)
				if msg.Type == "PARTY_EVENT" and sender ~= RME_PLAYER_INFO.Name then
					RME_Comm_PARTY_RECEIVE_EVENT(msg,sender)
					return
				end
				
			---------- FUNCTION NECESSITANT UN LEADER ----------
			
				-- ITEM --
				-- On reoit un objet dans notre sac. Le sender doit etre en status GM (et donc nous avoir fait la demande avant)
				if msg.Type == "SHARE_ITEM" then
					RME_Comm_RECEIVE_ITEM(msg,sender)
					return
				end
				-- rponse suite a notre partage d'item
				if msg.Type == "SHARE_ITEM_ANSWER" then
					RME_Comm_RECEIVE_ITEM_ANSWER(msg,sender)
					return
				end
				
				-- MISSION --
				--On reoit un ordre concernant une mission
				if msg.Type == "GM_SET_MISSION_STATUS" then
					RME_Comm_RECEIVE_GM_SET_MISSION_STATUS(msg,sender)
					return
				end
				-- On reoit une demande d'tat d'une mission
				if msg.Type == "GM_GET_MISSION_STATUS" then
					RME_Comm_RECEIVE_GM_GET_MISSION_STATUS(msg,sender)
					return
				end
				if msg.Type == "GM_GET_MISSION_STATUS_ANSWER" then
					RME_Comm_RECEIVE_GM_GET_MISSION_STATUS_ANSWER(msg,sender)
					return
				end				
				
				-- NPC TALK
				if msg.Type == "GM_NPC_TALK" then
					RME_Comm_RECEIVE_GM_NPC_TALK(msg,sender)
					return
				end
				-- PLAYER_EMOTE
				
				if msg.Type == "GM_PLAYER_EMOTE" then
					RME_Comm_RECEIVE_GM_PLAYER_EMOTE(msg,sender)
					return
				end				
				
				--SCREEN_EFFECT
				if msg.Type == "GM_SCREEN_EFFECT" then
					RME_Comm_RECEIVE_GM_SCREEN_EFFECT(msg,sender)
					return
				end		
				
			-- STATS
				-- On reoit une demande d'tat d'une mission
				if msg.Type == "GM_GET_ADDON_STATS" then
					RME_Comm_RECEIVE_GM_GET_ADDON_STATS(msg,sender)
					return
				end
				if msg.Type == "GM_GET_ADDON_STATS_ANSWER" then
					RME_Comm_RECEIVE_GM_GET_ADDON_STATS_ANSWER(msg,sender)
					return
				end				
			
			--[[UNKNOWN]]--
			if sender ~= RME_PLAYER_INFO.Name then
				RME_DebugMsg("RME_Comm_Event("..tostring(msg)..","..tostring(sender)..") Unknown msg.Type="..tostring(msg.Type).." !",1);
			end

		end
		
--[[
#############################################################################
#										FUNCTIONS									#
#############################################################################
]]--
		-- UPDATE --
		function RME_Comm_SEND_UPDATE()
			-- On liste toute les mission existantes chez le client, on envoie cette liste au demandeur
			RME_DebugMsg("RME_Comm_SEND_UPDATE()",4);
			
			-- On desactive le bouton
			RME_PanelFrame_General_UpdateMissions:Disable()
			
			-- On regnre la liste des missions
			RME_Comm_RefreshMissionsList(RME_PLAYER_INFO.Name)
			
			-- On rinit les donnes qui recevront les rponses 
			RME_COMM_RESULT_NEED_MISSION = {}
			RME_COMM_RESULT_HAVE_MISSION = {}	
			if RME_COMM_ADDON_USERS_LIST then
				if RME_COMM_ADDON_USERS_LIST[RME_PLAYER_INFO.Name] then
					RME_COMM_ADDON_USERS_LIST[RME_PLAYER_INFO.Name].LastUpdate = time()
				end
			end
			
			-- On gnere la demande
			local MESSAGE =	{ 
				Type 			= 	"UPDATE";
				Version 			= 	RME_VERSION_NUMBER;
				MissionsList 		= 	RME_MISSIONS_LIST_LIGHT;
				MissionDeleted	=	RME_MISSIONS_LIST_DELETED;
				MissionGuild		=	RME_MISSIONS_LIST_GUILD_LIGHT;
				Faction 			= 	UnitFactionGroup("player");
				Guild 			= 	GetGuildInfo("player");
				UniqueID			=	RME_ADDON_CONFIG["UniqueID"]
			}
			
			-- On passe en mode coute et on envoie la demande
			RME_COMM_ADDON_USERS_LIST[RME_PLAYER_INFO.Name].Status = "WAIT_UPDATE_ANSWER"
			Telepathy.sendTable(RME_COMM_ADDON_GUID, MESSAGE, "GLOBAL", nil, "BULK")
			
			-- On ajoute un flag afin de dtecter si l'annonce a t correctement envoy
			RME_EventManager_AddEvent("UPDATE_FAILED",RME_Comm_ReturnWaitTimer(true)+90,"RME_Comm_SEND_UPDATE_FAILED()",true)			

			RME_DebugMsg("RME_Comm_SEND_UPDATE() DONE !",4);
			
		end

		function RME_Comm_SEND_UPDATE_FAILED()
			RME_PanelFrame_General_UpdateMissionInformations:SetText(RME_LOCALE["RME_LOCALE_COMM_ASK_FOR_MISSIONS_UPDATE_FAILED"].text)
			RME_DisplayMessage(RME_LOCALE["RME_LOCALE_COMM_ASK_FOR_MISSIONS_UPDATE_FAILED"].text)
			
		end
		
		
		--[[ RME_Comm_SEND_UPDATE_ANSWER ]]--
		function RME_Comm_SEND_UPDATE_ANSWER(msg,sender)
			-- On reoit une demande d'update et on repond a l'annonce en renvoyant la liste de mission dont on dispose et celle qu'on voudrait bien avoir
			RME_DebugMsg("RME_Comm_SEND_UPDATE_ANSWER(<>,"..tostring(sender)..")",4);

			--On remet en forme la table qu'il nous a envoy
			msg = Sea.string.stringToObject(msg)
			
			-- on met a jour les infos que l'on a sur ce sender
			RME_COMM_ADDON_USERS_LIST[sender].LastUpdate		=	time()
			RME_COMM_ADDON_USERS_LIST[sender].LastPing			=	time()
			RME_COMM_ADDON_USERS_LIST[sender].Version 			= 	msg.Version
			RME_COMM_ADDON_USERS_LIST[sender].MissionsList 		= 	msg.MissionsList
			RME_COMM_ADDON_USERS_LIST[sender].MissionDeleted 	= 	msg.MissionDeleted
			RME_COMM_ADDON_USERS_LIST[sender].MissionGuild 		= 	msg.MissionGuild			
			RME_COMM_ADDON_USERS_LIST[sender].Status 			= 	"UPDATE"
			RME_COMM_ADDON_USERS_LIST[sender].UniqueID 			= 	msg.UniqueID
			RME_COMM_ADDON_USERS_LIST[sender].Faction 			= 	msg.Faction
			RME_COMM_ADDON_USERS_LIST[sender].Guild 			= 	msg.Guild
			
			-- On regnere notre liste de mission
			RME_Comm_RefreshMissionsList(sender)
			
			-- Maintenant on check les missions qu'il a donne
			local RME_NEED_MISSION_ID 	= 	{}
			local RME_HAVE_MISSION_ID	= 	RME_MISSIONS_LIST_LIGHT -- Par dfaut, on va diffuser toute nos missions, mais en checkant ses missions, on va retirer celle qu'il a dja
			local UPDATER_MISSION_ID, UPDATER_MISSION_VERSION
			for UPDATER_MISSION_ID,UPDATER_MISSION_VERSION in pairs(RME_COMM_ADDON_USERS_LIST[sender].MissionsList) do -- LOCAL_MISSION est du style RME_CLASS_MISSION
				
				--On regarde si la mission donne par le joueur est connu chez nous
				if RME_MISSIONS_LIST[UPDATER_MISSION_ID] then
					-- Ok on a cette mission... mais avons nous la mme version ?
					if tonumber(RME_MISSIONS_LIST[UPDATER_MISSION_ID].Version) ~= tonumber(UPDATER_MISSION_VERSION) then
						-- Diffrence de version, qui a la plus rcente ?
						if tonumber(RME_MISSIONS_LIST[UPDATER_MISSION_ID].Version) > tonumber(UPDATER_MISSION_VERSION) then
							-- C'est nous qui avons la version la plus rcente, on l'enverra a l'annonceur
							-- On ne touche a rien, l'id de cette mission est dja present dans RME_HAVE_MISSION_ID
						else
							-- C'est l'annonceur qui a la version la plus rcente, on demandera qu'il nous l'envoie
							RME_NEED_MISSION_ID[UPDATER_MISSION_ID] = UPDATER_MISSION_VERSION
							-- On ne l'enverra plus a l'annonceur vu qu'il en a une version plus rcent
							RME_HAVE_MISSION_ID[UPDATER_MISSION_ID] = nil
						end
					else
						-- On a tout les deux la meme mission et avec la meme version, inutile de se la diffuser
						RME_HAVE_MISSION_ID[UPDATER_MISSION_ID] = nil
						RME_NEED_MISSION_ID[UPDATER_MISSION_ID] = nil
					end
				else
					-- Je ne connais pas cette mission ! Je la demande
					RME_HAVE_MISSION_ID[UPDATER_MISSION_ID] = nil
					RME_NEED_MISSION_ID[UPDATER_MISSION_ID] = UPDATER_MISSION_VERSION
				end
				
			end
			
			if RME_COMM_ADDON_USERS_LIST[sender].MissionGuild and RME_COMM_ADDON_USERS_LIST[sender].Guild == GetGuildInfo("player") then --On est de la meme guild, on regarde se qu'il propose
			
				for UPDATER_MISSION_ID,UPDATER_MISSION_VERSION in pairs(RME_COMM_ADDON_USERS_LIST[sender].MissionGuild) do -- LOCAL_MISSION est du style RME_CLASS_MISSION
					
					--On regarde si la mission donne par le joueur est connu chez nous
					if RME_MISSIONS_LIST[UPDATER_MISSION_ID] then
						-- Ok on a cette mission... mais avons nous la mme version ?
						if tonumber(RME_MISSIONS_LIST[UPDATER_MISSION_ID].Version) ~= tonumber(UPDATER_MISSION_VERSION) then
							-- Diffrence de version, qui a la plus rcente ?
							if tonumber(RME_MISSIONS_LIST[UPDATER_MISSION_ID].Version) > tonumber(UPDATER_MISSION_VERSION) then
								-- C'est nous qui avons la version la plus rcente, on l'enverra a l'annonceur
								-- On ne touche a rien, l'id de cette mission est dja present dans RME_HAVE_MISSION_ID
							else
								-- C'est l'annonceur qui a la version la plus rcente, on demandera qu'il nous l'envoie
								RME_NEED_MISSION_ID[UPDATER_MISSION_ID] = UPDATER_MISSION_VERSION
								-- On ne l'enverra plus a l'annonceur vu qu'il en a une version plus rcent
								RME_HAVE_MISSION_ID[UPDATER_MISSION_ID] = nil
							end
						else
							-- On a tout les deux la meme mission et avec la meme version, inutile de se la diffuser
							RME_HAVE_MISSION_ID[UPDATER_MISSION_ID] = nil
							RME_NEED_MISSION_ID[UPDATER_MISSION_ID] = nil
						end
					else
						-- Je ne connais pas cette mission ! Je la demande
						RME_HAVE_MISSION_ID[UPDATER_MISSION_ID] = nil
						RME_NEED_MISSION_ID[UPDATER_MISSION_ID] = UPDATER_MISSION_VERSION
					end
					
				end
		
			end
			
			-- Ok a prsent on regarde la liste de mission deleted
			-- voir si c'est utile
			
			
			
			-- Jusqu'ici on a dtect 	- les mission que l'annonceur  dans une version plus rcente
			--				- les missions que l'annonceur  et qu'on ne connait pas
			-- A chaque fois que l'on avait la meme mission ou qu'il avait une version plus rcente, j'ai enlev la mission de RME_HAVE_MISSION_ID
			-- il n'y reste donc plus que celle qu'il n'a pas 
			-- On met en forme notre rponse (et on en profite avant pour nous annoncer)
			local MESSAGE =	{ 
				Type 				= 	"UPDATE_ANSWER"; 
				Version 				= 	RME_VERSION_NUMBER; 
				NeedMissionID			= 	RME_NEED_MISSION_ID; 
				HaveMissionID			= 	RME_HAVE_MISSION_ID;  
			}
			
			-- On met aussi a jour nos infos
			RME_COMM_ADDON_USERS_LIST[RME_PLAYER_INFO.Name].Status			= 	"UPDATE_ANSWERED";
			RME_COMM_ADDON_USERS_LIST[RME_PLAYER_INFO.Name].LastPing		=	time();
			if Telepathy.GlobalCommMemberList[sender] then
				Telepathy.sendTable(RME_COMM_ADDON_GUID,MESSAGE,'WHISPER',sender,'NORMAL');
			end
			
			RME_DebugMsg("RME_Comm_SEND_UPDATE_ANSWER("..tostring(msg)..","..tostring(sender)..") DONE !",4);
		end

		--[[RME_Comm_READ_UPDATE_ANSWER]]--
		function RME_Comm_READ_UPDATE_ANSWER(msg,sender)
			-- Cette fonction rcupere les rponses de l'annonce qu'envoie les sender
			-- Une fois que tout le monde aura renvoy sa rponse (rponses traites par cette fonction) on aura un bilan complet de l'etat des missions

			RME_DebugMsg("RME_Comm_READ_UPDATE_ANSWER("..tostring(msg)..","..tostring(sender)..")",4);

			-- il ne reste plus maintenant qu'a traiter la rponse proprement dite contenue dans msg.NeedMissionID	& msg.HaveMissionID
			-- on placera dans RME_COMM_RESULT_NEED_MISSION et RME_COMM_RESULT_HAVE_MISSION les ID des missions ainsi que le nom des senders ayant cette mission ou la demandant

			RME_DebugMsg(tostring(sender).." est  la version "..msg.Version,1);
			RME_DebugMsg(tostring(sender).." a besoin de mes missions "..Sea.string.objectToString(msg.NeedMissionID),2);
			RME_DebugMsg("Je need ses missions "..Sea.string.objectToString(msg.HaveMissionID),3);


			--[[RME_COMM_RESULT_NEED_MISSION]]--
			-- On place dans RME_COMM_RESULT_NEED_MISSION le nom de la personne demandant de msg.NeedMissionID
			local LOCAL_MISSION_ID, LOCAL_MISSION_VERSION
			for LOCAL_MISSION_ID,LOCAL_MISSION_VERSION in pairs(msg.NeedMissionID) do 
				
				--Est ce que cette mission est diffusable  ?
				if not RME_MISSIONS_LIST[LOCAL_MISSION_ID].Guild or (RME_MISSIONS_LIST[LOCAL_MISSION_ID].Guild and RME_COMM_ADDON_USERS_LIST[sender] and (RME_COMM_ADDON_USERS_LIST[sender].Guild == RME_MISSIONS_LIST[LOCAL_MISSION_ID].Guild)) then
				
					-- Est ce que celui qui me demande la mission a une version suffisante ?
					if RME_COMM_ADDON_USERS_LIST[sender].Version >= (RME_MISSIONS_LIST[LOCAL_MISSION_ID].RMEVersion)  then

						if not RME_COMM_RESULT_NEED_MISSION[LOCAL_MISSION_ID] then
							RME_COMM_RESULT_NEED_MISSION[LOCAL_MISSION_ID] = {}
						end
				
						-- On rajoute le nom de l'utilisateur dans l'id de la mission, cela permet d'avoir la liste des joueurs interess par cette mission 
						RME_DebugMsg("RME_Comm_READ_UPDATE_ANSWER() "..tostring(sender).." est intress par la mission "..tostring(RME_MISSIONS_LIST[LOCAL_MISSION_ID].Title),4);
						table.insert(RME_COMM_RESULT_NEED_MISSION[LOCAL_MISSION_ID],table.getn(RME_COMM_RESULT_NEED_MISSION[LOCAL_MISSION_ID])+1,sender)
					end
					
				end
			end
			
			--[[RME_COMM_RESULT_HAVE_MISSION]]--
			-- On place dans RME_COMM_RESULT_HAVE_MISSION le nom de la personne pouvant me fournir la mission msg.HaveMissionID
			local LOCAL_MISSION_ID, LOCAL_MISSION_VERSION
			for LOCAL_MISSION_ID,LOCAL_MISSION_VERSION in pairs(msg.HaveMissionID) do 
				
				-- On regarde si cette mission que nous propose sender n'est pas dja connu chez nous mais non annonc (car passe prive)
				if RME_MISSIONS_LIST[LOCAL_MISSION_ID] and RME_MISSIONS_LIST[LOCAL_MISSION_ID].Version >= LOCAL_MISSION_VERSION then
					--sender a une mission flag publique alors qu'elle est maintenant private ! on lui envoie la derniere version

					-- On rajoute le nom de l'utilisateur dans l'id de la mission, cela permet d'avoir la liste des joueurs interess par cette mission
					if not RME_MISSIONS_LIST[LOCAL_MISSION_ID].IsDeleted then

						if not RME_COMM_RESULT_NEED_MISSION[LOCAL_MISSION_ID] then
							RME_COMM_RESULT_NEED_MISSION[LOCAL_MISSION_ID] = {}
						end
					
						RME_DebugMsg("RME_Comm_READ_UPDATE_ANSWER() "..tostring(sender).." nous proposait une mission publique qui est maintenant prive ("..tostring(RME_MISSIONS_LIST[LOCAL_MISSION_ID].Title)..")",4);
						table.insert(RME_COMM_RESULT_NEED_MISSION[LOCAL_MISSION_ID],table.getn(RME_COMM_RESULT_NEED_MISSION[LOCAL_MISSION_ID])+1,sender)
					end
					
				else 
				
					if not RME_COMM_RESULT_HAVE_MISSION[LOCAL_MISSION_ID] then
						RME_COMM_RESULT_HAVE_MISSION[LOCAL_MISSION_ID] = {}
					end
					-- On rajoute le nom de l'utilisateur dans l'id de la mission, cela permet d'avoir la liste des joueurs pouvant me fournir cette mission
					RME_DebugMsg("RME_Comm_READ_UPDATE_ANSWER() Je suis intress par la mission "..tostring(LOCAL_MISSION_ID).." qu' "..tostring(sender),4);
					table.insert(RME_COMM_RESULT_HAVE_MISSION[LOCAL_MISSION_ID],table.getn(RME_COMM_RESULT_HAVE_MISSION[LOCAL_MISSION_ID])+1,sender)
					
				end
			end
			
			-- Maintenant on attend le Bilan de l'annonce
			RME_PanelFrame_General_UpdateMissionInformations:SetText(format(RME_LOCALE["RME_LOCALE_COMM_MISSION_RECEIVE_ANSWER"].text,sender))
			
			if RME_NOTIFY_UPDATE_MSG then
				RME_DisplayMessage(format(RME_LOCALE["RME_LOCALE_COMM_MISSION_RECEIVE_ANSWER"].text,sender))
			end
			RME_DebugMsg("RME_Comm_READ_UPDATE_ANSWER("..tostring(msg)..","..tostring(sender)..") DONE !",4);
			
		end

		--[[ RME_Comm_UPDATE_RESULT]]--
		function RME_Comm_UPDATE_RESULT()
			-- Cette fonction fait un bilan des rponses  l'annonce et lance une demande et/ou un envoi a chaque excution jusqu'a puisement des demande/envoie

			-- On en deduit une liste d'action en fonction de RME_COMM_RESULT_NEED_MISSION & RME_COMM_RESULT_HAVE_MISSION
				-- Demande de partage de x missions a x joueurs (bas sur la liste de noms disposant ce cette mission et tir alatoirement pour viter que a soit la meme personne qui partage tout)
				-- Partage des missions dont on dispose aux joueurs en ayant fait la demande. (Si il y a plus d'un joueur demandant cette mission on la diffusera en global, sinon en WHISPER)
			RME_DebugMsg("RME_Comm_UPDATE_RESULT()",4);
			
			if RME_getn(RME_COMM_RESULT_HAVE_MISSION) + RME_getn(RME_COMM_RESULT_NEED_MISSION) > 0 then
				RME_EventManager_AddEvent("UPDATE_RESULT",3,"RME_Comm_UPDATE_RESULT()",true)
				RME_PanelFrame_General_UpdateMissionInformations:SetText(format(RME_LOCALE["RME_LOCALE_COMM_UPDATE_RESULT"].text,RME_getn(RME_COMM_RESULT_HAVE_MISSION),RME_getn(RME_COMM_RESULT_NEED_MISSION)))				
			end
			
			--Cette fonction est lance toute les 3 secondes tant que RME_COMM_RESULT_NEED_MISSION et RME_COMM_RESULT_HAVE_MISSION ne sont pas vide
		
			local LOCAL_MISSION_ID, LOCAL_USER_LIST
			for LOCAL_MISSION_ID,LOCAL_USER_LIST in pairs(RME_COMM_RESULT_NEED_MISSION) do 	
				
				if RME_MISSIONS_LIST[LOCAL_MISSION_ID].Guild then -- Mission flagg guild, on ne la diffuse que via le chan (addon) guilde 
					
					RME_EventManager_AddEvent("SHARE_MISSION_NEED_"..LOCAL_MISSION_ID.."_"..tostring(#LOCAL_USER_LIST),RME_Comm_ReturnWaitTimer(),"RME_Comm_SHARE_MISSION('"..LOCAL_MISSION_ID.."','GUILD')",true)
					RME_COMM_RESULT_NEED_MISSION[LOCAL_MISSION_ID] = nil
					return
					
				elseif #LOCAL_USER_LIST > 0 then -- On diffuse le reste des missions aux autres en WHISPER (tant donn le l'encodate utf-8 bug si je le diffuse via le chan global :'( )
					
					RME_DebugMsg(tostring(#LOCAL_USER_LIST).." joueur(s) demande la mission "..tostring(RME_MISSIONS_LIST[LOCAL_MISSION_ID].Title),4);		
					RME_EventManager_AddEvent("SHARE_MISSION_NEED_"..LOCAL_MISSION_ID.."_"..tostring(#LOCAL_USER_LIST),RME_Comm_ReturnWaitTimer(),"RME_Comm_SHARE_MISSION('"..LOCAL_MISSION_ID.."','WHISPER','"..tostring(LOCAL_USER_LIST[1]).."')",true)
					table.remove(RME_COMM_RESULT_NEED_MISSION[LOCAL_MISSION_ID],1)										
					if #LOCAL_USER_LIST == 0 then -- On vient de supprimer le dernier joueur
						RME_COMM_RESULT_NEED_MISSION[LOCAL_MISSION_ID] = nil
					end					
					return
					
				else
					RME_COMM_RESULT_NEED_MISSION[LOCAL_MISSION_ID] = nil
					return
				end
				
			end
			
			for LOCAL_MISSION_ID,LOCAL_USER_LIST in pairs(RME_COMM_RESULT_HAVE_MISSION) do 		
				RME_DebugMsg(tostring(#LOCAL_USER_LIST).." joueur(s) a une mission (ID "..tostring(LOCAL_MISSION_ID)..") qui m'interesse.",4);		
					
				local user_selected = math.random(1,#LOCAL_USER_LIST)
				RME_DebugMsg("user_selected="..tostring(user_selected),4);	
				RME_EventManager_AddEvent("ASK_MISSION"..LOCAL_MISSION_ID.."_"..tostring(#LOCAL_USER_LIST),RME_Comm_ReturnWaitTimer(),"RME_Comm_ASK_MISSION('"..LOCAL_MISSION_ID.."','"..tostring(LOCAL_USER_LIST[user_selected]).."')",true)
				RME_COMM_RESULT_HAVE_MISSION[LOCAL_MISSION_ID] = nil
				return
				
			end
			
			RME_DisplayMessage(RME_LOCALE["RME_LOCALE_COMM_ASK_FOR_MISSIONS_UPDATE_DONE"].text)
			RME_PanelFrame_General_UpdateMissionInformations:SetText(RME_LOCALE["RME_LOCALE_COMM_ASK_FOR_MISSIONS_UPDATE_DONE"].text)
			RME_COMM_ADDON_USERS_LIST[RME_PLAYER_INFO.Name].Status = "IDLE"
			RME_NOTIFY_UPDATE_MSG = nil
			RME_PanelFrame_General_UpdateMissions:Enable()
			RME_DebugMsg("RME_Comm_UPDATE_RESULT() DONE !",4);
		end
		-- MISSION --
		--[[ RME_Comm_SHARE_MISSION ]] --
		function RME_Comm_SHARE_MISSION(MissionID,method,target)
		-- On envoie une mission
			-- MissionID - Mission partage
			-- method - "PARTY", "GUILD", "WHISPER" 		("GLOBAL" annul)
			-- Le "RAID" sera automatiquement detect (on met party par defaut)
			--		target - player name for "WHISPER" target (Optional)
		
			RME_DebugMsg("RME_Comm_SHARE_MISSION("..tostring(MissionID)..","..tostring(method)..","..tostring(target)..")",4);
			
			-- On regarde si la methode et la target sont ok
			-- Methode GLOBAL annul pour la diffusion des missions suite au souci UTF-8
			-- > lorsque l'on dcoupe la mission en moreau il arrive parfois qu'un caractre particulier (les accents notamment) se retrouve dcoup en deux.
			-- > exemple: "" qui en utf-8 est egal  "\195\169". Il suffit que l'on coupe ce code en deux pour que cela gnre une erreur.
			--> les autres modes ne sont pas impact par ce souci, seul Global  ce souci.
			
			if (method == "GLOBAL" and method ~= "PARTY" and method ~= "GUILD" and method ~= "WHISPER") then
				RME_DebugMsg("RME_Comm_SHARE_MISSION("..tostring(MissionID)..","..tostring(method)..","..tostring(target)..") Methode incorrecte...",1);
				return
			end
			if (method == "WHISPER" and not target) then
				RME_DebugMsg("RME_Comm_SHARE_MISSION("..tostring(MissionID)..","..tostring(method)..","..tostring(target)..") Pas de cible vers lequel partager la mission...",1);
				return
			end
			-- Inutile d'avoir un target si on ne fait pas un WHISPER
			if (method ~= "WHISPER" and target) then
				target = nil
			end

			--On regarde si on est dans une party ou un raid
			if GetNumRaidMembers() > 0 and method == "PARTY" then
				method = "RAID"
			end			

			-- D'abord on regarde si on connait cette mission
			if not RME_MISSIONS_LIST[MissionID] or RME_MISSIONS_LIST[MissionID].ID ~= MissionID then
				-- On partage une mission qu'on a pas ! oO
				RME_DebugMsg("RME_Comm_SHARE_MISSION("..tostring(MissionID)..","..tostring(method)..","..tostring(target)..") Mission inconnu",4);
				if RME_NOTIFY_UPDATE_MSG then
					RME_PlayerNotify(RME_LOCALE["RME_LOCALE_COMM_CANT_SHARE_MISSION_UNKNOWN_MISSION_ID"].text,0)
				end
				return
			end
			
			-- On regarde si le demandeur a une version de RME suprieure ou gale  celle qui a cr la mission --RME_MISSIONS_LIST[MissionID].RMEVersion
			if target and (RME_COMM_ADDON_USERS_LIST[target].Version < 134 ) then
				RME_DebugMsg(format(RME_LOCALE["RME_LOCALE_COMM_CANT_SHARE_MISSION_BAD_VERSION"].text,target,RME_MISSIONS_LIST[MissionID].RMEVersion),1);
				--on n'affiche pas ce message si il apparait pendant la mise a jour automatique
				if RME_COMM_ADDON_USERS_LIST[RME_PLAYER_INFO.Name].Status ~= "WAIT_UPDATE_ANSWER" then
					RME_PlayerNotify(format(RME_LOCALE["RME_LOCALE_COMM_CANT_SHARE_MISSION_BAD_VERSION"].text,target,RME_MISSIONS_LIST[MissionID].RMEVersion),0)
				end
				return
			end
			
			-- On regarde si la faction correspond
			if RME_MISSIONS_LIST[MissionID].Faction and RME_MISSIONS_LIST[MissionID].Faction ~= RME_PLAYER_INFO.Faction then
				RME_DebugMsg("Mauvaise faction, on ne diffuse pas une mission cre pour la faction oppose",1);
				return
			end
			
			-- On cre le message (qui risque d'etre gros)
			local LOCAL_MISSION = RME_MISSIONS_LIST[MissionID]
			local temp_ignore = LOCAL_MISSION.IsIgnore
			LOCAL_MISSION.IsIgnore = nil -- on enleve l'ignore si on l'avait mis (info propre a chaque joueur)
			
			local MESSAGE =	{ 
				Type 			= 	"SHARE_MISSION"; 
				Version 			= 	RME_VERSION_NUMBER;
				Mission_ID		=	LOCAL_MISSION.ID;
				Mission_Version	=	LOCAL_MISSION.Version;
				Mission_Data		=	LOCAL_MISSION;
			}
			
			-- On envoie le message
			if method ~= "WHISPER" or (method == "WHISPER" and Telepathy.GlobalCommMemberList[target]) then
				Telepathy.sendTable(RME_COMM_ADDON_GUID, MESSAGE, method, target, "NORMAL")
			end
			
			-- On remet l'ignore 
			LOCAL_MISSION.IsIgnore = temp_ignore -- on remet l'info ignore choisi par l'user
			
			-- On informe le joueur
			if RME_NOTIFY_UPDATE_MSG then
				RME_DisplayMessage(format(RME_LOCALE["RME_LOCALE_COMM_MISSION_SHARE"].text,RME_MISSIONS_LIST[MissionID].Title))
			end
			RME_DebugMsg("RME_Comm_SHARE_MISSION("..tostring(MissionID)..","..tostring(method)..","..tostring(target)..") DONE !",4);
			
		end

		--[[ RME_Comm_RECEIVE_MISSION ]] --
		function RME_Comm_RECEIVE_MISSION(msg,sender)
			-- On reoit une mission
			RME_DebugMsg("RME_Comm_RECEIVE_MISSION("..tostring(msg)..","..tostring(sender)..")",4);

			local LOCAL_MISSION = RME_CLASS_MISSION(msg.Mission_ID)
			LOCAL_MISSION:Load(msg.Mission_Data)
			
			-- on regarde si l'utilisateur de cette mission peut lancer la mission.
			-- Il faut qu'il ait une version egale ou suprieur a sa version de RME
			if LOCAL_MISSION.RMEVersion > RME_VERSION_NUMBER then
				RME_PlayerNotify(format(RME_LOCALE["RME_LOCALE_COMM_CANT_SHARE_MISSION_BAD_VERSION_YOURSELF"].text,LOCAL_MISSION.Title,RME_MISSIONS_LIST[MissionID].RMEVersion),0)
				return
			end			
			
			-- on regarde quel type de mise a jour on vient de recevoir
			if RME_MISSIONS_LIST[msg.Mission_ID] then
				-- Ok on connait cette mission... mais avons nous la mme version ?
				if RME_MISSIONS_LIST[msg.Mission_ID].Version == msg.Mission_Version or RME_MISSIONS_LIST[msg.Mission_ID].Version >  msg.Mission_Version then
					-- On dispose d'une mission plus rcente, on ignore ce message qui devait etre diffus en global pour quelqu'un d'autre
					RME_DebugMsg("RME_Comm_RECEIVE_MISSION("..tostring(msg)..","..tostring(sender)..") On a une version plus rcente ou gale",4);
					-- On regarde si cette mission ne serait pas annul
					if RME_MISSIONS_LIST[msg.Mission_ID].IsDeleted and sender ~= RME_PLAYER_INFO.Name then 
						-- le sender nous a envoy la mission avant suppression. 
						-- Comme les missions supprime ne sont plus prsent dans notre demande de maj, le sender nous l'a propos.
						-- On va lui rpondre donc que cette mission est supprime en lui envoyant notre version
						RME_Comm_SHARE_MISSION(msg.Mission_ID,"WHISPER",sender)
					end
					return
				else
					-- Version plus ancienne, on va prendre en compte cette mission
					RME_DisplayMessage(format(RME_LOCALE["RME_LOCALE_COMM_UPDATE_MISSION"].text,LOCAL_MISSION.Title))
				end
			else
				-- Mission inconnue, on prend en compte cette nouvelle mission
				RME_DisplayMessage(format(RME_LOCALE["RME_LOCALE_COMM_NEW_MISSION"].text,LOCAL_MISSION.Title))
			end
			
			-- On place cette mission dans la liste globale
			RME_MISSIONS_LIST[LOCAL_MISSION.ID] = LOCAL_MISSION
			
			-- On regarde la mission venant d'etre partage: 
				-- Si il est fait mention d'une autre mission en pre-requis on vrifie si on l'a ..
				if LOCAL_MISSION.NeedMissionID and not RME_MISSIONS_LIST[LOCAL_MISSION.NeedMissionID] then
					-- On en fait la demande
					RME_Comm_ASK_MISSION(LOCAL_MISSION.NeedMissionID,sender)
				end
				-- Idem si il est fait mention d'une mission lance a la fin
				if LOCAL_MISSION.LaunchMissionID and not RME_MISSIONS_LIST[LOCAL_MISSION.LaunchMissionID] then
					-- On en fait la demande
					RME_Comm_ASK_MISSION(LOCAL_MISSION.LaunchMissionID,sender)
				end
			
			-- On check si cet id n'tait pas dja en cours chez nous (dans ce cas il est prfrable d'annuler la mission puis de la reprendre
			if RME_IN_PROGRESS_MISSIONS_LIST[LOCAL_MISSION.ID] then
				-- Mission en cours, on avertit le joueur. 
				-- La mission qu'il a actuellement n'est pas modifi par cette mise  jour car lorsqu'on prend une mission on fait une copie complete de donnes de la mission
				RME_DisplayMessage(format(RME_LOCALE["RME_LOCALE_COMM_UPDATE_MISSION_ACTIVATED"].text))
			
			elseif RME_COMPLETED_MISSIONS_LIST[LOCAL_MISSION.ID] then
				-- Mission en cours, on avertit le joueur. 
				-- On avertit le joueur pour info (et encore... est ce utile...)
				if RME_NOTIFY_UPDATE_MSG and not LOCAL_MISSION.IsDeleted then
					RME_DisplayMessage(format(RME_LOCALE["RME_LOCALE_COMM_UPDATE_MISSION_FINISH"].text))
				end

			end
			
			-- On rafraichi nos donnes
			RME_MISSION_NEEDUPDATE = true
			RME_Mega_Update(true)
			
			-- On active les objets li  cette mission (ceux qui ont un MISSION & Mission_LaunchID)
			-- Pour a on fait un coup de mise a jour des objets (on vrifie que tout est ok)
			RME_Bag_CheckItemRelationship()

			-- Si cette mission tait attendu on l'affiche
			if RME_PLAYER_WAIT_MISSIONID[LOCAL_MISSION.ID] and RME_PLAYER_WAIT_MISSIONID[LOCAL_MISSION.ID] == "WAIT_MISSION" then
				RME_PLAYER_WAIT_MISSIONID[LOCAL_MISSION.ID] = nil
				RME_QuestFrame_ShowMissionDetails(LOCAL_MISSION.ID)
			end
			
			-- On signale qu'on a bien reu la mission (utilis pour le moment pour debug)
			RME_Comm_SEND_PUSH_MISSION_ANSWER("SHARE_MISSION_RECEIVED",sender,LOCAL_MISSION.ID)
			
			
			RME_DebugMsg("RME_Comm_RECEIVE_MISSION("..tostring(msg)..","..tostring(sender)..") DONE !",4);
		end

		--[[ RME_Comm_ASK_MISSION ]] --
		function RME_Comm_ASK_MISSION(ID_MISSION,owner)
			-- On demande une mission a quelqu'un
			RME_DebugMsg("RME_Comm_ASK_MISSION("..tostring(ID_MISSION)..","..tostring(owner)..")",4);
			
			-- On vrifie si on connait l'owner
			if not RME_COMM_ADDON_USERS_LIST[owner] then
				-- Inconnu au bataillon ! on annule 
				RME_DebugMsg("RME_Comm_ASK_MISSION("..tostring(ID_MISSION)..","..tostring(owner)..") Owner de la mission inconnu, il a peut etre dco",4);
				return
			end

			-- On cre le message
			local MESSAGE =	{ 
				Type 			= 	"ASK_MISSION"; 
				Version 			= 	RME_VERSION_NUMBER;
				Mission_ID		=	ID_MISSION;
			}
			
			-- On envoie le message
			if Telepathy.GlobalCommMemberList[owner] then
				Telepathy.sendTable(RME_COMM_ADDON_GUID, MESSAGE, "WHISPER", owner, "NORMAL")
			end
			
			-- On informe le joueur
			if RME_NOTIFY_UPDATE_MSG then
				RME_DisplayMessage(format(RME_LOCALE["RME_LOCALE_COMM_ASK_FOR_SHARING_MISSION_2"].text,tostring(owner)))
			end
			RME_DebugMsg("RME_Comm_ASK_MISSION("..tostring(ID_MISSION)..","..tostring(owner)..") DONE !",4);
		end

		--[[ RME_Comm_RECEIVE_ASK_MISSION ]]
		function RME_Comm_RECEIVE_ASK_MISSION(msg,sender)
			-- On vient de recevoir une demande de partage
			RME_DebugMsg("RME_Comm_RECEIVE_ASK_MISSION("..tostring(msg)..","..tostring(sender)..")",4);
				
			-- On regarde si on connait cette mission 
			if not RME_MISSIONS_LIST[msg.Mission_ID] then
				RME_DebugMsg("RME_Comm_RECEIVE_ASK_MISSION("..tostring(msg)..","..tostring(sender)..") nous demande une mission que l'on a pas !",1);
				return
			end
		
			-- On informe le joueur de la demande de partage
			if RME_NOTIFY_UPDATE_MSG then
				RME_DisplayMessage(format(RME_LOCALE["RME_LOCALE_COMM_ASK_FOR_SHARING_MISSION"].text,sender,RME_MISSIONS_LIST[msg.Mission_ID].Title))
			end
			
			-- Ok on connait cette mission, on la partage
			RME_Comm_SHARE_MISSION(msg.Mission_ID,"WHISPER",sender)
			
		end
		--[[ RME_Comm_PUSH_MISSION ]]
		function RME_Comm_PUSH_MISSION(MissionID,method,target)
			RME_DebugMsg("RME_Comm_PUSH_MISSION("..tostring(MissionID)..","..tostring(method)..","..tostring(target)..")",4);
				
			-- On regarde si la methode et la target sont ok
			if (method ~= "PARTY" and method ~= "GUILD" and method ~= "WHISPER") then
				RME_DebugMsg("RME_Comm_PUSH_MISSION("..tostring(MissionID)..","..tostring(method)..","..tostring(target)..") Methode incorrecte...",1);
				return
			end
			if (method == "WHISPER" and not target) then
				RME_DebugMsg("RME_Comm_PUSH_MISSION("..tostring(MissionID)..","..tostring(method)..","..tostring(target)..") Pas de cible vers lequel partager la mission...",1);
				return
			end

			--On regarde si on est dans une party ou un raid
			if GetNumRaidMembers() > 0 and method == "PARTY" then
				method = "RAID"
			end			
			
			-- On vrifie si on a la mission MissionID
			if not RME_MISSIONS_LIST[MissionID] or RME_MISSIONS_LIST[MissionID].ID ~= MissionID then
				-- On partage une mission qu'on a pas ! oO
				RME_DebugMsg("RME_Comm_PUSH_MISSION("..tostring(MissionID)..","..tostring(method)..","..tostring(target)..")",4);
				if RME_NOTIFY_UPDATE_MSG then
					RME_PlayerNotify(RME_LOCALE["RME_LOCALE_COMM_CANT_SHARE_MISSION_UNKNOWN_MISSION_ID"].text,0)
				end
				return
			end
					
			-- on lance l'affichage de la mission chez les users
			-- On cre le message
			local MESSAGE =	{ 
				Type 			= 	"PUSH_MISSION"; 
				Version 			= 	RME_VERSION_NUMBER;
				Mission_ID		=	RME_MISSIONS_LIST[MissionID].ID;
			}
			
			-- On envoie le message
			if method ~= "WHISPER" or (method == "WHISPER" and Telepathy.GlobalCommMemberList[target]) then			
				Telepathy.sendTable(RME_COMM_ADDON_GUID, MESSAGE, method, target, "NORMAL")
			end
			
			-- On informe le joueur
			RME_DisplayMessage(format(RME_LOCALE["RME_LOCALE_COMM_MISSION_SHARE"].text,RME_MISSIONS_LIST[MissionID].Title))
			RME_DebugMsg("RME_Comm_PUSH_MISSION("..tostring(MissionID)..","..tostring(method)..","..tostring(target)..") DONE !",4);

		end
		--[[ RME_Comm_RECEIVE_PUSH_MISSION ]]
		function RME_Comm_RECEIVE_PUSH_MISSION(msg,sender)
			-- On reoit une mission
			RME_DebugMsg("RME_Comm_RECEIVE_PUSH_MISSION("..tostring(msg)..","..tostring(sender)..")",4);

			if RME_COMPLETED_MISSIONS_LIST[msg.Mission_ID] then
				-- Deja termine
				RME_Comm_SEND_PUSH_MISSION_ANSWER("ALREADY_DONE",sender,msg.Mission_ID)
				
			elseif  RME_IN_PROGRESS_MISSIONS_LIST[msg.Mission_ID] then
				-- Dja sur la mission
				RME_Comm_SEND_PUSH_MISSION_ANSWER("ALREADY_ACTIVE",sender,msg.Mission_ID)
				
			elseif RME_MISSIONS_LIST[msg.Mission_ID] then
				-- On la propose
				RME_QuestFrame_ShowMissionDetails(msg.Mission_ID)
				RME_Comm_SEND_PUSH_MISSION_ANSWER("SHARE_MISSION",sender,msg.Mission_ID)
				
			else  -- On ne connait pas cette mission
				RME_Comm_ASK_MISSION(msg.Mission_ID,sender) -- on demande directement au joueur ayant la mission
				RME_PlayerNotify(RME_LOCALE["RME_LOCALE_COMM_WAIT_MISSION_DATA"].text,0.5)					
				RME_PLAYER_WAIT_MISSIONID[msg.Mission_ID] = "WAIT_MISSION"
				RME_Comm_SEND_PUSH_MISSION_ANSWER("DOWNLOAD_MISSION",sender,msg.Mission_ID)
			end
			
			RME_DebugMsg("RME_Comm_RECEIVE_PUSH_MISSION("..tostring(msg)..","..tostring(sender)..") DONE !",4);

		end
		
		--[[ RME_Comm_SEND_PUSH_MISSION_ANSWER ]]
		function RME_Comm_SEND_PUSH_MISSION_ANSWER(reponse,target,ID_MISSION)
			RME_DebugMsg("RME_Comm_SEND_PUSH_MISSION_ANSWER("..tostring(reponse)..","..tostring(target)..")",4);
		
			local MESSAGE =	{ 
				Type 			= 	"PUSH_MISSION_ANSWER"; 
				Version 		= 	RME_VERSION_NUMBER;
				Mission_ID		=	ID_MISSION;
				Answer			=	reponse
			}
			
			-- envoie du message
			if Telepathy.GlobalCommMemberList[target] then			
				Telepathy.sendTable(RME_COMM_ADDON_GUID,MESSAGE,'WHISPER',target,'NORMAL');
			end
			
			RME_DebugMsg("RME_Comm_SEND_PUSH_MISSION_ANSWER("..tostring(reponse)..","..tostring(target)..") DONE !",4);
			
		end
		
		
		--[[ RME_Comm_RECEIVE_PUSH_MISSION_ANSWER ]]
		function RME_Comm_RECEIVE_PUSH_MISSION_ANSWER(msg,sender)
			RME_DebugMsg("RME_Comm_RECEIVE_PUSH_MISSION_ANSWER("..tostring(msg)..","..tostring(sender)..")",4);
			
			if msg.Answer == "ALREADY_DONE" then
				RME_DisplayMessage(format(RME_LOCALE["RME_LOCALE_COMM_PUSH_MISSION_ANSWER_ALREADY_DONE"].text,sender,RME_MISSIONS_LIST[msg.Mission_ID]))
				
			elseif msg.Answer == "ALREADY_ACTIVE" then
				RME_DisplayMessage(format(RME_LOCALE["RME_LOCALE_COMM_PUSH_MISSION_ANSWER_ALREADY_ACTIVE"].text,sender,RME_MISSIONS_LIST[msg.Mission_ID]))

			elseif msg.Answer == "SHARE_MISSION" then
				RME_DisplayMessage(format(RME_LOCALE["RME_LOCALE_COMM_PUSH_MISSION_ANSWER_SHARE_MISSION"].text,RME_MISSIONS_LIST[msg.Mission_ID],sender))

			elseif msg.Answer == "DOWNLOAD_MISSION" then
				RME_DisplayMessage(format(RME_LOCALE["RME_LOCALE_COMM_PUSH_MISSION_ANSWER_DOWNLOAD_MISSION"].text,sender,RME_MISSIONS_LIST[msg.Mission_ID]))
				
			elseif msg.Answer == "SHARE_MISSION_RECEIVED" then
				RME_DebugMsg(tostring(sender).." a bien reu la mission "..tostring(RME_MISSIONS_LIST[msg.Mission_ID]),3);			
				
			else
				RME_DebugMsg("RME_Comm_RECEIVE_PUSH_MISSION_ANSWER("..tostring(msg)..","..tostring(sender)..") Unknow answer ("..tostring(msg.Answer)..") !",4);			
			end

			RME_DebugMsg("RME_Comm_RECEIVE_PUSH_MISSION_ANSWER("..tostring(msg)..","..tostring(sender)..") DONE !",4);
		end
		
		
		--[[ RME_Comm_SEND_MISSION_FINISH_INFORMATION ]]
		function RME_Comm_SEND_MISSION_INFORMATION(target,ID_MISSION,Information)
			RME_DebugMsg("RME_Comm_SEND_PUSH_MISSION_ANSWER("..tostring(target)..","..tostring(ID_MISSION)..")",4);
		
			local MESSAGE =	{ 
				Type 			= 	"MISSION_INFORMATIONS"; 
				Version 			= 	RME_VERSION_NUMBER;
				Mission_ID		=	ID_MISSION;
				Information		=	Information; --Take_Mission|Mission_Completed|Mission_Failed|Mission_Succes|Mission_Cancel
			}

			-- envoie du message
			if Telepathy.GlobalCommMemberList[target] then
				Telepathy.sendTable(RME_COMM_ADDON_GUID,MESSAGE,'WHISPER',target,'NORMAL');
			end
			
			RME_DebugMsg("RME_Comm_SEND_PUSH_MISSION_ANSWER("..tostring(target)..","..tostring(ID_MISSION)..") DONE !",4);
			
		end		

		--[[ RME_Comm_RECEIVE_MISSION_FINISH_INFORMATION ]]		
		function RME_Comm_RECEIVE_MISSION_INFORMATION(msg,sender)
			-- On ajoute les objets demand en objectifs de mission dans le sac
			RME_DebugMsg("RME_Comm_RECEIVE_MISSION_INFORMATION("..tostring(msg)..","..tostring(sender)..")",4);
			
			-- D'abord on regarde si cette mission est connu
			if not  RME_MISSIONS_LIST[msg.Mission_ID] then
				return
			end
			-- Ok on charge la mission
			local LOCAL_MISSION = RME_MISSIONS_LIST[msg.Mission_ID]

			if msg.Information == "Take_Mission" then -- Mission termine
			
				-- On avertit le joueur que quelqu'un vient de prendre une mission
				RME_DisplayMessage(format(RME_LOCALE["RME_LOCALE_QUEST_START"].text,sender,LOCAL_MISSION.Title))	
				PlaySound("HumanExploration")
				RME_DebugMsg("RME_Comm_RECEIVE_MISSION_INFORMATION("..tostring(msg)..","..tostring(sender)..") Mission "..tostring(msg.Mission_ID),2);
				return
				
			elseif msg.Information == "Mission_Completed" then
				-- Mission termine
				local LOCAL_OBJECTIVE, LOCAL_ITEM
				for i = 1, table.getn(LOCAL_MISSION.MissionObjectives) do
					LOCAL_OBJECTIVE = LOCAL_MISSION.MissionObjectives[i]
					if LOCAL_OBJECTIVE.ObjectiveType == "NEED_ITEM" then
						LOCAL_ITEM = LOCAL_MISSION.MissionItemsList[LOCAL_OBJECTIVE.Need_Item_ItemNeeded]
						if LOCAL_ITEM then -- On rajoute les objets qu'on a retir du sac
							RME_AddInBag(LOCAL_ITEM,LOCAL_OBJECTIVE.Need_Item_QuantityNeeded)							
						end
					end
				end
				-- On avertit le joueur du pourquoi il reoit des objets dans son sac ^^
				RME_DisplayMessage(format(RME_LOCALE["RME_LOCALE_QUEST_FINISH"].text,sender,LOCAL_MISSION.Title))	
				PlaySound("HumanExploration")
				RME_DebugMsg("RME_Comm_RECEIVE_MISSION_INFORMATION("..tostring(msg)..","..tostring(sender)..") Mission "..tostring(msg.Mission_ID),2);
				return
			
			elseif msg.Information == "Mission_Failed" then -- Mission echou
			
				-- On avertit le joueur que quelqu'un vient de prendre une mission
				RME_DisplayMessage(format(RME_LOCALE["RME_LOCALE_QUEST_FAILED"].text,sender,LOCAL_MISSION.Title))	
				PlaySound("HumanExploration")
				RME_DebugMsg("RME_Comm_RECEIVE_MISSION_INFORMATION("..tostring(msg)..","..tostring(sender)..") Mission "..tostring(msg.Mission_ID),2);
				return
				
			elseif msg.Information == "Mission_Cancel" then -- Mission annule/abandonne
			
				-- On avertit le joueur que quelqu'un vient de prendre une mission
				RME_DisplayMessage(format(RME_LOCALE["RME_LOCALE_QUEST_CANCEL"].text,sender,LOCAL_MISSION.Title))	
				PlaySound("HumanExploration")
				RME_DebugMsg("RME_Comm_RECEIVE_MISSION_INFORMATION("..tostring(msg)..","..tostring(sender)..") Mission "..tostring(msg.Mission_ID),2);
				return
				
			elseif msg.Information == "Mission_Succes" then -- Mission echou
			
				-- On avertit le joueur que quelqu'un vient de prendre une mission
				RME_DisplayMessage(format(RME_LOCALE["RME_LOCALE_QUEST_SUCCESS"].text,sender,LOCAL_MISSION.Title))	
				PlaySound("HumanExploration")
				RME_DebugMsg("RME_Comm_RECEIVE_MISSION_INFORMATION("..tostring(msg)..","..tostring(sender)..") Mission "..tostring(msg.Mission_ID),2);
				return
			end

			
		end		
		-- MISSION_EVENT --
		--[[ RME_Comm_PARTY_SEND_EVENT ]]--
		function RME_Comm_PARTY_SEND_EVENT(method,target,New_Event_Table)
			RME_DebugMsg("RME_Comm_PARTY_SEND_EVENT("..tostring(method)..","..tostring(target)..","..tostring(New_Event_Table)..")",4);
			
			-- On regarde si la methode et la target sont ok
			if (method ~= "GLOBAL" and method ~= "PARTY" and method ~= "GUILD" and method ~= "WHISPER") then
				RME_DebugMsg("RME_Comm_PARTY_SEND_EVENT("..tostring(method)..","..tostring(target)..","..tostring(New_Event_Table)..") Methode incorrecte...",1);
				return
			end
			if (method == "WHISPER" and not target) then
				RME_DebugMsg("RME_Comm_PARTY_SEND_EVENT("..tostring(method)..","..tostring(target)..","..tostring(New_Event_Table)..") Pas de cible vers lequel partager la mission...",1);
				return
			end
			-- Inutile d'avoir un target si on ne fait pas un WHISPER
			if (method ~= "WHISPER" and target) then
				target = nil
			end		
			--On regarde si on est dans une party ou un raid
			if GetNumRaidMembers() > 0 and method == "PARTY" then
				method = "RAID"
			end			

		
			-- On cre le message event destin a notre equipe/guilde/target
			local MESSAGE =	{ 
				Type 			= 	"PARTY_EVENT"; 
				Version 			= 	RME_VERSION_NUMBER; 
				Event_Table		=	New_Event_Table;
			}
			-- On envoie le message
			if method ~= "WHISPER" or (method == "WHISPER" and Telepathy.GlobalCommMemberList[target]) then			
				Telepathy.sendTable(RME_COMM_ADDON_GUID, MESSAGE, method, target, "ALERT")
			end

		end
		
		--[[ RME_Comm_PARTY_RECEIVE_EVENT ]]
		function RME_Comm_PARTY_RECEIVE_EVENT(msg,sender)
			--On reoit un event en provenance de notre equipe/guidle
			RME_DebugMsg("RME_Comm_PARTY_RECEIVE_EVENT("..tostring(msg)..","..tostring(sender)..")",4);
			
			-- On rcupere la table comprenant l'event
			local Event_Table = msg.Event_Table
			-- On en gnre l'event qu'on lance en local
			RME_Check_Mission_Event(Event_Table.event,Event_Table.arg1,Event_Table.arg2)		
			
			RME_DebugMsg("RME_Comm_PARTY_RECEIVE_EVENT("..tostring(msg)..","..tostring(sender)..") DONE !",4);
			
		end
		-- GM --
		--SET
		--[[ RME_Comm_SEND_GM_SET_MISSION_STATUS ]]--
		function RME_Comm_SEND_GM_SET_MISSION_STATUS(method,target,MissionID,Order)
			
			RME_DebugMsg("RME_Comm_SEND_GM_SET_MISSION_STATUS("..tostring(method)..","..tostring(target)..","..tostring(MissionID)..","..tostring(Order)..")",4);
				
			-- On regarde si la methode et la target sont ok
			if (method ~= "GLOBAL" and method ~= "PARTY" and method ~= "GUILD" and method ~= "WHISPER") then
				return
			end
			if (method == "WHISPER" and not target) then
				return
			end
			if (method ~= "WHISPER" and target) then
				-- Inutile d'avoir un target si on ne fait pas un WHISPER
				target = nil
			end
			--On regarde si on est dans une party ou un raid
			if GetNumRaidMembers() > 0 and method == "PARTY" then
				method = "RAID"
			end			
			-- On cre le message
			local MESSAGE =	{ 
				Type 			= 	"GM_SET_MISSION_STATUS"; 
				Version 			= 	RME_VERSION_NUMBER;
				MissionID			=	MissionID;
				MissionVersion		=	RME_MISSIONS_LIST[MissionID].Version;
				Order			=	Order
			}		
			
			-- On envoie le message
			if method ~= "WHISPER" or (method == "WHISPER" and Telepathy.GlobalCommMemberList[target]) then						
				Telepathy.sendTable(RME_COMM_ADDON_GUID, MESSAGE, method, target, "NORMAL")
			end
		end
		
		--[[ RME_Comm_RECEIVE_GM_SET_MISSION_STATUS ]]--
		function RME_Comm_RECEIVE_GM_SET_MISSION_STATUS(msg,sender)

			RME_DebugMsg("RME_Comm_RECEIVE_GM_SET_MISSION_STATUS("..tostring(msg)..","..tostring(sender)..")",4);
			
			-- Pas mission ou pas bonne version > on demande
			if (not RME_MISSIONS_LIST[msg.MissionID] or RME_MISSIONS_LIST[msg.MissionID].Version ~= msg.MissionVersion) then
				RME_Comm_ASK_MISSION(msg.MissionID,sender)
				RME_DebugMsg("RME_Comm_RECEIVE_GM_SET_MISSION_STATUS("..tostring(msg)..","..tostring(sender)..") Pas mission ou bonne version",2);
				return
			end
			
			RME_DebugMsg("RME_Comm_RECEIVE_GM_SET_MISSION_STATUS "..tostring(RME_MISSIONS_LIST[msg.MissionID].Title).." msg.Order="..tostring(msg.Order),4);
			
			-- Le sender a t il le droit ?
			if not RME_Comm_SENDER_IS_LEADER(sender) then
				RME_DebugMsg("RME_Comm_RECEIVE_GM_GET_MISSION_STATUS("..tostring(msg)..","..tostring(sender)..") Action non permise !",1);
				return
			end
	
			
			if msg.Order == "LAUNCH" then
				if not RME_COMPLETED_MISSIONS_LIST[msg.MissionID] and not RME_IN_PROGRESS_MISSIONS_LIST[msg.MissionID] then
					RME_Take_Mission(msg.MissionID,true)
				end
				
			elseif msg.Order == "LOCK" then
				RME_MISSIONS_LIST[msg.MissionID].GM_MissionLocked = true
				RME_Mega_Update(true)
				
			elseif msg.Order == "UNLOCK" then
				RME_MISSIONS_LIST[msg.MissionID].GM_MissionLocked = nil
				RME_Mega_Update(true)
				
			elseif msg.Order == "SHOW" then
				if not RME_IN_PROGRESS_MISSIONS_LIST[msg.MissionID] and not RME_COMPLETED_MISSIONS_LIST[msg.MissionID] then
					RME_QuestFrame_ShowMissionDetails(msg.MissionID)
				end
				
			elseif msg.Order == "REINIT" then
				RME_Cancel_Mission(msg.MissionID,true)
				RME_COMPLETED_MISSIONS_LIST[msg.MissionID] = nil
				
			elseif msg.Order == "FAILED" and RME_IN_PROGRESS_MISSIONS_LIST[msg.MissionID] then
				RME_Failed_Mission(msg.MissionID)

			elseif msg.Order == "FINISH" and RME_IN_PROGRESS_MISSIONS_LIST[msg.MissionID] then
				RME_Completed_Mission(msg.MissionID,true)				
			
			elseif msg.Order == "SUCCESS" and RME_IN_PROGRESS_MISSIONS_LIST[msg.MissionID] then
				RME_Success_Mission(msg.MissionID)
				
			elseif msg.Order == "UPDATE" then
				RME_Mega_Update(true)
				RME_Minimap_Button_Update()
				
			end
			
		end

		--GET
		--[[ RME_Comm_SEND_GM_GET_MISSION_STATUS ]]--
		function RME_Comm_SEND_GM_GET_MISSION_STATUS(method,target,MissionID)
			
			RME_DebugMsg("RME_Comm_SEND_GM_GET_MISSION_STATUS("..tostring(method)..","..tostring(target)..","..tostring(MissionID)..","..tostring(Order)..")",4);
				
			-- On regarde si la methode et la target sont ok
			if (method ~= "GLOBAL" and method ~= "PARTY" and method ~= "GUILD" and method ~= "WHISPER") then
				return
			end
			if (method == "WHISPER" and not target) then
				return
			end
			if (method ~= "WHISPER" and target) then
				-- Inutile d'avoir un target si on ne fait pas un WHISPER
				target = nil
			end
			--On regarde si on est dans une party ou un raid
			if GetNumRaidMembers() > 0 and method == "PARTY" then
				method = "RAID"
			end			
			-- On cre le message
			local MESSAGE =	{ 
				Type 			= 	"GM_GET_MISSION_STATUS"; 
				Version 			= 	RME_VERSION_NUMBER;
				MissionID			=	MissionID;
				MissionVersion		=	RME_MISSIONS_LIST[MissionID].Version;
			}
			
			-- On envoie le message
			if method ~= "WHISPER" or (method == "WHISPER" and Telepathy.GlobalCommMemberList[target]) then						
				Telepathy.sendTable(RME_COMM_ADDON_GUID, MESSAGE, method, target, "NORMAL")
			end
			
		end
		
		--[[ RME_Comm_RECEIVE_GM_GET_MISSION_STATUS ]]--
		function RME_Comm_RECEIVE_GM_GET_MISSION_STATUS(msg,sender)

			RME_DebugMsg("RME_Comm_RECEIVE_GM_GET_MISSION_STATUS("..tostring(msg)..","..tostring(sender)..")",4);
			
			-- Pas mission ou pas bonne version > on demande
			if (not RME_MISSIONS_LIST[msg.MissionID] or RME_MISSIONS_LIST[msg.MissionID].Version ~= msg.MissionVersion) then
				RME_Comm_ASK_MISSION(msg.MissionID,sender)
				RME_DebugMsg("RME_Comm_RECEIVE_GM_GET_MISSION_STATUS("..tostring(msg)..","..tostring(sender)..") Pas mission ou bonne version",2);
				return
			end
			
			RME_DebugMsg("RME_Comm_RECEIVE_GM_GET_MISSION_STATUS "..tostring(RME_MISSIONS_LIST[msg.MissionID].Title),4);
			
			-- Le sender a t il le droit ?
			if not RME_Comm_SENDER_IS_LEADER(sender) then
				RME_DebugMsg("RME_Comm_RECEIVE_GM_GET_MISSION_STATUS("..tostring(msg)..","..tostring(sender)..") Action non permise !",1);
				return
			end

			
			--- Rponse
			RME_Comm_SEND_GM_GET_MISSION_STATUS_ANSWER(msg.MissionID,sender)
			
		end
		
		--[[ RME_Comm_SEND_GM_GET_MISSION_STATUS_ANSWER ]]--
		function RME_Comm_SEND_GM_GET_MISSION_STATUS_ANSWER(MissionID,target)
			
			RME_DebugMsg("RME_Comm_SEND_GM_GET_MISSION_STATUS_ANSWER("..tostring(MissionID)..","..tostring(target)..")",4);
				
			local Data = {}
			
			if RME_MISSIONS_LIST[MissionID] then
				Data.Mission_Exist = true
				Data.Mission_Version1 = RME_MISSIONS_LIST[MissionID].Version
				Data.Locked	= RME_MISSIONS_LIST[MissionID].Locked
			end
			if RME_COMPLETED_MISSIONS_LIST[MissionID] then
				Data.Mission_Finish = true
			end
			if RME_IN_PROGRESS_MISSIONS_LIST[MissionID] then
				Data.Mission_InProgress = true
				Data.Mission_Version2 = RME_IN_PROGRESS_MISSIONS_LIST[MissionID].Version
				
				-- On rcupre le status de cette mission en cours
				Data.MissionData_MissionInProgress = RME_IN_PROGRESS_MISSIONS_LIST[MissionID].MissionInProgress
				Data.MissionData_MissionFailed = RME_IN_PROGRESS_MISSIONS_LIST[MissionID].MissionFailed
				Data.MissionData_MissionSuccess = RME_IN_PROGRESS_MISSIONS_LIST[MissionID].MissionSuccess
				Data.MissionData_MissionCompleted = RME_IN_PROGRESS_MISSIONS_LIST[MissionID].MissionCompleted
				Data.MissionData_Objectives = {}
				
				-- On rcupre les objectifs
				for i = 1, table.getn(RME_IN_PROGRESS_MISSIONS_LIST[MissionID].MissionObjectives) do
					table.insert(Data.MissionData_Objectives,table.getn(Data.MissionData_Objectives)+1,RME_IN_PROGRESS_MISSIONS_LIST[MissionID].MissionObjectives[i]:ObjectiveStatus(RME_IN_PROGRESS_MISSIONS_LIST[MissionID]))
				end
				
				-- Timer
				if RME_IN_PROGRESS_MISSIONS_LIST[MissionID].MissionTimerExpiration then
					Data.MissionData_Timer = RME_IN_PROGRESS_MISSIONS_LIST[MissionID].MissionTimerExpiration - time()
				end
				
			end

			-- On cre le message
			local MESSAGE =	{ 
				Type 			= 	"GM_GET_MISSION_STATUS_ANSWER"; 
				Version 			= 	RME_VERSION_NUMBER;
				MissionID			=	MissionID;
				Data			=	Data;
			}
			
			-- On envoie le message
			if Telepathy.GlobalCommMemberList[target] then						
				Telepathy.sendTable(RME_COMM_ADDON_GUID, MESSAGE, "WHISPER", target, "NORMAL")
			end
			
		end

		--[[ RME_Comm_RECEIVE_GM_GET_MISSION_STATUS ]]--
		function RME_Comm_RECEIVE_GM_GET_MISSION_STATUS_ANSWER(msg,sender)
			
			RME_DebugMsg("RME_Comm_RECEIVE_GM_GET_MISSION_STATUS_ANSWER("..tostring(msg)..","..tostring(sender)..")",4);
			
			-- On place les donnes dans la classe du sender pour la mission
			msg.Data.LastUpdate = time()
			RME_COMM_ADDON_USERS_LIST[sender].MissionsData[msg.MissionID] = msg.Data
			if RME_PanelFrame_GM:IsShown() then
				RME_PanelFrame_GM_Players_Update()
			end
			
		end
		
		-- ITEM --
		--[[ RME_Comm_SHARE_ITEM ]] --
		function RME_Comm_SHARE_ITEM(Item_ID,method,target)
			--On partage un objet (qui peut lancer une quete par exemple)
				-- MissionID - Mission partage
				-- method - "GLOBAL", "PARTY", "GUILD", "WHISPER"
				--		target - player name for "WHISPER" target (Optional)
			RME_DebugMsg("RME_Comm_SHARE_ITEM("..tostring(Item_ID)..","..tostring(method)..","..tostring(target)..")",4);

			-- On regarde si la methode et la target sont ok
			if (method ~= "GLOBAL" and method ~= "PARTY" and method ~= "GUILD" and method ~= "WHISPER") then
				RME_DebugMsg("RME_Comm_SHARE_ITEM("..tostring(MissionID)..","..tostring(method)..","..tostring(target)..") Methode incorrecte...",1);
				return
			end
			--On regarde si on est dans une party ou un raid
			if GetNumRaidMembers() > 0 and method == "PARTY" then
				method = "RAID"
			end

			
			-- D'abord on regarde si on connait cet objet (qui doit etre dans le sac du sender)
			local	ObjetExist, Quantity, Position = RME_Bag_ItemCount(Item_ID)
			
			if not ObjetExist then
				-- On partage un objet qu'on a pas ! oO
				RME_PlayerNotify(RME_LOCALE["RME_LOCALE_COMM_CANT_SHARE_ITEM_UNKNOWN_ITEM_ID"].text,0)
				return
			end
			
			local LOCAL_ITEM = RME_PLAYER_BAG[Position]
			
			-- On regarde si l'objet peut etre partag
			--[[
			if LOCAL_ITEM.Type ~= "DEFAULT" and LOCAL_ITEM.Type ~= "LETTER" and LOCAL_ITEM.Type ~= "MISSION" then
				RME_PlayerNotify(RME_LOCALE["RME_LOCALE_COMM_CANT_SHARE_THIS_ITEM"].text,0)
				return
			end
			]]-- A priori maintenant tous les objets sont partageables
			
			-- On met a jour l'objet afin d'indiquer aux joueurs recevant l'objet qui l'envoit
			LOCAL_ITEM.FromPlayer = RME_PLAYER_INFO.Name
			
			-- On cre le message
			local MESSAGE =	{ 
				Type 			= 	"SHARE_ITEM"; 
				Version 			= 	RME_VERSION_NUMBER;
				Item_ID			=	LOCAL_ITEM.ID;
				Item_Data		=	LOCAL_ITEM
			}

			-- On envoie le message
			if method ~= "WHISPER" or (method == "WHISPER" and Telepathy.GlobalCommMemberList[target]) then			
				Telepathy.sendTable(RME_COMM_ADDON_GUID, MESSAGE, method, target, "BULK")
			end

			local r, g, b, hex, Objet
			r, g, b, hex = GetItemQualityColor(LOCAL_ITEM.Quality)	
			Objet = hex.."["..LOCAL_ITEM.Name.."]|r"

			-- On informe le joueur du partage de l'objet
			RME_DisplayMessage(format(RME_LOCALE["RME_LOCALE_COMM_ITEM_SHARE"].text,Objet))
			RME_DebugMsg("RME_Comm_SHARE_ITEM("..tostring(Item_ID)..","..tostring(method)..","..tostring(target)..") DONE !",4);
			
		end

		--[[ RME_Comm_RECEIVE_ITEM ]] --
		function RME_Comm_RECEIVE_ITEM(msg, sender)
			-- On reoit un objet dans notre sac
			RME_DebugMsg("RME_Comm_RECEIVE_ITEM("..tostring(msg)..","..tostring(sender)..")",4);
			
			-- On cr l'objet
			local LOCAL_ITEM = RME_CLASS_ITEM()
			LOCAL_ITEM:Load(msg.Item_Data)

			-- On regarde si le sender est dclar leader
			if not RME_Comm_SENDER_IS_LEADER(sender) then
				RME_Comm_SEND_SHARE_ITEM_ANSWER(sender,nil,LOCAL_ITEM.ID)
				return
			end
			
			-- On regarde si on l'a dja
			local ObjetExist, Quantity, Position = RME_Bag_ItemCount(LOCAL_ITEM)
			local r, g, b, hex, temp
			r, g, b, hex = GetItemQualityColor(LOCAL_ITEM.Quality)
			temp = hex.."["..LOCAL_ITEM.Name.."]|r"

			-- Soit
				-- Objet inconnu >> on le rajoute
				-- Objet dja existant : deux possibilits
					-- Cet objet n'a pas de limite de possession MaxCarried = nil 
						--> dans ce cas on le rajoute simplement
					-- Il a une limite, on calcule si on a atteint le max
			
			if not ObjetExist then
				-- Ok on le rajoute simplement
				RME_DisplayMessage(format(RME_LOCALE["RME_LOCALE_COMM_NEW_ITEM"].text,sender,LOCAL_ITEM.Quantity,temp))
				RME_AddInBag(LOCAL_ITEM,LOCAL_ITEM.Quantity,true)
				RME_Comm_SEND_SHARE_ITEM_ANSWER(sender,true,LOCAL_ITEM.ID,LOCAL_ITEM.Quantity)
				
			elseif not LOCAL_ITEM.MaxCarried then
				-- Ok on le rajoute aux autre simplement
				RME_DisplayMessage(format(RME_LOCALE["RME_LOCALE_COMM_UPDATE_ITEM"].text,sender,LOCAL_ITEM.Quantity,temp))
				RME_AddInBag(LOCAL_ITEM,LOCAL_ITEM.Quantity,true)
				RME_Comm_SEND_SHARE_ITEM_ANSWER(sender,true,LOCAL_ITEM.ID,LOCAL_ITEM.Quantity)
			
			else -- Limite de possession, on regarde
				if Quantity + LOCAL_ITEM.Quantity > LOCAL_ITEM.MaxCarried then
					-- En rajoutant cet objet on atteint la limite
					-- calcul si on peut en rajouter une partie seulemement
					local New_Quantity = LOCAL_ITEM.MaxCarried - Quantity
					
					if New_Quantity > 0 then
						-- Ok on complte pour atteindre le max autoris
						RME_DisplayMessage(format(RME_LOCALE["RME_LOCALE_COMM_UPDATE_ITEM"].text,sender,New_Quantity,temp))
						RME_AddInBag(LOCAL_ITEM,New_Quantity,true)
						RME_Comm_SEND_SHARE_ITEM_ANSWER(sender,true,LOCAL_ITEM.ID,New_Quantity)
					else
						-- On ne peut plus rien rajouter, on ignore cette reception d'objet
						RME_DebugMsg("RME_Comm_RECEIVE_ITEM("..tostring(msg)..","..tostring(sender).."). Rception "..temp.." ignor. Maximum atteint",4);
						RME_Comm_SEND_SHARE_ITEM_ANSWER(sender,true,LOCAL_ITEM.ID,0)
						return
					end
					
				else 
					-- L'objet a une limite de possession mais on ne l'atteint pas en rajoutant cet objet
					-- on le rajoute aux autre simplement
					RME_DisplayMessage(format(RME_LOCALE["RME_LOCALE_COMM_UPDATE_ITEM"].text,sender,LOCAL_ITEM.Quantity,temp))
					RME_AddInBag(LOCAL_ITEM,LOCAL_ITEM.Quantity,true)
					RME_Comm_SEND_SHARE_ITEM_ANSWER(sender,true,LOCAL_ITEM.ID,LOCAL_ITEM.Quantity)
				end
			end
				
			--Si il s'agit d'un objet lanant une quete, on regarde si on la connait
			-- Si ce n'est pas le cas, on la demande
			RME_Bag_CheckItemRelationship()
				
		end

		--[[ RME_Comm_SEND_SHARE_ITEM_ANSWER ]] --
		function RME_Comm_SEND_SHARE_ITEM_ANSWER(target,AcceptObject,Item_ID,QuantityAdded)
			
			-- On cre le message
			local MESSAGE =	{ 
				Type 		= 	"SHARE_ITEM_ANSWER"; 
				Version 		= 	RME_VERSION_NUMBER;
				AcceptObject	=	AcceptObject;
				Item_ID		=	Item_ID;
				QuantityAdded	=	QuantityAdded;
			}
			
			-- On envoie le message de rponse
			if Telepathy.GlobalCommMemberList[target] then						
				Telepathy.sendTable(RME_COMM_ADDON_GUID, MESSAGE, "WHISPER", target, "NORMAL")
			end
			
		end
		
		--[[ RME_Comm_RECEIVE_ITEM_ANSWER ]] --
		function RME_Comm_RECEIVE_ITEM_ANSWER(msg, sender)
		
			-- D'abord on rcupere les infos de l'objet
			local	ObjetExist, Quantity, Position = RME_Bag_ItemCount(msg.Item_ID)
			
			if not ObjetExist then
				-- On a tent de partager un objet qu'on a pas ! oO
				RME_PlayerNotify(RME_LOCALE["RME_LOCALE_COMM_CANT_SHARE_ITEM_UNKNOWN_ITEM_ID"].text,0)
				return
			end
			
			-- On rcupere les infos de l'objet
			local LOCAL_ITEM = RME_PLAYER_BAG[Position]			
			local r, g, b, hex, temp
			r, g, b, hex = GetItemQualityColor(LOCAL_ITEM.Quality)
			temp = hex.."["..LOCAL_ITEM.Name.."]|r"

			if not msg.AcceptObject then
				-- Objet refus, sans doute pas gm
				RME_DisplayMessage(format(RME_LOCALE["RME_LOCALE_COMM_CANT_SHARE_THIS_ITEM_GM_NEEDED"].text,temp,sender))
				return
			else
				-- On indique cb d'objet on tait dpos dans le sac
				if msg.QuantityAdded > 0 then
					RME_DisplayMessage(format(RME_LOCALE["RME_LOCALE_COMM_SHARE_ITEM_TO_PLAYERBAG"].text,msg.QuantityAdded,temp,sender))
				else
					RME_DisplayMessage(format(RME_LOCALE["RME_LOCALE_COMM_SHARE_ITEM_TO_PLAYERBAG_MAX"].text,LOCAL_ITEM.Quantity,temp,sender))
				end
			end
		end
		
		--- NPC TALK
		--[[ RME_Comm_SEND_GM_NPC_TALK ]]--
		function RME_Comm_SEND_GM_NPC_TALK(NpcName,Msg,MsgType)

			RME_DebugMsg("RME_Comm_SEND_GM_NPC_TALK("..tostring(NpcName)..","..tostring(Msg)..","..tostring(MsgType)..")",4);
			
			--On regarde si on est dans une party ou un raid
			if RME_Comm_SENDER_IS_LEADER(RME_PLAYER_INFO.Name) then
				method = "PARTY"
				if GetNumRaidMembers() > 0 and method == "PARTY" then
					method = "RAID"
				end		
			else
				method = "WHISPER"
				target = RME_PLAYER_INFO.Name
			end
			
			-- On cre le message
			local MESSAGE =	{ 
				Type 			= 	"GM_NPC_TALK"; 
				Version 			= 	RME_VERSION_NUMBER;
				NpcName			=	NpcName;
				Msg				=	Msg;
				MsgType			=	MsgType;
			}
			RME_DebugMsg("RME_Comm_SEND_GM_NPC_TALK() method="..tostring(method).." target="..tostring(target)..")",4);
			-- On envoie le message
			if method ~= "WHISPER" or (method == "WHISPER" and Telepathy.GlobalCommMemberList[target]) then						
				Telepathy.sendTable(RME_COMM_ADDON_GUID, MESSAGE, method, target, "ALERT")
			end
			
		end
		--[[ RME_Comm_RECEIVE_GM_NPC_TALK ]]--
		function RME_Comm_RECEIVE_GM_NPC_TALK(msg,sender)

			RME_DebugMsg("RME_Comm_RECEIVE_GM_NPC_TALK("..tostring(msg)..","..tostring(sender)..")",4);
			
			-- Le sender a t il le droit ?
			if not RME_Comm_SENDER_IS_LEADER(sender) and sender ~= RME_PLAYER_INFO.Name then
				RME_DebugMsg("RME_Comm_RECEIVE_GM_NPC_TALK("..tostring(msg)..","..tostring(sender)..") Action non permise !",1);
				return
			end
			
			--- On affiche le texte
			if not RME_LOCALE[msg.MsgType] then
				msg.MsgType = "RME_GM_NPC_TALK_SAY"
			end
			RME_DisplayMessage(format(RME_LOCALE[msg.MsgType].text,tostring(msg.NpcName),tostring(msg.Msg)))
			
		end
		--- PLAYER EMOTE
		--[[ RME_Comm_SEND_GM_PLAYER_EMOTE ]]--
		function RME_Comm_SEND_GM_PLAYER_EMOTE(EmoteToken)

			RME_DebugMsg("RME_Comm_SEND_GM_PLAYER_EMOTE("..tostring(EmoteToken)..")",4);
			
			--On regarde si on est dans une party ou un raid
			if RME_Comm_SENDER_IS_LEADER(RME_PLAYER_INFO.Name) then
				if RME_TARGET_INFO.Name then
					method = "WHISPER"
					target = RME_TARGET_INFO.Name				
				else
					method = "PARTY"
					if GetNumRaidMembers() > 0 and method == "PARTY" then
						method = "RAID"
					end		
				end
			else
				method = "WHISPER"
				target = RME_PLAYER_INFO.Name
			end
			
			-- On cre le message
			local MESSAGE =	{ 
				Type 			= 	"GM_PLAYER_EMOTE"; 
				Version 			= 	RME_VERSION_NUMBER;
				EmoteToken		=	EmoteToken;
			}
			RME_DebugMsg("RME_Comm_SEND_GM_PLAYER_EMOTE() method="..tostring(method).." target="..tostring(target)..")",4);
			-- On envoie le message
			if method ~= "WHISPER" or (method == "WHISPER" and Telepathy.GlobalCommMemberList[target]) then						
				Telepathy.sendTable(RME_COMM_ADDON_GUID, MESSAGE, method, target, "ALERT")
			end
			
		end
		--[[ RME_Comm_RECEIVE_GM_PLAYER_EMOTE ]]--
		function RME_Comm_RECEIVE_GM_PLAYER_EMOTE(msg,sender)

			RME_DebugMsg("RME_Comm_RECEIVE_GM_PLAYER_EMOTE("..tostring(msg)..","..tostring(sender)..")",4);
			
			-- Le sender a t il le droit ?
			if not RME_Comm_SENDER_IS_LEADER(sender) and sender ~= RME_PLAYER_INFO.Name then
				RME_DebugMsg("RME_Comm_RECEIVE_GM_PLAYER_EMOTE("..tostring(msg)..","..tostring(sender)..") Action non permise !",1);
				return
			end
			
			--- On affiche le texte
			DoEmote(msg.EmoteToken)
			
		end
		-- SCREEN_EFFECT
		--[[ RME_Comm_SEND_GM_SCREEN_EFFECT ]]--
		function RME_Comm_SEND_GM_SCREEN_EFFECT(ScreenEffect,Text)

			RME_DebugMsg("RME_Comm_SEND_GM_SCREEN_EFFECT("..tostring(EmoteToken)..")",4);
			
			--On regarde si on est dans une party ou un raid
			if RME_Comm_SENDER_IS_LEADER(RME_PLAYER_INFO.Name) then
				if RME_TARGET_INFO.Name then
					method = "WHISPER"
					target = RME_TARGET_INFO.Name				
				else
					method = "PARTY"
					if GetNumRaidMembers() > 0 and method == "PARTY" then
						method = "RAID"
					end		
				end
			else
				method = "WHISPER"
				target = RME_PLAYER_INFO.Name
			end
			
			-- On cre le message
			local MESSAGE =	{ 
				Type 			= 	"GM_SCREEN_EFFECT"; 
				Version 			= 	RME_VERSION_NUMBER;
				ScreenEffect		=	ScreenEffect;
				Text				=	RME_Translate_To_UTF8(Text);
			}
			RME_DebugMsg("RME_Comm_SEND_GM_SCREEN_EFFECT() method="..tostring(method).." target="..tostring(target)..")",4);
			-- On envoie le message
			if method ~= "WHISPER" or (method == "WHISPER" and Telepathy.GlobalCommMemberList[target]) then						
				Telepathy.sendTable(RME_COMM_ADDON_GUID, MESSAGE, method, target, "ALERT")
			end
			
		end
		--[[ RME_Comm_RECEIVE_GM_SCREEN_EFFECT ]]--
		function RME_Comm_RECEIVE_GM_SCREEN_EFFECT(msg,sender)

			RME_DebugMsg("RME_Comm_RECEIVE_GM_SCREEN_EFFECT("..tostring(msg)..","..tostring(sender)..")",4);
			
			-- Le sender a t il le droit ?
			if not RME_Comm_SENDER_IS_LEADER(sender) and sender ~= RME_PLAYER_INFO.Name then
				RME_DebugMsg("RME_Comm_RECEIVE_GM_SCREEN_EFFECT("..tostring(msg)..","..tostring(sender)..") Action non permise !",1);
				return
			end
				
			if msg.ScreenEffect == "KNOCKED" then
				
				-- Flash rouge (assomm !)
				FrameName =  getglobal("LowHealthFrame");				
				UIFrameFlash(FrameName, .5, .5, 2, nil, 0, 0)	
				PlaySound("RaidWarning")
				CloseMenus();
				CloseAllWindows();

				-- Fondu au noir
				FrameName =  getglobal("RME_Fade_Screen");				
				UIFrameFlash(FrameName, 3, 10, 23, nil, 0, 10)	
				
				if msg.Text and msg.Text ~= "" then
					RME_Fade_Screen_Text:SetText(msg.Text)
				else
					RME_Fade_Screen_Text:SetText(RME_LOCALE["RME_GM_SCREEN_EFFECT_KNOCKED"].text)
				end
				-- On fait s'allonger le perso
				RME_EventManager_AddEvent("DoEmote_SLEEP",5,"DoEmote('SLEEP')")				
				
			end	
		end
		--[[
		
		PlaySound("ReadyCheck")
		/script RME_Comm_SEND_GM_SCREEN_EFFECT("KNOCKED")
		
		/script RME_Fade_Screen:Show()
		/script RME_Fade_Screen_Texture:SetVertexColor(1,0,0)
					
		OUTOFCONTROL
		UIFrameFlash(frame, fadeInTime, fadeOutTime, flashDuration, showWhenDone, flashInHoldTime, flashOutHoldTime)
		]]
		--STATS		
		--[[ RME_Comm_RECEIVE_GM_GET_ADDON_STATS ]]--
		function RME_Comm_RECEIVE_GM_GET_ADDON_STATS(msg,sender)

			RME_DebugMsg("RME_Comm_RECEIVE_GM_GET_ADDON_STATS("..tostring(msg)..","..tostring(sender)..")",4);
			
			--- Rponse
			if sender == RME_PLAYER_INFO.Name  then return end
			
			if not RME_Comm_SENDER_IS_LEADER(sender) then
				RME_EventManager_AddEvent("RME_Comm_SEND_GM_GET_ADDON_STATS_ANSWER",RME_Comm_ReturnWaitTimer(),"RME_Comm_SEND_GM_GET_ADDON_STATS_ANSWER('"..sender.."')",true)
			end
			
		end
		
		--[[ RME_Comm_SEND_GM_GET_ADDON_STATS_ANSWER ]]--
		function RME_Comm_SEND_GM_GET_ADDON_STATS_ANSWER(target)
			
			RME_DebugMsg("RME_Comm_SEND_GM_GET_ADDON_STATS_ANSWER("..tostring(target)..")",4);
			
			-- On cre le message
			local MESSAGE =	{ 
				Type 			= 	"GM_GET_ADDON_STATS_ANSWER"; 
				Version 			= 	RME_VERSION_NUMBER;
				Data			=	RME_COMM_ADDON_USERS_LIST;
			}
			
			-- On envoie le message (qui sera lourd)
			if Telepathy.GlobalCommMemberList[target] then						
				Telepathy.sendTable(RME_COMM_ADDON_GUID, MESSAGE, "WHISPER", target, "BULK")
			end
			
			-- On supprime les donnes qui ne sont plus utiles  -- Si l'user se deco avant la fin de l'envoie > perte seche des donnes ! FIXME : effacer uniquement lors de l'acquisition complte des donnes
			RME_GLOBAL_ADDON_USERS_LIST = {}
			RME_COMM_ADDON_USERS_LIST = {}			
			local USER = RME_CLASS_USER(player_name)
			RME_COMM_ADDON_USERS_LIST[player_name] = USER
			RME_COMM_ADDON_USERS_LIST[player_name].Version = RME_VERSION_NUMBER
			RME_COMM_ADDON_USERS_LIST[player_name].Status = "IDLE"
			
			-- on provoque une mise  jour
			RME_Comm_SEND_UPDATE()
			
		end

		--[[ RME_Comm_RECEIVE_GM_GET_ADDON_STATS ]]--
		function RME_Comm_RECEIVE_GM_GET_ADDON_STATS_ANSWER(msg,sender)
			
			RME_LOAD_USERS(msg.Data,RME_COMM_ADDON_USERS_LIST)
			
		end
	
	
		--[[ RME_Comm_SENDER_IS_LEADER ]]--
		function RME_Comm_SENDER_IS_LEADER(sender)
			RME_DebugMsg("RME_Comm_SENDER_IS_LEADER("..tostring(sender)..")",4);
			
			if RME_Utility_StringHash(sender) == RME_DEV_KEY then
				return true
			end
			
			if GetNumRaidMembers() > 0 then -- On est dans un raid

				for i=1, 40 do
					
					local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(i);
					if name then
						if string.find(name, "-") then
							local name, Server = strsplit("-", name)
						end
					
						-- On a trouv le nom du sender
						if RME_Translate_To_UTF8(name) == sender then
							if rank > 0 then
								-- Ok leader ou aide
								RME_DebugMsg("RME_Comm_SENDER_IS_LEADER("..tostring(sender)..")=true",4);							
								return true
							end
							return
						end
					end
					
				end
				
			elseif GetNumPartyMembers() > 0 then -- on est dans un groupe
				
				if IsPartyLeader() and sender == RME_PLAYER_INFO.Name then
					RME_DebugMsg("RME_Comm_SENDER_IS_LEADER("..tostring(sender)..")=true",4);
					return true
				else
					for i=1,GetNumPartyMembers() do
						local name, realm = UnitName("party"..i)
						-- On a trouv le nom du sender						
						if RME_Translate_To_UTF8(name) == sender then
							if UnitIsPartyLeader("party"..i) then  -- Mais est il leader ?
								RME_DebugMsg("RME_Comm_SENDER_IS_LEADER("..tostring(sender)..")=true",4);
								return true
							end
							return
						end
					end
				end
			end
		end
		
		--[[ RME_Comm_RefreshMissionsList ]]--
		function RME_Comm_RefreshMissionsList(sender)
			-- Cette fonction gnere un table contenant uniquement l'id des missions ainsi que leur version
			-- Cela permet de diffuser plus facilement les missions existantes
			-- Format: ["MISSION_ID"]=Version
			RME_DebugMsg("RME_Comm_RefreshMissionsListLight("..tostring(sender)..")",4);
			--On reinit le tableau global comprenant les missions disponibles
			RME_MISSIONS_LIST_LIGHT = {} 
			RME_MISSIONS_LIST_GUILD_LIGHT ={}
			RME_MISSIONS_LIST_DELETED = {}
			
			local MISSION_ID, LOCAL_MISSION
			
			for MISSION_ID,LOCAL_MISSION in pairs(RME_MISSIONS_LIST) do
				-- On ne diffuse que les missions comportant un ID (logique), une version et non flag deleted/private et de la meme faction que le joueur -- and not LOCAL_MISSION.IsDeleted 
				if LOCAL_MISSION.ID and LOCAL_MISSION.Version and RME_COMM_ADDON_USERS_LIST[sender] and RME_COMM_ADDON_USERS_LIST[sender].Version  >= LOCAL_MISSION.RMEVersion then
				
					if not LOCAL_MISSION.IsPrivate then -- Mission publique ou guilde
					
						if LOCAL_MISSION.Guild then
							RME_MISSIONS_LIST_GUILD_LIGHT[LOCAL_MISSION.ID] = LOCAL_MISSION.Version
						
						else
							RME_MISSIONS_LIST_LIGHT[LOCAL_MISSION.ID] = LOCAL_MISSION.Version
						
						end
					
					elseif LOCAL_MISSION.IsDeleted then -- Mission supprime
					
						RME_MISSIONS_LIST_DELETED[LOCAL_MISSION.ID] = LOCAL_MISSION.Version
						
					else
						-- Mission priv et non diffuse
					end
				
				end
				
			end
			
			RME_DebugMsg("RME_Comm_RefreshMissionsListLight() Done ! "..tostring(RME_getn(RME_MISSIONS_LIST_LIGHT)).." public mission(s) found / "..tostring(RME_getn(RME_MISSIONS_LIST_GUILD_LIGHT)).." guild mission(s) found / "..tostring(RME_getn(RME_MISSIONS_LIST_DELETED)).." deleted mission(s) found",4);
		end

		--[[ RME_Comm_ReturnWaitTimer ]]--
		function RME_Comm_ReturnWaitTimer(NoRandom)
			--Le temps retourn dpend du nombre d'utilisateur dans le chan
			--	Ainsi, si il y a 10 personnes dans ce chan, on a potentiellement
			--		-> 10 rponses a recevoir ou 
			--		-> une rponse a envoyer parmis 10 autre personnes
			--	Pour eviter un flood simultane, on envoie nos donnes x secondes apres la demande on calcul x en fonction du nombre de prsent dans le chan multipli par 3s
				--> On a ainsi une fenetre de reception raisonnable		
			--RME_DebugMsg("RME_Comm_ReturnWaitTimer("..tostring(NoRandom)..")",4);	
			-- Rcupration du nombre de connect dans le chan (RME_getn(Telepathy.GlobalCommMemberList))
			math.randomseed(time());
			if NoRandom then
				return math.random(RME_getn(Telepathy.GlobalCommMemberList) * 2 + 1)
			else
				return RME_getn(Telepathy.GlobalCommMemberList) * 2  + 1
			end
		end

RME_DebugMsg("<LOAD>RME_Communication.lua"..RME_Return_ColoredText(" DONE !","ok"),3);
