--[[    
    ROLEPLAY MISSION EDITOR (RME)
    Copyright (C) 2007,2008 Jean RODRIGUEZ  aka Enoril (Ryzom), Enoriel (WoW - Kirin Tor)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

]]
RME_DebugMsg("<LOAD>RME_EventManager.lua",3);

local register_timer = 0
function RME_EventManager_OnUpdate()
	register_timer = register_timer + arg1		
	if register_timer > 0.10 then
		register_timer = 0
		if RME_getn(RME_EVENT_MANAGER_QUEUE) > 0 then
			local EVENT_NAME, LOCAL_EVENT
			for EVENT_NAME, LOCAL_EVENT in pairs(RME_EVENT_MANAGER_QUEUE) do	
				RME_EVENT_MANAGER_QUEUE[EVENT_NAME].InTime = RME_EVENT_MANAGER_QUEUE[EVENT_NAME].InTime - 100
				if  RME_EVENT_MANAGER_QUEUE[EVENT_NAME].InTime < 1 then
					local Command = RME_EVENT_MANAGER_QUEUE[EVENT_NAME].Command
					RME_EVENT_MANAGER_QUEUE[EVENT_NAME] = nil					
					RunScript(Command)
					return
				end
			end
		else
			RME_EventManagerFrame:Hide();
		end
	end	
end

-- Ajoute un event / Met a jour un event deja connu
function RME_EventManager_AddEvent(EventName,LaunchIn,Action,MustBeUnique,Milliseconde)

	--RME_DebugMsg("RME_EventManager_AddEvent("..tostring(EventName)..","..tostring(LaunchIn)..","..tostring(Action)..")",3);
	if not Milliseconde then
		LaunchIn = LaunchIn * 1000
	end
	--On regarde si cet event n'est pas dja en attente
	if RME_EVENT_MANAGER_QUEUE[EventName] then
		RME_EVENT_MANAGER_QUEUE[EventName].InTime = LaunchIn + 0
	else
		local NEW_EVENT = RME_CLASS_EVENTMANAGER(EventName,LaunchIn,Action)
		RME_EVENT_MANAGER_QUEUE[EventName] = NEW_EVENT
	end
	--On affiche la frame EventManagerFrame si celle ci tait invisible > ceci active RME_EventManager_OnUpdate
	if not RME_EventManagerFrame:IsShown() then
		RME_EventManagerFrame:Show();
	end
end

RME_DebugMsg("<LOAD>RME_EventManager.lua"..RME_Return_ColoredText(" DONE !","ok"),3);