--[[    
    ROLEPLAY MISSION EDITOR (RME)
    Copyright (C) 2007,2008 Jean RODRIGUEZ  aka Enoril (Ryzom), Enoriel (WoW - Kirin Tor)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

]]
RME_DebugMsg("<LOAD>RME_MissionEvents.lua",3);

--[[ CE CODE DOIT ETRE MODIFIE
	TODO: ajout nouveaut GUID pour les cibles des USE_ON_#
 ]]--

--[[ RME_Check_Mission_Event ]]--
	-- Cette fonction vrifie si l'event qui vient de se produire interesse une mission en cours
	-- On test donc l'event pour chaque mission en cours (RME_IN_PROGRESS_MISSIONS_LIST)
	function RME_Check_Mission_Event(event,arg1,arg2)
		RME_DebugMsg("RME_Check_Mission_Event("..tostring(event)..","..tostring(arg1)..","..tostring(arg2)..")" ,4);
		local MISSION_ID, LOCAL_MISSION
		RME_QUESTLOG_NBQUESTS = 0
		RME_PLAYER_HAVE_MISSION_IN_PROGRESS = nil
		for MISSION_ID,LOCAL_MISSION in pairs(RME_IN_PROGRESS_MISSIONS_LIST) do -- LOCAL_MISSION est du style RME_CLASS_MISSION
			RME_DebugMsg("RME_Check_Mission_Event("..tostring(event).."): Check Mission ".. tostring(MISSION_ID) ,4);
			-- On check la mission uniquement si elle est en cours, si elle n'est pas fini ou chou
			if LOCAL_MISSION.MissionInProgress and not LOCAL_MISSION.MissionSuccess and not LOCAL_MISSION.MissionFailed then
				RME_PLAYER_HAVE_MISSION_IN_PROGRESS = true
				LOCAL_MISSION:CheckEvent(event,arg1,arg2)
				LOCAL_MISSION:CheckObjective(event,arg1,arg2)
			end
		end
		RME_DebugMsg("RME_Check_Mission_Event("..tostring(event)..","..tostring(arg1)..","..tostring(arg2)..") DONE !" ,4);		
	end
	
	-- Propagation d'un event a l'quipe
		-- Exemple: lorsqu'on a tous une mission demandant de tuer les meme cibles, le compteur s'incrmente pour tout le monde a chaque mort.
		-- Cela n'est pas valable pour tout les events d'une mission
		-- Event gr: (KILL_MOB,CreatureName) | 
	function RME_Party_Mission_Event(New_Event,arg1,arg2) 	
		RME_DebugMsg("RME_Party_Mission_Event("..tostring(event)..","..tostring(arg1)..","..tostring(arg2)..")" ,4);
		
		--Le joueur est il en quipe ?
		if GetNumPartyMembers() < 1 then
			-- non ! on ignore
			return
		end
		
		local Event_Table =	{ 
				event 		= 	New_Event,
				arg1			=	arg1,
				arg2			= 	arg2
		}
		
		-- On envoit les donnes  l'quipe
		--TODO: pour l'instant on envoie uniquement a l'quipe, sans vrifier si ils sont a cot du joueur. il faudra modifier a
		RME_Comm_PARTY_SEND_EVENT("PARTY",nil,Event_Table)
		
		RME_DebugMsg("RME_Party_Mission_Event("..tostring(event)..","..tostring(arg1)..","..tostring(arg2)..") DONE !" ,4);
	end

--[[ RME_Check_PlayerOnTaxi ]]--
	-- Cette fonction vrifie si l'utilisateur est en vol
	-- si UnitOnTaxi = false et que OldUnitOnTaxi = false -> cela signifie que l'user a juste regarder la page du npctaxi.
	-- si UnitOnTaxi = true et que OldUnitOnTaxi = false -> cela signifie que l'user vient de commencer son vol. On lance l'event TAXI_ON et on relance cette fonction pour detecter l'atterrissage
	-- si UnitOnTaxi = true et que OldUnitOnTaxi = true --> cela signifie que l'user est en plein vol. . On va donc relancer cette event jusqu'a qu'il atterisse (ce qui permettra de detecter la fin du vol)
	-- Si UnitOnTaxi = false et que OldUnitOnTaxi = true --> cela signifie que l'user vient d'arriver. on lancer l'event TAXI_OFF et on ne relance plus cette fonction.
	function RME_Check_PlayerOnTaxi(OldUnitOnTaxi)
		RME_DebugMsg("RME_Check_PlayerOnTaxi("..tostring(OldUnitOnTaxi)..")",4);
			
		-- On met a jour le statut du joueur
		RME_PLAYER_INFO:Update("player") -- MAJ info player
			
		if not RME_PLAYER_INFO.UnitOnTaxi and not OldUnitOnTaxi then
			-- L'user a juste regard la page
			-- on ne relance pas l'event
			return
		end
		if RME_PLAYER_INFO.UnitOnTaxi and not OldUnitOnTaxi then
			-- L'user vient de decoller --> check event
			RME_Check_Mission_Event("TAXI_ON",nil,nil)
			-- On relance l'event pour detecter la fin du vol
			RME_EventManager_AddEvent("Check_Taxi",5,"RME_Check_PlayerOnTaxi("..tostring(RME_PLAYER_INFO.UnitOnTaxi)..")",true)
			return
		end
		if RME_PLAYER_INFO.UnitOnTaxi and OldUnitOnTaxi then
			-- L'user est en vol --> On relance l'event pour detecter la fin du vol
			RME_EventManager_AddEvent("Check_Taxi",5,"RME_Check_PlayerOnTaxi("..tostring(RME_PLAYER_INFO.UnitOnTaxi)..")",true)
			return
		end
		if not RME_PLAYER_INFO.UnitOnTaxi and OldUnitOnTaxi then
			-- L'user vient d'atterrir
			RME_Check_Mission_Event("TAXI_OFF",nil,nil)
			-- On ne relance pas l'event de check taxi.
			-- par contre on force la mise a jour des donnes de la zone vu que  celle ci tait dsactiv pendant le vol
			RME_Load_Available_Mission(RME_PLAYER_INFO.Location_RealZone)
			RME_Check_Mission_Event("ZONE_CHANGED_NEW_AREA",RME_PLAYER_INFO.Location_RealZone,RME_PLAYER_INFO.Location_SubZone)
			return
		end
	end

	--[[ RME_Check_PlayerOnMount ]]--
	-- 
	-- 
	function RME_Check_PlayerOnMount(OldUnitOnMount)
		RME_DebugMsg("RME_Check_PlayerOnMount()",4);
		
		RME_PLAYER_INFO:Update("player") -- MAJ info player
		
		if not OldUnitOnMount and RME_PLAYER_INFO.UnitOnMount then
			-- L'user n'tait pas sur une monture et maintenant oui --> on lance l'event MOUNT_ON
			RME_Check_Mission_Event("MOUNT_ON",nil,nil)
			return
		end
		
		if OldUnitOnMount and not RME_PLAYER_INFO.UnitOnMount then
			-- L'user etait sur une monture et vient d'en descendre (ou s'est fait dismount) --> on lance l'event MOUNT_ON
			RME_Check_Mission_Event("MOUNT_OFF",nil,nil)
			return
		end
		
	end
	
	-- some mount textures share non-mount buff textures, if you run across one put it here
	local problem_mounts = {
		["Interface\\Icons\\Ability_Mount_PinkTiger"] = 1,
		["Interface\\Icons\\Ability_Mount_WhiteTiger"] = 1,
		["Interface\\Icons\\Spell_Nature_Swiftness"] = 1,
		["Interface\\Icons\\INV_Misc_Foot_Kodo"] = 1,
		["Interface\\Icons\\Ability_Mount_JungleTiger"] =1,
	}
	
	
	--[[ RME_PlayerMounted ]]--
	-- 
	-- 
	function RME_PlayerMounted()
		--RME_DebugMsg("RME_PlayerMounted()",4);
		local buff
		for i=1,24 do
			_,_,buff = UnitBuff("player",i)
			if buff then
				if problem_mounts[buff] or string.find(buff,"QirajiCrystal_") then
					-- hunter could be in group, could be warlock epic mount etc, check if this is truly a mount
					-- or if v1 is set to true, always check every buff. sigh this is slow but really no way around it without more data from users
					RME_TooltipScan:SetUnitBuff("player",i)
					if string.find(RME_TooltipScanTextLeft2:GetText() or "",RME_LOCALE["RME_LOCALE_INCREASE_MOUNT_SPEED"].text) then
						return true
					end
				elseif string.find(buff,"Mount_") then
					return true
				end
			end
		end
	end
	

--[[ LETTER ]]--	

	
--[[ USE ON MOB ]]--
function RME_ITEM_Use_On_Mob(LOCAL_ITEM,this,CastingBarDone)
	RME_DebugMsg("RME_ITEM_Use_On_Mob("..tostring(LOCAL_ITEM)..","..tostring(CastingBarDone)..")",4);

	if LOCAL_ITEM.Type ~= "USE_ON_MOB"  then
		RME_DebugMsg("RME_ITEM_Use_On_Mob("..tostring(LOCAL_ITEM)..") Not a USEONMOB item !",1);
		return
	end	

	-- On regarde si la mission existe dans la base
	if not LOCAL_ITEM.FromMissionId or not RME_MISSIONS_LIST[LOCAL_ITEM.FromMissionId] then
		RME_DebugMsg("RME_ITEM_Use_On_Mob("..tostring(LOCAL_ITEM)..") Mission issue de l'objet inactive",1);
		PlaySound("igQuestLogAbandonQuest")
		RME_PlayerNotify(RME_LOCALE["RME_LOCALE_ITEM_IMPOSSIBLE_ACTION_MISSING_MISSION"].text,0)
		RME_Comm_SEND_UPDATE() -- On lance une mise a jour pour demander la mission
		return
	end	
	
	-- On regarde si l'objet final existe dans la liste des objets de cette mission
	if LOCAL_ITEM.UseOnMob_CreateObjectID and not RME_MISSIONS_LIST[LOCAL_ITEM.FromMissionId].MissionItemsList[LOCAL_ITEM.UseOnMob_CreateObjectID] then
		RME_DebugMsg("RME_ITEM_Use_On_Mob("..tostring(LOCAL_ITEM)..") Object cens etre cre inexistance dans la mission fournit",1);	
		PlaySound("igQuestLogAbandonQuest")
		RME_PlayerNotify(RME_LOCALE["RME_LOCALE_ITEM_IMPOSSIBLE_ACTION"].text,0)
		return
	end
	
	-- On regarde si le bouton est actif
	if this and this.isLocked then
		return
	end
	
	-- On regarde si il n'y a pas un cooldown sur l'objet	
	if this and (this.Cooldown or this.Cooldown_Start) then
		return
	end		
	
	-- On regarde si il n'y a pas dja une action en cours
	if RME_CastingBarFrame:IsShown() and RME_CastingBarFrame.LOCAL_ITEM.ID ~= LOCAL_ITEM.ID then
		-- C'est pas bon !
		PlaySound("igQuestLogAbandonQuest")
		RME_PlayerNotify(RME_LOCALE["RME_LOCALE_ITEM_IMPOSSIBLE_ACTION"].text,0)
		return
	end
	
	
	-- On regarde si le joueur n'est pas en monture
	if RME_PlayerMounted() then
		PlaySound("igQuestLogAbandonQuest")
		RME_PlayerNotify(RME_LOCALE["RME_LOCALE_ITEM_IMPOSSIBLE_WHEN_MOUNT"].text,0)
		return
	end
	

	-- On regarde si la target actuel est bien celle qu'il faut (si pas de cible demand, ben on ignore)	
	if LOCAL_ITEM.UseOnMob_MobName then
		
		-- On regarde si les noms correspondent a se qui est attendu
		if LOCAL_ITEM.UseOnMob_MobName ~= RME_TARGET_INFO.Name then
			-- C'est pas bon !
				PlaySound("igQuestLogAbandonQuest")
				RME_PlayerNotify(format(RME_LOCALE["RME_LOCALE_ITEM_NEED_MOB"].text,tostring(LOCAL_ITEM.UseOnMob_MobName)),0)
			return
		end
		-- On regarde si l'tat de la target correspond a se qu'on demande
		if LOCAL_ITEM.UseOnMob_NeedMobDead and RME_TARGET_INFO.IsAlive then
			-- C'est pas bon !
				PlaySound("igQuestLogAbandonQuest")
				RME_PlayerNotify(RME_LOCALE["RME_LOCALE_ITEM_NEED_MOB_DEAD"].text,0)
			return
		end
		
		-- On regarde si on est assez pret
		if not RME_TARGET_INFO:CheckInteraction("target") then
			-- C'est pas bon !
				PlaySound("igQuestLogAbandonQuest")
				RME_PlayerNotify(RME_LOCALE["RME_LOCALE_ITEM_TOO_FAR"].text,0)
			return
		end
		
	end	
		
	-- On regarde si il n'est pas aggro
	if UnitAffectingCombat("player") then
			-- C'est pas bon !
				PlaySound("igQuestLogAbandonQuest")
				RME_PlayerNotify(RME_LOCALE["RME_LOCALE_ITEM_IMPOSSIBLE_WHEN_ATTACKED"].text,0)
		return
	end


	--Ok on a fait le tour des pre requis
	if not CastingBarDone then
		
		-- On passe le bouton en cooldown (si il y en a un)
		if LOCAL_ITEM.CoolDown then
			local cooldown = getglobal(this:GetName().."Cooldown");
			this.Cooldown = LOCAL_ITEM.CoolDown
			this.Cooldown_Start = GetTime()
			
		else
			-- Sinon on bloque le bouton par dfaut pendant la dure de l'incantation
			local cooldown = getglobal(this:GetName().."Cooldown");
			this.Cooldown = LOCAL_ITEM.UseOnMob_Action_Timer
			this.Cooldown_Start = GetTime()
			
		end		
		
		-- On lance l'event casting bar
		RME_CastingBarFrame.LOCAL_ITEM = LOCAL_ITEM
		RME_CastingBarFrame_OnEvent("START_CASTING")
		
	else
		-- Le cast c'est bien droul, on transforme l'objet
		if LOCAL_ITEM.UseOnMob_CreateObjectID then
			local NEW_LOCAL_ITEM = RME_CLASS_ITEM()
			NEW_LOCAL_ITEM:Load(RME_MISSIONS_LIST[LOCAL_ITEM.FromMissionId].MissionItemsList[LOCAL_ITEM.UseOnMob_CreateObjectID])
			RME_AddInBag(NEW_LOCAL_ITEM,NEW_LOCAL_ITEM.Quantity,true)
		end		
		if LOCAL_ITEM.UseOnMob_DestroyOnSuccess then
			RME_RemoveInBag(LOCAL_ITEM,1,true)
		end
			
	end

end


--[[ USE ITEM ]]--
function RME_ITEM_Use_Item(LOCAL_ITEM,this,CastingBarDone)
	RME_DebugMsg("RME_ITEM_Use_Item("..tostring(LOCAL_ITEM)..","..tostring(this)..","..tostring(CastingBarDone)..")",4);

	if LOCAL_ITEM.Type ~= "USE_ITEM"  then
		RME_DebugMsg("RME_ITEM_Use_Item("..tostring(LOCAL_ITEM)..") Not a UseItem item !",1);
		return
	end
	
	-- On regarde si la mission existe dans la base
	if not LOCAL_ITEM.FromMissionId or not RME_MISSIONS_LIST[LOCAL_ITEM.FromMissionId] then
		RME_DebugMsg("RME_ITEM_Use_Item("..tostring(LOCAL_ITEM)..") Mission issue de l'objet inactive",1);
		PlaySound("igQuestLogAbandonQuest")
		RME_PlayerNotify(RME_LOCALE["RME_LOCALE_ITEM_IMPOSSIBLE_ACTION_MISSING_MISSION"].text,0)
		RME_Comm_SEND_UPDATE() -- On lance une mise a jour pour demander la mission
		return
	end	
	
	-- On regarde si l'objet final existe dans la liste des objets de cette mission
	if LOCAL_ITEM.UseItem_CreateObjectID and not RME_MISSIONS_LIST[LOCAL_ITEM.FromMissionId].MissionItemsList[LOCAL_ITEM.UseItem_CreateObjectID] then
		RME_DebugMsg("RME_ITEM_Use_Item("..tostring(LOCAL_ITEM)..") Object cens etre cre inexistance dans la mission fournit",1);	
		PlaySound("igQuestLogAbandonQuest")
		RME_PlayerNotify(RME_LOCALE["RME_LOCALE_ITEM_IMPOSSIBLE_ACTION"].text,0)
		return
	end

	-- On regarde si le bouton est actif
	if this and this.isLocked then
		RME_DebugMsg("RME_ITEM_Use_Item("..tostring(LOCAL_ITEM)..") isLocked",1);
		return
	end
	
	-- On regarde si il n'y a pas un cooldown sur l'objet	
	if this and (this.Cooldown or this.Cooldown_Start) then
		RME_DebugMsg("RME_ITEM_Use_Item("..tostring(LOCAL_ITEM)..") Cooldown or Cooldown_Start",1);
		return
	end		

	
	-- On regarde si il n'y a pas dja une action en cours
	if RME_CastingBarFrame:IsShown() and RME_CastingBarFrame.LOCAL_ITEM.ID ~= LOCAL_ITEM.ID then
		-- C'est pas bon !
		PlaySound("igQuestLogAbandonQuest")
		RME_PlayerNotify(RME_LOCALE["RME_LOCALE_ITEM_IMPOSSIBLE_ACTION"].text,0)
		return
	end
	
	
	-- On regarde si le joueur n'est pas en monture
	if RME_PlayerMounted() then
		PlaySound("igQuestLogAbandonQuest")
		RME_PlayerNotify(RME_LOCALE["RME_LOCALE_ITEM_IMPOSSIBLE_WHEN_MOUNT"].text,0)
		return
	end
			
	-- On regarde si il n'est pas aggro
	if UnitAffectingCombat("player") then
			-- C'est pas bon !
				PlaySound("igQuestLogAbandonQuest")
				RME_PlayerNotify(RME_LOCALE["RME_LOCALE_ITEM_IMPOSSIBLE_WHEN_ATTACKED"].text,0)
		return
	end


	--Ok on a fait le tour des pre requis
	if not CastingBarDone then
	
		-- On passe le bouton en cooldown (si il y en a un)
		if LOCAL_ITEM.CoolDown then
			local cooldown = getglobal(this:GetName().."Cooldown");
			this.Cooldown = LOCAL_ITEM.CoolDown
			this.Cooldown_Start = GetTime()
			
		else
			-- Sinon on bloque le bouton par dfaut pendant la dure de l'incantation
			local cooldown = getglobal(this:GetName().."Cooldown");
			this.Cooldown = LOCAL_ITEM.UseItem_Action_Timer
			this.Cooldown_Start = GetTime()
			
		end

		-- On lance l'event casting bar
		RME_CastingBarFrame.LOCAL_ITEM = LOCAL_ITEM
		RME_CastingBarFrame_OnEvent("START_CASTING")
	else
		-- Le cast c'est bien droul, on transforme l'objet
		if LOCAL_ITEM.UseItem_CreateObjectID then
			local NEW_LOCAL_ITEM = RME_CLASS_ITEM()
			NEW_LOCAL_ITEM:Load(RME_MISSIONS_LIST[LOCAL_ITEM.FromMissionId].MissionItemsList[LOCAL_ITEM.UseItem_CreateObjectID])
			RME_AddInBag(NEW_LOCAL_ITEM,NEW_LOCAL_ITEM.Quantity,true)
		end
		if LOCAL_ITEM.UseItem_DestroyOnSuccess then
			RME_RemoveInBag(LOCAL_ITEM,1,true)
		end

	end

end



-- Fin du chargement des fonctions et du fichier
RME_DebugMsg("<LOAD>RME_MissionEvents.lua() "..RME_Return_ColoredText("DONE !","ok"),3)
