--[[    
    ROLEPLAY MISSION EDITOR (RME)
    Copyright (C) 2007,2008 Jean RODRIGUEZ  aka Enoril (Ryzom), Enoriel (WoW - Kirin Tor)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

]]
-- ****************************************************************************************************--
-- Nom du fichier: RME_Utilities.lua
-- Premiere modification: 11/09/2007
-- 133: 19/01/08 - 02h52
-- 134: 10/02/08 - 05h45
-- 135: 11/02/08 - 22h36
-- 136: 21/02/08 - 00h25
-- 137: 30/03/08 - 16h33
-- 138: 30/03/08 - 23h15
-- ****************************************************************************************************--


-- ******************** INITIALISATION VARIABLES ******************** --

-- AddOn
RME_DEBUG_LEVEL 								= 	0				-- 0 = No debug | 1 = Error Debug | 2 = +Function Debug | 3 = +Dump | 4 = Full Debug
RME_DEBUG_MSG								=	{}				-- Contient la liste de tout les messages de debug
RME_UI_LOADED 								= 	nil				-- Indique si l'addon s'est completement charg
RME_ADDON_NAME								= 	"Roleplay Missions Editor"
RME_VERSION_NUMBER 							= 	00140			-- # ## ## (Major Minor Revision)
RME_VERSION_TEXTE 							= 	"Version 140"		-- 
RME_LOCALE 									= 	{}				-- Fichier de localisation
RME_NOTIFY_UPDATE_MSG						=	nil
RME_CONFIG									= 	{}
RME_ADDON_CONFIG							=	{}
RME_DEV_KEY									=	0

-- Communication
RME_COMM_ADDON_GUID							=	"RME_86525"
RME_COMM_ADDON_USERS_LIST 					= 	{}				-- Contient les infos des users utilisant cet addon (indispensable pour la diffusion des missions)
--RME_GLOBAL_ADDON_USERS_LIST 				= 	{}				-- correspond a la sauvegarde de RME_COMM_ADDON_USERS_LIST dans le toc
RME_COMM_NOFLOOD_NEXT_UPDATE				=	60*5			-- Nombre de secondes minimum qui doivent s'couler entre deux demande d'update
RME_COMM_GM_LIST								=	{}
RME_COMM_GM_USER_LIST						=	{}

-- Missions List
	RME_MISSIONS_LIST								= 	{}				-- Contiendra toutes les missions RME		(Tableau comprenant des objects de style RME_CLASS_MISSION)
	RME_MISSIONS_LIST_LIGHT						=	nil				-- Contient uniquement l'id des missions prsentes dans le pc avec leur numro de version. Format ["ID"]=Version
	RME_MISSIONS_LIST_GUILD_LIGHT					=	nil
	RME_MISSIONS_LIST_DELETED						=	nil
	RME_MISSIONS_LIST_SORTED						=	{}				-- Contient la liste des ID des mission par ordre alphanumrique
	RME_MISSION_AUTHOR_LIST_SORTED				=	{}				-- Contient la liste des auteurs de mission par ordre alphanumrique
	--RME_GLOBAL_MISSIONS_SAVE					= 	{} 				-- Variable globale dclare dans le toc, c'est elle qui contient toute les missions une fois le jeu quitt
	RME_IN_PROGRESS_MISSIONS_LIST					=	{}				-- Contiendra la liste des missions MIP par le joueur (bas sur RME_CLASS_MISSION) (MIP= Mission In Progress)
	--RME_GLOBAL_PLAYER_MIP						= 	{}				-- Variable globale dclare dans le toc, c'est elle qui contient la liste des mission MIP une fois le jeu quitt. Variable/personnage
	RME_COMPLETED_MISSIONS_LIST					= 	{}				-- Contient la liste des mission termine par le joueur (sauvegarde sur le longterme). Variable/personnage
	--RME_GLOBAL_MISSIONS_FINISH_LIST				= 	{}				-- Variable globale dclare dans le toc, c'est elle qui contient la liste des mission MIP une fois le jeu quitt. Variable/personnage
	RME_AVAILABLE_MISSIONS_LIST						= 	{}				-- Mission available in this region (based on Location_RealZone label) + mission en cours du joueur
	RME_PLAYER_HAVE_MISSION_IN_PROGRESS			=	true				-- true par defaut. Cette variable active un check des events si besoin
	RME_PLAYER_WAIT_MISSIONID						=	{}				-- Contient l'id de la mission a afficher des qu'on recevra la mission.
	RME_COMM_RESULT_NEED_MISSION 					= 	{}				-- Contient les id mission et les user needant cette mission
	RME_COMM_RESULT_HAVE_MISSION 					= 	{}				-- contient l'id des missions que l'on veut ainsi que la liste des joueurs l'ayant

	
-- Mode GM
	RME_MISSIONID_SELECTED						=	nil				-- Contient l'id
	RME_AUTHOR_SELECTED							=	nil				-- Utilis pour connaitre l'user slectionn
	RME_CAMPAGNE_SELECTED						=	nil				-- Utilis pour connaitre la campagne slectionne
	RME_MISSION_NEEDUPDATE						=	true
	RME_PARTY_PLAYERS							=	{}
	RME_PLAYER_SELECTED							=	nil
	
-- Target
	RME_PLAYER_INFO 						= 	nil				-- Contiendra les infos du joueur 				(class: RME_Class_Player)
	RME_TARGET_INFO 						= 	nil				-- Contiendra les infos de la target slectionne 	(class: RME_Class_Target)
	RME_NPC_INTERACTION_LIST				=	{}				-- Contient la liste des NPC "actifs" (cad donneur d'une mission disponible (point exclamation jaune), indisponible (point exclamation gris), en attente d'une mission (point interrogation gris), reoit une fin de mission point interrogation jaune))
	RME_ACTUAL_RME_NPC_SELECTED 			= 	{}				-- Contient les infos (de type RME_CLASS_TARGET) du dernier NPC dclar comme ayant des missions "RME". Si le joueur s'en loigne trop > nil
	if not RME_VIP_ESCORT_LIST then
		RME_VIP_ESCORT_LIST				=	{}				-- contient le nom des personnage a protger
	end
	
-- Sac
	RME_PLAYER_BAG						=	{}				-- Contenu du sac du joueur (compos de RME_CLASS_ITEM) (sauvegard sous RME_GLOBAL_PLAYER_BAG)

-- Timer et Event
	RME_EVENT_MANAGER_QUEUE			= 	{}				-- Contient la liste des commandes en attente d'excution


-- Message Log Pattern, utilis pour dtecter les mob/joueur mort via le chat
	RME_CHAT_PATTERN						= 	{
												["CHAT_MSG_SYSTEM"] 				= DUEL_WINNER_KNOCKOUT
											}
-- Gossip / QuestLog
	RME_QUESTLOG_MISSIONID 					= 	nil				-- Contient l'ID de la mission actuellement slectionn (dans la liste des missions RME du QuestLog)
	RME_QUESTFRAME_MISSION_ID					=	nil				-- Contient l'ID de la mission actuellement affich (dans la fenetre questframe)
	RME_MISSION_DISPLAYED 					= 	6				-- Nombre de missions visibles dans le faux scrollbar (li au xml)
	RME_PANNELFRAME_MISSION_DISPLAYED 			= 	28				-- Nombre de mission affiches dans le choix d'une mission
	RME_QUESTLOG_QUEST_HEIGHT 				= 	16				-- Hauteur de chaque ligne de mission visibles dans questlog
	RME_QUESTLOG_SELECTED_LINE				=	0				-- Position de la mission actuellement slectionne (dans le faux scrollframe)
	RME_MAX_MISSIONS							=	30				-- Nombre max de mission RME prenables en meme temps
	RME_MAX_OBJECTIVES						=	10				-- Nombre max d'objectif affichable dans les fenetre quest (li a l'xml)
	RME_MAX_EVENTS							=	10				-- Nombre d'event max
	RME_MAX_ITEMS							=	10				-- Nombre max d'item affichable dans les fenetre quest (li a l'xml)
	RME_NUMGOSSIPBUTTONS 					= 	32				-- Nombre d'options visibles dans la fenetre gossip(li au xml)		
	RME_ITEM_CHOICE							=	0				-- position de l'objet choisi dans le liste rewardchoice pour la mission actuellement selectionn

-- Minimap
	RME_MINIMAP_MAX_MINIMAP_ICONS				=	75
	RME_MINIMAP_MAX_WORLDMAP_ICONS			=	250
	RME_MINIMAP_NEED_UPDATE					=	true

-- Editor	
	RME_MISSION_EDITOR_LIST					=	{}				-- Contient la liste (et donnes) des missions actuellement dites
	RME_MISSION_EDITOR_LIST_MAX				=	10				-- Nombre de mission simultanement ditable
	RME_MISSION_EDITION 						= 	{}				-- Contient les infos de la mission actuellement charges et en cours d'dition (RME_CLASS_MISSION)
	RME_EDITOR_LIST_SORTED					=	{}				-- Contient la liste des mission actuellement edit class alpha
	RME_EDITOR_MAX_LEVEL						= 	70				-- contient le niveau max des missions (compris entre 1 et le level max du jeu (+ 10 en rab pour les elite en instance)
	RME_EDITOR_TIMER_MAX_TIME					=	(60*24)			-- Contient le nombre de minutes maximum que peut durer un timer de mission
	RME_CAMPAGNES_LIST						=	{}
	RME_CAMPAGNES_LIST_SORTED				=	{}
	RME_OBJECTIVE_KILL_MOB_MAX_KILL				=	30				-- Nombre max de crature a tuer pour russir un objectif
	RME_OBJECTIVE_NEED_ITEM_MAX_ITEM			=	30				-- Nombre max d'objet a ramener pour russir un objectif
	RME_MAX_NPCS							=	30				-- Nombre max de pnj pouvant donner cette mission
	RME_ITEM_USE_ON_MOB_MAX_TIME				=	60*3			-- Temps d'utilisation de l'objet USE_ON_MOB
	
	-- Item
	RME_IMAGE_LIST							=	nil				-- Contient la liste complete des icones du jeu
	RME_QUESTEDITORFRAME_SELECTITEMTEXTURE 	= 	""			-- Chemin de la texture actuellement slectionne
	RME_IMAGE_LIST_MAINCAT					=	""
	RME_IMAGE_LIST_SUBCAT						=	""
	RME_SELECTEDITEMICON_TEXTURE				=	"Interface\Icons\INV_Misc_QuestionMark"
	-- Event
	RME_EDITOR_EVENT_ID						=	nil				-- Contient l'event actuellement slectionn
	-- couleur
	RMEQuestDifficultyColor = { };
	RMEQuestDifficultyColor["impossible"] 		= { r = 1.00, 	g = 0.10, 	b = 0.10 };
	RMEQuestDifficultyColor["verydifficult"] 	= { r = 1.00, 	g = 0.50, 	b = 0.25 };
	RMEQuestDifficultyColor["difficult"] 		= { r = 1.00, 	g = 1.00, 	b = 0.00 };
	RMEQuestDifficultyColor["standard"] 		= { r = 0.25, 	g = 0.75, 	b = 0.25 };
	RMEQuestDifficultyColor["trivial"]			= { r = 0.50, 	g = 0.50, 	b = 0.50 };
	RMEQuestDifficultyColor["header"]			= { r = 0.7, 	g = 0.7, 	b = 0.7 };
	RMEQuestDifficultyColor["objectivedone"]	= { r = 0.2, 	g = 0.2, 	b = 0.2 };


	


-- ******************** /INITIALISATION VARIABLES ******************** --

--[[ MESSAGE ]] --
	-- Affiche un message dans le chat de l'user
	function RME_DisplayMessage(msg)
	
		msg = RME_Translate_To_UTF8(msg)
		RME_DebugMsg("RME_DisplayMessage("..msg..")",4)
		DEFAULT_CHAT_FRAME:AddMessage(tostring(msg))
		
	end

	-- Renvois un message avec les infos couleur  -- A REVOIR --
	function RME_Return_ColoredText (Text, ColorCode)
		
		if ColorCode == "red" or ColorCode == "error" then
			return "|CFFFF3333".. Text .. "|r"
			
		elseif ColorCode == "green" or ColorCode == "ok" then
			return "|cFF33CC00".. Text
			
		elseif ColorCode == "yellow" then
			return "|cFFFFFF33".. Text .. "|r"
			
		elseif ColorCode == "info" then
			return "|cFF66CCFF".. Text .. "|r"
			
		elseif ColorCode == "orange" then
			return "|cFFFFCC33".. Text .. "|r"

		elseif ColorCode == "debug" then
			return "|c99999999".. Text .. "|r"
		
		elseif ColorCode == "white" then
			return "|cFFFFFFFF".. Text .. "|r"
		
		else
			--Couleur inconnue
			RME_DebugMsg("RME_Return_ColoredText:ColorCode unknown >" .. color .. "<",1)
			return "|cFFFFFFFF".. Text .. "|r"
		end
		
	end
	-- Affiche un message l'informant de l'volution de sa mission
	function RME_PlayerNotify(msg, percent)
		msg = RME_Translate_To_UTF8(msg)
		color = RME_GetColorFromCompletion(percent)
		RME_DebugMsg("RME_PlayerNotify("..tostring(msg)..","..tostring(color)..")",4)
		DEFAULT_CHAT_FRAME:AddMessage(tostring(msg),color.r,color.g,color.b)
		UIErrorsFrame:AddMessage(msg, color.r, color.g, color.b, 53, 5);
	end


	-- RME_GetColorFromCompletion
	-- Renvoie un color r,g,b en fonction du pourcentage donn
	function RME_GetColorFromCompletion(percent)
		RME_DebugMsg("RME_GetColorFromCompletion("..tostring(percent)..")",4)

		if percent <= 0 then
			return RMEQuestDifficultyColor["impossible"]
		elseif percent >= 1 then
			return RMEQuestDifficultyColor["standard"]
		elseif percent == 0.5 then
			return RMEQuestDifficultyColor["difficult"]
		elseif percent < 0.5 then
			percent = percent / 0.5
			local r1,g1,b1 = RMEQuestDifficultyColor["impossible"].r, RMEQuestDifficultyColor["impossible"].g, RMEQuestDifficultyColor["impossible"].b
			local r2,g2,b2 = RMEQuestDifficultyColor["difficult"].r, RMEQuestDifficultyColor["difficult"].g, RMEQuestDifficultyColor["difficult"].b
			return { r = (r1+(r2-r1)*percent), g = (g1+(g2-g1)*percent), b = (b1+(b2-b1)*percent) }
		elseif percent < 1 then
			percent = (percent-0.5) / 0.5
			local r1,g1,b1 = RMEQuestDifficultyColor["difficult"].r, RMEQuestDifficultyColor["difficult"].g, RMEQuestDifficultyColor["difficult"].b
			local r2,g2,b2 = RMEQuestDifficultyColor["standard"].r, RMEQuestDifficultyColor["standard"].g, RMEQuestDifficultyColor["standard"].b
			return { r = tonumber(r1+(r2-r1)*percent), g = tonumber(g1+(g2-g1)*percent), b= tonumber(b1+(b2-b1)*percent) }
		end
		
	end	

	-- Used for quests and enemy coloration
	function RME_GetDifficultyColor(level)
		
		local temp_level
		
		--[[if type(level) == "table"  then
			temp_level = 0
		else
			temp_level = level
		end]]
	
		local levelDiff = -2; --UnitLevel("player"); --FIX ME : Souci avec a
		local color
		if ( levelDiff >= 5 ) then
			color = QuestDifficultyColor["impossible"];
		elseif ( levelDiff >= 3 ) then
			color = QuestDifficultyColor["verydifficult"];
		elseif ( levelDiff >= -2 ) then
			color = QuestDifficultyColor["difficult"];
		elseif ( -levelDiff <= GetQuestGreenRange() ) then
			color = QuestDifficultyColor["standard"];
		else
			color = QuestDifficultyColor["trivial"];
		end
		return color;
	end

	function RME_GetObjectiveColor(ObjectiveType)
		local color
		if ( ObjectiveType == "KILL_MOB" ) then
			color = QuestDifficultyColor["impossible"];
		elseif ( ObjectiveType == "NEED_ITEM" ) then
			color = QuestDifficultyColor["verydifficult"];
		elseif ( ObjectiveType == "CONDITION" ) then
			color = QuestDifficultyColor["difficult"];
		elseif ( ObjectiveType  == "EXPLORATION" ) then
			color = QuestDifficultyColor["standard"];
		elseif ( ObjectiveType  == "NEED_EVENT" ) then
			color = QuestDifficultyColor["trivial"];			
		else
			color = QuestDifficultyColor["trivial"];
		end
		return color;
	end
	
	function RME_GetEventColor(EventType)
		local color
		if ( EventType == "LOOT_WHEN_KILL_MOB" ) then
			color = QuestDifficultyColor["impossible"];
		elseif ( EventType == "" ) then
			color = QuestDifficultyColor["verydifficult"];
		elseif ( EventType == "" ) then
			color = QuestDifficultyColor["difficult"];
		elseif ( EventType  == "" ) then
			color = QuestDifficultyColor["standard"];
		else
			color = QuestDifficultyColor["trivial"];
		end
		return color;
	end
	
	
	-- ColorToText
	function RME_ColorToText( r, g, b, a )
		if not a then a = 1.0 end
		r = 255 * (r+0.0001)
		g = 255 * (g+0.0001)
		b = 255 * (b+0.0001)
		a = 255 * (a+0.0001)
		return string.format ( "|c%.2x%.2x%.2x%.2x", a, r, g, b )
	end

	-- Retourne le nombre d'lement non numrique (donc les "key") contenu dans table
	function RME_getn(t)
		local n = 0
		for i, _ in pairs(t) do  
			n = n + 1
		end
		return n
	end
	-- Retourne le nbeme element dans t
	function RME_getkey(t,nb)
		local count = 0
		for i, _ in pairs(t) do  
			if not nb then return i end
			count = count + 1
			if nb == count then return i end
		end
	end
	-----
--[[ GUID ]] --
	-- Renvoie un nouveau GUID (Globally Unique Identifier) de type 1D41621A-1132-0001-6EBA-E40C148019D2
	-- Voir http://www.af-design.com/services/javascript/uuid/ for javascript code
	function RME_Generate_New_GUID()
		RME_DebugMsg("RME_Generate_New_GUID()",4)
		
		-- Init gnrateur alatoire
		math.randomseed(math.random(0,8191)+(GetTime()*1000))

		local dg = 70545564
		local dc = time() 
		local t = dc - dg
		local tl = strsub(RME_getIntegerBits(t,0,31),1,8)
		local tm = strsub(RME_getIntegerBits(math.random(0,4456095),12,27),1,4)
		local thv = strsub(RME_getIntegerBits(math.random(0,4456095),8,19),1,3)..tostring("1") -- version 1, security version is 2
		local csar = strsub(RME_getIntegerBits(math.random(0,4456095),0,12),1,4)
		local csl = RME_getIntegerBits(math.random(0,4456095),0,7)
		local n = RME_getIntegerBits(math.random(0,4456095),0,7)..	
				RME_getIntegerBits(math.random(0,4456095),8,15)..
				RME_getIntegerBits(math.random(0,4456095),0,7)..
				RME_getIntegerBits(math.random(0,4456095),8,15).. 
				RME_getIntegerBits(math.random(0,4456095),0,15); -- this last number is two octets long				
		
		return tostring(tl).."-"..tostring(tm).."-"..tostring(thv).."-"..tostring(csar).."-"..strsub(tostring(csl)..tostring(n),1,12); 
		
	end
	
	-- Renvoi un texte en hexa prit alatoirement suivant les valeurs d'entres
	function RME_getIntegerBits (val,v_start,v_end)
		--RME_DebugMsg("RME_getIntegerBits("..tostring(val)..","..tostring(v_start)..","..tostring(v_end)..")",4)
		local base16 = RME_DEC_HEX(val)
		local quadArray = {}
		local quadString = ""
		for i = 1, strlen(base16) do
			table.insert(quadArray,strsub(base16,i,i+1))
		end 
		for i = floor(v_start/4), floor(v_end/4) do
			if not quadArray[i] or quadArray[i] == "" then
				quadString = quadString.."0" 
			else
				quadString = quadString..tostring(quadArray[i])
			end
		end
		return tostring(quadString)
	end
	
	
	function RME_DEC_HEX(IN)
		local B,K,OUT,I,D=16,"0123456789ABCDEF","",0		
		while IN>0 do
			I=I+1
			IN,D=floor(IN/B),mod(IN,B)+1
			OUT=string.sub(K,D,D)..OUT
		end
		return OUT
	end

--[[ /GUID ]] --	
	function RME_Translate_To_UTF8 (Texte)
		
		if not Texte then
			return ""
		end
		--FIX UTF8
		Texte = RME_Translate_To_UTF8_FIX(Texte)		
		Texte = string.gsub(Texte, "", "\195\160")
		Texte = string.gsub(Texte, "", "\195\161")
		Texte = string.gsub(Texte, "", "\195\162")
		Texte = string.gsub(Texte, "", "\195\163")
		Texte = string.gsub(Texte, "", "\195\164")
		Texte = string.gsub(Texte, " ", "\195\166")
		Texte = string.gsub(Texte, "", "\195\167")
		Texte = string.gsub(Texte, "", "\195\168")
		Texte = string.gsub(Texte, "", "\195\169")
		Texte = string.gsub(Texte, "", "\195\170")
		Texte = string.gsub(Texte, "", "\195\171")
		Texte = string.gsub(Texte, "", "\195\172")
		Texte = string.gsub(Texte, "", "\195\173")
		Texte = string.gsub(Texte, "", "\195\174")
		Texte = string.gsub(Texte, "", "\195\175")
		Texte = string.gsub(Texte, "", "\195\177")
		Texte = string.gsub(Texte, "", "\195\178")
		Texte = string.gsub(Texte, "", "\195\179")
		Texte = string.gsub(Texte, "", "\195\180")
		Texte = string.gsub(Texte, "", "\195\181")
		Texte = string.gsub(Texte, "", "\195\185")
		Texte = string.gsub(Texte, "", "\195\186")
		Texte = string.gsub(Texte, "", "\195\187")
		Texte = string.gsub(Texte, "", "\195\188")
		Texte = string.gsub(Texte, "", "\195\182")
		Texte = string.gsub(Texte, "", "\195\184")
		Texte = string.gsub(Texte, "oe", "\197\147")
		Texte = string.gsub(Texte, "", "\195\132")
		Texte = string.gsub(Texte, "", "\195\150")
		Texte = string.gsub(Texte, "", "\195\156")
		Texte = string.gsub(Texte, "", "\195\159")
		Texte = string.gsub(Texte, "", "\195\137")
		Texte = string.gsub(Texte, "'", "\39")
		Texte = string.gsub(Texte, "\"", "\34")
		Texte = string.gsub(Texte, "\006", "")
		Texte = string.gsub(Texte, "\007", "")
		Texte = string.gsub(Texte, "\008", "")
		Texte = string.gsub(Texte, "\009", "")
		Texte = string.gsub(Texte, "&lt;", "<")
		Texte = string.gsub(Texte, "&gt;", ">")
		Texte = string.gsub(Texte, "\009", "")
		Texte = string.gsub(Texte, "\226\128\153","'")
		
		return Texte
		
	end
	
	function RME_HTML_Replace_Tag(Texte)
	
		Texte = string.gsub(Texte, "<","&lt;")
		Texte = string.gsub(Texte, ">","&gt;")
		return Texte

	end
	
	function RME_Replace_Text(Texte)
		
		Texte = string.gsub(Texte, "<NOM>",RME_PLAYER_INFO.Name)
		Texte = string.gsub(Texte, "<CLASSE>",RME_PLAYER_INFO.Class)
		Texte = string.gsub(Texte, "<RACE>",RME_PLAYER_INFO.Race)
		return Texte
		
	end
	
	-- Affiche un message DEBUG dans le chat de l'user si RME_DEBUG_MODE activ
	function RME_DebugMsg(msg,debuglevel)

		msg = RME_Translate_To_UTF8(msg)
	
		if debuglevel <= RME_DEBUG_LEVEL then
			if debuglevel == 1 then --Error > Red
				DEFAULT_CHAT_FRAME:AddMessage(RME_Return_ColoredText(tostring(msg),"error"))
			elseif debuglevel == 2 then -- + Function
				DEFAULT_CHAT_FRAME:AddMessage(RME_Return_ColoredText(tostring(msg),"orange"))
			elseif debuglevel == 3 then -- + Info diverse
				DEFAULT_CHAT_FRAME:AddMessage(RME_Return_ColoredText(tostring(msg),"info"))
			elseif debuglevel == 4 then -- + Function Log complet
				DEFAULT_CHAT_FRAME:AddMessage(RME_Return_ColoredText(tostring(msg),"debug"))				
			end
		end	
		
		--[[table.insert(RME_DEBUG_MSG,#RME_DEBUG_MSG+1,msg)
		
		if #RME_DEBUG_MSG > 1000 then
			table.remove(RME_DEBUG_MSG,1)
		end
		]]
	end	
	
-- Maintenant que les fonctions sont dclars, on informe le chargement du fichier
RME_DebugMsg("<LOAD>RME_Utilities.lua()",3);

--[[ Dclaration d'une class ]]-- 
function class(base,ctor)
	local c = {}     -- a new class instance
	if not ctor and type(base) == 'function' then
		ctor = base
		base = nil
	elseif type(base) == 'table' then
		-- our new class is a shallow copy of the base class!
		for i,v in pairs(base) do
			c[i] = v
		end
		c._base = base
	end
	-- the class will be the metatable for all its objects,
	-- and they will look up their methods in it.
	c.__index = c

	-- expose a ctor which can be called by <classname>(<args>)
	local mt = {}
	mt.__call = function(class_tbl,...)
	local obj = {}
	setmetatable(obj,c)
	if ctor then
		ctor(obj,...)
	else 
	-- make sure that any stuff from the base class is initialized!
		if base and base.init then
			base.init(obj,...)
		end
	end
	return obj
end
c.init = ctor
c.is_a = function(self,klass)
	local m = getmetatable(self)
	while m do 
		if m == klass then return true end
			m = m._base
		end
		return false
	end
	setmetatable(c,mt)
	return c
end
-- Fin du chargement des fonctions et du fichier
RME_DebugMsg("<LOAD>RME_Utilities.lua() "..RME_Return_ColoredText("DONE !","ok"),3)
