--[[    
    ROLEPLAY MISSION EDITOR (RME)
    Copyright (C) 2007,2008 Jean RODRIGUEZ  aka Enoril (Ryzom), Enoriel (WoW - Kirin Tor)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

]]
RME_DebugMsg("<LOAD>RME_Class_Event.lua",3);

	RME_CLASS_EVENT = class(function(a)
			a.ToBeCheck					=	nil	--
			a.EventType 					=	nil	-- Type d'action dclench par cette event: LOOT_WHEN_KILL_MOB | READ_ITEM
			a.EventID						=	nil	-- ID de l'event
											
			-- LOOT_WHEN_KILL_MOB
			-- Peut etre donn en dbut de mission (amener objet ), ou lors de la mort d'un mob (loot alatoire)
			a.Loot_On_Mob				= 	nil	-- Nom des mobs lachant cet objet sa mort (["NOM DU MOB"]
			a.Loot_Probability				=	nil	-- Probabilit de loot lors de l'event (sur 100) (si nil > loot a chaque mort)
			a.Loot_Quantity				=	nil	-- Nombre d'objet pouvant etre loot a la fois (compris entre 1 et Loot_Quantity). Si nil -> 1 objet  la fois
			a.Loot_ItemID					=	nil	-- Nombre d'objet pouvant etre loot a la fois (compris entre 1 et Loot_Quantity). Si nil -> 1 objet  la fois
			
			-- READ_ITEM
			a.ReadItem_ItemID				=	nil	-- ID de l'objet lu (pour viter de dclencher l'event lors de la lecture d'une autre lettre)
			a.ReadItem_EventName			=	nil	--
	end)

	-- Par defaut on renvoit l'ObjectiveType
	function RME_CLASS_EVENT:__tostring()
		return self.EventType
	end
	
	function RME_CLASS_EVENT:Load(LOCAL_EVENT)
		RME_DebugMsg("RME_CLASS_EVENT:Load()",4);	

		self.ToBeCheck				=		LOCAL_EVENT.ToBeCheck
		self.EventType					= 		LOCAL_EVENT.EventType
		self.EventID					=		LOCAL_EVENT.EventID
		if not self.EventID then
			self.EventID 				= 		RME_Generate_New_GUID()
		end
		-- LOOT_WHEN_KILL_MOB
		if self.EventType == "LOOT_WHEN_KILL_MOB" then
			self.Loot_On_Mob			= 		LOCAL_EVENT.Loot_On_Mob	
			self.Loot_Probability			=		LOCAL_EVENT.Loot_Probability
			self.Loot_Quantity			=		LOCAL_EVENT.Loot_Quantity
			self.Loot_ItemID			=		LOCAL_EVENT.Loot_ItemID
			
		elseif self.EventType == "READ_ITEM" then
			self.ReadItem_ItemID			=	LOCAL_EVENT.ReadItem_ItemID
			self.ReadItem_EventName		=	LOCAL_EVENT.ReadItem_EventName

		end
	end	
	
	function RME_CLASS_EVENT:IsValid(LOCAL_MISSION)
		if self.EventType and self.EventID then
			if self.EventType == "LOOT_WHEN_KILL_MOB" and self.Loot_On_Mob and self.Loot_Probability and self.Loot_Quantity and self.Loot_ItemID and LOCAL_MISSION.MissionItemsList[self.Loot_ItemID] then
				return true
			elseif self.EventType == "READ_ITEM" and self.ReadItem_ItemID and LOCAL_MISSION.MissionItemsList[self.ReadItem_ItemID] and self.ReadItem_EventName then
				return true
			end
		end
		RME_PlayerNotify(format(RME_LOCALE["RME_LOCALE_EDITOR_EVENT_HAVE_ERROR"].text,tostring(self.TriggerWhen)),0)
	end
	function RME_CLASS_EVENT:Trigger(LOCAL_MISSION_ID,arg1,arg2)
		RME_DebugMsg("RME_CLASS_EVENT:Trigger("..tostring(arg1)..","..tostring(arg2)..","..tostring(self.EventType)..",self.Loot_On_Mob="..tostring(self.Loot_On_Mob)..",self.ReadItem_ItemID="..tostring(self.ReadItem_ItemID)..")",4);	
		
		if self.EventType == "LOOT_WHEN_KILL_MOB" and self.Loot_On_Mob == arg1 then
			-- Dans ce cas : arg1 = Nom du mob tu
				-- Ok, le mob tu est bien un mob lootant un objet
				-- On calcul sa chance de tomber cette fois ci
				if self.Loot_Probability then  -- On joue les ds
					-- Calcul probabilit a faire
					math.randomseed(math.random(0,8191)+(GetTime()*1000))
					if math.random(1,100) > self.Loot_Probability then
						return --pas de chance !
					end
				end
				-- Si on arrive ici c'est qu'on a le droit de recevoir le loot
				LOCAL_MISSION = RME_IN_PROGRESS_MISSIONS_LIST[LOCAL_MISSION_ID]
				local LOCAL_ITEM = LOCAL_MISSION.MissionItemsList[self.Loot_ItemID]
				-- quel quantit ?
				if self.Loot_Quantity then
					RME_AddInBag(LOCAL_ITEM,math.random(1,tonumber(self.Loot_Quantity)))
				else
					RME_AddInBag(LOCAL_ITEM,1)
				end
				
		elseif self.EventType == "READ_ITEM" and self.ReadItem_ItemID == arg1 then
			-- Dans ce cas : arg1 = id de l'objet
			-- On provoque un event dans 1 seconde
			RME_EventManager_AddEvent("EVENT_"..self.EventID,1,"RME_Check_Mission_Event('EVENT','"..tostring(self.EventID).."')",true)
			
		end
		
	end
	
	
	-- Retourne le texte li a l'objectif
	function RME_CLASS_EVENT:EventStatus(LOCAL_MISSION)
		
		if self.EventType == "LOOT_WHEN_KILL_MOB" then
		
			if not self.Loot_On_Mob then
				return "<"..format(RME_LOCALE["RME_QuestEditorFrame_Event_Type_List"][self.EventType],RME_LOCALE["RME_LOCALE_EDITOR_NEED_MOBNAME"].text).."> "
			else
				return "<"..format(RME_LOCALE["RME_QuestEditorFrame_Event_Type_List"][self.EventType],self.Loot_On_Mob).."> "
			end
		
		elseif self.EventType == "READ_ITEM" then
		
			if not self.ReadItem_EventName then
				return "<"..format(RME_LOCALE["RME_QuestEditorFrame_Event_Type_List"][self.EventType],RME_LOCALE["RME_LOCALE_EDITOR_NEED_EVENTNAME"].text).."> "
			else
				return "<"..format(RME_LOCALE["RME_QuestEditorFrame_Event_Type_List"][self.EventType],self.ReadItem_EventName).."> "
			end
		
		end

	end		

RME_DebugMsg("<LOAD>RME_Class_Event.lua"..RME_Return_ColoredText(" DONE !","ok"),3);