--[[    
    ROLEPLAY MISSION EDITOR (RME)
    Copyright (C) 2007,2008 Jean RODRIGUEZ  aka Enoril (Ryzom), Enoriel (WoW - Kirin Tor)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

]]
RME_DebugMsg("<LOAD>RME_Class_Item.lua",3);

	RME_CLASS_ITEM = class(function(a)
		
		-- Commun
		a.ID					=	nil			-- ID de l'objet
		a.Name				=	nil			-- Nom de l'objet
		a.NameHex			=	nil			-- Nom de l'objet mais avec la couleur hex
		a.Quality				=   	nil			-- Qualit de l'objet: 0 - Poor, 1 - Common, 2 - Uncommon, 3 - Rare, 4 - Epic, 5 - Legendary, 6 - Artifact
		a.Description			= 	nil			-- Description de l'objet
		a.Texture 			=	"Interface\Icons\INV_Misc_QuestionMark" -- "?" par dfaut
		a.Quantity			=	nil			--
		a.MaxCarried			= 	nil			-- Nombre maximum pouvant etre port / joueur. nil = pas de limite
		a.Desactivated		=	nil			-- Object desactiv
		a.CoolDown			=	nil			-- Temps de recharge de l'objet (utilis lors de l'event)
		a.Position			=	nil			-- Position de l'objet (utilis pour le sac) << Not use pour l'instant
		a.Enabled			=	nil			-- Objet correctement charg ? (mis a true apres le chargement)
		-- Li a l'change
		a.FromPlayer			=	nil			-- Nom du joueur vous ayant donn l'objet (dans le cas d'un partage d'objet)	
		-- Li au mission
		a.FromMissionId		=	nil			-- Provient de la mission ID. Permet la destruction de l'object en cas d'annulation de la mission
		a.GivenAtStart		=	nil			-- Objet donn au debut de la mission ? (si mission annul, on s'en sert pour supprimer les objets)
		-- Type de l'objet
		a.Type				=	nil			-- DEFAULT, LETTER, MISSION, USE_ITEM, USE_ON_MOB,LAUNCH_EVENT
		
		-- DEFAULT (Object de quete) 
			-- Objet ncessaire pour la validation d'une mission.
			-- Utilis pouvant etre utilis comme objectifs de mission ou comme rcompense
			-- Les parametres communs suffisent pour le definir
						
		-- LETTER
			-- Provoque l'affichage d'une lettre
			a.Letter_Text			=	nil	-- Texte de la lettre
		
		-- MISSION
			-- Clic droit sur cet object (une lettre par exemple) provoquera l'affichage du panneau accept mission pour la mission ID fournie (si pas dja en cours)
			-- Si Mission_LaunchID est renseign, on affichera d'abord la demande de mission
			a.Mission_LaunchID		=	nil	-- Mission ID qui sera affich
		
		--[[ FIXME : Merger les controles identiques entre USE_ITEM et USE_ON_MOB ]]--
		
		-- USE_ITEM
			-- Cet object lance une action qui cre un autre object 
			a.UseItem_CreateObjectID			= 	nil	-- ID de l'object cr
			a.UseItem_Action_Timer			=	nil -- Nombre de seconde ncessaire pour la creation du nouvel object 
			a.UseItem_Timer_Text				=	nil	-- Text affich pendant le timer (style "Rcupration du miel")
			a.UseItem_Use_Text				=	nil	-- Texte affich dans la tooltip 'Utiliser: '..UseItem_Use_Text
			a.UseItem_DestroyOnSuccess		=	nil	-- Supprime l'object en cas de succes
			
			
		-- USEONMOB
			-- Cet object lance une action qui cre un autre object 
			-- Pour pouvoir lancer l'action, il faut slectionner un mob UseOnMob_MobName
			a.UseOnMob_MobName 			=	nil	-- Nom a selectionner
			a.UseOnMob_NeedMobDead 		=	nil -- Le mob doit il etre mort ?
			a.UseOnMob_CreateObjectID		= 	nil	-- ID de l'object cr
			a.UseOnMob_Action_Timer			=	nil -- Nombre de seconde ncessaire pour la creation du nouvel object 
			a.UseOnMob_Timer_Text			=	nil	-- Text affich pendant le timer (style "Rcupration du miel")
			a.UseOnMob_Use_Text				=	nil	-- Texte affich dans la tooltip 'Utiliser: '..UseOnMob_Use_Text
			a.UseOnMob_DestroyOnSuccess		=	nil	-- Supprime l'object en cas de succes
			
		-- LAUNCH_EVENT
			a.LaunchEvent_EventID			=	nil	-- Lance l'event ID de la misison self.FromMissionId (doit tre activ)
			a.LaunchEvent_Repeatable			=	nil	-- Event rptable ?
	end)

	-- Par defaut on renvoit l'ObjectiveType
	function RME_CLASS_ITEM:__tostring()
		return self.Name
	end
	function RME_CLASS_ITEM:Load(LOCAL_ITEM)
		RME_DebugMsg("RME_CLASS_ITEM:Load()",4);		
			self.ID					=	LOCAL_ITEM.ID
			self.FromMissionId			=	LOCAL_ITEM.FromMissionId
			self.FromPlayer			=	LOCAL_ITEM.FromPlayer
			self.Name					=	RME_Translate_To_UTF8(LOCAL_ITEM.Name)
			self.Quality				=   	LOCAL_ITEM.Quality
			self.NameHex				=	RME_Translate_To_UTF8(LOCAL_ITEM.NameHex)			
			self.Description			= 	RME_Translate_To_UTF8(LOCAL_ITEM.Description)
			self.Texture 				=	LOCAL_ITEM.Texture
			self.MaxCarried			= 	LOCAL_ITEM.MaxCarried
			self.Quantity				=	LOCAL_ITEM.Quantity
			self.Type					=	LOCAL_ITEM.Type
			self.Position				=	LOCAL_ITEM.Position
			self.GivenAtStart			=	LOCAL_ITEM.GivenAtStart
			self.CoolDown				=	LOCAL_ITEM.CoolDown
			self.Desactivated			=	LOCAL_ITEM.Desactivated
			
			-- LETTER
			if self.Type == "LETTER" then
				self.Letter_Text			=	RME_Translate_To_UTF8(LOCAL_ITEM.Letter_Text)
			
			-- MISSION
			elseif self.Type == "MISSION" then				
				self.Mission_LaunchID	=	LOCAL_ITEM.Mission_LaunchID
				
			-- USEONMOB
			elseif self.Type == "USE_ON_MOB" then				
				self.UseOnMob_MobName 		=	LOCAL_ITEM.UseOnMob_MobName
				self.UseOnMob_NeedMobDead 	=	LOCAL_ITEM.UseOnMob_NeedMobDead
				self.UseOnMob_CreateObjectID	= 	LOCAL_ITEM.UseOnMob_CreateObjectID
				self.UseOnMob_Action_Timer		=	LOCAL_ITEM.UseOnMob_Action_Timer
				self.UseOnMob_Timer_Text		=	RME_Translate_To_UTF8(LOCAL_ITEM.UseOnMob_Timer_Text)
				self.UseOnMob_Use_Text			=	RME_Translate_To_UTF8(LOCAL_ITEM.UseOnMob_Use_Text)
				self.UseOnMob_DestroyOnSuccess	=	LOCAL_ITEM.UseOnMob_DestroyOnSuccess
				
			-- UseItem
			elseif self.Type == "USE_ITEM" then				
				self.UseItem_CreateObjectID		= 	LOCAL_ITEM.UseItem_CreateObjectID
				self.UseItem_Action_Timer		=	LOCAL_ITEM.UseItem_Action_Timer
				self.UseItem_Timer_Text			=	RME_Translate_To_UTF8(LOCAL_ITEM.UseItem_Timer_Text)
				self.UseItem_Use_Text			=	RME_Translate_To_UTF8(LOCAL_ITEM.UseItem_Use_Text)
				self.UseItem_DestroyOnSuccess	=	LOCAL_ITEM.UseItem_DestroyOnSuccess

			end
			
			self.Enabled = true
			
	end	

	--Check si objet valide
	function RME_CLASS_ITEM:IsValid(LOCAL_MISSION) 
		if self.Name and self.Name ~= "" and self.Type and self.Quantity and self.Quality then
			
			if self.Type == "DEFAULT" then
				return true
				
			-- check si mission lanc par l'objet existe
			elseif self.Type == "MISSION" and (self.Mission_LaunchID == LOCAL_MISSION.ID or RME_MISSIONS_LIST[self.Mission_LaunchID]) then
				return true
			
			-- Check si texte de la lettre existe
			elseif self.Type == "LETTER" then
				return true
				
			elseif self.Type == "USE_ITEM" then	
				if self.UseItem_Action_Timer and self.UseItem_Timer_Text and self.UseItem_Use_Text and self.UseItem_Timer_Text then 
					if self.UseItem_CreateObjectID then
						if LOCAL_MISSION.MissionItemsList[self.UseItem_CreateObjectID] then -- objet existe
							return true 
						end
					else
						--pas d'objet cre > ok tout semble bon
						return true
					end 
				end			

			elseif self.Type == "USE_ON_MOB" then	
				if self.UseOnMob_Action_Timer and self.UseOnMob_Timer_Text and self.UseOnMob_Use_Text and self.UseOnMob_Timer_Text then 
					if self.UseOnMob_CreateObjectID then
						if LOCAL_MISSION.MissionItemsList[self.UseOnMob_CreateObjectID] then -- objet existe
							return true 
						end
					else
						--pas d'objet cre > ok tout semble bon
						return true
					end 
				end
			end
		end
		RME_PlayerNotify(format(RME_LOCALE["RME_LOCALE_EDITOR_ITEM_HAVE_ERROR"].text,tostring(self.Name)),0)
	end
    
	function RME_CLASS_ITEM:GenerateNameHex()
		-- On gnre le nom de l'objet avec les couleurs hex
		local r, g, b, hex
		r, g, b, hex = GetItemQualityColor(self.Quality)
		self.NameHex = hex..self.Name.."|r"
	end
    
	
	function RME_CLASS_ITEM:IsUsable()
		return true --- FIXME
	end


RME_DebugMsg("<LOAD>RME_Class_Item.lua"..RME_Return_ColoredText(" DONE !","ok"),3);