--[[    
    ROLEPLAY MISSION EDITOR (RME)
    Copyright (C) 2007,2008 Jean RODRIGUEZ  aka Enoril (Ryzom), Enoriel (WoW - Kirin Tor)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

]]

--[[ CLASS A REVOIR, certain code pouvant etre dport dans des sous classe, cela permettra l'ajout plus simple de nouvelles fonctions/event/trigger) ]]--

RME_DebugMsg("<LOAD>RME_Class_Mission.lua",3);

	RME_CLASS_MISSION = class(function(a,MissionID)
		
			a.ID							= 	MissionID 			-- Mission ID, doit etre unique (tous joueurs confondus)
			a.Hash						= 	nil 					-- Hash de la mission
			a.Faction						=	RME_PLAYER_INFO.Faction -- Faction de la mission
			a.Version						= 	1					-- Permet de detecter les missions devant tre mises  jour (incrmentation automatique  chaque sauvegarde de la mission pendant l'dition) - Si negatif > mission supprimee !
			a.RMEVersion					= 	RME_VERSION_NUMBER	-- Stock le numro de version minimum de RME  avoir pour faire fonctionner cette mission, par defaut on indique la version courante
				
			a.CreateBy					= 	nil					-- Auteur de la mission
			a.CreateInServer				=	nil					-- Nom du serveur sur lequel la mission a t cre
			a.CreateByID					=	nil					-- ID de l'auteur (permet l'dition d'une mission meme si on a commence celle ci depuis un autre personnage)
				
			a.CreateDate					= 	nil					-- Date de la creation
				
			a.IsDeleted					=	nil					-- Signifie que la mission ne doit plus etre diffus puis supprim (on ne garde que le minimum de donne)
			a.IsDeletedBy					=	nil					-- Contient le nom de la personne ayant supprime la mission
			a.IsPrivate					= 	nil					-- Mission prive ? Ne sera pas diffus par le processus de mise a jour (diffus uniquement lors du partage de la mission en quipe)
			a.Guild						=	nil					-- Mission publies uniquement dans la guilde du crateur (si il a pas de guilde > reste prive)
			a.Locked						= 	nil					-- Mission verrouille (status total)
			a.GM_MissionLocked			=	nil					-- Mission verrouille (uniquement pour le groupe, ne doit pas tre sauvegard !)
			a.Archived					= 	nil					-- Mission Archiv  ---> comprendre mission dsactive
			a.ServersShareable			=	nil					-- Cette mission peut etre publie sur les autres serveurs ? (vrification si pnj mission sont non joueurs)
			a.IsIgnore					=	nil					-- On ignore cette mission ? (ne doit pas etre partage ! cela est propre  chaques joueurs)

			a.Title 						= 	RME_LOCALE["RME_LOCALE_EDITOR_NEED_TITLE"].Text					-- Mission Title			
			a.Level						= 	nil					-- Level of this mission (informative)		
			a.MissionType					=	nil					-- Type de la mission
			a.Campagne					=	nil					-- Nom de la campagne
			a.Comment					= 	nil					-- Commentaire / synopsis de la mission
			a.EditorComment				= 	nil					-- Commentaire dans l'diteur
			a.NeedSave					= 	nil					-- Renvoi true si la mission n'a pas t sauvegard (utilis uniquement en mode dition)
			
			a.Enabled 					= 	nil					-- Mission active (pour etre active, il faut que l'diteur de la mission l'active ET que les donnes indispensables soient correctement renseignes))
			a.EditorLoad_Lock				=	nil					-- True si on interdit le chargement dans l'diteur
			a.Publication_Lock				=	nil					-- true si on interdit la publication
			
			
			a.MissionText_Description		= 	nil					-- Mission description text 
			a.MissionText_Objective		= 	nil					-- Mission Objective Text 
			a.MissionText_InProgress		= 	nil					-- Text displayed when player select mission 
			a.MissionText_Success			= 	nil					-- Text displayed when player have done all objective > mission ending		
			
			
			a.NeedLevel		 			= 	nil					-- Minimal Level of player for play this scenario 0 = pas de prerequis
			a.NeedMissionID 				= 	nil 					-- ID of mission requested before this one
			a.NeedClass					= 	nil					-- Class du joueur
			a.NeedRace					= 	nil					-- Race du joueur
			a.LaunchMissionID				=	nil					-- Lance une autre mission quand cette mission est termine
			
			a.MissionInProgress			= 	nil					-- Mission actuellement active chez le joueur
			a.MissionFailed				= 	nil					-- Mission choue
			a.MissionSuccess				= 	nil					-- true si les objectifs ont t atteint et que le npc end attend le joueur
			a.MissionCompleted			= 	nil					-- Mission russie (valid par le pnc de fin)
			
			a.MissionTimer				= 	nil					-- Cette mission est chronomtre. nil si inactif sinon contient le nombre de secondes pour faire la mission 
			a.MissionTimerExpiration		=	nil					-- Timestamp >>>Local<<< a laquel la mission sera echou (le joueur doit donc russir les objectifs avant que son timestamp local dpasse celui ci)
			
			
			a.NPC_List					= 	{}					-- contient la liste des npc proposant/finalisant cette mission (liste de type RME_Class_NPC)
			a.MissionEvents				=	{}					-- contient la liste des events se dclenchant pendant la mission
			a.MissionObjectives			= 	{}					-- List des objectifs de la mission (bas sur RME_Class_Objective)
			a.MissionItemsList				= 	{}					-- Contient tout les objets de la mission (de type RME_CLASS_ITEM)
			a.MissionReward				= 	{}					-- Contient la liste des rcompenses de la mission
			a.MissionRewardChoice			= 	{}					-- Contient la liste des rcompenses slectionnable. On ne devra en choisir qu'un seul
			
	end)

	-- Par defaut on renvoit le nom
	function RME_CLASS_MISSION:__tostring()
		return self.Title
	end 
    
    --[[ FIXME : A revoir ]]--
	function RME_CLASS_MISSION:ReturnHash()
		return RME_Utility_StringHash(self.ID..tostring(self.IsPrivate)..tostring(self.Locked)..tostring(self.EditorLoad_Lock)..tostring(self.Publication_Lock)..tostring(self.Version)..tostring(self.RMEVersion)..tostring(self.CreateBy)..tostring(self.IsDeleted)..self.Title)    
	end
    

	function RME_CLASS_MISSION:UpdateNpcInteraction()
		local NPC_ID, LOCAL_NPC
		--  check sur l'ensemble de la liste des npc de cette mission
		for NPC_ID,LOCAL_NPC in pairs(self.NPC_List) do -- LOCAL_NPC est du style RME_CLASS_NPC
			if (string.lower(LOCAL_NPC.RealZone) == string.lower(RME_PLAYER_INFO.Location_RealZone) or (string.lower(LOCAL_NPC.RealZone) == "<all>" and Telepathy.GlobalCommMemberList[LOCAL_NPC.Name])) then
				if (LOCAL_NPC.StartMission and not self.MissionInProgress) then
					-- On ajoute la mission ce npc dans la liste RME_NPC_INTERACTION_LIST[<nom npc>]
					if  not RME_NPC_INTERACTION_LIST[NPC_ID] then
						RME_NPC_INTERACTION_LIST[NPC_ID] = {}
					end
					table.insert(RME_NPC_INTERACTION_LIST[NPC_ID],#RME_NPC_INTERACTION_LIST[NPC_ID]+1,LOCAL_NPC)
				elseif  (LOCAL_NPC.EndMission and self.MissionInProgress)  then
					-- On ajoute ce npc dans la liste RME_NPC_INTERACTION_LIST
					if  not RME_NPC_INTERACTION_LIST[NPC_ID] then
						RME_NPC_INTERACTION_LIST[NPC_ID] = {}
					end
					table.insert(RME_NPC_INTERACTION_LIST[NPC_ID],#RME_NPC_INTERACTION_LIST[NPC_ID]+1,LOCAL_NPC)
				end		
			end
		end
	end
	
	-- renvoie true si cette mission a un PNJ dans la zone RealZone fournie
	-- dans le cas d'un pnj de debut/fin joueur la zone sera "<all>"
	
	function RME_CLASS_MISSION:NpcInZone(RealZone)
		RealZone = RME_Translate_To_UTF8(RealZone)
		local NPC_ID, LOCAL_NPC,NB
		--  check sur l'ensemble de la liste des npc de cette mission
		for NPC_ID,LOCAL_NPC in pairs(self.NPC_List) do -- LOCAL_NPC est du style RME_CLASS_NPC
			if (string.lower(LOCAL_NPC.RealZone) == string.lower(RealZone)) or (string.lower(LOCAL_NPC.RealZone) == "<all>" and Telepathy.GlobalCommMemberList[LOCAL_NPC.Name]) then
				-- Ok ce pnj est dans la zone mais est il actif ?
				-- Il ne doit etre utilis que si il donne une mission non activ ou termine un mission termin
				if  (not self.MissionInProgress and LOCAL_NPC.StartMission) or (self.MissionInProgress and self.MissionSuccess and LOCAL_NPC.EndMission) then
					if not RME_NPC_INTERACTION_LIST[NPC_ID] then
						RME_NPC_INTERACTION_LIST[NPC_ID] = {}
					end
					table.insert(RME_NPC_INTERACTION_LIST[NPC_ID],#RME_NPC_INTERACTION_LIST[NPC_ID]+1,LOCAL_NPC)
					NB = true
				end
			end
		end
		
		if NB then
			return true
		end
	end

	-- On vrifie si cette mission peut etre prise
	function RME_CLASS_MISSION:MissionCanBeTaken()
		
		--Deja: est ce que cette mission est active (edition de la mission termine) ?
		if not self.Enabled then 
			return
		end
		
		--FACTION
		if self.Faction and (self.Faction ~= RME_PLAYER_INFO.Faction) then
			return
		end

		-- ARCHIVE
		if self.Archived then 
			return
		end		
		
		-- IGNORE ?
		if self.IsIgnore then
			return
		end 
		
		-- GUILDE
		if self.Guild and (RME_PLAYER_INFO.Guild ~= self.Guild) then 
			return
		end				
		
		-- Cette mission n'a t elle pas dja t fini par le joueur ? n'est elle pas dja en cours ?
		if RME_COMPLETED_MISSIONS_LIST[self.ID] then
			return
		end
		
		if  RME_IN_PROGRESS_MISSIONS_LIST[self.ID] then -- On vrifie a dans la table des missions termines		
			return
		end
		
		-- LEVEL
		--(si LOCAL_MISSION.NeedLevel = nil > aucun pre requis)
		if self.NeedLevel and RME_PLAYER_INFO.Level < self.NeedLevel then
			return
		end

		-- RACE
		if self.NeedRace and string.lower(RME_PLAYER_INFO.Race2) ~= string.lower(self.NeedRace) then
			return
		end
		
		-- CLASS
		if self.NeedClass and string.lower(RME_PLAYER_INFO.Class2) ~= string.lower(self.NeedClass) then
			return
		end			
		
		--PRE REQUIS MISSION
		if self.NeedMissionID and not RME_COMPLETED_MISSIONS_LIST[self.NeedMissionID] then
			return
		end	

		-- Si on arrive ici c'est que tous les criteres sont respects
		return true
	end
	
	-- Chargement de la mission suite a sauvegarde (lancement du jeu)
	-- Le but de cette fonction est de charger le contenu de la table dans cette classe
	function RME_CLASS_MISSION:Load(LOCAL_TABLE)
		RME_DebugMsg("RME_CLASS_MISSION:Load("..tostring(LOCAL_TABLE)..")",4);
		
		if not LOCAL_TABLE.ID then
			return
		end
		
		-- Chargement des variables
		self.ID						= LOCAL_TABLE.ID 	
		self.Hash						= LOCAL_TABLE.Hash 	
		self.Faction 					= LOCAL_TABLE.Faction
		self.Version					= LOCAL_TABLE.Version	
		self.RMEVersion				= LOCAL_TABLE.RMEVersion		
		
		self.CreateBy					= RME_Translate_To_UTF8(LOCAL_TABLE.CreateBy)
		self.CreateInServer				= LOCAL_TABLE.CreateInServer
		self.CreateByID				= LOCAL_TABLE.CreateByID
		self.CreateDate				= LOCAL_TABLE.CreateDate	

		self.IsDeleted 					= LOCAL_TABLE.IsDeleted		
		self.IsDeletedBy 				= LOCAL_TABLE.IsDeletedBy			
		self.IsPrivate 					= LOCAL_TABLE.IsPrivate		
		self.Guild 						= LOCAL_TABLE.Guild		
		self.Locked 					= LOCAL_TABLE.Locked		
		self.Archived 					= LOCAL_TABLE.Archived		
		self.ServersShareable			= LOCAL_TABLE.ServersShareable
		self.IsIgnore					= LOCAL_TABLE.IsIgnore
		
		self.Title 						= RME_Translate_To_UTF8(LOCAL_TABLE.Title)
		self.Level						= LOCAL_TABLE.Level
		self.MissionType				= LOCAL_TABLE.MissionType
		self.Campagne					= RME_Translate_To_UTF8(LOCAL_TABLE.Campagne) 
		self.Comment					= RME_Translate_To_UTF8(LOCAL_TABLE.Comment)
		self.EditorComment				= RME_Translate_To_UTF8(LOCAL_TABLE.EditorComment)
		self.NeedSave					= LOCAL_TABLE.NeedSave
		
		self.Enabled 					= LOCAL_TABLE.Enabled	
		self.EditorLoad_Lock 			= LOCAL_TABLE.EditorLoad_Lock		
		self.Publication_Lock 			= LOCAL_TABLE.Publication_Lock		
		
		self.MissionText_Description		= RME_Translate_To_UTF8(LOCAL_TABLE.MissionText_Description)
		self.MissionText_Objective		= RME_Translate_To_UTF8(LOCAL_TABLE.MissionText_Objective)
		self.MissionText_InProgress		= RME_Translate_To_UTF8(LOCAL_TABLE.MissionText_InProgress)
		self.MissionText_Success			= RME_Translate_To_UTF8(LOCAL_TABLE.MissionText_Success)

		
		self.NeedLevel		 			= LOCAL_TABLE.NeedLevel
		self.NeedMissionID 				= LOCAL_TABLE.NeedMissionID
		self.NeedClass					= LOCAL_TABLE.NeedClass
		self.NeedRace					= LOCAL_TABLE.NeedRace
		self.LaunchMissionID			= LOCAL_TABLE.LaunchMissionID
		
		self.MissionInProgress			= LOCAL_TABLE.MissionInProgress
		self.MissionFailed				= LOCAL_TABLE.MissionFailed
		self.MissionSuccess				= LOCAL_TABLE.MissionSuccess
		self.MissionCompleted			= LOCAL_TABLE.MissionCompleted
		
		self.MissionTimer				= LOCAL_TABLE.MissionTimer
		self.MissionTimerExpiration		= LOCAL_TABLE.MissionTimerExpiration
		
		
		-- Chargement des class si existante
		
		-- Liste des NPC
		self.NPC_List					= {}
		if LOCAL_TABLE.NPC_List then
			local NPC_ID, LOCAL_NPC_ENTRANT
			for NPC_ID,LOCAL_NPC_ENTRANT in pairs(LOCAL_TABLE.NPC_List) do
				local LOCAL_NPC_SORTANT = RME_CLASS_NPC()
				LOCAL_NPC_SORTANT:Load(LOCAL_NPC_ENTRANT)
				self.NPC_List[NPC_ID] = LOCAL_NPC_SORTANT
			end
		end		
		
		-- Mission Objectives
		self.MissionObjectives			= {}
		if LOCAL_TABLE.MissionObjectives then
			for i=1,#LOCAL_TABLE.MissionObjectives do
				local LOCAL_OBJECTIVE = RME_CLASS_OBJECTIVE()
				LOCAL_OBJECTIVE:Load(LOCAL_TABLE.MissionObjectives[i])
				if LOCAL_OBJECTIVE.ObjectiveType then
					table.insert(self.MissionObjectives,#self.MissionObjectives+1,LOCAL_OBJECTIVE)
				end
			end
		end
		LOCAL_OBJECTIVE = nil
		
		-- MissionReward
		self.MissionReward			= {}
		if LOCAL_TABLE.MissionReward then
			for i=1,#LOCAL_TABLE.MissionReward do
				table.insert(self.MissionReward,#self.MissionReward+1,LOCAL_TABLE.MissionReward[i])
			end
		end
		
		--MissionRewardChoice
		self.MissionRewardChoice		= {}
		if LOCAL_TABLE.MissionRewardChoice then
			for i=1,#LOCAL_TABLE.MissionRewardChoice do
				table.insert(self.MissionRewardChoice,#self.MissionRewardChoice+1,LOCAL_TABLE.MissionRewardChoice[i])
			end
		end
		
		--MissionItemsList
		self.MissionItemsList			= {}
		if LOCAL_TABLE.MissionItemsList then
			local LOCAL_ITEM_ENTRANT, LOCAL_ITEM_SORTANT
			for ITEM_ID,LOCAL_ITEM_ENTRANT in pairs(LOCAL_TABLE.MissionItemsList) do -- LOCAL_ITEM est du style RME_CLASS_ITEM
				local LOCAL_ITEM_SORTANT = RME_CLASS_ITEM()
				LOCAL_ITEM_SORTANT:Load(LOCAL_ITEM_ENTRANT)
				self.MissionItemsList[ITEM_ID] = LOCAL_ITEM_SORTANT
			end
		end

		--Mission Events
		self.MissionEvents				= {}
		if LOCAL_TABLE.MissionEvents then
			for i=1,#LOCAL_TABLE.MissionEvents do
				local LOCAL_EVENT = RME_CLASS_EVENT()
				LOCAL_EVENT:Load(LOCAL_TABLE.MissionEvents[i])
				table.insert(self.MissionEvents,#self.MissionEvents+1,LOCAL_EVENT)
			end
		end

		self.Enabled = true
		
		RME_DebugMsg("RME_CLASS_MISSION:LoadMissionSaved("..tostring(LOCAL_TABLE)..") FINI",4);
	end
	
	-- On passe la mission en active et on donne les objets ncessaires pour raliser les objectifs (si ncessaire)
	-- On active les objectifs de mission
	function RME_CLASS_MISSION:Take_Mission()
		RME_DebugMsg("RME_CLASS_MISSION:Take_Mission()",4);
		self.MissionInProgress		= 	true
		self.MissionFailed			= 	nil		
		self.MissionSuccess		= 	nil		
		self.MissionCompleted		= 	nil		

		--On donne au joueur les objets ncessaire a la ralisation de la mission
		local ITEM_ID, LOCAL_ITEM
		for ITEM_ID,LOCAL_ITEM in pairs(self.MissionItemsList) do -- LOCAL_ITEM est du style RME_CLASS_ITEM
			if LOCAL_ITEM.GivenAtStart then -- On donne l'objet uniquement si il est flag "GivenAtStart"
				-- On place les objets dans le sac du joueur
				RME_AddInBag(LOCAL_ITEM,LOCAL_ITEM.Quantity)
			end
		end
		
		-- Activation objectifs/events/timer
		self:ActivateObjectives()
		self:ActivateEvents()
		self:ActivateTimer()
		RME_DisplayMessage(format(RME_LOCALE["RME_LOCALE_QUEST_TAKEN"].text,self.Title))
		RME_PLAYER_HAVE_MISSION_IN_PROGRESS = true
		
		-- On avertit le joueur "pnj de debut" que la mission commence.
		-- Si cette mission contenait des objets requis, on les placera dans le sac du joueur de fin
		--Note: RME_QuestFrameNpcNameText:GetText()  = nom du pnj de fin (prsent sur la fenetre de la mission)
		local LOCAL_NPC = self.NPC_List[string.lower(RME_QuestFrameNpcNameText:GetText())]
		if  LOCAL_NPC then
			if LOCAL_NPC.RealZone == "<all>" then -- pnj joueur !
				RME_Comm_SEND_MISSION_INFORMATION(LOCAL_NPC.Name,self.ID,"Take_Mission")
			end
		end
		
		-- On avertit l'auteur (sauf si c'tait dj lui)
		if LOCAL_NPC and LOCAL_NPC.Name and LOCAL_NPC.Name ~= self.CreateBy and RME_COMM_ADDON_USERS_LIST[self.CreateBy] then
			RME_Comm_SEND_MISSION_INFORMATION(self.CreateBy,self.ID,"Take_Mission")
		end		
	
	end
	
	-- On annule la mission en cours et on dtruit les objets donnes en dbut de mission, on desactive les objectifs
	function RME_CLASS_MISSION:Leave_Mission()
		RME_DebugMsg("RME_CLASS_MISSION:Leave_Mission()",4);
		
		self.MissionInProgress		= 	nil
		self.MissionFailed			= 	nil		
		self.MissionSuccess			= 	nil		
		self.MissionCompleted		= 	nil
		
		-- On retire les objets demand en objectifs de mission
		local LOCAL_OBJECTIVE, LOCAL_ITEM
		for i = 1, table.getn(self.MissionObjectives) do
			LOCAL_OBJECTIVE = self.MissionObjectives[i]
			if LOCAL_OBJECTIVE.ObjectiveType == "NEED_ITEM" then
				LOCAL_ITEM = self.MissionItemsList[LOCAL_OBJECTIVE.Need_Item_ItemNeeded]
				if LOCAL_ITEM and not LOCAL_ITEM.Mission_LaunchID and not LOCAL_ITEM.Type == "LOOT" then
					RME_RemoveInBag(LOCAL_ITEM,LOCAL_ITEM.Quantity)		
				end
			end
		end

		--On retire au joueur les objets donn en dbut de mission
		local ITEM_ID, LOCAL_ITEM
		for ITEM_ID,LOCAL_ITEM in pairs(self.MissionItemsList) do -- LOCAL_ITEM est du style RME_CLASS_ITEM
			if LOCAL_ITEM.GivenAtStart then -- On retire l'objet uniquement si il est flag "GivenAtStart"
				RME_RemoveInBag(LOCAL_ITEM,LOCAL_ITEM.Quantity)		
			end
		end
		
		-- On avertit l'auteur 
		if RME_COMM_ADDON_USERS_LIST[self.CreateBy] then
			RME_Comm_SEND_MISSION_INFORMATION(self.CreateBy,self.ID,"Mission_Cancel")
		end				
		
		-- Desactivation des objectifs et timer
		self:DesactivateObjectives()
		self:DesactivateEvents()
		self:DesactivateTimer()
		RME_DebugMsg("RME_CLASS_MISSION:Leave_Mission() DONE !",4);
	end
	
	-- On marque la mission comme choue. pour pouvoir la reprendre il faudra d'abord l'annuler
	function RME_CLASS_MISSION:Mission_Failed()
		RME_DebugMsg("RME_CLASS_MISSION:Mission_Failed()",4);
		self.MissionInProgress		= 	true
		self.MissionFailed			= 	true		
		self.MissionSuccess			= 	nil		
		self.MissionCompleted		= 	nil		

		-- On avertit l'auteur 
		if RME_COMM_ADDON_USERS_LIST[self.CreateBy] then
			RME_Comm_SEND_MISSION_INFORMATION(self.CreateBy,self.ID,"Mission_Failed")
		end						
		
		-- Desactivation des objectifs et timer
		self:DesactivateObjectives()
		self:DesactivateEvents()
		self:DesactivateTimer()
	end
	
	-- On marque cette mission comme russi (il faudra la valider aupres du npc pour passer en completed)
	function RME_CLASS_MISSION:Mission_Success()
		RME_DebugMsg("RME_CLASS_MISSION:Mission_Success()",4);
		self.MissionInProgress		= 	true
		self.MissionFailed			= 	nil		
		self.MissionSuccess			= 	true		
		self.MissionCompleted		= 	nil		
		
		-- On avertit l'auteur 
		if RME_COMM_ADDON_USERS_LIST[self.CreateBy] then
			RME_Comm_SEND_MISSION_INFORMATION(self.CreateBy,self.ID,"Mission_Succes")
		end
		
		-- Desactivation des objectifs et timer
		self:DesactivateObjectives()
		self:DesactivateEvents()
		self:DesactivateTimer()
	end
	
	-- On marque cette mission comme termine et on donne les rcompenses
	function RME_CLASS_MISSION:Mission_Completed()
		RME_DebugMsg("RME_CLASS_MISSION:Mission_Completed()",4);

		self.MissionInProgress		= 	nil
		self.MissionFailed			= 	nil		
		self.MissionSuccess			= 	nil		
		self.MissionCompleted		= 	true		

		-- On retire les objets demand en objectifs de mission
		local LOCAL_OBJECTIVE, LOCAL_ITEM
		for i = 1, table.getn(self.MissionObjectives) do
			LOCAL_OBJECTIVE = self.MissionObjectives[i]
			if LOCAL_OBJECTIVE.ObjectiveType == "NEED_ITEM" then
				LOCAL_ITEM = self.MissionItemsList[LOCAL_OBJECTIVE.Need_Item_ItemNeeded]
				if LOCAL_ITEM then
					RME_RemoveInBag(LOCAL_ITEM,LOCAL_OBJECTIVE.Need_Item_QuantityNeeded)							
				end
			end
		end
		
		
		--On retire au joueur les objets donn en dbut de mission
		local ITEM_ID, LOCAL_ITEM
		for ITEM_ID,LOCAL_ITEM in pairs(self.MissionItemsList) do -- LOCAL_ITEM est du style RME_CLASS_ITEM
			LOCAL_ITEM = self.MissionItemsList[ITEM_ID]
			if LOCAL_ITEM.DestroyAtEnd then -- On retire l'objet uniquement si il est flag "DestroyAtEnd"
				RME_RemoveInBag(LOCAL_ITEM,LOCAL_ITEM.Quantity)		
			end
		end
		
		-- Rcompense d'office (MissionReward)
		local LOCAL_ITEM
		for i = 1, table.getn(self.MissionReward) do
			LOCAL_ITEM = self.MissionItemsList[self.MissionReward[i]]
			-- On place les objets dans le sac du joueur
			RME_AddInBag(LOCAL_ITEM,LOCAL_ITEM.Quantity)
		end
		
		-- Rcompense d'office (MissionReward)
		if RME_ITEM_CHOICE == 0 then
			RME_ITEM_CHOICE = 1 --par dfaut
		end
		if table.getn(self.MissionRewardChoice) > 0 and RME_ITEM_CHOICE then
			LOCAL_ITEM = self.MissionItemsList[self.MissionRewardChoice[RME_ITEM_CHOICE]]
			RME_AddInBag(LOCAL_ITEM,LOCAL_ITEM.Quantity)
		end
		
		-- Texte
		RME_PlayerNotify(QUEST_COMPLETE.." : "..self.Title,1)
		PlaySound("QUESTCOMPLETED")

		-- On avertit le joueur "pnj de fin" que la mission est termine.
		-- Si cette mission contenait des objets requis, on les placera dans le sac du joueur de fin
		--Note: RME_QuestFrameNpcNameText:GetText()  = nom du pnj de fin (prsent sur la fenetre de la mission)		
		local LOCAL_NPC = self.NPC_List[string.lower(RME_QuestFrameNpcNameText:GetText())]
		if  LOCAL_NPC then
			if LOCAL_NPC.RealZone == "<all>" then -- pnj joueur !
				RME_Comm_SEND_MISSION_INFORMATION(LOCAL_NPC.Name,self.ID,"Mission_Completed")
			end
		end
		
		-- On avertit l'auteur (sauf si c'tait dj lui)
		if LOCAL_NPC.Name ~= self.CreateBy and RME_COMM_ADDON_USERS_LIST[self.CreateBy] then
			RME_Comm_SEND_MISSION_INFORMATION(self.CreateBy,self.ID,"Mission_Completed")
		end		
		
		--Dans le cas ou cette mission lance immdiatement la suite...
		if self.LaunchMissionID and RME_MISSIONS_LIST[self.LaunchMissionID] then
			RME_DebugMsg("RME_CLASS_MISSION:Mission_Completed() LaunchMissionID",4);
			RME_QUESTFRAME_MISSION_ID = self.LaunchMissionID
			RME_EventManager_AddEvent("RME_QuestFrame_ShowMissionDetails()",1,"RME_QuestFrame_ShowMissionDetails('"..self.LaunchMissionID.."')",true)

		end
		
	end
	
	-- Cette fonction check les objectifs de la mission en fonction de l'event fournit
	function RME_CLASS_MISSION:CheckEvent(event,arg1,arg2,arg3)
		RME_DebugMsg("RME_CLASS_MISSION:CheckEvent("..tostring(event)..","..tostring(arg1)..","..tostring(arg2)..","..tostring(arg3)..")",4);
		-- Liste des events pris en compte:
			-- "KILL_MOB"
		-- Liste des events non pris en compte:
			-- "TAXI_ON" / "TAXI_OFF" -> depart/arriv vol 
			-- "ZONE_CHANGED_NEW_AREA" / "ZONE_CHANGED" / "ZONE_CHANGED_INDOORS"  --> chg de zone
			-- "CHAT_MSG_COMBAT_HOSTILE_DEATH" --> mob/cible tu
			--  "PLAYER_DEAD" 	--> joueur mort
			
			--Event reu mais pas vraiment utiles("PLAYER_UNGHOST"/ "PLAYER_ALIVE")
		RME_DebugMsg("table.getn(self.MissionEvents)="..tostring(table.getn(self.MissionEvents)),4);
			
			 
		-- On boucle sur la liste des events de la mission contenu dans self.MissionObjectives
		for i = 1, table.getn(self.MissionEvents) do
			--On charge l'objectif courant (class de type RME_CLASS_OBJECTIVE)
			-- Cet event doit il etre dclench ?
			if self.MissionEvents[i].ToBeCheck then
				-- Oui ! on check maintenant le type d'event pour voir si il correspond a l'event reu
				self.MissionEvents[i]:Trigger(self.ID,arg1,arg2,arg3)
			end
			
		end -- MissionEvents
	end
	-- Cette fonction check les objectifs de la mission en fonction de l'event fournit
	function RME_CLASS_MISSION:CheckObjective(event,arg1,arg2,arg3)
		RME_DebugMsg("RME_CLASS_MISSION:CheckObjective("..tostring(event)..","..tostring(arg1)..","..tostring(arg2)..","..tostring(arg3)..")",4);
		-- Liste des events pris en compte:
			-- "TAXI_ON" / "TAXI_OFF" -> depart/arriv vol 
			-- "ZONE_CHANGED_NEW_AREA" / "ZONE_CHANGED" / "ZONE_CHANGED_INDOORS"  --> chg de zone
			-- "CHAT_MSG_COMBAT_HOSTILE_DEATH" > KILL_MOB/VIP_DEAD --> mob/cible tu
			--  "PLAYER_DEAD" 	--> joueur mort
			
			--Event reu mais pas vraiment utiles("PLAYER_UNGHOST"/ "PLAYER_ALIVE")
			
		-- On boucle sur la liste des objectifs de la mission contenu dans self.MissionObjectives
		local OBJECTIVE_HAVE_CHANGE = 0

		for i = 1, table.getn(self.MissionObjectives) do
			--On charge l'objectif courant (class de type RME_CLASS_OBJECTIVE)
			RME_DebugMsg("RME_CLASS_MISSION:CheckObjective() Check objective ".. tostring(self.MissionObjectives[i].ObjectiveType) ,4);
			
			-- Cet objectif doit il etre check ?
			if self.MissionObjectives[i].ToBeCheck then
				OBJECTIVE_HAVE_CHANGE = OBJECTIVE_HAVE_CHANGE + self.MissionObjectives[i]:Trigger(self,event,arg1,arg2,arg3)
			end 
			
		end
		
		-- on met a jour le statut de la mission ?
		if OBJECTIVE_HAVE_CHANGE > 0 or table.getn(self.MissionObjectives) == 0 then 
			-- Un objectif a chang on regarde l'tat de la mission
			self:CheckMissionStatus()			
		end
	end

	-- Cette fonction check le statut de la mission en fonction de ces objectifs
	function RME_CLASS_MISSION:CheckMissionStatus()
		RME_DebugMsg("RME_CLASS_MISSION:CheckMissionStatus()",4);
		local MissionSuccess = 0
		if table.getn(self.MissionObjectives) == 0 then
			RME_Success_Mission(self.ID)
			RME_QuestLog_UpdateInfo()
			return
		end

		for i = 1, table.getn(self.MissionObjectives) do
			--On charge le npc courant (class de type RME_CLASS_NPC)
			RME_DebugMsg("RME_CLASS_MISSION:CheckObjective() Check objective ".. tostring(self.MissionObjectives[i].ObjectiveType) ,4);
			-- Objectif chou ?
			if self.MissionObjectives[i].ObjectiveFailed then
				-- Inutile de continuer, on lance l'event mission chou
				RME_DebugMsg("RME_CLASS_MISSION:CheckMissionStatus() Objectif "..tostring(i).." chou",4);
				RME_PlayerNotify(format(RME_LOCALE["RME_LOCALE_MISSION_FAILED"].text,tostring(self.Title)),1)
				RME_Failed_Mission(self.ID)
				return
			end
			-- Objectif russi ?
			if self.MissionObjectives[i].ObjectiveDone then
				RME_DebugMsg("RME_CLASS_MISSION:CheckMissionStatus() Objectif "..tostring(i).." russi",4);
				MissionSuccess = tonumber(MissionSuccess) + 1
			end
		end
		-- Si le nombre d'objectifs russis correspond au nombre d'objectifs de la mission c'est que les objectifs de mission sont russi, la mission est termine, il faut la valider
		if MissionSuccess == table.getn(self.MissionObjectives) then
			RME_PlayerNotify(format(RME_LOCALE["RME_LOCALE_QUEST_COMPLETE"].text,tostring(self.Title)),1)
			RME_Success_Mission(self.ID)
		else
			RME_Mega_Update()
		end
		
		
	end

	function RME_CLASS_MISSION:CheckTimer()
		-- On vrifie le status du timer
		if not self.MissionTimerExpiration or time() > self.MissionTimerExpiration then
			-- Timer coul
			RME_DebugMsg("RME_CLASS_MISSION:CheckMissionStatus() Objectif "..tostring(i).." chou",4);
			RME_PlayerNotify(format(RME_LOCALE["RME_LOCALE_TIME_EXPIRED"].text,self.Title),0)
			RME_Failed_Mission(self.ID)
			return
		end
		
	end
	
	-- Cette fonction active les objectifs de la mission ainsi que le timer
	function RME_CLASS_MISSION:ActivateObjectives()
		RME_DebugMsg("RME_CLASS_MISSION:ActivateObjectives()",4);
		for i = 1, table.getn(self.MissionObjectives) do
			-- On active la demande de check de cet objectif
			self.MissionObjectives[i].ToBeCheck = true	
			self.MissionObjectives[i].ObjectiveFailed = nil
			self.MissionObjectives[i].ObjectiveDone  =	nil
			
			
			if self.MissionObjectives[i].ObjectiveType == "CONDITION" then
				-- Si un objectif est une condition, on la passe par defaut en ObjectiveDone = true
				self.MissionObjectives[i].ObjectiveDone = true
				if self.MissionObjectives[i].Escort_VIP then
					RME_VIP_ESCORT_LIST[self.MissionObjectives[i].Escort_VIP] = true
				end
			elseif self.MissionObjectives[i].ObjectiveType == "KILL_MOB" then
				self.MissionObjectives[i].Kill_MobKilled = 0
				
			elseif self.MissionObjectives[i].ObjectiveType == "NEED_ITEM" then
				local LOCAL_ITEM = self.MissionItemsList[self.MissionObjectives[i].Need_Item_ItemNeeded]
				local Quantity = 0
				if LOCAL_ITEM then
					local	ObjetExist, Quantity, Position = RME_Bag_ItemCount(LOCAL_ITEM)
				end
				self.MissionObjectives[i].Need_Item_QuantityInBag = Quantity
				if tonumber(self.MissionObjectives[i].Need_Item_QuantityInBag) >= self.MissionObjectives[i].Need_Item_QuantityNeeded then
						-- Objectif atteint ! Je met a jour directement l'objectif (self.MissionObjectives[i])
						self.MissionObjectives[i].ObjectiveDone 	= 	true
						self.MissionObjectives[i].ObjectiveFailed 	= 	nil
				end
			end
		end
		
		if table.getn(self.MissionObjectives) == 0 then
			self.MissionSuccess = true
		end
		
		RME_DebugMsg("RME_CLASS_MISSION:ActivateObjectives() DONE !",4);
		
	end
	
	-- Cette fonction desactive les objectifs de la mission ainsi que les timer associs
	function RME_CLASS_MISSION:DesactivateObjectives()
		RME_DebugMsg("RME_CLASS_MISSION:DesactivateObjectives()",4);
		for i = 1, table.getn(self.MissionObjectives) do
			self.MissionObjectives[i].ToBeCheck 				= 	nil
			if self.MissionObjectives[i].ObjectiveType == "CONDITION" then
				if self.MissionObjectives[i].Escort_VIP then
					if RME_VIP_ESCORT_LIST[self.MissionObjectives[i].Escort_VIP] then
						RME_VIP_ESCORT_LIST[self.MissionObjectives[i].Escort_VIP] = nil
					end
				end
			end
		end	
	end
	
	function RME_CLASS_MISSION:ActivateEvents()
		RME_DebugMsg("RME_CLASS_MISSION:ActivateEvents()",4);
		for i = 1, table.getn(self.MissionEvents) do
			self.MissionEvents[i].ToBeCheck = true
		end
	end
	
	function RME_CLASS_MISSION:DesactivateEvents()
		RME_DebugMsg("RME_CLASS_MISSION:DesactivateEvents()",4);
		for i = 1, table.getn(self.MissionEvents) do
			self.MissionEvents[i].ToBeCheck = nil
		end
	end
	
	function RME_CLASS_MISSION:ActivateTimer()
		if self.MissionTimer then
			-- On rcupere le timestamp actuel (en seconde) auquel on rajoute le temps donn au joueur pour accomplir les objectifs
			self.MissionTimerExpiration	= tonumber(time() + self.MissionTimer)
			-- On lance l'event de vrification du timer
			RME_EventManager_AddEvent("CHECK_TIMER_MISSION",1,"RME_CheckMissionsTimer()",true)
			-- On affiche le timer
			RME_QuestTimerFrame.MISSION_ID = self.ID
			RME_QuestTimerFrame:Show()
		end
	end
	
	function RME_CLASS_MISSION:DesactivateTimer()
		if self.MissionTimer then
			-- On rcupere le timestamp actuel (en seconde) auquel on rajoute le temps donn au joueur pour accomplir les objectifs
			self.MissionTimerExpiration	= nil
			-- On cache le timer
			RME_QuestTimerFrame.MISSION_ID = nil
			RME_QuestTimerFrame:Hide()
		end
	end
	

RME_DebugMsg("<LOAD>RME_Class_Mission.lua"..RME_Return_ColoredText(" DONE !","ok"),3);