--[[    
    ROLEPLAY MISSION EDITOR (RME)
    Copyright (C) 2007,2008 Jean RODRIGUEZ  aka Enoril (Ryzom), Enoriel (WoW - Kirin Tor)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

]]
RME_DebugMsg("<LOAD>RME_Class_NPC.lua",3);

	RME_CLASS_NPC= class(function(a)
			a.Name			=	nil							-- Nom du NPC (ou du joueur finalissant la mission)
			a.RealZone		=   	nil							-- Nom de la zone principale dans laquel se trouve le npc
			a.MapID			= 	nil							-- Nom du continent
			a.ZoneID			= 	nil							-- Nom de la zone
			a.NPC_Hidden	=	nil							-- Ce pnj est cach ? (peut etre utile pour un cache cache)
			a.X				=	nil 							-- Coordonne X du npc
			a.Y				=	nil							-- Coordonne Y du npc
			a.StartMission	= 	nil							-- False si ce NPC donne une misison
			a.EndMission		=	nil							-- True si  ce NPC cloture une mission
			a.FromMissionID	= 	nil							-- Mission ID utilisant ce NPC
	end)

	-- Par defaut on renvoit le nom
	function RME_CLASS_NPC:__tostring()
		return self.Name
	end
	
	function RME_CLASS_NPC:Load(LOCAL_NPC)			
			self.Name			=	LOCAL_NPC.Name
			self.RealZone			=   	LOCAL_NPC.RealZone
			self.MapID			= 	LOCAL_NPC.MapID
			self.ZoneID			= 	LOCAL_NPC.ZoneID
			self.NPC_Hidden		= 	LOCAL_NPC.NPC_Hidden
			self.X				=	LOCAL_NPC.X
			self.Y				=	LOCAL_NPC.Y
			self.StartMission		= 	LOCAL_NPC.StartMission
			self.EndMission		=	LOCAL_NPC.EndMission
			self.FromMissionID		= 	LOCAL_NPC.FromMissionID
	end

	function RME_CLASS_NPC:IsValid(LOCAL_MISSION) 
		if self.Name and self.Name ~= "" and self.FromMissionID and self.FromMissionID == LOCAL_MISSION.ID and self.RealZone and self.RealZone ~= "" then
			return true
		end
		RME_PlayerNotify(format(RME_LOCALE["RME_LOCALE_EDITOR_NPC_HAVE_ERROR"].text,tostring(self.Name),tostring(self.RealZone)),0)
	end
	
RME_DebugMsg("<LOAD>RME_Class_NPC.lua"..RME_Return_ColoredText(" DONE !","ok"),3);