--[[    
    ROLEPLAY MISSION EDITOR (RME)
    Copyright (C) 2007,2008 Jean RODRIGUEZ  aka Enoril (Ryzom), Enoriel (WoW - Kirin Tor)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

]]
RME_DebugMsg("<LOAD>RME_Class_Objective.lua",3);

	RME_CLASS_OBJECTIVE = class(function(a)
			a.ObjectiveType				=   	nil		-- Mission type -> CONDITION | KILL_MOB | EXPLORATION | NEED_ITEM | NEED_EVENT
			a.ToBeCheck					=	nil 		-- doit on checker cet objectif ?
			a.ObjectiveDone				= 	nil		-- Objectif atteint
			a.ObjectiveFailed				= 	nil		-- Objectif perdu
			a.ObjectiveID					=	nil		-- ID unique de l'objectif
			
			-- ObjectiveType = EXPLORATION --
			a.Exploration_ZoneName		=	nil		-- Nom de la zone a explorer
			
			-- ObjectiveType = KILL_MOB --
			a.Kill_MobName 				=	nil		-- Nom du mob a tuer
			a.Kill_MobKilled				=	nil		-- Nombre de mob tu
			a.Kill_KillObjective				=   	nil		-- Nombre de mob  tuer
			
			-- ObjectiveType = CONDITION
			a.Mount_NotTaxi				= 	nil		-- Si NotTaxi==true, le joueur ne doit pas prendre de taxi
			a.Mount_NotMount			=	nil		-- Si Mount_NotMount == true, le joueur ne doit pas utiliser de monture
			a.Mount_NeedMount			=	nil		-- Si Mount_NeedMount == true, le joueur ne doit pas descendre de monture
			a.Player_MustBeAlive			=	nil		-- Si true, le joueur ne doit pas mourrir !!
			a.Escort_VIP					=	nil		-- Si diffrent de nil,  Escort_VIP ne doit pas mourrir !
			
			-- ObjectiveType = NEED_ITEM
			a.Need_Item_ItemNeeded		=	nil		-- De type RME_CLASS_ITEM
			a.Need_Item_QuantityNeeded	=	nil		-- Nombre d'objet attendu
			a.Need_Item_QuantityInBag	=	nil		-- Qty dans le sac
		
			-- ObjectiveType = NEED_EVENT
			a.Need_Event_EventID			=	nil		-- EventID ncessaire pour russi cet objectif
			a.Need_Event_ObjectiveName	=	nil		-- Texte de l'objectif
			
	end)

	-- Par defaut on renvoit l'ObjectiveType
	function RME_CLASS_OBJECTIVE:__tostring()
		return self.ObjectiveType
	end
	function RME_CLASS_OBJECTIVE:Load(LOCAL_OBJECTIVE)
		RME_DebugMsg("RME_CLASS_OBJECTIVE:LoadMissionSaved()",4);	
		self.ObjectiveType					=   	LOCAL_OBJECTIVE.ObjectiveType
		self.ToBeCheck					=	LOCAL_OBJECTIVE.ToBeCheck
		self.ObjectiveDone					= 	LOCAL_OBJECTIVE.ObjectiveDone
		self.ObjectiveFailed				= 	LOCAL_OBJECTIVE.ObjectiveFailed
		self.ObjectiveID					=	LOCAL_OBJECTIVE.ObjectiveID
		if not self.ObjectiveID then
			self.ObjectiveID				=	RME_Generate_New_GUID()
		end
		
		-- ObjectiveType = EXPLORATION --
		if self.ObjectiveType == "EXPLORATION" then
			self.Exploration_ZoneName		=	LOCAL_OBJECTIVE.Exploration_ZoneName
		
		-- ObjectiveType = KILL_MOB --
		elseif self.ObjectiveType == "KILL_MOB" then
			self.Kill_MobName 			=	LOCAL_OBJECTIVE.Kill_MobName
			self.Kill_MobKilled				=	LOCAL_OBJECTIVE.Kill_MobKilled
			self.Kill_KillObjective			=  	LOCAL_OBJECTIVE.Kill_KillObjective
		
		-- ObjectiveType = CONDITION
		elseif self.ObjectiveType == "CONDITION" then
			self.Mount_NotTaxi			= 	LOCAL_OBJECTIVE.Mount_NotTaxi
			self.Mount_NotMount			=	LOCAL_OBJECTIVE.Mount_NotMount
			self.Mount_NeedMount			=	LOCAL_OBJECTIVE.Mount_NeedMount
			self.Player_MustBeAlive		=	LOCAL_OBJECTIVE.Player_MustBeAlive
			self.Escort_VIP				=	LOCAL_OBJECTIVE.Escort_VIP

		-- ObjectiveType = NEED_ITEM
		elseif self.ObjectiveType == "NEED_ITEM" then
			self.Need_Item_ItemNeeded		=	LOCAL_OBJECTIVE.Need_Item_ItemNeeded
			self.Need_Item_QuantityNeeded	=	LOCAL_OBJECTIVE.Need_Item_QuantityNeeded
			self.Need_Item_QuantityInBag	=	LOCAL_OBJECTIVE.Need_Item_QuantityInBag
		
		-- ObjectiveType = NEED_EVENT
		elseif self.ObjectiveType == "NEED_EVENT" then
			self.Need_Event_EventID		=	LOCAL_OBJECTIVE.Need_Event_EventID
			self.Need_Event_ObjectiveName	=	LOCAL_OBJECTIVE.Need_Event_ObjectiveName
			
		end
		RME_DebugMsg("RME_CLASS_OBJECTIVE:LoadMissionSaved() DONE !",4);			
	end
	function RME_CLASS_OBJECTIVE:IsValid(LOCAL_MISSION)
		
		if self.ObjectiveType == "EXPLORATION" and self.Exploration_ZoneName and self.Exploration_ZoneName~= "" then
			return true
		
		-- ObjectiveType = KILL_MOB --
		elseif self.ObjectiveType == "KILL_MOB" and self.Kill_MobName and self.Kill_MobName ~= "" and self.Kill_KillObjective and self.Kill_KillObjective  > 0 then
			return true
			
		-- ObjectiveType = CONDITION
		elseif self.ObjectiveType == "CONDITION" and (self.Mount_NotTaxi or self.Mount_NotMount or self.Mount_NeedMount or self.Player_MustBeAlive or self.Escort_VIP) then
			return true

		-- ObjectiveType = NEED_ITEM
		elseif self.ObjectiveType == "NEED_ITEM" and self.Need_Item_ItemNeeded	and LOCAL_MISSION.MissionItemsList and LOCAL_MISSION.MissionItemsList[self.Need_Item_ItemNeeded] and self.Need_Item_QuantityNeeded and self.Need_Item_QuantityNeeded > 0 then
			return true
			
		-- ObjectiveType = NEED_EVENT
		elseif self.ObjectiveType == "NEED_EVENT" and self.Need_Event_EventID and self.MissionEvents[self.Need_Event_EventID] and self.Need_Event_ObjectiveName and self.Need_Event_ObjectiveName ~= "" then			
			return true
			
		end
		RME_PlayerNotify(format(RME_LOCALE["RME_LOCALE_EDITOR_OBJECTIVE_HAVE_ERROR"].text,tostring(self.ObjectiveType)),0)
	end
	function RME_CLASS_OBJECTIVE:Trigger(LOCAL_MISSION,event,arg1,arg2,arg3)
		-- EXPLORATION --
		if self.ObjectiveType == "EXPLORATION" and event == "EXPLORATION" then
			if not RME_PLAYER_INFO.IsAlive then 
				return 0
			end
			-- Si il s'agit d'un objectif EXPLORATION
			if event=="EXPLORATION" then
				-- On prend en compte l'event 
				-- 	arg1 contient la zone et arg2 contient la subzone
				-- 	self.Exploration_ZoneName contient la zone ou subzone a visiter
				if not arg3 then arg3= ""	end
				if string.lower(arg1) == string.lower(self.Exploration_ZoneName) or string.lower(arg2) == string.lower(self.Exploration_ZoneName) or string.lower(arg3) == string.lower(self.Exploration_ZoneName) then
				
					-- Objectif atteint ! 
					self.ObjectiveDone 	= 	true
					self.ToBeCheck	=	nil
					-- On informe le joueur qu'il a visiter une rgion comptant pour sa mission
					RME_DebugMsg("Visiter "..tostring(self.Exploration_ZoneName)..": "..RME_Return_ColoredText(" Reussi !","ok"),2);
					RME_PlayerNotify(format(RME_LOCALE["RME_LOCALE_OBJECTIVE_EXPLORATION"].text,self.Exploration_ZoneName).." ("..COMPLETE..")",1)							
					
					return 1 --afin de detecter qu'un objectif a chang
				end
			end
		end
		
		-- KILL_MOB --
		if self.ObjectiveType == "KILL_MOB" and event == "KILL_MOB" then
			-- Si il s'agit d'un objectif KILL
			-- On prend en compte l'event 
			-- 	arg1 contient le texte le nom du mob tu par le joueur
			-- 	self.Kill_MobName contient le nom du mob a tuer
			-- 	self.Kill_MobKilled contient le nombre de mob tu jusqu'a prsent
			-- 	self.Kill_KillObjective contient le nombre de mob  tuer pour russir l'objectif
			if string.lower(arg1) == string.lower(self.Kill_MobName) then
				-- On ajoute ce mob au nombre de mob deja tu
				self.Kill_MobKilled = tonumber(self.Kill_MobKilled) + 1
					
				-- Objectif atteint ?
				if tonumber(self.Kill_MobKilled) >= self.Kill_KillObjective then
					-- Objectif atteint !
					self.ObjectiveDone 	= 	true
					self.ToBeCheck	=	nil
					RME_DebugMsg("Tuer "..tostring(self.Kill_KillObjective).." "..tostring(self.Kill_MobName).." : "..RME_Return_ColoredText(" Atteint !","ok"),2);
					RME_PlayerNotify(format(RME_LOCALE["RME_LOCALE_OBJECTIVE_KILL"].text,tostring(self.Kill_MobName),tonumber(self.Kill_MobKilled),tonumber(self.Kill_KillObjective)).." ("..COMPLETE..")",tonumber(self.Kill_MobKilled / self.Kill_KillObjective))
				else
					-- On informe le joueur qu'il a tu un mob comptant pour sa mission
					RME_DebugMsg(tostring(self.Kill_MobName)..": "..tostring(self.Kill_MobKilled).."/"..tostring(self.Kill_KillObjective),2);
					RME_PlayerNotify(format(RME_LOCALE["RME_LOCALE_OBJECTIVE_KILL"].text,tostring(self.Kill_MobName),tonumber(self.Kill_MobKilled),tonumber(self.Kill_KillObjective)),tonumber(self.Kill_MobKilled / self.Kill_KillObjective))
				end
				return 1 --afin de detecter qu'un objectif a chang
			end
		end

		-- CHECK ITEM
		if self.ObjectiveType == "NEED_ITEM" then
			-- On rcupere d'abord les infos sur l'objet demand
			local LOCAL_ITEM = LOCAL_MISSION.MissionItemsList[self.Need_Item_ItemNeeded]
			local	ObjetExist, Quantity, Position = RME_Bag_ItemCount(LOCAL_ITEM)
			if not self.Need_Item_QuantityInBag then
				self.Need_Item_QuantityInBag = 0 	-- Creation temporaire, Need_Item_QuantityInBag n'est pas sauvegard
			end
			if not Quantity then  Quantity = 0 	end
			if Quantity ~= self.Need_Item_QuantityInBag then
				RME_DebugMsg(tostring(self.Need_Item_QuantityInBag).."/"..tostring(Quantity),1);
				self.Need_Item_QuantityInBag = Quantity
				-- Objectif atteint ?
				if tonumber(self.Need_Item_QuantityInBag) >= self.Need_Item_QuantityNeeded then
					-- Objectif atteint ! Je met a jour directement l'objectif
					self.ObjectiveDone 	= 	true
					self.ToBeCheck	=	nil
					RME_PlayerNotify(tostring(LOCAL_ITEM.Name).." : "..tostring(self.Need_Item_QuantityInBag).."/"..tostring(self.Need_Item_QuantityNeeded).." ("..COMPLETE..")",tonumber(self.Need_Item_QuantityInBag / self.Need_Item_QuantityNeeded))
				else
					-- On informe le joueur qu'il a tu ramass un objet comptant pour sa mission
					RME_PlayerNotify(tostring(LOCAL_ITEM.Name).." : "..tostring(self.Need_Item_QuantityInBag).."/"..tostring(self.Need_Item_QuantityNeeded),tonumber(self.Need_Item_QuantityInBag / self.Need_Item_QuantityNeeded))
				end
				return 1 --afin de detecter qu'un objectif a chang
			end
		end
		-- CONDITION
		if self.ObjectiveType == "CONDITION" then
			-- Cet objectif fonctionne a l'envers. Si on rencontre l'event et la condition l'objectif est perdu, la mission aussi
			
			-- Joueur en taxi alors que c'est interdit ?
			if event == "TAXI_ON" and self.Mount_NotTaxi then
				RME_DebugMsg("RME_CLASS_MISSION:CheckObjective() CONDITION: joueur sur taxi, perdu",4);
				self.ObjectiveFailed 		= 	true
				self.ObjectiveDone		= 	nil
				self.ToBeCheck		=	nil
				RME_PlayerNotify(RME_LOCALE["RME_LOCALE_CONDITION_NOTAXI"].text.." ("..FAILED..")",0)
				return 1
			end
			
			-- Joueur en mounture alors que c'est interdit ?
			if event == "MOUNT_ON" and self.Mount_NotMount then
				RME_DebugMsg("RME_CLASS_MISSION:CheckObjective() CONDITION: joueur sur monture, perdu",4);
				self.ObjectiveFailed 		= 	true
				self.ObjectiveDone		= 	nil
				self.ToBeCheck		=	nil				
				RME_PlayerNotify(RME_LOCALE["RME_LOCALE_CONDITION_NOMOUNT"].text.." ("..FAILED..")",0)
				return 1
			end

			-- Joueur descendu de monture alors que c'est interdit ?
			if event == "MOUNT_OFF" and self.Mount_NeedMount then
				RME_DebugMsg("RME_CLASS_MISSION:CheckObjective() CONDITION: joueur descendu de sa monture, perdu",4);
				self.ObjectiveFailed 		= 	true
				self.ObjectiveDone		= 	nil
				self.ToBeCheck		=	nil
				RME_PlayerNotify(RME_LOCALE["RME_LOCALE_CONDITION_USEMOUNT"].text.." ("..FAILED..")",0)
				return 1
			end
			
			-- Le joueur est mort, est ce que c'tait permis ?
			if event == "PLAYER_DEAD" and self.Player_MustBeAlive then
				RME_DebugMsg("RME_CLASS_MISSION:CheckObjective() CONDITION: joueur mort, perdu",4);
				self.ObjectiveFailed 		= 	true
				self.ObjectiveDone		= 	nil
				self.ToBeCheck		=	nil
				RME_PlayerNotify(RME_LOCALE["RME_LOCALE_CONDITION_PLAYERSURVIVAL"].text.." ("..FAILED..")",0)
				return 1
			end
			
			-- La cible a escorter est elle morte ?
			if event == "VIP_DEAD" and self.Escort_VIP == arg1 then
				RME_DebugMsg("RME_CLASS_MISSION:CheckObjective() CONDITION: VIP  escorter mort, perdu",4);
				self.ObjectiveFailed 		= 	true
				self.ObjectiveDone		= 	nil
				self.ToBeCheck			=	nil
				RME_PlayerNotify(format(RME_LOCALE["RME_LOCALE_CONDITION_ESCORTVIP"].text,self.Escort_VIP).." ("..FAILED..")",0)
				return 1
			end
		end
		-- NEED_EVENT
		if self.ObjectiveType == "NEED_EVENT" and event == "EVENT" then
			if  arg1 == self.Need_Event_EventID then
				self.ObjectiveDone 	= 	true
				self.ToBeCheck		=	nil
			end
			RME_PlayerNotify(tostring(self.Need_Event_ObjectiveName).." ("..COMPLETE..")",1)
			return 1
		end 
		return 0
	end
	-- Retourne le texte li a l'objectif
	function RME_CLASS_OBJECTIVE:ObjectiveStatus(LOCAL_MISSION,IsEditor)
	
		local Text
		
		if self.ObjectiveType == "EXPLORATION" then
			if not self.Exploration_ZoneName then
				self.Exploration_ZoneName = RME_LOCALE["RME_LOCALE_EDITOR_NEED_ZONENAME"].text
			end
			Text = format(RME_LOCALE["RME_LOCALE_OBJECTIVE_EXPLORATION"].text,tostring(self.Exploration_ZoneName))
			
		elseif self.ObjectiveType == "KILL_MOB" then
			if not self.Kill_MobName then
				self.Kill_MobName = RME_LOCALE["RME_LOCALE_EDITOR_NEED_MOBNAME"].text
			end
			if not self.Kill_MobKilled then
				self.Kill_MobKilled = 0
			end
			if not self.Kill_KillObjective then
				self.Kill_KillObjective = 1
			end
			Text = format(RME_LOCALE["RME_LOCALE_OBJECTIVE_KILL"].text,tostring(self.Kill_MobName),tonumber(self.Kill_MobKilled),tonumber(self.Kill_KillObjective))

		elseif self.ObjectiveType == "NEED_ITEM" then
			--Calcul
			if self.Need_Item_ItemNeeded and LOCAL_MISSION.MissionItemsList[self.Need_Item_ItemNeeded].Name then
			
				if not self.Need_Item_QuantityInBag then
					self.Need_Item_QuantityInBag = 0
				end
				if not self.Need_Item_QuantityNeeded then
					self.Need_Item_QuantityNeeded = 1
				end
				
			
				Text = RME_Translate_To_UTF8(tostring(LOCAL_MISSION.MissionItemsList[self.Need_Item_ItemNeeded].Name ).." : "..tostring(self.Need_Item_QuantityInBag).."/"..tostring(self.Need_Item_QuantityNeeded))
			else
				Text = RME_LOCALE["RME_QuestEditorFrame_Objective_Type_NEED_ITEM_ChooseItem"].text
			end
			
		elseif self.ObjectiveType == "CONDITION" then
		
			if self.Mount_NotTaxi then
				Text = RME_LOCALE["RME_LOCALE_CONDITION_NOTAXI"].text
				
			elseif self.Mount_NotMount then
				Text = RME_LOCALE["RME_LOCALE_CONDITION_NOMOUNT"].text
				
			elseif self.Mount_NeedMount then
				Text = RME_LOCALE["RME_LOCALE_CONDITION_USEMOUNT"].text
				
			elseif self.Player_MustBeAlive then
				Text = RME_LOCALE["RME_LOCALE_CONDITION_PLAYERSURVIVAL"].text
			
			elseif self.Escort_VIP then
				Text = format(RME_LOCALE["RME_LOCALE_CONDITION_ESCORTVIP"].text,self.Escort_VIP)

			end			

			if not Text then
				Text = RME_LOCALE["RME_QuestEditorFrame_Objective_Type_CONDITION_ChooseCondition"].text
			end
			
		elseif self.ObjectiveType == "NEED_EVENT" then
			Text = tostring(self.Need_Event_ObjectiveName)
		
		else
			Text = RME_LOCALE["RME_LOCALE_CONDITION_UNKNOWN"].text
		end
		
		if not IsEditor then
			if self.ObjectiveFailed then
				return RME_ColorToText(RMEQuestDifficultyColor["objectivedone"].r, RMEQuestDifficultyColor["objectivedone"].g, RMEQuestDifficultyColor["objectivedone"].b)..Text.." ("..FAILED..")|r"
			elseif self.ObjectiveDone then
				return RME_ColorToText(RMEQuestDifficultyColor["objectivedone"].r, RMEQuestDifficultyColor["objectivedone"].g, RMEQuestDifficultyColor["objectivedone"].b)..Text.." ("..COMPLETE..")|r"
			else
				return Text
			end			
		else
			return "<"..RME_LOCALE["RME_QuestEditorFrame_Objective_Type_List"][self.ObjectiveType].."> "..Text
		end
	end	
RME_DebugMsg("<LOAD>RME_Class_Objective.lua"..RME_Return_ColoredText(" DONE !","ok"),3);