RME_DebugMsg("<LOAD>RME_Class_Player.lua",3);

	RME_CLASS_PLAYER = class(function(a,unit)
		a.Name 						= 		RME_Translate_To_UTF8(UnitName(unit))
		a.Level 						= 		UnitLevel(unit)
		a.Race,a.Race2					=		UnitRace(unit)
		a.Class,a.Class2				=		UnitClass(unit)
		a.Faction 						= 		UnitFactionGroup(unit)
		a.Guild, _, _					=		GetGuildInfo(unit);
		a.UnitOnTaxi					=		UnitOnTaxi(unit) 			-- Returns 1 if unit is on a taxi, nil otherwise. 
		a.UnitOnMount					=		RME_PlayerMounted()
		a.InInstance, _					=		IsInInstance()
		a.IsAlive						= 		not UnitIsDeadOrGhost(unit)
		a.IsAggro						=		UnitAffectingCombat(unit);
		a.Location_RealZone				= 		RME_Translate_To_UTF8(GetRealZoneText()) --
		a.Location_SubZone 				= 		RME_Translate_To_UTF8(GetSubZoneText())
		a.Location_MinimapZone 			= 		RME_Translate_To_UTF8(GetMinimapZoneText())
		SetMapToCurrentZone();
		a.X, a.Y 						= 		GetPlayerMapPosition(unit)
		a.Last_X, a.Last_Y				= 		0,0 
		a.MapID 						= 		GetCurrentMapContinent()
		a.ZoneID						=		GetCurrentMapZone()
		a.Server						=		GetCVar("realmName")
	end)

	-- Par defaut on renvoit le nom
    function RME_CLASS_PLAYER:__tostring()
		return self.Name
    end
	
	-- On met a jour la position x,y du joueur
	function RME_CLASS_PLAYER:Update(unit)
		self.Level 						= 		UnitLevel(unit)
		self.Guild, _, _					=		GetGuildInfo(unit);
		self.UnitOnTaxi 				= 		UnitOnTaxi("player")
		self.UnitOnMount				=		RME_PlayerMounted()
		self.InInstance, _				=		IsInInstance()
		self.IsAlive					= 		not UnitIsDeadOrGhost(unit)		
		self.IsAggro					=		UnitAffectingCombat(unit);
		self.Location_RealZone			= 		RME_Translate_To_UTF8(GetRealZoneText())
		self.Location_SubZone 			= 		RME_Translate_To_UTF8(GetSubZoneText())
		self.Location_MinimapZone 		= 		RME_Translate_To_UTF8(GetMinimapZoneText())
		SetMapToCurrentZone();
		self.X, self.Y 					= 		GetPlayerMapPosition("player")
		self.MapID 					= 		GetCurrentMapContinent()
		self.ZoneID					=		GetCurrentMapZone()		
	end
	

RME_DebugMsg("<LOAD>RME_Class_Player.lua"..RME_Return_ColoredText(" DONE !","ok"),3);