RME_DebugMsg("<LOAD>RME_Class_Target.lua",3);

	RME_CLASS_TARGET = class(function(a,unit)
		-- Basic
		a.Name 					= 		nil
		a.Level 					= 		nil
		a.Health 					= 		nil
		a.CanInteract 				= 		nil
		a.IsAlive					= 		nil
		a.Location_RealZone		= 		RME_Translate_To_UTF8(GetRealZoneText())
		a.Location_SubZone 		= 		RME_Translate_To_UTF8(GetSubZoneText())
		a.Location_MinimapZone 	= 		RME_Translate_To_UTF8(GetMinimapZoneText())
		a.X, a.Y					= 		nil , nil
		a.MapID					=		nil
		-- Attributs
		a.IsNPC 					= 		false
		a.Faction 					= 		nil
		a.PlayerStanding 			= 		nil
		a.IsAnNpcMission 			= 		false
		a.NpcMissionsList			=		{} --Contient la liste des IDmission disponibles pour cette target
		a.MapID 					= 		GetCurrentMapContinent()
		a.ZoneID					=		GetCurrentMapZone()
		a.GUID					=		UnitGUID(unit) 
		
    end)

	-- Par defaut on renvoit le nom
	function RME_CLASS_TARGET:__tostring()
		return self.Name
	end
	
	function RME_CLASS_TARGET:Update(unit) 
		RME_DebugMsg("RME_CLASS_TARGET:Update("..tostring(unit)..")",4);
		-- On met  jour les informations de la target
		self.Name 						= 		RME_Translate_To_UTF8(UnitName(unit))
		if self.Name == "" then 
			self.Name = nil 
		end
		if self.Name == nil then
			self.Level 						= 		nil
			self.Health 					= 		nil
			self.CanInteract 				= 		nil
			self.IsAlive					= 		nil
			self.Location_RealZone 			= 		nil
			self.Location_SubZone 			= 		nil
			self.Location_SubZone 			= 		nil
			self.X, self.Y					= 		nil , nil
			self.MapID					=		nil
			-- Attributs
			self.IsNPC 					= 		nil
			self.Faction 					= 		nil
			self.PlayerStanding 				= 		nil
			self.IsAnNpcMission 			= 		nil
			self.NpcMissionsList				=		{} --Contient la liste des IDmission disponibles pour cette target
			self.MapID 					= 		nil
			self.ZoneID					=		nil
			self.GUID						=		nil
			return; 
		end -- Pas de cible
		self.Level 						= 		UnitLevel(unit)
		self.Health 					= 		UnitHealth(unit)
		self.CanInteract 				= 		self:CheckInteraction(unit)
		self.IsAlive 					= 		not UnitIsDeadOrGhost(unit);
		self.Location_RealZone			= 		RME_Translate_To_UTF8(GetRealZoneText())
		self.Location_SubZone 			= 		RME_Translate_To_UTF8(GetSubZoneText())
		self.Location_MinimapZone 		= 		RME_Translate_To_UTF8(GetMinimapZoneText())
		self.GUID						=		UnitGUID(unit) 
		if self.CanInteract then -- On rcupere la position du pnj uniquement si le joueur est proche de celui ci
			SetMapToCurrentZone();
			self.X, self.Y 				= 		GetPlayerMapPosition("player")
			self.MapID 				= 		GetCurrentMapContinent()
			self.ZoneID				=		GetCurrentMapZone()
		else
			self.X, self.Y				= 		nil , nil
			self.MapID				=		nil
			self.ZoneID				=		nil			
		end
		if UnitIsPlayer(unit) or UnitPlayerControlled(unit) then
			-- Target Joueur
			self.IsNPC 				= 		nil
			self.Faction 				= 		nil
			self.PlayerStanding 			= 		nil
			self.IsAnNpcMission 		= 		nil
			self.X 					= 		nil
			self.Y 					= 		nil
			self.MapID 				= 		nil
			self.ZoneID				=		nil			
		else
			-- Target NPC
			self.IsNPC 				= 		true
			self.Faction 				= 		nil -- return_NPCFaction(unit)
			self.PlayerStanding 			= 		nil -- return_PlayerFactionStanding(a.Faction)
			-- Si la faction n'est pas connu du joueur, return nil (cela signifie que la rcupration du joueur peut avoir chou)
			if self.PlayerStanding == nil then
				self.Faction 			= 		nil 
			end		
		end
		self.IsAnNpcMission				= 		self:CheckIsAnNpcMission(UnitName(unit))
			
		RME_DebugMsg("RME_CLASS_TARGET:Update("..tostring(unit)..") DONE !",4);

	end
	
	-- Le joueur se trouve t il a cot ?
	function RME_CLASS_TARGET:CheckInteraction(unit)
		
		RME_DebugMsg("RME_CLASS_TARGET:CheckInteraction("..tostring(unit)..")",4);
		if (CheckInteractDistance(unit, 2) ) then
			RME_DebugMsg("CanInteract=true",4);
			return true
		else
			RME_DebugMsg("CanInteract=false",4);
			return
		end
		
	end
	
	-- La cible a t elle une mission a proposer/terminer ?
	-- Si oui on charge les missions dans self.NpcMissionsList
	function RME_CLASS_TARGET:CheckIsAnNpcMission(Name)
	
		RME_DebugMsg("RME_CLASS_TARGET;CheckIsAnNpcMission("..tostring(Name)..")",4);
		-- Pour savoir si ce npc propose/finalise une mission, on regarde si son nom est connu dans la liste des interactions possibles
		-- La liste des npc se trouve dans RME_NPC_INTERACTION_LIST
		-- On chargera la mission dans NpcMissionsList
		self.NpcMissionsList = {}
		
		if Name == nil then 
			RME_DebugMsg("RME_CLASS_TARGET;CheckIsAnNpcMission()=false 1",4);
			return false; 
		end
		
		-- Ce pnj attend une interaction du joueur ?
		if RME_NPC_INTERACTION_LIST[string.lower(Name)] then
			local LOCAL_NPC
			-- On rcupere la liste des mission qu'a ce pnj
			RME_DebugMsg("#RME_NPC_INTERACTION_LIST[string.lower(Name)]="..tostring(#RME_NPC_INTERACTION_LIST[string.lower(Name)]),4);
			for i=1,#RME_NPC_INTERACTION_LIST[string.lower(Name)] do
				LOCAL_NPC = RME_NPC_INTERACTION_LIST[string.lower(Name)][i]
				-- Oui ! on charge donc la mission dans self.NpcMissionsList
			
				-- mais avant on vrifie si la mission cit dans le NPC existe bien ! (On connait le mission ID via l'info LOCAL_NPC.FromMissionID)
				if RME_MISSIONS_LIST[LOCAL_NPC.FromMissionID] then
					-- tout est ok, On rajoute l'ID de la mission
					table.insert(self.NpcMissionsList,#self.NpcMissionsList+1,LOCAL_NPC.FromMissionID)
					RME_DebugMsg("Mission ID ["..tostring(LOCAL_NPC.FromMissionID).."] found in missions list. Adding missionID "..tostring(LOCAL_NPC.FromMissionID).." for NPC "..tostring(Name),4);	
						
				else
						-- Souci !
					RME_DebugMsg("Mission ID ["..tostring(LOCAL_NPC.FromMissionID).."] not found in missions list. Fix missionID association for NPC "..tostring(Name),1);	
				end
			end
		end

		
		-- On regarde a prsent si self.NpcMissionsList contient des missions
		-- Si oui on renvoit CheckIsAnNpcMission = true 
		-- Si non on renvoit CheckIsAnNpcMission = false
		if #self.NpcMissionsList == 0 then
			RME_DebugMsg("No mission found for the npc "..tostring(Name),3);	
			RME_DebugMsg("RME_CLASS_TARGET;CheckIsAnNpcMission()=false",4);
			return false
		else
			RME_DebugMsg(tostring(table.getn(self.NpcMissionsList)).." mission(s) found for the npc "..tostring(Name),3);	
			RME_DebugMsg("RME_CLASS_TARGET;CheckIsAnNpcMission()=true",4);
			return true
		end
		
	end
	
RME_DebugMsg("<LOAD>RME_Class_Player.lua"..RME_Return_ColoredText(" DONE !","ok"),3);