--[[    
    ROLEPLAY MISSION EDITOR (RME)
    Copyright (C) 2007,2008 Jean RODRIGUEZ  aka Enoril (Ryzom), Enoriel (WoW - Kirin Tor)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

]]
RME_DebugMsg("<LOAD>RME_Frames.lua()",3)

--[[RME_Load_Variable_InitAndLoading]]--

--[[RME_Utilities()]]--
	--RME_Utility_StringHash
	function RME_Utility_StringHash(text)
		if not text then
			RME_DebugMsg("RME_Utility_StringHash() Pas de texte !",1)
			return
		end
	  local counter = 1
	  local len = string.len(text)
	  for i = 1, len, 3 do 
	    counter = math.fmod(counter*8161, 4294967279) +  -- 2^32 - 17: Prime!
		  (string.byte(text,i)*16776193) +
		  ((string.byte(text,i+1) or (len-i+256))*8372226) +
		  ((string.byte(text,i+2) or (len-i+256))*3932164)
	  end
	  return math.fmod(counter, 4294967291) -- 2^32 - 5: Prime (and different from the prime in the loop)
	end
	
	--RME_GetActiveForm
	function RME_Utility_GetActiveForm()
		--Permet de rcuprer la forme du joueur (forme localise !)
		local nb,is_active,form_name
		for nb=1,GetNumShapeshiftForms() do
			_,form_name,is_active = GetShapeshiftFormInfo(nb)
			if is_active then
				return form_name
			end
		end
	end
--[[ POPUP ]]--
StaticPopupDialogs["RME_CONFIRM_NEW_MISSION"] = {
	text = RME_LOCALE["RME_LOCALE_POPUP_CONFIRM_NEW_MISSION"].text,
	button1 = YES,
	button2 = NO,
	OnAccept = function()
		RME_PanelFrame_Mission_EditMission_NewMission(true);
	end,
	timeout = 0,
	showAlert = 1,
	hideOnEscape = 1,
};
StaticPopupDialogs["RME_CONFIRM_LOAD_MISSION"] = {
	text = RME_LOCALE["RME_LOCALE_POPUP_CONFIRM_LOAD_MISSION"].text,
	button1 = YES,
	button2 = NO,
	OnAccept = function()
		RME_PanelFrame_Mission_EditMission_LoadMission(true);
	end,
	timeout = 0,
	showAlert = 1,
	hideOnEscape = 1,
};
StaticPopupDialogs["RME_CONFIRM_DELETE_MISSION"] = {
	text = RME_LOCALE["RME_LOCALE_POPUP_CONFIRM_DELETE_MISSION"].text,
	button1 = YES,
	button2 = NO,
	OnAccept = function()
		RME_PanelFrame_Editor_DeleteMission(true);
	end,
	timeout = 0,
	showAlert = 1,
	hideOnEscape = 1,
	sound = "PVPTHROUGHQUEUE",
};
StaticPopupDialogs["RME_CONFIRM_CANCEL_EDITION"] = {
	text = RME_LOCALE["RME_CONFIRM_CANCEL_EDITION"].text,
	button1 = YES,
	button2 = NO,
	OnAccept = function()
		RME_PanelFrame_Editor_CancelEdition_OnClick(true);
	end,
	timeout = 0,
	showAlert = 1,
	hideOnEscape = 1,
	sound = "PVPTHROUGHQUEUE",
};

StaticPopupDialogs["RME_CONFIRM_LEAVE_MISSION"] = {
	text = RME_LOCALE["RME_LOCALE_POPUP_CONFIRM_LEAVE_MISSION"].text,
	button1 = YES,
	button2 = NO,
	OnAccept = function()
		RME_Cancel_Mission(true);
	end,
	timeout = 0,
	showAlert = 1,
	hideOnEscape = 1,
};
StaticPopupDialogs["RME_CONFIRM_IGNORE_MISSION"] = {
	text = RME_LOCALE["RME_LOCALE_POPUP_CONFIRM_IGNORE_MISSION"].text,
	button1 = YES,
	button2 = NO,
	OnAccept = function()
		RME_QuestFrameIgnoreButton_OnClick(true);
	end,
	timeout = 0,
	showAlert = 1,
	hideOnEscape = 1,
};
StaticPopupDialogs["RME_EDITOR_TOO_MANY_MISSIONS"] = {
	text = RME_LOCALE["RME_EDITOR_TOO_MANY_MISSIONS"].text,
	button1 = OKAY,
	timeout = 0,
	showAlert = 1,
	hideOnEscape = 1,
};	 
StaticPopupDialogs["RME_TOO_MANY_MISSIONS"] = {
	text = RME_LOCALE["RME_LOCALE_POPUP_TOO_MANY_MISSIONS"].text,
	button1 = OKAY,
	OnAccept = function()
		return
	end,
	timeout = 0,
	showAlert = 1,
	hideOnEscape = 1,
};
StaticPopupDialogs["RME_CONFIRM_MISSING_NPC_START"] = {
	text = RME_LOCALE["RME_CONFIRM_MISSING_START_NPC"].text,
	button1 = YES,
	button2 = NO,
	OnAccept = function()
		RME_PanelFrame_Editor_PublishMission_OnClick(true);
	end,
	timeout = 0,
	showAlert = 1,
	hideOnEscape = 1,
};
StaticPopupDialogs["RME_CONFIRM_CANCEL_MISSION_IN_PROGRESS"] = {
	text = RME_LOCALE["RME_CONFIRM_CANCEL_MISSION_IN_PROGRESS"].text,
	button1 = YES,
	button2 = NO,
	OnAccept = function()
		RME_PanelFrame_Editor_PublishMission_OnClick(true,true);
	end,
	timeout = 0,
	showAlert = 1,
	hideOnEscape = 1,
};
StaticPopupDialogs["RME_CONFIRM_CANCEL_MISSION_COMPLETE"] = {
	text = RME_LOCALE["RME_CONFIRM_CANCEL_MISSION_COMPLETE"].text,
	button1 = YES,
	button2 = NO,
	OnAccept = function()
		RME_PanelFrame_Editor_PublishMission_OnClick(true,true,true);
	end,
	timeout = 0,
	showAlert = 1,
	hideOnEscape = 1,
};
StaticPopupDialogs["RME_EDITOR_CONFIRM_DELETE_ITEM_OBJECTIVE_NEED_ITEM"] = {
	text = RME_LOCALE["RME_EDITOR_CONFIRM_DELETE_ITEM_OBJECTIVE_NEED_ITEM"].text,
	button1 = YES,
	button2 = NO,
	OnAccept = function()
		RME_QuestEditorFrame_Item_Delete_OnClick(true);
	end,
	timeout = 0,
	showAlert = 1,
	hideOnEscape = 1,
};
StaticPopupDialogs["RME_EDITOR_CONFIRM_DELETE_ITEM_CREATE_ITEM"] = {
	text = RME_LOCALE["RME_EDITOR_CONFIRM_DELETE_ITEM_CREATE_ITEM"].text,
	button1 = YES,
	button2 = NO,
	OnAccept = function()
		RME_QuestEditorFrame_Item_Delete_OnClick(true,true);
	end,
	timeout = 0,
	showAlert = 1,
	hideOnEscape = 1,
};	

StaticPopupDialogs["RME_CONFIRM_DELETE_ITEM"] = {
	text = RME_LOCALE["RME_CONFIRM_DELETE_ITEM"].text,
	button1 = YES,
	button2 = NO,
	OnAccept = function()
		RME_QuestLogRewardItemTemplate_OnClick("LeftButton",true);
	end,
	timeout = 0,
	showAlert = 1,
	hideOnEscape = 1,
};
StaticPopupDialogs["RME_EDITOR_CANT_LOAD_NOT_AUTHORIZED"] = {
	text = RME_LOCALE["RME_EDITOR_CANT_LOAD_NOT_AUTHORIZED"].text,
	button1 = OKAY,
	timeout = 0,
	showAlert = 1,
	hideOnEscape = 1,
};
StaticPopupDialogs["RME_EDITOR_CANT_PUBLISH_NOT_AUTHORIZED"] = {
	text = RME_LOCALE["RME_EDITOR_CANT_PUBLISH_NOT_AUTHORIZED"].text,
	button1 = OKAY,
	timeout = 0,
	showAlert = 1,
	hideOnEscape = 1,
	sound = "igQuestLogAbandonQuest",		
};	 
StaticPopupDialogs["RME_EDITOR_CANT_PUBLISH_MISSING_TEXTE"] = {
	text = RME_LOCALE["RME_LOCALE_EDITOR_MISSING_TEXTE"].text,
	button1 = OKAY,
	timeout = 0,
	showAlert = 1,
	hideOnEscape = 1,
	sound = "igQuestLogAbandonQuest",	
};	
StaticPopupDialogs["RME_EDITOR_CANT_PUBLISH_MISSING_END_NPC"] = {
	text = RME_LOCALE["RME_LOCALE_EDITOR_MISSING_END_NPC"].text,
	button1 = OKAY,
	timeout = 0,
	showAlert = 1,
	hideOnEscape = 1,
	sound = "igQuestLogAbandonQuest",	
};	
StaticPopupDialogs["RME_EDITOR_CANT_PUBLISH_MISSION_HAVE_ERROR"] = {
	text = RME_LOCALE["RME_EDITOR_CANT_PUBLISH_MISSION_HAVE_ERROR"].text,
	button1 = OKAY,
	timeout = 0,
	showAlert = 1,
	hideOnEscape = 1,
	sound = "igQuestLogAbandonQuest",	
};	
StaticPopupDialogs["RME_EDITOR_CANT_SET_GUILD"] = {
	text = RME_LOCALE["RME_EDITOR_CANT_SET_GUILD"].text,
	button1 = OKAY,
	timeout = 0,
	showAlert = 1,
	hideOnEscape = 1,
};
--[[ RME_Frame_Mouse ]]--
function RME_Frame_OnMouseDown()
	if (arg1 == "LeftButton") then
		this:StartMoving()
	end
end
function RME_Frame_OnMouseUp()
	if (arg1 == "LeftButton") then
		this:StopMovingOrSizing()
	end
end
--[[ RME_Mega_Update ]]--
function RME_Mega_Update(full)
	RME_DebugMsg("RME_Mega_Update("..tostring(full)..")",2);
	if full then
		RME_Load_Available_Mission(RME_PLAYER_INFO.Location_RealZone)	
	end
	if RME_QuestLogFrame:IsShown() then
		RME_QuestLog_Update()
	end
	if RME_GossipFrame:IsShown() then
		RME_GossipFrameUpdate()
	end
	if RME_BagFrame:IsShown() then
		RME_Bag_Update()
	end
	if RME_PanelFrame_Mission_ChooseMission:IsShown() then
		RME_PanelFrame_Mission_ChooseMission_OnShow()
	end	
	
	RME_UpdateGossipOnglets()
	RME_UpdateMainOnglets()
	RME_Minimap_Button_Update()
	RME_DebugMsg("RME_Mega_Update() DONE !",2);
end
--[[RME_Onglet Quest Log]]--
function RME_UpdateMainOnglets()
	RME_DebugMsg("RME_UpdateMainOnglets()",4)
	
	if QuestLogFrame:IsShown() then
		RME_TabsOnglet1UP:Show(); -- Onglet 1 activ
		RME_TabsOnglet1DOWN:Hide();
		RME_TabsOnglet2UP:Hide();
		RME_TabsOnglet2DOWN:Show();
		RME_TabsOnglet3UP:Hide();
		RME_TabsOnglet3DOWN:Show();
	
	elseif RME_QuestLogFrame:IsShown() then
		RME_TabsOnglet1UP:Hide(); 
		RME_TabsOnglet1DOWN:Show();
		RME_TabsOnglet2UP:Show(); -- Onglet 2 activ
		RME_TabsOnglet2DOWN:Hide();
		RME_TabsOnglet3UP:Hide();
		RME_TabsOnglet3DOWN:Show();

	--[[elseif RME_QuestLogFrame:IsShown() then
		RME_TabsOnglet1UP:Hide(); 
		RME_TabsOnglet1DOWN:Show();
		RME_TabsOnglet2UP:Hide(); 
		RME_TabsOnglet2DOWN:Show();
		RME_TabsOnglet3UP:Show(); -- Onglet 3 activ
		RME_TabsOnglet3DOWN:Hide();	
	]]
	else
		-- Tout est cach
		RME_TabsOnglet1UP:Hide(); 
		RME_TabsOnglet1DOWN:Hide();
		RME_TabsOnglet2UP:Hide(); 
		RME_TabsOnglet2DOWN:Hide();
		RME_TabsOnglet3UP:Hide(); 
		RME_TabsOnglet3DOWN:Hide();
	
	end
end
function RME_Onglet_Click(TabNumber)	
	RME_DebugMsg("RME_Onglet_Click("..tostring(TabNumber)..")",4);
	
	if TabNumber == 1 then
		--On affiche la fenetre de quete normale
		ShowUIPanel(QuestLogFrame);
		HideUIPanel(RME_QuestLogFrame);
		-- On actualise les onglets
		RME_UpdateMainOnglets()
		
	elseif TabNumber == 2 then
		--On affiche la fenetre de quete RME > RME_QuestLogFrame <
		ShowUIPanel(RME_QuestLogFrame);
		HideUIPanel(QuestLogFrame);
		-- On actualise les onglets
		RME_UpdateMainOnglets()
		
	elseif TabNumber == 3 then
	
		ShowUIPanel(RME_PanelFrame)
		RME_PanelFrame_TabButton_OnClick(3)
		--ShowUIPanel(RME_QuestEditorFrame);
		HideUIPanel(QuestLogFrame);
		HideUIPanel(RME_QuestLogFrame);
		-- On actualise les onglets
		RME_UpdateMainOnglets()
	end
end
function RME_Legend_OnEnter(Local_Table)
	GameTooltip_AddNewbieTip(Local_Table.text, 1.0, 1.0, 1.0, Local_Table.help, 1);
end
function RME_Legend_OnLeave()
	GameTooltip:Hide();
end
--[[RME_QuestLogFrame]]--
function RME_QuestLogTitleButton_OnLoad()
	RME_DebugMsg(" RME_QuestLogTitleButton_OnLoad()",4)	
	this:RegisterForClicks("LeftButtonUp", "RightButtonUp");
	this.MISSION_ID = nil -- Contiendra l'ID de la mission
end
function RME_QuestLogTitleButton_OnEvent(event)
	RME_DebugMsg(" RME_QuestLogTitleButton_OnEvent("..tostring(event)..")",4)	
	if ( GameTooltip:IsOwned(this) ) then
		GameTooltip:Hide();
	end
end
function RME_QuestLogTitleButton_OnEnter()
	-- Pourra etre utilis pour afficher les info sup de la mission
	-- this.MISSION_ID
	
	
end
function RME_QuestLogTitleButton_OnLeave()
	if (this.MISSION_ID ~= RME_QUESTLOG_MISSIONID) then
		getglobal(this:GetName().."Tag"):SetTextColor(this.r, this.g, this.b);
	end
	GameTooltip:Hide();
end
function RME_QuestLog_OnLoad()
	RME_DebugMsg(" RME_QuestLog_OnLoad",4)	
	RMEQuestFramePushQuestButton:Disable();
	tinsert(UISpecialFrames,this:GetName());
end
function RME_QuestLog_Update()

	RME_DebugMsg("RME_QuestLog_Update()",4)	
	-- update texte "Quetes 0/25"
	RME_QuestLogQuestCount:SetText(format(RME_LOCALE["RME_LOCALE_MISSION_COUNT_TEMPLATE"].text, RME_getn(RME_IN_PROGRESS_MISSIONS_LIST), tonumber(RME_MAX_MISSIONS)));
	local width = RME_QuestLogQuestCount:GetWidth();
	local textHeight = 12;
	local hPadding = 15;
	local vPadding = 8;
	width = RME_QuestLogQuestCount:GetWidth();
	RME_QuestLogCount:SetHeight(textHeight+8);
	RME_QuestLogCount:SetPoint("TOPRIGHT", RME_QuestLogFrame, "TOPRIGHT", -44, -41);
	RME_QuestLogCount:SetWidth(width+hPadding);

	-- Update frame si pas de mission
	if ( RME_getn(RME_IN_PROGRESS_MISSIONS_LIST) == 0 ) then
		RME_EmptyQuestLogFrame:Show();
		RME_QuestLogDetailScrollFrame:Hide();
		RME_QuestLogFrameAbandonButton:Disable();
		RME_QuestLogFrame.hasTimer = nil;
		RMEQuestFramePushQuestButton:Disable();

	else
		RME_EmptyQuestLogFrame:Hide();
		RME_QuestLogDetailScrollFrame:Show();
		RME_QuestLogFrameAbandonButton:Enable();
		RME_QuestLogFrame.hasTimer = nil;
		RMEQuestFramePushQuestButton:Enable();

	end

	if not RME_QUESTLOG_MISSIONID and RME_getn(RME_IN_PROGRESS_MISSIONS_LIST) > 0 then
		RME_QUESTLOG_MISSIONID = RME_getkey(RME_IN_PROGRESS_MISSIONS_LIST)
		RME_QuestLogListScrollFrame:SetVerticalScroll(0)
	end
	
	-- On update le fauxscroll qui liste les noms de mission	
	if RME_getn(RME_IN_PROGRESS_MISSIONS_LIST) > RME_MISSION_DISPLAYED then
		FauxScrollFrame_Update(RME_QuestLogListScrollFrame,RME_getn(RME_IN_PROGRESS_MISSIONS_LIST), RME_MISSION_DISPLAYED, RME_QUESTLOG_QUEST_HEIGHT, nil, nil, nil, RME_QuestLogHighlightFrame, 293, 316 )
	else
		FauxScrollFrame_Update(RME_QuestLogListScrollFrame,6, 5, 16, nil, nil, nil, nil,nil, nil )
		RME_QuestLogListScrollFrameScrollBarScrollUpButton:Disable()
		RME_QuestLogListScrollFrameScrollBarScrollDownButton:Disable()		
	end
	-- Update the quest listing
	RME_QuestLogHighlightFrame:Hide();

	--RME_QUESTLOG_MISSIONID
	local questIndex, questLogTitle, questTitleTag, questNumGroupMates, questNormalText, questHighlight, questCheck;
	local questLogTitleText, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily, color;
	local numPartyMembers, partyMembersOnQuest, tempWidth, textWidth;
	local LOCAL_MISSION
		
	for i=1, RME_MISSION_DISPLAYED, 1 do
		
		questIndex = i + FauxScrollFrame_GetOffset(RME_QuestLogListScrollFrame);
		questLogTitle = getglobal("RME_QuestLogTitle"..i);
		questTitleTag = getglobal("RME_QuestLogTitle"..i.."Tag");
		questNumGroupMates = getglobal("RME_QuestLogTitle"..i.."GroupMates");
		questCheck = getglobal("RME_QuestLogTitle"..i.."Check");
		questNormalText = getglobal("RME_QuestLogTitle"..i.."NormalText");
		questHighlight = getglobal("RME_QuestLogTitle"..i.."Highlight");

		if ( questIndex <= RME_getn(RME_IN_PROGRESS_MISSIONS_LIST)  ) then
			
			LOCAL_MISSION = RME_IN_PROGRESS_MISSIONS_LIST[RME_getkey(RME_IN_PROGRESS_MISSIONS_LIST,questIndex)]
			questLogTitle.MISSION_ID = LOCAL_MISSION.ID
			--[[
			if LOCAL_MISSION.Level then
				questLogTitle:SetText("["..tostring(LOCAL_MISSION.Level).."] "..tostring(LOCAL_MISSION.Title));
				QuestLogDummyText:SetText("["..tostring(LOCAL_MISSION.Level).."] "..tostring(LOCAL_MISSION.Title));
			else
			end
			]]--
			questLogTitle:SetText(tostring(LOCAL_MISSION.Title));
			QuestLogDummyText:SetText(tostring(LOCAL_MISSION.Title));
			
			questLogTitle:SetNormalTexture("");
			questHighlight:SetTexture("");
			questTag = nil
			if ( LOCAL_MISSION.MissionFailed ) then
				questTag = FAILED;
			elseif (LOCAL_MISSION.MissionSuccess ) then
				questTag = COMPLETE;
			end
			if ( questTag ) then
				questTitleTag:SetText("("..questTag..")");
				-- Shrink text to accomdate quest tags without wrapping
				tempWidth = 275 - 15 - questTitleTag:GetWidth();
				if ( QuestLogDummyText:GetWidth() > tempWidth ) then
					textWidth = tempWidth;
				else
					textWidth = QuestLogDummyText:GetWidth();
				end
				questNormalText:SetWidth(tempWidth);
				-- If there's quest tag position check accordingly
				questCheck:Hide();
			else
				questTitleTag:SetText("");
				questNormalText:SetWidth(275);
				questCheck:Hide();
			end
			if LOCAL_MISSION.Level then
				color = RME_GetDifficultyColor(LOCAL_MISSION.Level);
			else
				color = QuestDifficultyColor["standard"];
			end
			questTitleTag:SetTextColor(color.r, color.g, color.b);
			questLogTitle:SetTextColor(color.r, color.g, color.b);
			questNumGroupMates:SetTextColor(color.r, color.g, color.b);
			questLogTitle.r = color.r;
			questLogTitle.g = color.g;
			questLogTitle.b = color.b;
			questLogTitle:Show();

			-- Place the highlight and lock the highlight state
			if ( RME_QUESTLOG_MISSIONID == LOCAL_MISSION.ID ) then
				RME_QuestLogHighlightFrame:SetPoint("TOPLEFT", "RME_QuestLogTitle"..i, "TOPLEFT", 0, 0);
				RME_QuestLogSkillHighlight:SetVertexColor(questLogTitle.r, questLogTitle.g, questLogTitle.b);
				RME_QuestLogHighlightFrame:Show();
				questTitleTag:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
				questLogTitle:LockHighlight();
			else
				questLogTitle:UnlockHighlight();
			end
			
		else
			questLogTitle:Hide();
		end
	end
	RME_QuestLog_UpdateInfo()
end
function RME_QuestLog_UpdateInfo ()
	RME_DebugMsg("RME_QuestLog_UpdateInfo()",4)
	
	-- Si il n'y a pas de mission slectionn on annule
	if not RME_QUESTLOG_MISSIONID or not RME_QuestLogFrame:IsShown() then
		return
	end
	
	-- Chargement de la mission
	local LOCAL_MISSION = RME_IN_PROGRESS_MISSIONS_LIST[RME_QUESTLOG_MISSIONID]
	--[[TITRE]]--
	--Titre de la mission
	if not LOCAL_MISSION.Title then
		RME_QuestLogQuestTitle:SetText("")
	elseif LOCAL_MISSION.MissionFailed then -- On ajoute le tag "failed" sur le titre
		RME_QuestLogQuestTitle:SetText(LOCAL_MISSION.Title.." - ("..FAILED..")")
	else
		RME_QuestLogQuestTitle:SetText(LOCAL_MISSION.Title) 
	end	
	--[[OBJECTIFS]]--
	--Objectifs de la mission
	RME_QuestLogObjectivesText:SetText(RME_Replace_Text(LOCAL_MISSION.MissionText_Objective))
	
		-- Timer si besoin
		if LOCAL_MISSION.MissionTimer and not LOCAL_MISSION.MissionSuccess then

			RME_QuestLogTimerText:Show();
			if LOCAL_MISSION.MissionTimerExpiration and time() < LOCAL_MISSION.MissionTimerExpiration then
				RME_QuestLogTimerText:SetText(TIME_REMAINING.." "..SecondsToTime(tonumber(LOCAL_MISSION.MissionTimerExpiration - time())));
				RME_QuestLogTimerText:SetTextColor(0,0,0);
				
			elseif LOCAL_MISSION.MissionFailed then
				RME_QuestLogTimerText:SetText(TIME_REMAINING.." "..FAILED);
				RME_QuestLogTimerText:SetTextColor(RMEQuestDifficultyColor["objectivedone"].r, RMEQuestDifficultyColor["objectivedone"].g, RMEQuestDifficultyColor["objectivedone"].b);
				
			elseif LOCAL_MISSION.MissionSuccess then
				RME_QuestLogTimerText:SetText(TIME_REMAINING.." "..COMPLETE);
				RME_QuestLogTimerText:SetTextColor(RMEQuestDifficultyColor["objectivedone"].r, RMEQuestDifficultyColor["objectivedone"].g, RMEQuestDifficultyColor["objectivedone"].b);
			
			end

			-- On rattache le timer derriere derriere le titre Objectifs
			RME_QuestLogTimerText:SetPoint("TOPLEFT", "RME_QuestLogObjectivesText", "BOTTOMLEFT", 0, -10);
			-- On rattache le 1er objectif derriere le timer
			RME_QuestLogObjective1:SetPoint("TOPLEFT", "RME_QuestLogTimerText", "BOTTOMLEFT", 0, -10);
			
		else
			--RME_QuestLogFrame.hasTimer = nil;
			RME_QuestLogTimerText:Hide();
			-- On rattache le 1er objectif derriere le titre Objectifs
			RME_QuestLogObjective1:SetPoint("TOPLEFT", "RME_QuestLogObjectivesText", "BOTTOMLEFT", 0, -10);
		end
		
		--liste des objectifs >> RME_QuestLogObjective1->10
		for i = 1, table.getn(LOCAL_MISSION.MissionObjectives) do
			
			-- Chargement de l'objectif courant
			local LOCAL_OBJECTIVE = LOCAL_MISSION.MissionObjectives[i]
			
			if LOCAL_OBJECTIVE.ObjectiveFailed then
				--getglobal("RME_QuestLogObjective"..i):SetTextColor(RMEQuestDifficultyColor["objectivedone"].r, RMEQuestDifficultyColor["objectivedone"].g, RMEQuestDifficultyColor["objectivedone"].b);
				getglobal("RME_QuestLogObjective"..i):SetText(LOCAL_OBJECTIVE:ObjectiveStatus(LOCAL_MISSION));
				
			elseif LOCAL_OBJECTIVE.ObjectiveDone then
				--getglobal("RME_QuestLogObjective"..i):SetTextColor(RMEQuestDifficultyColor["objectivedone"].r, RMEQuestDifficultyColor["objectivedone"].g, RMEQuestDifficultyColor["objectivedone"].b);
				getglobal("RME_QuestLogObjective"..i):SetText(LOCAL_OBJECTIVE:ObjectiveStatus(LOCAL_MISSION));
				
			else
				--getglobal("RME_QuestLogObjective"..i):SetTextColor(0, 0, 0);
				getglobal("RME_QuestLogObjective"..i):SetText(LOCAL_OBJECTIVE:ObjectiveStatus(LOCAL_MISSION));
				
				
			end			
			getglobal("RME_QuestLogObjective"..i):Show();
			RME_QuestLogFrame_SetAsLastShown(getglobal("RME_QuestLogObjective"..i))
			
		end
		
		-- On cache les objectifs inutiles
		for i= table.getn(LOCAL_MISSION.MissionObjectives) + 1, RME_MAX_OBJECTIVES, 1 do
			getglobal("RME_QuestLogObjective"..i):Hide();
		end
	
	--[[DESCRIPTION]]--
		-- On rattache le titre "Description" derriere le dernier texte affich. 
		-- Si cette mission a des objectifs on le rattache derriere le dernier objectif
		-- Sinon derriere le timer (si actif) ou derriere le texte Objectif
		
		
		if table.getn(LOCAL_MISSION.MissionObjectives) > 0 then
			-- il y a des objectifs on place le titre a la suite
			RME_QuestLogDescriptionTitle:SetPoint("TOPLEFT", "RME_QuestLogObjective"..table.getn(LOCAL_MISSION.MissionObjectives), "BOTTOMLEFT", 0, -10);
			
		else
			-- Pas d'objectif, on place soit apres le timer (si actif) soit apres le texte d'objectifs
			if ( LOCAL_MISSION.MissionTimer) then
				RME_QuestLogDescriptionTitle:SetPoint("TOPLEFT", "RME_QuestLogTimerText", "BOTTOMLEFT", 0, -10);
			else
				RME_QuestLogDescriptionTitle:SetPoint("TOPLEFT", "RME_QuestLogObjectivesText", "BOTTOMLEFT", 0, -10);
			end
		end
		
		
	-- RME_QuestLogDescriptionTitle >> Texte "Description" on touche pas
	--Description de la mission
		if ( not LOCAL_MISSION.MissionText_Description ) then
			RME_QuestLogQuestDescription:SetText("")
			RME_QuestLogDescriptionTitle:Hide()
			RME_QuestLogFrame_SetAsLastShown(RME_QuestLogQuestDescription)
		else
			RME_QuestLogQuestDescription:SetText(RME_Replace_Text(LOCAL_MISSION.MissionText_Description))
			RME_QuestLogDescriptionTitle:Show()
		end	

	--[[RECOMPENSE]]--
	--Reward
		-- Y a t il une rcompense ? (reward choice et/ou reward)
		if (table.getn(LOCAL_MISSION.MissionRewardChoice) + table.getn(LOCAL_MISSION.MissionReward)) > 0   then
			
			-- texte rcompense
			RME_QuestLogRewardTitleText:Show()
			
			--[[MissionRewardChoice]]--
			-- Affichage des rcompenses slectionnables (normalement au moins 2)
			if table.getn(LOCAL_MISSION.MissionRewardChoice) > 0 then
				-- On propose aux joueurs de choisir sa rcompense, on affiche donc la phrase
				RME_QuestLogItemChooseText:Show()
				RME_QuestLogFrame_SetAsLastShown(RME_QuestLogItemChooseText)			
					
				-- On place le 1er item sous la phrase de choix
				RME_QuestLogItem1:SetPoint("TOPLEFT", "RME_QuestLogItemChooseText", "BOTTOMLEFT", 0, -10);
					
				-- On boucle sur la liste des items "choix"
				for i = 1, table.getn(LOCAL_MISSION.MissionRewardChoice) do
					-- On charge l'item
					local LOCAL_ITEM = LOCAL_MISSION.MissionItemsList[LOCAL_MISSION.MissionRewardChoice[i]]
					-- On met a jour l'affichage
					local questItem = getglobal("RME_QuestLogItem"..i);
					questItem.type = "reward"			-- Sera utilis pour la gestion de l'objet (clic, etc)
					questItem.LOCAL_ITEM = LOCAL_ITEM
					-- Mise a jour affichage
					getglobal("RME_QuestLogItem"..i.."Name"):SetText(LOCAL_ITEM.Name);
					getglobal("RME_QuestLogItem"..i.."IconTexture"):SetTexture(LOCAL_ITEM.Texture);
					if LOCAL_ITEM.Quantity > 1 then
						getglobal("RME_QuestLogItem"..i.."Count"):SetText(tostring(LOCAL_ITEM.Quantity));
					else
						getglobal("RME_QuestLogItem"..i.."Count"):SetText("");
					end
					
					---LOCAL_MISSION.MissionRewardChoice[i]:isUsable()
					-- L'utilisateur saura l'utiliser ?
					if (true) then
						SetItemButtonTextureVertexColor(questItem, 1.0, 1.0, 1.0);
						SetItemButtonNameFrameVertexColor(questItem, 1.0, 1.0, 1.0);
					else
						SetItemButtonTextureVertexColor(questItem, 0.9, 0, 0);
						SetItemButtonNameFrameVertexColor(questItem, 0.9, 0, 0);
					end
					-- Placement (ils sont affichs 2 par ligne		
					if ( i > 1 ) then
						if ( mod(i,2) == 1 ) then
							questItem:SetPoint("TOPLEFT", "RME_QuestLogItem"..(i - 2), "BOTTOMLEFT", 0, -2);
						else
							questItem:SetPoint("TOPLEFT", "RME_QuestLogItem"..(i - 1), "TOPRIGHT", 1, 0);
						end
					else
						questItem:SetPoint("TOPLEFT", "RME_QuestLogItemChooseText", "BOTTOMLEFT", -3, -5);
					end
					-- On affiche l'item
					questItem:Show();
					RME_QuestLogFrame_SetAsLastShown(questItem, spacerFrame);
					
					-- Erase suite a bug
					LOCAL_ITEM = nil
				end
			else
				-- Pas de rcompense slectionnable, on cache la phrase
				RME_QuestLogItemChooseText:Hide()				
			end

			--[[MissionReward]]--
			if ( table.getn(LOCAL_MISSION.MissionReward) > 0  ) then
				-- On annonce au joueurs qu'il recevra de(s) objet(s)
				-- Mais suivant si il y a eu ou non des choix de rcompense (au dessus) la phrase change
				if table.getn(LOCAL_MISSION.MissionRewardChoice) > 0 then
					-- Il y a eu des rcompenses a choisir, on met a jour le texte en consquence et on s'accroche donc en dessous du dernier objectif (derniere ligne, cot gauche)
					RME_QuestLogItemReceiveText:SetText(REWARD_ITEMS);
						-- Calcul du numro d'objectif se trouvant a la derniere ligne a gauche
						local index = table.getn(LOCAL_MISSION.MissionRewardChoice);
							if ( mod(index, 2) == 0 ) then
								index = index - 1;
						end
						RME_QuestLogItemReceiveText:SetPoint("TOPLEFT", "RME_QuestLogItem"..index, "BOTTOMLEFT", 3, -5);
				else
					-- il n'y a que ces rcompenses, on met a jour le texte et on s'accroche donc a la suite du titre "recompense"
					RME_QuestLogItemReceiveText:SetText(REWARD_ITEMS_ONLY);
					RME_QuestLogItemReceiveText:SetPoint("TOPLEFT", "RME_QuestLogRewardTitleText", "BOTTOMLEFT", 3, -5);
					
				end
				-- On affiche a prsent le bon texte
				RME_QuestLogItemReceiveText:Show();
				RME_QuestLogFrame_SetAsLastShown(RME_QuestLogItemReceiveText, spacerFrame);
				
				-- On boucle sur la liste des items "rcompense"
				for i=1, table.getn(LOCAL_MISSION.MissionReward), 1 do
					-- On charge l'item
					local LOCAL_ITEM = LOCAL_MISSION.MissionItemsList[LOCAL_MISSION.MissionReward[i]]

					index = i + table.getn(LOCAL_MISSION.MissionRewardChoice) -- On utilise le 1er item non utilis
					local questItem = getglobal("RME_QuestLogItem"..index);
					questItem.type = "reward"			-- Sera utilis pour la gestion de l'objet (clic, etc)
					questItem.LOCAL_ITEM = LOCAL_ITEM
					-- Mise a jour affichage
					getglobal("RME_QuestLogItem"..index.."Name"):SetText(LOCAL_ITEM.Name);
					getglobal("RME_QuestLogItem"..index.."IconTexture"):SetTexture(LOCAL_ITEM.Texture);
					if LOCAL_ITEM.Quantity > 1 then
						getglobal("RME_QuestLogItem"..index.."Count"):SetText(tostring(LOCAL_ITEM.Quantity));
					else
						getglobal("RME_QuestLogItem"..index.."Count"):SetText("");
					end
					-- L'utilisateur saura l'utiliser ?
					--LOCAL_MISSION.MissionReward[i]:isUsable()
					if (true) then
						SetItemButtonTextureVertexColor(questItem, 1.0, 1.0, 1.0);
						SetItemButtonNameFrameVertexColor(questItem, 1.0, 1.0, 1.0);
					else
						SetItemButtonTextureVertexColor(questItem, 0.9, 0, 0);
						SetItemButtonNameFrameVertexColor(questItem, 0.9, 0, 0);
					end
					-- Placement (ils sont affichs 2 par ligne		
					if ( i >  1 ) then
						if ( mod(i,2) == 1 ) then
							questItem:SetPoint("TOPLEFT", "RME_QuestLogItem"..(index - 2), "BOTTOMLEFT", 0, -2);
						else
							questItem:SetPoint("TOPLEFT", "RME_QuestLogItem"..(index - 1), "TOPRIGHT", 1, 0);
						end
					else
						questItem:SetPoint("TOPLEFT", "RME_QuestLogItemReceiveText", "BOTTOMLEFT", -3, -5);
					end
					-- On affiche l'item
					questItem:Show();
					RME_QuestLogFrame_SetAsLastShown(questItem, spacerFrame);
					-- Erase suite a bug
					LOCAL_ITEM = nil
				end -- End for
				
			else
				-- Pas de rcompense slectionnable, on cache la phrase
				RME_QuestLogItemReceiveText:Hide()				
			end
			
			-- On cache le surlignage des objets (utile uniquement lors de la finalisation de la mission et le choix de la rcompense)
			RME_QuestRewardItemHighlight:Hide();
			-- On cache les item non utiliss
			for i=(table.getn(LOCAL_MISSION.MissionReward) + table.getn(LOCAL_MISSION.MissionRewardChoice) + 1), RME_MAX_ITEMS, 1 do
				getglobal("RME_QuestLogItem"..i):Hide();
			end
			
		else
			-- Pas de rcompenses du tout pour cette mission, on cache tout
			RME_QuestRewardItemHighlight:Hide();
			RME_QuestLogRewardTitleText:Hide()
			RME_QuestLogItemChooseText:Hide()
			RME_QuestLogItemReceiveText:Hide();
			for i=tonumber(table.getn(LOCAL_MISSION.MissionReward) + table.getn(LOCAL_MISSION.MissionRewardChoice) + 1), RME_MAX_ITEMS, 1 do
				getglobal("RME_QuestLogItem"..i):Hide();
			end
			RME_QuestLogFrame_SetAsLastShown(getglobal("RME_QuestLogQuestDescription"))
		end

	
		
end
function RME_QuestLog_PushMission()
	if RME_QUESTLOG_MISSIONID then
		RME_Comm_PUSH_MISSION(RME_QUESTLOG_MISSIONID,"PARTY")
	end
end
function RME_QuestLogFrame_SetAsLastShown(frame, spacerFrame)
	if ( not spacerFrame ) then
		spacerFrame = RME_QuestLogSpacerFrame;
	end
	spacerFrame:SetPoint("TOP", frame, "BOTTOM", 0, 0);
end
function RME_QuestLogTitleButton_OnClick(arg1,arg2)

	RME_DebugMsg("RME_QuestLogTitleButton_OnClick("..tostring(arg2)..")",4)		
	RME_QUESTLOG_MISSIONID = this.MISSION_ID	
	RME_QuestLog_Update()
	-- on remonte le scrollframe decrivant la mission
	RME_QuestLogDetailScrollFrame:SetVerticalScroll(0)
	
end
function RME_QuestLog_OnShow()
	RME_DebugMsg("RME_QuestLog_OnShow",4)	
	if  RME_GossipFrame:IsShown() then
		HideUIPanel(RME_GossipFrame);
	end	
	if  GossipFrame:IsShown() then
		HideUIPanel(GossipFrame);
	end	
	RME_UpdateMainOnglets()
	RME_QuestLog_Update()	
	PlaySound("igQuestLogOpen")	
end
function RME_QuestLog_OnHide()
	RME_DebugMsg("RME_QuestLog_OnHide",4)	
	RME_UpdateMainOnglets()
	PlaySound("igQuestLogClose");
end
function RME_ToggleQuestLog()
	RME_DebugMsg("RME_ToggleQuestLog()",4)	
	if ( RME_QuestLogFrame:IsShown() ) then 
		HideUIPanel(RME_QuestLogFrame);-- On cache
		if ( QuestLogFrame:IsShown() ) then
			HideUIPanel(QuestLogFrame);
		end
	else
		ShowUIPanel(RME_QuestLogFrame); -- On affiche
		if ( QuestLogFrame:IsShown() ) then
			HideUIPanel(QuestLogFrame);
		end
	end
	RME_UpdateMainOnglets()

	PlaySound("igCharacterInfoTab");
	RME_DebugMsg("RME_ToggleQuestLog() OK",4)	
end
--[[ RME_PanelFrame ]]--
function RME_PanelFrame_OnLoad()
	RME_DebugMsg("RME_PanelFrame_OnLoad()",3)	
	tinsert(UISpecialFrames, "RME_PanelFrame")
	RME_PanelFrame_TxtOptionsTitle:SetText(RME_ADDON_NAME.." - "..RME_VERSION_TEXTE)
	PanelTemplates_SetNumTabs(RME_PanelFrame_Tabs, 6 )
	RME_PanelFrame_Tabs.selectedTab = 1
	PanelTemplates_UpdateTabs( RME_PanelFrame_Tabs )
	this.ACTION = nil
end
function RME_PanelFrame_OnShow()
end
function RME_PanelFrame_OnHide()
	if RME_PanelFrame.ACTION then
		RME_PanelFrame_Mission_Select_Cancel_OnClick()
	end
end
function RME_PanelFrame_DropDown_Initialize()
	if string.sub(this:GetName(),-6) ~= "Button" then return end
	local dropDownName = string.sub(this:GetName(),1,-7)
	local choice = RME_LOCALE[dropDownName].choice1
	local count = 1
	while choice do
		local info = UIDropDownMenu_CreateInfo()
		info.text = choice
		info.value = count
		info.func = getglobal(dropDownName.."_OnClick") 
		UIDropDownMenu_AddButton( info )
		count = count + 1
		choice = RME_LOCALE[dropDownName]["choice"..count] 
	end
end
function RME_PanelFrame_Toggle()
	RME_DebugMsg("RME_PanelFrame_Toggle()",4)	
	if ( RME_PanelFrame:IsShown() ) then
		HideUIPanel(RME_PanelFrame);
	else
		ShowUIPanel(RME_PanelFrame);
	end
	PlaySound("igCharacterInfoTab");
end
function RME_PanelFrame_TabButton_OnClick(arg1,arg2)
	RME_DebugMsg("RME_PanelFrame_TabButton_OnClick("..tostring(arg1)..","..tostring(arg2)..")",4)	
	
	if not arg1 then arg1 =  this:GetID() end
	if not arg2 then arg2 = "RME_PanelFrame" end
	
	if string.find(arg2, "RME_PanelFrame") then
	
		PanelTemplates_SetTab(RME_PanelFrame_Tabs,arg1)	
		local selected = RME_PanelFrame_Tabs.selectedTab
		
		RME_PanelFrame_General:Hide()
		RME_PanelFrame_Mission:Hide()
		RME_PanelFrame_Editor:Hide()
		RME_PanelFrame_GM:Hide()
		RME_PanelFrame_Help:Hide()
		RME_PanelFrame_Credits:Hide()
		
		if  selected == 1 then --Bienvenue
			RME_PanelFrame_General:Show()
		end
		if  selected == 2 then --Mission
			RME_PanelFrame_Mission:Show()
		end
		if  selected == 3 then --Editeur Mission
			RME_PanelFrame_Editor:Show()
		end
		if  selected == 4 then --Mode MJ
			if RME_Comm_SENDER_IS_LEADER(RME_PLAYER_INFO.Name) then
				RME_PanelFrame_GM:Show()
			else
				message(RME_LOCALE["RME_PanelFrame_GM_Create_Session_NotGroupLeader"].text)
				PanelTemplates_SetTab(RME_PanelFrame_Tabs,1)	
				RME_PanelFrame_General:Show()
			end
		end
		if  selected == 5 then -- Options
			RME_PanelFrame_Help:Show()
		end
		if  selected == 6 then --Aide/Credit
			RME_PanelFrame_Credits:Show()
		end

	elseif string.find(arg2, "RME_QuestEditorFrame") then
		
		PanelTemplates_SetTab(RME_QuestEditorFrame_Tabs,arg1)
	
		RME_QuestEditorFrame_General:Hide()
		RME_QuestEditorFrame_Mission:Hide()
		RME_QuestEditorFrame_Objective:Hide()
		RME_QuestEditorFrame_NPC:Hide()
		RME_QuestEditorFrame_Object:Hide()
		RME_QuestEditorFrame_Event:Hide()
		
		local selected = RME_QuestEditorFrame_Tabs.selectedTab
		if  selected == 1 then
			RME_QuestEditorFrame_General:Show()
		end
		if  selected == 2 then
			RME_QuestEditorFrame_Mission:Show()
		end
		if  selected == 3 then
			RME_QuestEditorFrame_Objective:Show()
			RME_QuestEditorFrame_Objectives_Update()
		end
		if  selected == 4 then
			RME_QuestEditorFrame_NPC:Show()
			RME_QuestEditorFrame_NPCs_Update()
		end
		if  selected == 5 then
			RME_QuestEditorFrame_Object:Show()
			RME_QuestEditorFrame_Item_Update()
		end
		if  selected == 6 then
			RME_QuestEditorFrame_Event:Show()
			RME_QuestEditorFrame_Events_Update()
		end		
		
	end
	
end
-- Mission --
function RME_PanelFrame_Mission_OnLoad()
end
function RME_PanelFrame_Mission_OnShow()
end
function RME_PanelFrame_MissionLine_OnLoad()
	this:RegisterForClicks("LeftButtonUp", "RightButtonUp");
	this.r = nil
	this.g = nil
	this.b = nil
	this.MISSION_ID = nil
end
function RME_PanelFrame_MissionLine_OnClick(arg1,ID)
	RME_DebugMsg("RME_PanelFrame_MissionLine_OnClick()"..tostring(this.MISSION_ID),4)	
	RME_MISSIONID_SELECTED = this.MISSION_ID
	RME_PanelFrame_Mission_Update()
	if RME_PanelFrame.ACTION then
		RME_ChooseMission_Validation:Enable()
	end
end
function RME_PanelFrame_MissionLine_OnEnter()
	return
end
function RME_PanelFrame_MissionLine_OnLeave()
	if (this.MISSION_ID ~= RME_MISSIONID_SELECTED) then
		getglobal(this:GetName().."Tag"):SetTextColor(this.r, this.g, this.b);
	end
	GameTooltip:Hide();
end
function RME_PanelFrame_Mission_ChooseMission_OnLoad()
	this:SetBackdropColor(0.1,0.1,0.1,1)
end
function RME_PanelFrame_Mission_ChooseMission_OnShow()
	if RME_MISSION_NEEDUPDATE then
		RME_MISSION_AUTHOR_LIST_SORTED = RME_PanelFrame_SortAuthors(RME_MISSIONS_LIST)
		RME_MISSIONS_LIST_SORTED = RME_PanelFrame_SortMissions(RME_MISSIONS_LIST,RME_AUTHOR_SELECTED,nil,RME_CAMPAGNE_SELECTED)
		RME_CAMPAGNES_LIST = RME_PanelFrame_SortCampagne(RME_MISSIONS_LIST)
		RME_CAMPAGNES_LIST_SORTED = RME_PanelFrame_SortCampagne(RME_MISSIONS_LIST)
		UIDropDownMenu_Initialize(RME_PanelFrame_Mission_ChooseMission_DropDownEditorList, RME_PanelFrame_Mission_ChooseMission_DropDownEditorList_Refresh)
		UIDropDownMenu_Initialize(RME_PanelFrame_Mission_ChooseMission_DropDownCampagneList, RME_PanelFrame_Mission_ChooseMission_DropDownCampagneList_Refresh)
		UIDropDownMenu_Initialize(RME_QuestEditorFrame_MissionCampagneDropDown, RME_QuestEditorFrame_MissionCampagneDropDown_Refresh)
		
		RME_MISSION_NEEDUPDATE= nil
	end
	RME_PanelFrame_Mission_Update()
end
function RME_PanelFrame_Mission_ChooseMission_DropDownEditorList_OnClick()
	RME_DebugMsg("RME_PanelFrame_Mission_ChooseMission_DropDownEditorList_OnClick()"..tostring(this:GetID()),4)	
	UIDropDownMenu_SetSelectedID(RME_PanelFrame_Mission_ChooseMission_DropDownEditorList, this:GetID());
	RME_AUTHOR_SELECTED = RME_MISSION_AUTHOR_LIST_SORTED[UIDropDownMenu_GetSelectedID(RME_PanelFrame_Mission_ChooseMission_DropDownEditorList)-1]
	RME_MISSIONS_LIST_SORTED = RME_PanelFrame_SortMissions(RME_MISSIONS_LIST,RME_AUTHOR_SELECTED,nil,RME_CAMPAGNE_SELECTED)
	RME_PanelFrame_Mission_Update()
end
function RME_PanelFrame_Mission_ChooseMission_DropDownEditorList_Refresh()
	RME_DebugMsg("RME_PanelFrame_Mission_ChooseMission_DropDownEditorList_Refresh()",4)	
	local dropDownName = "RME_PanelFrame_Mission_ChooseMission_DropDownEditorList"
	local info = UIDropDownMenu_CreateInfo()
	local i
	info.text = RME_LOCALE["RME_PanelFrame_Mission_ChooseMission_DropDownEditorList"].choice1
	info.value = nil
	info.func = getglobal(dropDownName.."_OnClick") 
	UIDropDownMenu_AddButton( info )
	for i = 1, #RME_MISSION_AUTHOR_LIST_SORTED do
		if RME_MISSION_AUTHOR_LIST_SORTED[i] and strtrim(RME_MISSION_AUTHOR_LIST_SORTED[i]) ~= "" then
			local info = UIDropDownMenu_CreateInfo()
			info.text = RME_MISSION_AUTHOR_LIST_SORTED[i]
			info.value = RME_MISSION_AUTHOR_LIST_SORTED[i]
			info.func = getglobal(dropDownName.."_OnClick") 
			UIDropDownMenu_AddButton( info )
		end
	end
	if RME_AUTHOR_SELECTED then
		UIDropDownMenu_SetSelectedName(RME_PanelFrame_Mission_ChooseMission_DropDownEditorList,RME_AUTHOR_SELECTED)
	else
		UIDropDownMenu_SetSelectedName(RME_PanelFrame_Mission_ChooseMission_DropDownEditorList,RME_LOCALE["RME_PanelFrame_Mission_ChooseMission_DropDownEditorList"].choice1)
	end
	RME_DebugMsg("RME_PanelFrame_Mission_ChooseMission_DropDownEditorList_Refresh() DONE !",4)	
end
function RME_PanelFrame_Mission_ChooseMission_DropDownCampagneList_OnClick()
	RME_DebugMsg("RME_PanelFrame_Mission_ChooseMission_DropDownCampagneList_OnClick()"..tostring(this:GetID()),4)	
	UIDropDownMenu_SetSelectedID(RME_PanelFrame_Mission_ChooseMission_DropDownCampagneList, this:GetID());
	RME_CAMPAGNE_SELECTED = RME_CAMPAGNES_LIST_SORTED[UIDropDownMenu_GetSelectedID(RME_PanelFrame_Mission_ChooseMission_DropDownCampagneList)-1]
	RME_MISSIONS_LIST_SORTED = RME_PanelFrame_SortMissions(RME_MISSIONS_LIST,RME_AUTHOR_SELECTED,nil,RME_CAMPAGNE_SELECTED)
	RME_PanelFrame_Mission_Update()
end
function RME_PanelFrame_Mission_ChooseMission_DropDownCampagneList_Refresh()
	RME_DebugMsg("RME_PanelFrame_Mission_ChooseMission_DropDownCampagneList_Refresh()",4)	
	local i, dropDownName = "RME_PanelFrame_Mission_ChooseMission_DropDownCampagneList"
	local info = UIDropDownMenu_CreateInfo()
	info.text = RME_LOCALE["RME_PanelFrame_Mission_ChooseMission_DropDownCampagneList"].choice1
	info.value = nil
	info.func = getglobal("RME_PanelFrame_Mission_ChooseMission_DropDownCampagneList_OnClick") 
	UIDropDownMenu_AddButton( info )

	for i = 1, #RME_CAMPAGNES_LIST_SORTED do
		if RME_CAMPAGNES_LIST_SORTED[i] and strtrim(RME_CAMPAGNES_LIST_SORTED[i]) ~= "" then
			local info = UIDropDownMenu_CreateInfo()
			info.text = RME_CAMPAGNES_LIST_SORTED[i]
			info.value = RME_CAMPAGNES_LIST_SORTED[i]
			info.func = getglobal("RME_PanelFrame_Mission_ChooseMission_DropDownCampagneList_OnClick") 
			UIDropDownMenu_AddButton( info )
		end
	end

	if RME_CAMPAGNE_SELECTED then
		UIDropDownMenu_SetSelectedName(RME_PanelFrame_Mission_ChooseMission_DropDownCampagneList,RME_CAMPAGNE_SELECTED)
	else
		UIDropDownMenu_SetSelectedName(RME_PanelFrame_Mission_ChooseMission_DropDownCampagneList,RME_LOCALE["RME_PanelFrame_Mission_ChooseMission_DropDownCampagneList"].choice1)
	end
	RME_DebugMsg("RME_PanelFrame_Mission_ChooseMission_DropDownCampagneList_OnClick() DONE !",4)	
end
function RME_PanelFrame_Mission_ChooseMission_HideArchived_OnClick()
	RME_MISSION_NEEDUPDATE = true
	RME_PanelFrame_Mission_ChooseMission_OnShow()
end
function RME_PanelFrame_Mission_GM_PushInParty_OnClick()

	-- Le sender a t il le droit ?
	if not RME_Comm_SENDER_IS_LEADER(RME_PLAYER_INFO.Name) then
			RME_PlayerNotify(RME_LOCALE["RME_PanelFrame_GM_Create_Session_NotGroupLeader"].text,0.1)
			PlaySound("igQuestLogAbandonQuest")
		return
	end
	
	if RME_MISSIONID_SELECTED then
	
		RME_DebugMsg("RME_PanelFrame_Mission_GM_PushInParty_OnClick()"..tostring(this:GetID()),4)			
		--UIDropDownMenu_SetSelectedID(RME_PanelFrame_Mission_GM_PushInParty, this:GetID());
		
		--
		local MODE = "PARTY"
		local TARGET = nil
		
		if not RME_TARGET_INFO.IsNPC then
			--joueur RME ?
			if RME_COMM_ADDON_USERS_LIST[RME_TARGET_INFO.Name] and UnitInParty("target")  then
				MODE = "WHISPER"
				TARGET = RME_TARGET_INFO.Name
			end
		end
				
		if this:GetID() ==2 then -- Share
			RME_Comm_SHARE_MISSION(RME_MISSIONID_SELECTED,MODE,TARGET)
			
		elseif this:GetID() >2 and this:GetID() <=11 then -- No action
			RME_Comm_SEND_GM_SET_MISSION_STATUS(MODE,TARGET,RME_MISSIONID_SELECTED,RME_LOCALE["RME_PanelFrame_Mission_GM_PushInParty"]["tag"..this:GetID()])
		
		elseif this:GetID() == 12  then -- No action
			RME_Comm_SEND_GM_GET_MISSION_STATUS(MODE,TARGET,RME_MISSIONID_SELECTED)
			
		end
	
		UIDropDownMenu_SetSelectedID(RME_PanelFrame_Mission_GM_PushInParty2,1);

	end
end
function RME_PanelFrame_Mission_GM_PushInParty2_OnClick()
	RME_PanelFrame_Mission_GM_PushInParty_OnClick()
end
function RME_PanelFrame_Mission_GM_PushInParty3_OnClick()
	RME_Comm_SEND_GM_SCREEN_EFFECT("KNOCKED")
end
function RME_PanelFrame_SortAuthors(TABLE_ENTRANTE)
	RME_DebugMsg("RME_PanelFrame_SortAuthors()",4)	
	local TABLE_SORTANTE = {}
	local HaveAdd, i
	for MISSION_ID,LOCAL_MISSION in pairs(TABLE_ENTRANTE) do -- LOCAL_MISSION est du style RME_CLASS_MISSION
		-- Maintenant on tri les noms des auteurs
		if #TABLE_SORTANTE > 0 then
			HaveAdd = nil; AlreadyIn = nil;
			for i = 1, #TABLE_SORTANTE do
				if string.lower(LOCAL_MISSION.CreateBy) == string.lower(TABLE_ENTRANTE[TABLE_SORTANTE[i]].CreateBy) then
					AlreadyIn = true
					break;
				elseif string.lower(LOCAL_MISSION.CreateBy) < string.lower(TABLE_ENTRANTE[TABLE_SORTANTE[i]].CreateBy) then
					if not HaveAdd then -- On note sa position
						HaveAdd = i
					end
				end
			end
			-- On le rajoute
			if HaveAdd and not AlreadyIn then	
				table.insert(TABLE_SORTANTE,HaveAdd,MISSION_ID)
			elseif not AlreadyIn then
				table.insert(TABLE_SORTANTE,#TABLE_SORTANTE+1,MISSION_ID)
			end
		else
			table.insert(TABLE_SORTANTE,#TABLE_SORTANTE+1,MISSION_ID)
		end
	end
	
	--Maintenant on rcupere le nom de l'auteur via l'id de la mission (sachant qu'on a gard qu'un seul id de mission / auteur)
	for i = #TABLE_SORTANTE, 1, -1 do
		if TABLE_ENTRANTE[TABLE_SORTANTE[i]].CreateBy and strtrim(TABLE_ENTRANTE[TABLE_SORTANTE[i]].CreateBy) ~= "" then
			TABLE_SORTANTE[i] = TABLE_ENTRANTE[TABLE_SORTANTE[i]].CreateBy
		else
			table.remove(TABLE_SORTANTE,i)
		end
	end
	
	RME_DebugMsg("RME_PanelFrame_SortAuthors() DONE !",4)		
	return TABLE_SORTANTE
end
function RME_PanelFrame_SortCampagne(TABLE_ENTRANTE)
	RME_DebugMsg("RME_PanelFrame_SortCampagne()",4)	
	local TABLE_SORTANTE = {}
	local HaveAdd, i
	for MISSION_ID,LOCAL_MISSION in pairs(TABLE_ENTRANTE) do -- LOCAL_MISSION est du style RME_CLASS_MISSION
	
		if LOCAL_MISSION.Campagne and strtrim(LOCAL_MISSION.Campagne) ~= "" then 
			-- on tri les noms des campagnes
			if #TABLE_SORTANTE > 0 then
				HaveAdd = nil; AlreadyIn = nil;
				for i = 1, #TABLE_SORTANTE do
					if string.lower(LOCAL_MISSION.Campagne) == string.lower(TABLE_ENTRANTE[TABLE_SORTANTE[i]].Campagne) then
						AlreadyIn = true
						break;
					elseif string.lower(LOCAL_MISSION.Campagne) < string.lower(TABLE_ENTRANTE[TABLE_SORTANTE[i]].Campagne) then
						if not HaveAdd then -- On note sa position
							HaveAdd = i
						end
					end
				end
				-- On le rajoute
				if HaveAdd and not AlreadyIn then	
					table.insert(TABLE_SORTANTE,HaveAdd,MISSION_ID)
				elseif not AlreadyIn then
					table.insert(TABLE_SORTANTE,#TABLE_SORTANTE+1,MISSION_ID)
				end
			else
				table.insert(TABLE_SORTANTE,#TABLE_SORTANTE+1,MISSION_ID)
			end
		end
		
	end
	
	--Maintenant on rcupere le nom de l'auteur via l'id de la mission (sachant qu'on a gard qu'un seul id de mission / auteur)
	for i = #TABLE_SORTANTE, 1, -1 do
		if TABLE_ENTRANTE[TABLE_SORTANTE[i]].Campagne and strtrim(TABLE_ENTRANTE[TABLE_SORTANTE[i]].Campagne) ~= "" then
			TABLE_SORTANTE[i] = TABLE_ENTRANTE[TABLE_SORTANTE[i]].Campagne
		else
			table.remove(TABLE_SORTANTE,i)
		end
	end
	
	RME_DebugMsg("RME_PanelFrame_SortCampagne() DONE !",4)		
	return TABLE_SORTANTE
end
function RME_PanelFrame_SortMissions(TABLE_ENTRANTE,OnlyAuthor,EditorList,OnlyCampagne)
	RME_DebugMsg("RME_PanelFrame_SortMissions()",4)	
	local TABLE_SORTANTE = {}
	local HaveAdd, ArchivedChecked, i, campagnename, campagnename2
	if RME_PanelFrame_Mission_ChooseMission_HideArchived:GetChecked() == 1 then ArchivedChecked = true end
	
	for MISSION_ID,LOCAL_MISSION in pairs(TABLE_ENTRANTE) do -- LOCAL_MISSION est du style RME_CLASS_MISSION
	
		if 		(not OnlyAuthor or OnlyAuthor == LOCAL_MISSION.CreateBy)
		and		(not LOCAL_MISSION.IsDeleted or RME_DEBUG_SHOW_DELETED_MISSION) 
		and 		((LOCAL_MISSION.Archived == ArchivedChecked ) or EditorList)
		and		(not LOCAL_MISSION.Faction or LOCAL_MISSION.Faction == RME_PLAYER_INFO.Faction)
		and		(not LOCAL_MISSION.Guild or LOCAL_MISSION.Guild == RME_PLAYER_INFO.Guild)
		and 		(not OnlyCampagne or LOCAL_MISSION.Campagne == OnlyCampagne) 				then 
				
				

			if LOCAL_MISSION.Campagne then
				campagnename = "["..LOCAL_MISSION.Campagne.."] "
			else
				campagnename = ""
			end
				
			-- Ok on affiche cette mission dans la liste
			-- Maintenant on tri les missions
			if #TABLE_SORTANTE > 0 then
				HaveAdd = nil; 
				for i = 1, #TABLE_SORTANTE do
					
					if TABLE_ENTRANTE[TABLE_SORTANTE[i]].Campagne then
						campagnename2 = "["..TABLE_ENTRANTE[TABLE_SORTANTE[i]].Campagne.."] "
					else
						campagnename2 = ""
					end
					
					
					if string.lower(campagnename..LOCAL_MISSION.Title) < string.lower(campagnename2..TABLE_ENTRANTE[TABLE_SORTANTE[i]].Title) then
						HaveAdd = i
						break;
					end
				end
				-- On le rajoute
				if HaveAdd then	
					table.insert(TABLE_SORTANTE,HaveAdd,MISSION_ID)
				else
					table.insert(TABLE_SORTANTE,#TABLE_SORTANTE+1,MISSION_ID)
				end
			else
				table.insert(TABLE_SORTANTE,#TABLE_SORTANTE+1,MISSION_ID)
			end
			
		end
	end
	
	RME_DebugMsg("RME_PanelFrame_SortMissions() DONE !",4)		
	return TABLE_SORTANTE
end

function RME_PanelFrame_Mission_Update()
	--RME_DebugMsg("RME_PanelFrame_Mission_Update()",4)	
	
	if not RME_MISSIONID_SELECTED and #RME_MISSIONS_LIST_SORTED > 0 and not RME_PanelFrame.ACTION then
		RME_MISSIONID_SELECTED = RME_MISSIONS_LIST_SORTED[1]
	end
		
	-- On update le fauxscroll qui liste les noms de mission	
	if RME_MISSIONS_LIST and #RME_MISSIONS_LIST_SORTED > RME_PANNELFRAME_MISSION_DISPLAYED then
		FauxScrollFrame_Update(RME_PanelFrame_Mission_ChooseMission_ScrollFrame,#RME_MISSIONS_LIST_SORTED, RME_PANNELFRAME_MISSION_DISPLAYED, RME_QUESTLOG_QUEST_HEIGHT, nil, nil, nil, RME_PanelFrame_Mission_ChooseMission_HighlightFrame, 293, 316 )		
	else
		FauxScrollFrame_Update(RME_PanelFrame_Mission_ChooseMission_ScrollFrame,#RME_MISSIONS_LIST_SORTED, RME_PANNELFRAME_MISSION_DISPLAYED, RME_QUESTLOG_QUEST_HEIGHT, nil, nil, nil, RME_PanelFrame_Mission_ChooseMission_HighlightFrame, 293, 316 )		
	end

	-- Update the quest listing
	RME_PanelFrame_Mission_ChooseMission_ScrollFrameHighlightFrame_Highlight:Hide();
	local questIndex, questLogTitle, questTitleTag, questNumGroupMates, questNormalText, questHighlight, questCheck;
	local questLogTitleText, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily, color;
	local numPartyMembers, partyMembersOnQuest, tempWidth, textWidth;
	local LOCAL_MISSION, ActualCampagne
	
	for i=1, RME_PANNELFRAME_MISSION_DISPLAYED do
		
		if FauxScrollFrame_GetOffset(RME_PanelFrame_Mission_ChooseMission_ScrollFrame) then
			questIndex = i + FauxScrollFrame_GetOffset(RME_PanelFrame_Mission_ChooseMission_ScrollFrame);
		else
			questIndex = i
		end

		questLogTitle = getglobal("RME_PanelFrame_Mission_ChooseMission_ScrollFrame_Line"..i);
		questTitleTag = getglobal("RME_PanelFrame_Mission_ChooseMission_ScrollFrame_Line"..i.."Tag");
		questNumGroupMates = getglobal("RME_PanelFrame_Mission_ChooseMission_ScrollFrame_Line"..i.."GroupMates");
		questCheck = getglobal("RME_PanelFrame_Mission_ChooseMission_ScrollFrame_Line"..i.."Check");
		questNormalText = getglobal("RME_PanelFrame_Mission_ChooseMission_ScrollFrame_Line"..i.."NormalText");
		questHighlight = getglobal("RME_PanelFrame_Mission_ChooseMission_ScrollFrame_Line"..i.."Highlight");
		
		if ( questIndex <= #RME_MISSIONS_LIST_SORTED)  then

			local LOCAL_MISSION = RME_MISSIONS_LIST[RME_MISSIONS_LIST_SORTED[questIndex]]
			if LOCAL_MISSION.Guild then
				questLogTitle:SetText("[G] "..LOCAL_MISSION.Title);
			else
				questLogTitle:SetText(LOCAL_MISSION.Title);
			end
			QuestLogDummyText:SetText(LOCAL_MISSION.Title);
			questLogTitle:SetNormalTexture("");
			questHighlight:SetTexture("");
			questNormalText:SetWidth(275);
			-- Mission modifi et devant etre publie ?
			
			if LOCAL_MISSION.Campagne and strtrim(LOCAL_MISSION.Campagne )~= "" then
				questTitleTag:SetText("["..LOCAL_MISSION.Campagne.."]");
			else
				questTitleTag:SetText("");
			end
			
			--[[if RME_MISSION_EDITOR_LIST[LOCAL_MISSION.ID] and RME_MISSION_EDITOR_LIST[LOCAL_MISSION.ID].NeedSave then
				questTitleTag:SetText("[*]");
			else
				questTitleTag:SetText("");
			end]]
			
			
			if LOCAL_MISSION.IsPrivate then --Priv, non publie
				color = {r = 0.9; g = 0.2; b = 0.2}
			else
				if LOCAL_MISSION.EditorLoad_Lock and LOCAL_MISSION.CreateBy ~= RME_PLAYER_INFO.Name then --publi mais non editable
					color = {r = 0.5; g = 0.5; b = 0.5}
				else
					color = {r = 0.7; g = 0.9; b = 0.4}
				end
			end		
			
			
			if RME_MISSION_EDITION and RME_MISSION_EDITION.ID and RME_MISSION_EDITION.ID == LOCAL_MISSION.ID  then -- En cours d'dition et actuellement dite
				questCheck:Show();
				questCheck:SetVertexColor(0,1,0)	
				questCheck:SetTexture("Interface\\GossipFrame\\BattleMasterGossipIcon")				
			
			elseif RME_MISSION_EDITOR_LIST[LOCAL_MISSION.ID]  then -- En cours d'dition mais non publie
				questCheck:Show();
				questCheck:SetVertexColor(.6,.6,.6)	
				questCheck:SetTexture("Interface\\GossipFrame\\BattleMasterGossipIcon")				
			
			elseif LOCAL_MISSION.Locked or LOCAL_MISSION.GM_MissionLocked then -- Publi mais Verrouill (pour le lancement d'une mission)
				questCheck:Show();
				questCheck:SetVertexColor(0.5,0,0)	
				questCheck:SetTexture("Interface\\GossipFrame\\AvailableQuestIcon")	
				
			elseif RME_IN_PROGRESS_MISSIONS_LIST[LOCAL_MISSION.ID] then -- En cours par le joueur
				questCheck:Show();
				questCheck:SetVertexColor(0,1,0)	
				questCheck:SetTexture("Interface\\GossipFrame\\BattleMaster")
				
			else
				questCheck:Hide();
			end
			
			questTitleTag:SetTextColor(color.r, color.g, color.b);
			questLogTitle:SetTextColor(color.r, color.g, color.b);
			questNumGroupMates:SetTextColor(color.r, color.g, color.b);
			questLogTitle.r = color.r;
			questLogTitle.g = color.g;
			questLogTitle.b = color.b;
			questLogTitle.MISSION_ID = LOCAL_MISSION.ID
			questLogTitle:Show();
			
			-- Place the highlight and lock the highlight state
			if  RME_MISSIONID_SELECTED ==  LOCAL_MISSION.ID then
				RME_PanelFrame_Mission_ChooseMission_ScrollFrameHighlightFrame:SetPoint("TOPLEFT", "RME_PanelFrame_Mission_ChooseMission_ScrollFrame_Line"..i, "TOPLEFT", 0, 0);
				RME_PanelFrame_Mission_ChooseMission_ScrollFrameHighlightFrame_Highlight:SetVertexColor(color.r, color.g, color.b);
				RME_PanelFrame_Mission_ChooseMission_ScrollFrameHighlightFrame_Highlight:Show();
				questTitleTag:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
				questLogTitle:LockHighlight();	
				RME_PanelFrame_Mission_UpdateInfos()
			else
				questLogTitle:UnlockHighlight();
			end
		else
			questLogTitle:Hide();
		end
	end

	--
	if #RME_MISSIONS_LIST_SORTED > 1 then
		RME_PanelFrame_Mission_ChooseMission_Summary:SetText(format(RME_LOCALE["RME_PanelFrame_Mission_ChooseMission_Summary"].text,#RME_MISSIONS_LIST_SORTED))
	else
		RME_PanelFrame_Mission_ChooseMission_Summary:SetText(format(RME_LOCALE["RME_PanelFrame_Mission_ChooseMission_Summary"].textalone,#RME_MISSIONS_LIST_SORTED))
	end
	
	--RME_DebugMsg("RME_PanelFrame_Mission_Update() Done !",4)	
end
function RME_PanelFrame_Mission_UpdateInfos()
	--Maj des boutons
	RME_PanelFrame_Mission_EditMission_Toggle_Private:Hide()
	RME_PanelFrame_Mission_EditMission_Toggle_Locked:Hide()
	RME_PanelFrame_Mission_EditMission_Toggle_EditorLock:Hide()
	RME_PanelFrame_Mission_EditMission_Toggle_PublishLock:Hide()	
	RME_PanelFrame_Mission_EditMission_Toggle_ResetMission:Hide()
	RME_PanelFrame_Mission_EditMission_Toggle_Archived:Hide()
	RME_PanelFrame_Mission_EditMission_Toggle_IgnoreMission:Show()
	
	if not RME_MISSIONID_SELECTED then
		RME_PanelFrame_Mission_EditMission_HTML:SetText(RME_LOCALE["RME_PANNELFRAME_NOMISSION"].text)
	end
	
	local LOCAL_MISSION = RME_MISSIONS_LIST[RME_MISSIONID_SELECTED]
	local Text
	Text = format(RME_LOCALE["RME_PANNELFRAME_TITLE"].text,RME_HTML_Replace_Tag(LOCAL_MISSION.Title),LOCAL_MISSION.CreateBy,LOCAL_MISSION.Version)
	
	if RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].CreateBy == RME_PLAYER_INFO.Name then
		--RME_PanelFrame_Mission_EditMission_Toggle_Private:Show()
		--RME_PanelFrame_Mission_EditMission_Toggle_Locked:Show()
		--RME_PanelFrame_Mission_EditMission_Toggle_EditorLock:Show()
		--RME_PanelFrame_Mission_EditMission_Toggle_PublishLock:Show()
		--RME_PanelFrame_Mission_EditMission_Toggle_Archived:Show()
	end	

	-- Public / priv  / Guild?
	if LOCAL_MISSION.IsPrivate then
		Text = Text..RME_LOCALE["RME_PANNELFRAME_HTML_MISSION_PRIVATE"].text
		RME_PanelFrame_Mission_EditMission_Toggle_Private.color = { .7, 0.2, 0}
		RME_PanelFrame_Mission_EditMission_Toggle_Private_Highlight:SetVertexColor(.7,0.2,0)

	elseif LOCAL_MISSION.Guild then
	
		Text = Text..RME_LOCALE["RME_PANNELFRAME_HTML_MISSION_GUILD"].text
		RME_PanelFrame_Mission_EditMission_Toggle_Private.color = { 0.2, 0.7, 0}
		RME_PanelFrame_Mission_EditMission_Toggle_Private_Highlight:SetVertexColor(0.2,0.7,0)
	
	elseif LOCAL_MISSION.ServersShareable then
	
		Text = Text..RME_LOCALE["RME_PANNELFRAME_HTML_MISSION_PUBLIC_ALL"].text
		RME_PanelFrame_Mission_EditMission_Toggle_Private.color = { 0.2, 0.7, 0}
		RME_PanelFrame_Mission_EditMission_Toggle_Private_Highlight:SetVertexColor(0.2,0.7,0)
		
	else
		Text = Text..RME_LOCALE["RME_PANNELFRAME_HTML_MISSION_PUBLIC"].text
		RME_PanelFrame_Mission_EditMission_Toggle_Private.color = { 0.2, 0.7, 0}
		RME_PanelFrame_Mission_EditMission_Toggle_Private_Highlight:SetVertexColor(0.2,0.7,0)
	end
	
	--Verrouill ?
	if LOCAL_MISSION.Locked or LOCAL_MISSION.GM_MissionLocked then
		Text = Text..RME_LOCALE["RME_PANNELFRAME_HTML_MISSION_UNAVAILABLE"].text
		RME_PanelFrame_Mission_EditMission_Toggle_Locked.color = { .7,0.2, 0}
		RME_PanelFrame_Mission_EditMission_Toggle_Locked_Highlight:SetVertexColor(.7,0.2,0)
	else
		Text = Text..RME_LOCALE["RME_PANNELFRAME_HTML_MISSION_AVAILABLE"].text
		RME_PanelFrame_Mission_EditMission_Toggle_Locked.color ={ 0.2, 0.7, 0}
		RME_PanelFrame_Mission_EditMission_Toggle_Locked_Highlight:SetVertexColor(.2,0.7,0)
	end
	
	--Chargeable dans l'diteur meme si pas auteur ?
	if LOCAL_MISSION.EditorLoad_Lock then
		Text = Text..RME_LOCALE["RME_PANNELFRAME_HTML_MISSION_EDITORLOCK"].text
		RME_PanelFrame_Mission_EditMission_Toggle_EditorLock.color = { .7, 0.2, 0}
		RME_PanelFrame_Mission_EditMission_Toggle_EditorLock_Highlight:SetVertexColor(.7,0.2,0)		
	else
		Text = Text..RME_LOCALE["RME_PANNELFRAME_HTML_MISSION_EDITORUNLOCK"].text
		RME_PanelFrame_Mission_EditMission_Toggle_EditorLock.color = { 0.2, 0.7, 0}
		RME_PanelFrame_Mission_EditMission_Toggle_EditorLock_Highlight:SetVertexColor(.2,0.7,0)
	end
	-- Publiable ?
	if LOCAL_MISSION.Publication_Lock  then
		Text = Text..RME_LOCALE["RME_PANNELFRAME_HTML_MISSION_PUBLICATIONLOCK"].text
		RME_PanelFrame_Mission_EditMission_Toggle_PublishLock.color = { .7, 0.2, 0}
		RME_PanelFrame_Mission_EditMission_Toggle_PublishLock_Highlight:SetVertexColor(.7,0.2,0)		
	else
		Text = Text..RME_LOCALE["RME_PANNELFRAME_HTML_MISSION_PUBLICATIONUNLOCK"].text
		RME_PanelFrame_Mission_EditMission_Toggle_PublishLock.color = { 0.2, 0.7, 0}
		RME_PanelFrame_Mission_EditMission_Toggle_PublishLock_Highlight:SetVertexColor(.2,0.7,0)
	end
	-- Archiv ?
	if LOCAL_MISSION.Archived  then
		Text = Text..RME_LOCALE["RME_PANNELFRAME_HTML_MISSION_ARCHIVED"].text
		RME_PanelFrame_Mission_EditMission_Toggle_Archived.color = { .7, 0.2, 0}
		RME_PanelFrame_Mission_EditMission_Toggle_Archived_Highlight:SetVertexColor(.7,0.2,0)		
	else
		Text = Text..RME_LOCALE["RME_PANNELFRAME_HTML_MISSION_NOTARCHIVED"].text
		RME_PanelFrame_Mission_EditMission_Toggle_Archived.color = { 0.2, 0.7, 0}
		RME_PanelFrame_Mission_EditMission_Toggle_Archived_Highlight:SetVertexColor(.2,0.7,0)
	end
	
	-- Mission Ignor ? ()
	if LOCAL_MISSION.IsIgnore then
		Text = Text..RME_LOCALE["RME_PANNELFRAME_HTML_MISSION_IGNORE"].text
		RME_PanelFrame_Mission_EditMission_Toggle_IgnoreMission.color = { .7, 0.2, 0}
		RME_PanelFrame_Mission_EditMission_Toggle_IgnoreMission_Highlight:SetVertexColor(.7,0.2,0)		
	else
		Text = Text..RME_LOCALE["RME_PANNELFRAME_HTML_MISSION_NOTIGNORE"].text
		RME_PanelFrame_Mission_EditMission_Toggle_IgnoreMission.color = { 0.2, 0.7, 0}
		RME_PanelFrame_Mission_EditMission_Toggle_IgnoreMission_Highlight:SetVertexColor(.2,0.7,0)
	end
	
	-- Mission disponible pour le joueur ?
	if RME_COMPLETED_MISSIONS_LIST[LOCAL_MISSION.ID] then
		-- Mission dja termin
		Text = Text..RME_LOCALE["RME_PANNELFRAME_HTML_MISSION_PLAYER_UNAVAILABLE_COMPLETED"].text
		RME_PanelFrame_Mission_EditMission_Toggle_ResetMission.color = { .7, 0.2, 0}
		RME_PanelFrame_Mission_EditMission_Toggle_ResetMission_Highlight:SetVertexColor(.7,0.2,0)
		RME_PanelFrame_Mission_EditMission_Toggle_ResetMission:Show()
		
		elseif RME_IN_PROGRESS_MISSIONS_LIST[LOCAL_MISSION.ID] then
		-- Mission en cours, on regarde si la version est ok
		if RME_IN_PROGRESS_MISSIONS_LIST[LOCAL_MISSION.ID].Version < LOCAL_MISSION.Version then
			-- Une mise a jour a eu lieu, il est prfrable de recommencer la mission
			Text = Text..RME_LOCALE["RME_PANNELFRAME_HTML_MISSION_PLAYER_INPROGRESS_EXPIRED"].text
			RME_PanelFrame_Mission_EditMission_Toggle_ResetMission.color = { .7, 0.2, 0}
			RME_PanelFrame_Mission_EditMission_Toggle_ResetMission_Highlight:SetVertexColor(.7,0.2,0)
			RME_PanelFrame_Mission_EditMission_Toggle_ResetMission:Show()
			
		else
			--Tout va bien
			Text = Text..RME_LOCALE["RME_PANNELFRAME_HTML_MISSION_PLAYER_INPROGRESS"].text
			RME_PanelFrame_Mission_EditMission_Toggle_ResetMission.color = { 0.2, 0.7, 0}
			RME_PanelFrame_Mission_EditMission_Toggle_ResetMission_Highlight:SetVertexColor(.2,0.7,0)		
			RME_PanelFrame_Mission_EditMission_Toggle_ResetMission:Show()
		end
		
	elseif LOCAL_MISSION:MissionCanBeTaken() then
		Text = Text..RME_LOCALE["RME_PANNELFRAME_HTML_MISSION_PLAYER_AVAILABLE"].text
		RME_PanelFrame_Mission_EditMission_Toggle_ResetMission.color = { 0.2, 0.7, 0}
		RME_PanelFrame_Mission_EditMission_Toggle_ResetMission_Highlight:SetVertexColor(.2,0.7,0)	
		RME_PanelFrame_Mission_EditMission_Toggle_ResetMission:Show()		
	else
		Text = Text..RME_LOCALE["RME_PANNELFRAME_HTML_MISSION_PLAYER_UNAVAILABLE_MISSION"].text
		RME_PanelFrame_Mission_EditMission_Toggle_ResetMission.color = { .7, 0.2, 0}
		RME_PanelFrame_Mission_EditMission_Toggle_ResetMission_Highlight:SetVertexColor(.7,0.2,0)	
		RME_PanelFrame_Mission_EditMission_Toggle_ResetMission:Show()
	end
	

	
	--Need mission ?
	if LOCAL_MISSION.NeedMissionID and RME_MISSIONS_LIST[LOCAL_MISSION.NeedMissionID] then
		if RME_COMPLETED_MISSIONS_LIST[LOCAL_MISSION.NeedMissionID] then
			Text = Text..format(RME_LOCALE["RME_PANNELFRAME_HTML_MISSION_NEED_MISSION"].text,"|cFF11FF00"..RME_HTML_Replace_Tag(RME_MISSIONS_LIST[LOCAL_MISSION.NeedMissionID].Title).."|r")
		else
			Text = Text..format(RME_LOCALE["RME_PANNELFRAME_HTML_MISSION_NEED_MISSION"].text,"|cFFFF1100"..RME_HTML_Replace_Tag(RME_MISSIONS_LIST[LOCAL_MISSION.NeedMissionID].Title).."|r")
		end
	end
	
	if LOCAL_MISSION.Comment and LOCAL_MISSION.Comment ~= "" then
		Text = Text..format(RME_LOCALE["RME_PANNELFRAME_HTML_COMMENT"].text,LOCAL_MISSION.Comment)
	end	
	
	Text = Text.."</p></body></html>"
	RME_PanelFrame_Mission_EditMission_HTML:SetText(Text)
	
end
function RME_PanelFrame_Mission_EditMission_Toggle_OnLoad()
	this.color = {}
end
function RME_PanelFrame_Mission_EditMission_Toggle_OnEnter()
	RME_Legend_OnEnter(RME_LOCALE[this:GetName()]);
	getglobal(this:GetName().."_Highlight"):SetVertexColor(1,1,1)
end
function RME_PanelFrame_Mission_EditMission_Toggle_OnLeave()
	RME_Legend_OnLeave();
	getglobal(this:GetName().."_Highlight"):SetVertexColor(this.color[1],this.color[2],this.color[3])
end
function RME_PanelFrame_Mission_EditMission_Toggle_OnClick(Button)
	if RME_MISSIONID_SELECTED then
		
		-- ok on a le droit
		if Button == "Private"  then
			if RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].ServersShareable then
				-- Passage Publique all serveur > priv
				RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].IsPrivate	= true
				RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].Guild	= nil
				RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].ServersShareable	= nil
			
			elseif RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].IsPrivate then
				-- Passage Priv > Guild 
				RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].IsPrivate	= nil
				RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].Guild	= RME_PLAYER_INFO.Guild
				RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].ServersShareable	= nil
				
			elseif RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].Guild then
				-- Passage Guild > Publique
				RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].IsPrivate	= nil
				RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].Guild	= nil
				RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].ServersShareable	= nil
				
			else 
				-- Passage Publique > Public all
				RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].IsPrivate	= nil
				RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].Guild	= nil
				RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].ServersShareable	= true
				
			end
			RME_EventManager_AddEvent("RefreshVersion('"..RME_MISSIONID_SELECTED.."')",15,"RME_PanelFrame_Mission_EditMission_Toggle_RefreshVersion('"..RME_MISSIONID_SELECTED.."')")
			
		elseif Button == "Locked" then
			if RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].Locked then
				RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].Locked	= nil
			else
				RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].Locked	= true
			end
			RME_EventManager_AddEvent("RefreshVersion('"..RME_MISSIONID_SELECTED.."')",15,"RME_PanelFrame_Mission_EditMission_Toggle_RefreshVersion('"..RME_MISSIONID_SELECTED.."')")
			
		elseif Button == "EditorLock" then
			if RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].EditorLoad_Lock then
				RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].EditorLoad_Lock	= nil
			else
				RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].EditorLoad_Lock	= true
			end
			RME_EventManager_AddEvent("RefreshVersion('"..RME_MISSIONID_SELECTED.."')",15,"RME_PanelFrame_Mission_EditMission_Toggle_RefreshVersion('"..RME_MISSIONID_SELECTED.."')")
			
		elseif Button == "PublishLock" then
			if RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].Publication_Lock then
				RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].Publication_Lock	= nil
			else
				RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].Publication_Lock	= true
			end
			RME_EventManager_AddEvent("RefreshVersion('"..RME_MISSIONID_SELECTED.."')",15,"RME_PanelFrame_Mission_EditMission_Toggle_RefreshVersion('"..RME_MISSIONID_SELECTED.."')")
			
		elseif Button == "Archived" then
			if RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].Archived then
				RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].Archived	= nil
			else
				RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].Archived	= true
			end
			RME_MISSION_NEEDUPDATE = true
			RME_PanelFrame_Mission_ChooseMission_OnShow()
			RME_PanelFrame_Mission_Update()
			RME_EventManager_AddEvent("RefreshVersion('"..RME_MISSIONID_SELECTED.."')",15,"RME_PanelFrame_Mission_EditMission_Toggle_RefreshVersion('"..RME_MISSIONID_SELECTED.."')")
			RME_Mega_Update(true)
			return
			
		elseif Button == "ResetMission" then
			-- Mission disponible pour le joueur ?
			if RME_COMPLETED_MISSIONS_LIST[RME_MISSIONID_SELECTED] then
				-- Mission dja termin, on la ractive
				RME_COMPLETED_MISSIONS_LIST[RME_MISSIONID_SELECTED] = nil
				RME_Mega_Update(true)

			elseif RME_IN_PROGRESS_MISSIONS_LIST[RME_MISSIONID_SELECTED] then
				-- Mission en cours, on regarde si la version est ok
				if RME_IN_PROGRESS_MISSIONS_LIST[RME_MISSIONID_SELECTED].Version < RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].Version then
					-- Une mise a jour a eu lieu, il est prfrable de recommencer la mission
					-- On annule la mission puis on la relance la mission immdiatement
					RME_QUESTLOG_MISSIONID = RME_MISSIONID_SELECTED
					RME_Cancel_Mission(true)
					RME_Take_Mission(RME_MISSIONID_SELECTED)					
				else
					--Tout va bien, aucune action (on affiche juste l'image verte)
					return
				end
			end
			
		elseif Button == "IgnoreMission" then
			if RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].IsIgnore then
				RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].IsIgnore	= nil
			else
				RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].IsIgnore	= true
			end
			RME_MISSION_NEEDUPDATE = true
			RME_PanelFrame_Mission_ChooseMission_OnShow()
			RME_PanelFrame_Mission_Update()
			RME_Mega_Update(true)
			return
			
		end
		RME_PanelFrame_Mission_Update()
	end
end
function RME_PanelFrame_Mission_EditMission_Toggle_RefreshVersion(MISSION_ID)
	RME_MISSIONS_LIST[MISSION_ID].Version = RME_MISSIONS_LIST[MISSION_ID].Version + 1		
	RME_PanelFrame_Mission_Update()
end
	-- Selection Mission --
function RME_PanelFrame_Mission_Select(ACTION)
	RME_PanelFrame.ACTION = ACTION
	RME_MISSIONID_SELECTED = nil
	RME_PanelFrame_TabButton_OnClick(2)
	PanelTemplates_DisableTab(RME_PanelFrame_Tabs,1)
	PanelTemplates_DisableTab(RME_PanelFrame_Tabs,3)
	PanelTemplates_DisableTab(RME_PanelFrame_Tabs,4)
	PanelTemplates_DisableTab(RME_PanelFrame_Tabs,5)
	PanelTemplates_DisableTab(RME_PanelFrame_Tabs,6)
	RME_ChooseMission_Cancel:Show()
	RME_ChooseMission_Validation:Show()
	RME_ChooseMission_Validation:Disable()
end
function RME_PanelFrame_Mission_Select_Valid_OnClick()

	PanelTemplates_EnableTab(RME_PanelFrame_Tabs,1)
	PanelTemplates_EnableTab(RME_PanelFrame_Tabs,2)
	PanelTemplates_EnableTab(RME_PanelFrame_Tabs,3)
	PanelTemplates_EnableTab(RME_PanelFrame_Tabs,4)
	PanelTemplates_EnableTab(RME_PanelFrame_Tabs,5)
	PanelTemplates_EnableTab(RME_PanelFrame_Tabs,6)
	RME_ChooseMission_Cancel:Hide()
	RME_ChooseMission_Validation:Hide()

	if RME_MISSIONID_SELECTED then
		if RME_PanelFrame.ACTION == "SELECT_ITEM_MISSIONID" then
			if RME_EDITOR_ITEM_ID then
				RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].Mission_LaunchID = RME_MISSIONID_SELECTED
			end
			RME_PanelFrame_TabButton_OnClick(3)
			
		elseif RME_PanelFrame.ACTION == "SELECT_NEED_MISSIONID" then	
			if RME_MISSION_EDITION.ID ~= RME_MISSIONID_SELECTED then
				RME_MISSION_EDITION.NeedMissionID = RME_MISSIONID_SELECTED
			end
			RME_PanelFrame_TabButton_OnClick(3)
			
		elseif RME_PanelFrame.ACTION == "SELECT_LAUNCH_MISSIONID" then		
			if RME_MISSION_EDITION.ID ~= RME_MISSIONID_SELECTED then
				RME_MISSION_EDITION.LaunchMissionID = RME_MISSIONID_SELECTED
			end
			RME_PanelFrame_TabButton_OnClick(3)
			
		elseif RME_PanelFrame.ACTION == "SELECT_ITEM_LAUNCH_MISSIONID" then
			if RME_EDITOR_ITEM_ID then
				RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].Mission_LaunchID = RME_MISSIONID_SELECTED
			end
			RME_PanelFrame_TabButton_OnClick(3)

		elseif RME_PanelFrame.ACTION == "SELECT_GM_MISSION_MISSIONID" then
			if RME_EDITOR_ITEM_ID then
				UIDropDownMenu_SetText(RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].Title,RME_PanelFrame_GM_ChoosePlayer_DropDownMissionList)
			end
			RME_PanelFrame_TabButton_OnClick(4)
		
		elseif RME_PanelFrame.ACTION == "SELECT_ITEM_FROM_MISSIONID" then
			if RME_MISSIONID_SELECTED and RME_MISSION_EDITION.ID and RME_MISSION_EDITION.ID ~= RME_MISSIONID_SELECTED then
				local LOCAL_ITEM_ID,LOCAL_ITEM,LOCAL_NEW_ITEM
				for LOCAL_ITEM_ID,LOCAL_ITEM in pairs(RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].MissionItemsList) do -- LOCAL_MISSION_ENTRANTE est une simple table issue de la sauvegarde
					LOCAL_NEW_ITEM = RME_CLASS_ITEM()
					LOCAL_NEW_ITEM:Load(LOCAL_ITEM)
					RME_MISSION_EDITION.MissionItemsList[LOCAL_ITEM_ID] = LOCAL_NEW_ITEM
				end
			end
			RME_PanelFrame_TabButton_OnClick(3)
			
		elseif RME_PanelFrame.ACTION == "LOAD_MISSION_EDITOR" then	
			RME_PanelFrame_Editor_LoadMission()
			RME_PanelFrame_TabButton_OnClick(3)

		elseif RME_PanelFrame.ACTION == "DELETE_MISSION_EDITOR" then	
			RME_PanelFrame_Editor_DeleteMission()
			RME_PanelFrame_TabButton_OnClick(3)
			
		end
	end
	
	RME_ChooseMission_Cancel:Hide()
	RME_ChooseMission_Validation:Show()
	RME_PanelFrame.ACTION = nil
end
function RME_PanelFrame_Mission_Select_Cancel_OnClick()

	PanelTemplates_EnableTab(RME_PanelFrame_Tabs,1)
	PanelTemplates_EnableTab(RME_PanelFrame_Tabs,2)
	PanelTemplates_EnableTab(RME_PanelFrame_Tabs,3)
	PanelTemplates_EnableTab(RME_PanelFrame_Tabs,4)
	PanelTemplates_EnableTab(RME_PanelFrame_Tabs,5)
	PanelTemplates_EnableTab(RME_PanelFrame_Tabs,6)
	RME_PanelFrame.ACTION = nil
	RME_ChooseMission_Cancel:Hide()
	RME_ChooseMission_Validation:Hide()
end
-- Editor
function RME_PanelFrame_Editor_OnLoad()
	RME_DebugMsg("RME_QuestEditorFrame_OnLoad()",3)	
	-- Tabs
	PanelTemplates_SetNumTabs(RME_QuestEditorFrame_Tabs, 6 )
	RME_QuestEditorFrame_Tabs.selectedTab = 1
	PanelTemplates_UpdateTabs( RME_QuestEditorFrame_Tabs )
	-- Slider pour les niveaux
	RME_QuestEditorFrame_MissionNeedLevel:SetMinMaxValues( 0, RME_EDITOR_MAX_LEVEL )
	RME_QuestEditorFrame_Timer:SetMinMaxValues( 0, RME_EDITOR_TIMER_MAX_TIME )
	-- Slider pour le nombre de crature a tuer / objet a ramener
	RME_QuestEditorFrame_Objective_Type_KILL_MOB_Number:SetMinMaxValues( 1, RME_OBJECTIVE_KILL_MOB_MAX_KILL)	
	RME_QuestEditorFrame_Objective_Type_NEED_ITEM_Number:SetMinMaxValues( 1, RME_OBJECTIVE_NEED_ITEM_MAX_ITEM)	
	RME_QuestEditorFrame_Item_Type_USE_ON_MOB_Action_Timer:SetMinMaxValues( 3, RME_ITEM_USE_ON_MOB_MAX_TIME)	
	RME_QuestEditorFrame_Item_Type_USE_ITEM_Action_Timer:SetMinMaxValues( 3, RME_ITEM_USE_ON_MOB_MAX_TIME)	
	RME_QuestEditorFrame_Item_Type_USE_ITEM_Cooldown:SetMinMaxValues( 1, RME_OBJECTIVE_NEED_ITEM_MAX_ITEM)	
	RME_QuestEditorFrame_Item_Type_USE_ON_MOB_Cooldown:SetMinMaxValues( 1, RME_ITEM_USE_ON_MOB_MAX_TIME)	
	RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_Number:SetMinMaxValues( 1, 100)	
	RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_Probability:SetMinMaxValues( 1, 100)	
	
	--Slider 
	RME_QuestEditorFrame_Item_Quantity:SetMinMaxValues( 1, 99)	
end
function RME_PanelFrame_Editor_OnShow()
	UIDropDownMenu_Initialize(RME_PanelFrame_Editor_DropDownEditorList, RME_PanelFrame_Editor_DropDownEditorList_Refresh)
	RME_PanelFrame_Editor_RefreshEditor()
end
function RME_PanelFrame_Editor_OnHide()
	RME_QuestEditorFrame_Objective_Type_ShowFrame()
	RME_QuestEditorFrame_Item_Type_ShowFrame()
end
function RME_PanelFrame_Editor_DropDownEditorList_OnClick()
	RME_DebugMsg("RME_PanelFrame_Editor_DropDownMissionEditionList_OnClick()"..tostring(this:GetID()),4)	
	UIDropDownMenu_SetSelectedID(RME_PanelFrame_Editor_DropDownEditorList, this:GetID());
	if this:GetID() ==1 then -- No action
		return
		
	elseif this:GetID() == 2 then -- New Mission
		RME_PanelFrame_Editor_NewMission()
		UIDropDownMenu_SetSelectedID(RME_PanelFrame_Editor_DropDownEditorList,1);
		
	elseif this:GetID() == 3 then -- Load Mission
		RME_PanelFrame_Mission_Select("LOAD_MISSION_EDITOR")
		UIDropDownMenu_SetSelectedID(RME_PanelFrame_Editor_DropDownEditorList,1);
	
	elseif this:GetID() == 4 then -- Copie Mission
		RME_PanelFrame_Editor_CopyMission()
		UIDropDownMenu_SetSelectedID(RME_PanelFrame_Editor_DropDownEditorList,1);
	
	elseif this:GetID() == 5 then -- Delete Mission
		RME_PanelFrame_Mission_Select("DELETE_MISSION_EDITOR")
		UIDropDownMenu_SetSelectedID(RME_PanelFrame_Editor_DropDownEditorList,1);
		
	else --Mission dja charg dans l'editeur, on switch dessus
		RME_PanelFrame_Editor_SwitchToMission(RME_EDITOR_LIST_SORTED[this:GetID()-5])
	end
	
end
function RME_PanelFrame_Editor_DropDownEditorList_Refresh()
	RME_DebugMsg("RME_PanelFrame_Editor_DropDownEditorList_Refresh()",4)	
	local dropDownName = "RME_PanelFrame_Editor_DropDownEditorList"	
	local choice = RME_LOCALE[dropDownName].choice1
	local count = 1
	local i
	while choice do
		local info = UIDropDownMenu_CreateInfo()
		info.text = choice
		info.value = count
		info.func = getglobal(dropDownName.."_OnClick") 
		UIDropDownMenu_AddButton( info )
		count = count + 1
		choice = RME_LOCALE[dropDownName]["choice"..count] 
	end
	
	RME_EDITOR_LIST_SORTED = RME_PanelFrame_SortMissions(RME_MISSION_EDITOR_LIST,nil,true,nil)
	
	for i = 1, #RME_EDITOR_LIST_SORTED do
		if RME_EDITOR_LIST_SORTED[i] and RME_MISSION_EDITOR_LIST[RME_EDITOR_LIST_SORTED[i]].Title and strtrim(RME_MISSION_EDITOR_LIST[RME_EDITOR_LIST_SORTED[i]].Title) ~= "" then
			local info = UIDropDownMenu_CreateInfo()
			info.text = RME_LOCALE["RME_LOCALE_SWITCH_TO_MISSION"].text..RME_MISSION_EDITOR_LIST[RME_EDITOR_LIST_SORTED[i]].Title
			info.value = RME_EDITOR_LIST_SORTED[i]
			info.func = getglobal(dropDownName.."_OnClick") 
			UIDropDownMenu_AddButton( info )
		end
	end
	
	UIDropDownMenu_SetSelectedID(RME_PanelFrame_Editor_DropDownEditorList,1);
	RME_DebugMsg("RME_PanelFrame_Editor_DropDownEditorList_Refresh() DONE !",4)	
end
function RME_PanelFrame_Editor_NewMission()
	RME_DebugMsg("RME_PanelFrame_Editor_NewMission_OnClick("..tostring(force)..")",4);
	
	--On regarde si on a pas atteint le maximum autoris
	if RME_getn(RME_MISSION_EDITOR_LIST)+1 >= RME_MISSION_EDITOR_LIST_MAX then
		StaticPopup_Show("RME_EDITOR_TOO_MANY_MISSIONS") 	
		return
	end
	
	-- Si une mission tait en cours d'dition on la sauvegarde dans la liste RME_MISSION_EDITOR_LIST
	if RME_MISSION_EDITION and RME_MISSION_EDITION.ID then
		local OLD_MISSION =  RME_CLASS_MISSION(RME_MISSION_EDITION.ID)
		OLD_MISSION:Load(RME_MISSION_EDITION)
		RME_MISSION_EDITOR_LIST[OLD_MISSION.ID] = OLD_MISSION
		RME_MISSION_EDITION = nil
	end	
	
	-- Si on arrive ici c'est que soit il n'existait pas de mission prcdemment charge ou que l'utilisateur a valid le prcdent popup
	RME_MISSION_EDITION = RME_CLASS_MISSION(RME_Generate_New_GUID())
	RME_MISSION_EDITION.Title			=	RME_LOCALE["RME_LOCALE_EDITOR_NEED_TITLE"].text
	RME_MISSION_EDITION.IsPrivate 		=	true
	RME_MISSION_EDITION.Locked 			=	true
	RME_MISSION_EDITION.EditorLoad_Lock =	true
	RME_MISSION_EDITION.Publication_Lock =	true
	RME_MISSION_EDITION.CreateBy		= 	RME_PLAYER_INFO.Name
	RME_MISSION_EDITION.CreateByID		=	RME_ADDON_CONFIG["UniqueID"]
	RME_MISSION_EDITION.CreateInServer	= 	RME_PLAYER_INFO.Server
	RME_MISSION_EDITION.CreateDate		= 	time()
	RME_MISSION_EDITION.NeedSave		=	true
	RME_MISSION_EDITOR_LIST[RME_MISSION_EDITION.ID] = RME_MISSION_EDITION -- On place cette mission dans la liste des missions dites

	RME_EDITOR_OBJECTIVE_ID			=	nil
	RME_EDITOR_NPC_ID				=	nil
	RME_EDITOR_ITEM_ID 				= 	nil
	RME_EDITOR_EVENT_ID				=	nil
	
	--On update l'affichage
	RME_MISSION_NEEDUPDATE = true
	RME_PanelFrame_Editor_RefreshEditor()
	RME_Mega_Update(true)
	
	RME_DebugMsg("RME_PanelFrame_Editor_NewMission_OnClick() New ID: "..tostring(RME_MISSION_EDITION.ID),3);
end
function RME_PanelFrame_Editor_LoadMission(force)
	RME_DebugMsg("RME_PanelFrame_Editor_LoadMission("..tostring(force)..")",4);
	
	-- Aucune mission slectionne, on ignore
	if not RME_MISSIONID_SELECTED then
		RME_DebugMsg("RME_PanelFrame_Editor_LoadMission("..tostring(force).."):No mission selected, skip...",3);
		return 
	end
	
	--On regarde si on a pas atteint le maximum autoris
	if (RME_getn(RME_MISSION_EDITOR_LIST))+1 >= RME_MISSION_EDITOR_LIST_MAX then
		StaticPopup_Show("RME_EDITOR_TOO_MANY_MISSIONS") 	
		return
	end		
	
	-- on regarde si on la connait
	if not RME_MISSIONS_LIST[RME_MISSIONID_SELECTED] then
		RME_DebugMsg("RME_PanelFrame_Editor_LoadMission("..tostring(force).."): Mission "..tostring(RME_MISSIONID_SELECTED).." doesn't exist in missions list",1);
		return
	end
	
	-- on vrifie les autorisations de chargement
	if RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].EditorLoad_Lock then
		-- Auteur a lock cette mission, on verifie si c'est bien lui
		if not RME_PanelFrame_Editor_CheckHaveMissionAccess(RME_MISSIONS_LIST[RME_MISSIONID_SELECTED]) then
			-- Pas le droit !
			StaticPopup_Show("RME_EDITOR_CANT_LOAD_NOT_AUTHORIZED") 
			return
		end
	end
	
	-- ok on update l'id afin d'tre toujours au dernier uniqueid 
	-- (sauf si c'est moi qui charge une mission de quelqu'un d'autre)
	if RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].CreateBy == RME_PLAYER_INFO.Name then
		RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].CreatebyID = RME_ADDON_CONFIG["UniqueID"]
	end
	
	
	
	-- Si une mission tait en cours d'dition on la sauvegarde dans la liste RME_MISSION_EDITOR_LIST
	if RME_MISSION_EDITION.ID ~= RME_MISSIONID_SELECTED then --Autre mission
		
		--Sauvegarde l'ancienne mission en cours d'dition dans RME_MISSION_EDITOR_LIST[ID]
		local OLD_MISSION =  RME_CLASS_MISSION(RME_MISSION_EDITION.ID)
		OLD_MISSION:Load(RME_MISSION_EDITION)
		RME_MISSION_EDITOR_LIST[OLD_MISSION.ID] = OLD_MISSION
		RME_MISSION_EDITION = nil
		
		-- Ok on charge la mission que le joueur veut prendre
		-- soit dans l'diteur si elle y est prsente
		-- soit dans la liste globale de mission
		if RME_MISSION_EDITOR_LIST[RME_MISSIONID_SELECTED] then
			RME_MISSION_EDITION = RME_CLASS_MISSION(RME_MISSIONID_SELECTED)
			RME_MISSION_EDITION:Load(RME_MISSION_EDITOR_LIST[RME_MISSIONID_SELECTED])		
			
		elseif RME_MISSIONS_LIST[RME_MISSIONID_SELECTED] then
			RME_MISSION_EDITION = RME_CLASS_MISSION(RME_MISSIONID_SELECTED)
			RME_MISSION_EDITION:Load(RME_MISSIONS_LIST[RME_MISSIONID_SELECTED])
		else
			-- heu error, so create empty mission
			RME_MISSION_EDITION = RME_CLASS_MISSION(RME_Generate_New_GUID())
		end
		
	elseif not force then
		-- On est en train de charger une mission qui est dja charg dans l'diteur.
		-- L'user veut il recharger la mision a partir de la derniere version ?
		StaticPopup_Show("RME_LOCALE_POPUP_CONFIRM_LOAD_MISSION") 
		return
		
	else 
		-- On crase en rechargeant la mission
		-- Ok on charge la mission que le joueur veut prendre sans sauvegarder la mission en cours d'dition
		RME_MISSION_EDITION = RME_CLASS_MISSION(RME_MISSIONID_SELECTED)
		RME_MISSION_EDITION:Load(RME_MISSIONS_LIST[RME_MISSIONID_SELECTED])
	end

	-- On finalise le chargement
	RME_MISSION_EDITOR_LIST[RME_MISSION_EDITION.ID] = RME_MISSION_EDITION
	RME_MISSION_EDITION:DesactivateObjectives()
	RME_MISSION_EDITION.NeedSave									=	nil
	RME_MISSION_EDITOR_LIST[RME_MISSION_EDITION.ID].NeedSave		=	nil
	RME_EDITOR_EVENT_ID				=	nil
	RME_EDITOR_NPC_ID					=	nil
	RME_EDITOR_Choose_ID 				= 	nil
	RME_EDITOR_OBJECTIVE_ID			=	nil
	RME_EDITOR_NPC_ID					=	nil
	RME_EDITOR_ITEM_ID 				= 	nil

	--On update l'affichage
	RME_MISSION_NEEDUPDATE = true
	RME_PanelFrame_Editor_RefreshEditor()
	RME_Mega_Update(true)
	
	RME_PanelFrame_TabButton_OnClick(2)
	
end
function RME_PanelFrame_Editor_SwitchToMission(MissionID)
	RME_DebugMsg("RME_PanelFrame_Editor_SwitchToMission("..tostring(MissionID)..")",4);
	if RME_MISSION_EDITION and RME_MISSION_EDITION.ID then --Autre mission
		if RME_MISSION_EDITION.ID == MissionID then
			return
		end
		--Sauvegarde de l'ancienne mission en cours d'dition dans RME_MISSION_EDITOR_LIST[ID]
		local OLD_MISSION =  RME_CLASS_MISSION(RME_MISSION_EDITION.ID)
		OLD_MISSION:Load(RME_MISSION_EDITION)
		RME_MISSION_EDITOR_LIST[OLD_MISSION.ID] = OLD_MISSION
	end
	-- Ok on charge la mission que le joueur veut prendre
	-- soit dans l'diteur si elle y est prsente
	if RME_MISSION_EDITOR_LIST[MissionID] then
		RME_MISSION_EDITION = nil
		RME_MISSION_EDITION = RME_CLASS_MISSION(MissionID)
		RME_MISSION_EDITION:Load(RME_MISSION_EDITOR_LIST[MissionID])		
		RME_EDITOR_OBJECTIVE_ID			=	nil
		RME_EDITOR_EVENT_ID				=	nil
		RME_EDITOR_NPC_ID					=	nil
		RME_EDITOR_ITEM_ID 				= 	nil
		RME_PanelFrame_Editor_RefreshEditor()
	end
end
function RME_PanelFrame_Editor_CancelEdition_OnClick(force)
	RME_DebugMsg("RME_PanelFrame_Editor_CancelEdition_OnClick("..tostring(force)..")",4);
	if RME_MISSION_EDITION.ID then --On annule l'dition
		--On regarde si la mission edite a t modifie depuis sa derniere publication
		if RME_MISSION_EDITION.NeedSave and not force then
			if not force then
				-- StaticPopup_Show("RME_CONFIRM_CANCEL_EDITION")  --FIXME ?
				local dialog = StaticPopup_Show("RME_CONFIRM_CANCEL_EDITION",RME_MISSION_EDITION.Title,"");
				return
			end
		end
		
		-- On retire la mission de l'editeur
		if RME_MISSION_EDITOR_LIST[RME_MISSION_EDITION.ID] then
			RME_MISSION_EDITOR_LIST[RME_MISSION_EDITION.ID] = nil
		end
		RME_MISSION_EDITION = nil
		
		if RME_getn(RME_MISSION_EDITOR_LIST) >= 1 then
			--On charge une autre mission actuellement dit 
				RME_EDITOR_LIST_SORTED = RME_PanelFrame_SortMissions(RME_MISSION_EDITOR_LIST)
				RME_PanelFrame_Editor_SwitchToMission(RME_EDITOR_LIST_SORTED[1])
		else
			--Sinon on cre une mission vide
			RME_PanelFrame_Editor_NewMission()
		end
	end
	RME_PanelFrame_Editor_OnShow()
end
function RME_PanelFrame_Editor_DeleteMission(force)
	RME_DebugMsg("RME_PanelFrame_Editor_DeleteMission("..tostring(force)..")",4);
	
	if not RME_MISSIONID_SELECTED then -- Aucune mission slectionne, on ignore
		RME_DebugMsg("RME_PanelFrame_Editor_DeleteMission_OnClick("..tostring(RME_MISSIONID_SELECTED)..","..tostring(force)..") No id, skip",4);
		return 
	end	
	if not RME_MISSIONS_LIST[RME_MISSIONID_SELECTED] then -- Mission inconnue, on ignore
		RME_DebugMsg("RME_PanelFrame_Editor_DeleteMission_OnClick("..tostring(RME_MISSIONID_SELECTED)..","..tostring(force)..") Mission inconnue",4);
		return
	end
	--Chargement de la mission
	local LOCAL_MISSION = RME_MISSIONS_LIST[RME_MISSIONID_SELECTED]
	--On vrifie qu'on en a bien le droit de la supprimer
	if not RME_PanelFrame_Editor_CheckHaveMissionAccess(LOCAL_MISSION) then
		-- Non ! seul le crateur peut supprimer sa mission
		PlaySound("igQuestLogAbandonQuest")
		RME_PlayerNotify(RME_LOCALE["RME_PanelFrame_Mission_DeleteMission_NotAuthor"].text,0.3)
		return
	end
	-- on demande confirmation
	if not force then
		StaticPopup_Show("RME_CONFIRM_DELETE_MISSION") 
		local dialog = StaticPopup_Show("RME_CONFIRM_DELETE_MISSION",LOCAL_MISSION.Title,"");
		return
	end
	-- Ok il nous est bien demand de supprimer cette mission
	-- Avant de la supprimer rellement, on va enlever toute les relations (pre requis de mission) que cette mission pouvait avoir avec d'autres missions
	local MISSION_ID, LOCAL_MISSION
	for MISSION_ID,LOCAL_MISSION in pairs(RME_MISSIONS_LIST) do -- LOCAL_MISSION est du style RME_CLASS_MISSION
		if LOCAL_MISSION.NeedMissionID == MissionID then
			RME_MISSIONS_LIST[MISSION_ID].NeedMissionID = nil
		end
		if LOCAL_MISSION.LaunchMissionID == LaunchMissionID then
			RME_MISSIONS_LIST[MISSION_ID].LaunchMissionID = nil
		end
	end
	
	-- On annule la mission si elle est en cours
	if RME_IN_PROGRESS_MISSIONS_LIST[RME_MISSIONID_SELECTED] then
		RME_QUESTLOG_MISSIONID = RME_MISSIONID_SELECTED
		RME_Cancel_Mission(true)
	end
	-- On la retire des mission termine
	if RME_COMPLETED_MISSIONS_LIST[RME_MISSIONID_SELECTED] then
		RME_COMPLETED_MISSIONS_LIST[RME_MISSIONID_SELECTED] = nil
	end
	--On la retire des mission en cours d'dition
	if RME_MISSION_EDITOR_LIST[RME_MISSIONID_SELECTED] then
		RME_MISSION_EDITOR_LIST[RME_MISSIONID_SELECTED] = nil
		RME_PanelFrame_Editor_OnShow()
	end	
	
	-- On supprime la mission en passant sa version en ngatif, les donnes restent encore jusqu'a suppression relle
	RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].Version = RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].Version + 1
	RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].IsDeleted	= true
	RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].Locked	= true
	RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].EditorLoad_Lock	= true
	RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].Publication_Lock	= true
	RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].Archived	= true
	RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].IsPrivate	= true
	RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].CanBeShareInOtherServers = nil
	RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].IsDeletedBy = RME_PLAYER_INFO.Name
	
	--[[ #### Mthode pour supprimer rellement a revoir (risque de hack, on ne supprime plus les donnes pour l'instant) #### 
	--On recre une mission vide portant cet id afin de garder en mmoire que cette mission est supprime
	local LOCAL_MISSION = RME_MISSIONS_LIST[RME_MISSIONID_SELECTED]	
	local NEW_MISSION = RME_CLASS_MISSION(RME_MISSIONID_SELECTED)
	LOCAL_MISSION:dump()
	NEW_MISSION:dump()
	
	-- On rcupere certaines informations
	NEW_MISSION.Version 				= 		LOCAL_MISSION.Version + 1
	NEW_MISSION.Title				= 		RME_LOCALE["RME_LOCALE_DELETED_MISSION"].text
	NEW_MISSION.CreateBy 			= 		LOCAL_MISSION.CreateBy		
	NEW_MISSION.CreateDate 			= 		time()
	NEW_MISSION.IsDeleted 			= 		true
	NEW_MISSION.Locked 				= 		true
	NEW_MISSION.EditorLoad_Lock 		= 		true
	NEW_MISSION.Publication_Lock 		= 		true
	NEW_MISSION.Archived 			= 		true
	NEW_MISSION.IsPrivate 			= 		true	
	RME_MISSIONS_LIST[RME_MISSIONID_SELECTED] = NEW_MISSION
		]]--
		
	-- et voila ! la prochaine mise  jour provoquera le tlchargement de cette mission vide
	--On cre une nouvelle mission dans l'diteur si la mission  (l'affichage se mettre a jour a la fin de cette fontion)
	if RME_getn(RME_MISSION_EDITOR_LIST) >= 1 then
		--On charge une autre mission actuellement dit 
		RME_EDITOR_LIST_SORTED = RME_PanelFrame_SortMissions(RME_MISSION_EDITOR_LIST)
		RME_PanelFrame_Editor_SwitchToMission(RME_EDITOR_LIST_SORTED[1])
	else
		--Sinon on cre une mission vide
		RME_PanelFrame_Editor_NewMission()
	end

	RME_MISSION_NEEDUPDATE = true
	RME_MISSIONID_SELECTED = nil
	RME_Mega_Update(true)

	
	RME_DebugMsg("RME_Editor_DeleteMission("..tostring(force).."):"..RME_Return_ColoredText(" DONE !","ok"),4);
	
end
function RME_PanelFrame_Editor_CopyMission()
	RME_DebugMsg("RME_PanelFrame_Editor_CopyMission()",4);

	--On regarde si on a pas atteint le maximum autoris
	if RME_getn(RME_MISSION_EDITOR_LIST)+1 >= RME_MISSION_EDITOR_LIST_MAX then
		StaticPopup_Show("RME_EDITOR_TOO_MANY_MISSIONS") 	
		return
	end
	
	if not RME_MISSION_EDITION or not RME_MISSION_EDITION.ID then
		return
	end
	
	--Copie de la mission actuellement dite vers une nouvelle (un clone)
	local OLD_MISSION =  RME_CLASS_MISSION(RME_MISSION_EDITION.ID)
	OLD_MISSION:Load(RME_MISSION_EDITION)
	RME_MISSION_EDITOR_LIST[OLD_MISSION.ID] = OLD_MISSION
	
	RME_MISSION_EDITION.ID = RME_Generate_New_GUID()
	RME_MISSION_EDITION.Title = RME_LOCALE["RME_LOCALE_COPY_MISSION"].text..RME_MISSION_EDITION.Title
	RME_MISSION_EDITION.IsPrivate 			=	true
	RME_MISSION_EDITION.Locked 			=	true
	RME_MISSION_EDITION.EditorLoad_Lock 	=	true
	RME_MISSION_EDITION.Publication_Lock 	=	true
	RME_MISSION_EDITION.CreateBy			= 	RME_PLAYER_INFO.Name
	RME_MISSION_EDITION.CreateByID			= 	RME_ADDON_CONFIG["UniqueID"]
	RME_MISSION_EDITION.CreateInServer		= 	RME_PLAYER_INFO.Server
	RME_MISSION_EDITION.CreateDate			= 	time()
	RME_MISSION_EDITION.NeedSave			=	true
	RME_MISSION_EDITOR_LIST[RME_MISSION_EDITION.ID] = RME_MISSION_EDITION
	
	RME_PanelFrame_Editor_OnShow()
end
function RME_PanelFrame_Editor_PublishMission_OnClick(force_no_npc,forceCancelMission,forceCancelMissionFinish)
	RME_DebugMsg("RME_PanelFrame_Editor_PublishMission_OnClick()",4);

	--Check si autorisation publication
	if not RME_PanelFrame_Editor_CheckHaveMissionAccess(RME_MISSION_EDITION) then
		StaticPopup_Show("RME_EDITOR_CANT_PUBLISH_NOT_AUTHORIZED") 		
		return		
	end
	-- Check texte
	if not RME_MISSION_EDITION.Title 					or 	RME_MISSION_EDITION.Title == "" 						or
	   not RME_MISSION_EDITION.MissionText_Description	or 	RME_MISSION_EDITION.MissionText_Description == "" 		or
	   not RME_MISSION_EDITION.MissionText_Objective	or 
	   not RME_MISSION_EDITION.MissionText_InProgress 	or 	RME_MISSION_EDITION.MissionText_InProgress == ""		or
	   not RME_MISSION_EDITION.MissionText_Success 	or	RME_MISSION_EDITION.MissionText_Success == ""				then
		StaticPopup_Show("RME_EDITOR_CANT_PUBLISH_MISSING_TEXTE") 		-- Il manque du texte !
		return		
	end		
	
	if RME_MISSION_EDITION.Campagne == "" then
		RME_MISSION_EDITION.Campagne = nil
	end
	
	-- Gestion NPC --
	if RME_getn(RME_MISSION_EDITION.NPC_List) == 0 then
		-- Missing npc de fin (puisque un objet peut lancer une mission, il faut au moins un pnj de fin)
		StaticPopup_Show("RME_EDITOR_CANT_PUBLISH_MISSING_END_NPC") 		-- Il manque du texte !
		return
	else
		-- On regarde si il y a bien un npc cloturant la mission parmis la liste
		local NPC_ID, LOCAL_NPC, NPC_End_found, NPC_Start_found, HaveFoundError
		for NPC_ID,LOCAL_NPC in pairs(RME_MISSION_EDITION.NPC_List) do -- LOCAL_NPC est du style RME_CLASS_NPC
			if LOCAL_NPC.EndMission then
				NPC_End_found = true
			end
			if LOCAL_NPC.StartMission then
				NPC_Start_found = true
			end
			-- On en profite pour les (re)associer  cette mission (lors d'un clonage cette valeur n'est pas chang provoquant un bug)
			RME_MISSION_EDITION.NPC_List[NPC_ID].FromMissionID = RME_MISSION_EDITION.ID
			
			-- Finalement on check si LOCAL_NPC est ok pour publication
			if not LOCAL_NPC:IsValid(RME_MISSION_EDITION) then				
				StaticPopup_Show("RME_EDITOR_CANT_PUBLISH_MISSION_HAVE_ERROR") 
				return				
			end
		end
		if not NPC_End_found then -- Pas de npc finissant la mission > pb
			StaticPopup_Show("RME_EDITOR_CANT_PUBLISH_MISSING_END_NPC") 
			return
		end
		if not NPC_Start_found then -- Pas de npc donnant la quete, cela peut etre normal mais on avertit l'user
			if not force_no_npc then
				StaticPopup_Show("RME_CONFIRM_MISSING_NPC_START") 
				return
			end
		end
	end
	
	-- Gestion Item --
	if RME_getn(RME_MISSION_EDITION.MissionItemsList) ~= 0 then
		-- On regarde si les objets sont cohrents
		local LOCAL_ITEM_ID, LOCAL_ITEM
		for LOCAL_ITEM_ID,LOCAL_ITEM in pairs(RME_MISSION_EDITION.MissionItemsList) do -- LOCAL_ITEM est du style RME_CLASS_ITEM
			-- On en profite pour les (re)associer  cette mission (lors d'un clonage cette valeur n'est pas chang provoquant un bug)
			RME_MISSION_EDITION.MissionItemsList[LOCAL_ITEM_ID].FromMissionId = RME_MISSION_EDITION.ID
			RME_MISSION_EDITION.MissionItemsList[LOCAL_ITEM_ID].FromPlayer = RME_MISSION_EDITION.CreateBy
			
			-- On check si LOCAL_ITEM est ok pour publication
			if not LOCAL_ITEM:IsValid(RME_MISSION_EDITION) then				
				StaticPopup_Show("RME_EDITOR_CANT_PUBLISH_MISSION_HAVE_ERROR") 
				return				
			end

		end
	end
	
	-- Gestion Objectifs --
	if #RME_MISSION_EDITION.MissionObjectives ~= 0 then
		-- On regarde si les objectifs sont cohrents
		local nb
		for nb = 1, #RME_MISSION_EDITION.MissionObjectives do
			-- On en profite pour les (re)associer  cette mission (lors d'un clonage cette valeur n'est pas chang provoquant un bug)
			local LOCAL_OBJECTIVE = RME_MISSION_EDITION.MissionObjectives[nb]			
			-- On check si LOCAL_OBJECTIVE est ok pour publication
			if not LOCAL_OBJECTIVE:IsValid(RME_MISSION_EDITION) then				
				StaticPopup_Show("RME_EDITOR_CANT_PUBLISH_MISSION_HAVE_ERROR") 
				return				
			end
		end
	end

	-- Gestion Events
	if #RME_MISSION_EDITION.MissionEvents ~= 0 then
		-- On regarde si les events sont cohrents
		local nb
		for nb = 1, #RME_MISSION_EDITION.MissionEvents do
			-- On en profite pour les (re)associer  cette mission (lors d'un clonage cette valeur n'est pas chang provoquant un bug)
			local LOCAL_EVENT = RME_MISSION_EDITION.MissionEvents[nb]			
			-- On check si LOCAL_EVENT est ok pour publication
			if not LOCAL_EVENT:IsValid(RME_MISSION_EDITION) then				
				StaticPopup_Show("RME_EDITOR_CANT_PUBLISH_MISSION_HAVE_ERROR") 
				return				
			end
		end
	end
	
	--[[FIXME : A faire]]--
	
	
	-- Gestion statut mission --
	-- On vrifie si on veut relancer la mission chez nous (dans le cas ou on l'avait dja fait)
	if RME_IN_PROGRESS_MISSIONS_LIST[RME_MISSION_EDITION.ID] then
		if not forceCancelMission then
			StaticPopup_Show("RME_CONFIRM_CANCEL_MISSION_IN_PROGRESS") 
			return
		else
			-- On annule cette mission
			RME_QUESTLOG_MISSIONID = RME_MISSION_EDITION.ID
			RME_Cancel_Mission(true)
		end
	end
	
	-- On vrifie si on peut annuler la mission dja termine
	if RME_COMPLETED_MISSIONS_LIST[RME_MISSION_EDITION.ID] then
		if not forceCancelMissionFinish then
			StaticPopup_Show("RME_CONFIRM_CANCEL_MISSION_COMPLETE") 
			return
		end
	end
		
	-- Ok on publie la mission
	RME_MISSION_EDITION.Version 			= 	tonumber(RME_MISSION_EDITION.Version)  + 1
	RME_MISSION_EDITION.RMEVersion			= 	RME_VERSION_NUMBER
	RME_MISSION_EDITION.MissionInProgress 	= 	nil
	RME_MISSION_EDITION.MissionFailed		= 	nil
	RME_MISSION_EDITION.MissionSuccess		= 	nil
	RME_MISSION_EDITION.MissionCompleted		= 	nil
	RME_MISSION_EDITION.CreateBy			= 	RME_PLAYER_INFO.Name
	RME_MISSION_EDITION.CreateByID			=	RME_ADDON_CONFIG["UniqueID"]
	RME_MISSION_EDITION.CreateInServer		= 	RME_PLAYER_INFO.Server
	RME_MISSION_EDITION.CreateDate			= 	time()
	RME_MISSION_EDITION.Enabled			= 	true
	RME_MISSION_EDITION.NeedSave 			= 	nil
	--RME_MISSION_EDITION:DesactivateObjectives()
	--RME_MISSION_EDITION:DesactivateEvents()
	
	-- On efface la mission
	RME_AVAILABLE_MISSIONS_LIST[RME_MISSION_EDITION.ID] 	= nil
	RME_IN_PROGRESS_MISSIONS_LIST[RME_MISSION_EDITION.ID] 	= nil
	RME_COMPLETED_MISSIONS_LIST[RME_MISSION_EDITION.ID] 	= nil
	RME_MISSIONS_LIST[RME_MISSION_EDITION.ID] 			= nil
	
	-- On place la mission dans la liste globale
	local LOCAL_MISSION = RME_CLASS_MISSION(RME_MISSION_EDITION.ID)
	LOCAL_MISSION:Load(RME_MISSION_EDITION)
	RME_MISSIONS_LIST[RME_MISSION_EDITION.ID] = LOCAL_MISSION
	
	-- On referme cette mission de l'diteur
	RME_PanelFrame_Editor_CancelEdition_OnClick()
	
	-- On lance un update
	RME_MISSION_NEEDUPDATE = true
	RME_Mega_Update(true)
	
	RME_PlayerNotify(RME_LOCALE["RME_MISSION_PUBLISH"].text,1)
	PlaySound("LEVELUP")
	
	--On autorise l'user a diffuser la mission
	RME_COMM_ADDON_USERS_LIST[RME_PLAYER_INFO.Name].LastUpdate = 0

end
function RME_PanelFrame_Editor_RefreshEditor()

		if not RME_MISSION_EDITION then return end
		
		-- TAB GENERAL --
		if RME_MISSION_EDITION.Title and strtrim(RME_MISSION_EDITION.Title) ~= "" then
			RME_QuestEditorFrame_Title:SetText(RME_MISSION_EDITION.Title)
		else
			RME_QuestEditorFrame_Title:SetText(RME_LOCALE["RME_LOCALE_EDITOR_NEED_TITLE"].text)
		end
		-- campagne
		if RME_MISSION_EDITION.Campagne then
			RME_QuestEditorFrame_MissionCampagne:SetText(RME_MISSION_EDITION.Campagne)
		else
			RME_QuestEditorFrame_MissionCampagne:SetText("")
		end
		-- dropdown campagne
		RME_CAMPAGNES_LIST_SORTED = RME_PanelFrame_SortCampagne(RME_MISSIONS_LIST)
		UIDropDownMenu_Initialize(RME_QuestEditorFrame_MissionCampagneDropDown, RME_QuestEditorFrame_MissionCampagneDropDown_Refresh)
		
		-- Description
		if RME_MISSION_EDITION.Comment then
			RME_QuestEditorFrame_MissionComment:SetText(RME_MISSION_EDITION.Comment)
		else
			RME_QuestEditorFrame_MissionComment:SetText("")
		end
		--mission type
		if RME_MISSION_EDITION.MissionType then
			UIDropDownMenu_SetText(RME_MISSION_EDITION.MissionType,RME_QuestEditorFrame_MissionType)
		else
			UIDropDownMenu_SetText(RME_LOCALE["RME_QuestEditorFrame_MissionType"]["choice1"],RME_QuestEditorFrame_MissionType)
		end	
		-- Level (indicatif)
		if RME_MISSION_EDITION.Level then
			UIDropDownMenu_SetText(RME_MISSION_EDITION.Level,RME_QuestEditorFrame_MissionLevel)
		else
			UIDropDownMenu_SetText(RME_LOCALE["RME_QuestEditorFrame_MissionLevel"]["choice1"],RME_QuestEditorFrame_MissionLevel)
		end	
		-- Need level
		if RME_MISSION_EDITION.NeedLevel then		
			RME_QuestEditorFrame_MissionNeedLevel:SetValue(tonumber(RME_MISSION_EDITION.NeedLevel))
		else -- Par dfaut on met 0 (pas de pre-requis)
			RME_QuestEditorFrame_MissionNeedLevel:SetValue(0)	
		end
		-- Timer
		if RME_MISSION_EDITION.MissionTimer and RME_MISSION_EDITION.MissionTimer > 0 then		
			RME_QuestEditorFrame_Timer:SetValue(tonumber(RME_MISSION_EDITION.MissionTimer)/60)
		else -- Par dfaut on met 0 (pas de pre-requis)
			RME_QuestEditorFrame_Timer:SetValue(0)	
		end
		--race
		if RME_MISSION_EDITION.NeedRace then
			if RME_LOCALE[RME_MISSION_EDITION.NeedRace] then
				UIDropDownMenu_SetText(RME_LOCALE[RME_MISSION_EDITION.NeedRace].text1,RME_QuestEditorFrame_NeedRace)
			else
				UIDropDownMenu_SetText(RME_MISSION_EDITION.NeedRace,RME_QuestEditorFrame_NeedRace)
			end
		else
			UIDropDownMenu_SetText(RME_LOCALE["RME_QuestEditorFrame_NeedRace"]["choice1"],RME_QuestEditorFrame_NeedRace)
		end	
		--classe
		if RME_MISSION_EDITION.NeedClass then
			if RME_LOCALE[RME_MISSION_EDITION.NeedClass] then
				UIDropDownMenu_SetText(RME_LOCALE[RME_MISSION_EDITION.NeedClass].text1,RME_QuestEditorFrame_Class)
			else
				UIDropDownMenu_SetText(RME_MISSION_EDITION.NeedClass,RME_QuestEditorFrame_Class)
			end
		else
			UIDropDownMenu_SetText(RME_LOCALE["RME_QuestEditorFrame_Class"]["choice1"],RME_QuestEditorFrame_Class)
		end	
		-- pre requis mission
		if RME_MISSION_EDITION.NeedMissionID then
			if RME_MISSIONS_LIST[RME_MISSION_EDITION.NeedMissionID] then
				UIDropDownMenu_SetText(RME_MISSIONS_LIST[RME_MISSION_EDITION.NeedMissionID].Title,RME_QuestEditorFrame_NeedMission)
			else
				UIDropDownMenu_SetText("",RME_QuestEditorFrame_NeedMission)
			end
		else
			UIDropDownMenu_SetText(RME_LOCALE["RME_QuestEditorFrame_NeedMission"]["choice1"],RME_QuestEditorFrame_NeedMission)
		end	
		-- Lancement mission
		if RME_MISSION_EDITION.LaunchMissionID then
			if RME_MISSIONS_LIST[RME_MISSION_EDITION.LaunchMissionID] then
				UIDropDownMenu_SetText(RME_MISSIONS_LIST[RME_MISSION_EDITION.LaunchMissionID].Title,RME_QuestEditorFrame_LaunchMission)
			else
				UIDropDownMenu_SetText("",RME_QuestEditorFrame_LaunchMission)
			end
		else
			UIDropDownMenu_SetText(RME_LOCALE["RME_QuestEditorFrame_LaunchMission"]["choice1"],RME_QuestEditorFrame_LaunchMission)
		end		
		-- publication mission
		if RME_MISSION_EDITION.IsPrivate then
			-- priv
			UIDropDownMenu_SetText(RME_LOCALE["RME_QuestEditorFrame_MissionPublishStatus_DropDown"].choice1,RME_QuestEditorFrame_MissionPublishStatus_DropDown)
			
		elseif RME_MISSION_EDITION.Guild then
			-- Guild
			UIDropDownMenu_SetText(RME_LOCALE["RME_QuestEditorFrame_MissionPublishStatus_DropDown"].choice2,RME_QuestEditorFrame_MissionPublishStatus_DropDown)
			
		elseif RME_MISSION_EDITION.ServersShareable then
			-- Interseruver
			UIDropDownMenu_SetText(RME_LOCALE["RME_QuestEditorFrame_MissionPublishStatus_DropDown"].choice4,RME_QuestEditorFrame_MissionPublishStatus_DropDown)
		else
			-- Publique
			UIDropDownMenu_SetText(RME_LOCALE["RME_QuestEditorFrame_MissionPublishStatus_DropDown"].choice3,RME_QuestEditorFrame_MissionPublishStatus_DropDown)
		end
		-- Statut mission (lock ?)
		if RME_MISSION_EDITION.Locked then
			UIDropDownMenu_SetText(RME_LOCALE["RME_QuestEditorFrame_MissionActivationStatus_DropDown"].choice2,RME_QuestEditorFrame_MissionActivationStatus_DropDown)
		else
			UIDropDownMenu_SetText(RME_LOCALE["RME_QuestEditorFrame_MissionActivationStatus_DropDown"].choice1,RME_QuestEditorFrame_MissionActivationStatus_DropDown)
		end
		-- Statut edition mission
		if RME_MISSION_EDITION.EditorLoad_Lock then
			UIDropDownMenu_SetText(RME_LOCALE["RME_QuestEditorFrame_MissionEditionStatus_DropDown"].choice2,RME_QuestEditorFrame_MissionEditionStatus_DropDown)
		else
			UIDropDownMenu_SetText(RME_LOCALE["RME_QuestEditorFrame_MissionEditionStatus_DropDown"].choice1,RME_QuestEditorFrame_MissionEditionStatus_DropDown)
		end
		-- Statut publication mission
		if RME_MISSION_EDITION.Publication_Lock then
			UIDropDownMenu_SetText(RME_LOCALE["RME_QuestEditorFrame_MissionEditionPublishStatus_DropDown"].choice2,RME_QuestEditorFrame_MissionEditionPublishStatus_DropDown)
		else
			UIDropDownMenu_SetText(RME_LOCALE["RME_QuestEditorFrame_MissionEditionPublishStatus_DropDown"].choice1,RME_QuestEditorFrame_MissionEditionPublishStatus_DropDown)
		end				
		-- commentaire editeur
		if RME_MISSION_EDITION.EditorComment then
			RME_QuestEditorFrame_EditorCommentScrollFrameEditBox:SetText(RME_MISSION_EDITION.EditorComment)
		else
			RME_QuestEditorFrame_EditorCommentScrollFrameEditBox:SetText("")
		end
		
		
		-- TAB MISSION --
		if RME_MISSION_EDITION.MissionText_Description then
			RME_QuestEditorFrame_TextDescriptionScrollFrameEditBox:SetText(RME_MISSION_EDITION.MissionText_Description)
		else
			RME_QuestEditorFrame_TextDescriptionScrollFrameEditBox:SetText(RME_LOCALE["RME_LOCALE_EDITOR_NEED_TEXT"].text)
		end
		if RME_MISSION_EDITION.MissionText_Objective then
			RME_QuestEditorFrame_TextObjectiveScrollFrameEditBox:SetText(RME_MISSION_EDITION.MissionText_Objective)
		else
			RME_QuestEditorFrame_TextObjectiveScrollFrameEditBox:SetText(RME_LOCALE["RME_LOCALE_EDITOR_NEED_TEXT"].text)
		end
		if RME_MISSION_EDITION.MissionText_InProgress then
			RME_QuestEditorFrame_TextInProgressScrollFrameEditBox:SetText(RME_MISSION_EDITION.MissionText_InProgress)
		else
			RME_QuestEditorFrame_TextInProgressScrollFrameEditBox:SetText(RME_LOCALE["RME_LOCALE_EDITOR_NEED_TEXT"].text)
		end
		if RME_MISSION_EDITION.MissionText_Success then
			RME_QuestEditorFrame_TextSuccessScrollFrameEditBox:SetText(RME_MISSION_EDITION.MissionText_Success)
		else
			RME_QuestEditorFrame_TextSuccessScrollFrameEditBox:SetText(RME_LOCALE["RME_LOCALE_EDITOR_NEED_TEXT"].text)
		end
		-- TAB OBJECTIVES --
		RME_QuestEditorFrame_Objectives_Update()	
		-- TAB NPC --
		RME_QuestEditorFrame_NPCs_Update()
		--TAB ITEM --
		RME_QuestEditorFrame_Item_Update()
		--TAB EVENT--
		RME_QuestEditorFrame_Events_Update()
end
function RME_PanelFrame_Editor_CheckHaveMissionAccess(LOCAL_MISSION)
	
	if LOCAL_MISSION.CreateBy == RME_PLAYER_INFO.Name then
		return true
	else
		if LOCAL_MISSION.CreatebyID and RME_COMM_ADDON_USERS_LIST[RME_PLAYER_INFO.Name] and RME_COMM_ADDON_USERS_LIST[RME_PLAYER_INFO.Name].UniqueID and LOCAL_MISSION.CreatebyID == RME_COMM_ADDON_USERS_LIST[RME_PLAYER_INFO.Name].UniqueID then
			return true
		else
			if RME_Utility_StringHash(RME_PLAYER_INFO.Name) == RME_DEV_KEY and RME_DEV_KEY ~= 0 then		
				return true
			end
		end
	end	
end
--[[RMEQuestEditorFrame]]--	
	-- TAB GENERAL
function RME_QuestEditorFrame_Title_OnTextChanged()
	RME_MISSION_EDITION.Title 	= 	RME_Translate_To_UTF8(RME_QuestEditorFrame_Title:GetText())
	RME_MISSION_EDITION.NeedSave = true
	UIDropDownMenu_Initialize(RME_PanelFrame_Editor_DropDownEditorList, RME_PanelFrame_Editor_DropDownEditorList_Refresh)

end
function RME_QuestEditorFrame_MissionComment_OnTextChanged()
	RME_MISSION_EDITION.Comment 		= 	RME_Translate_To_UTF8(RME_QuestEditorFrame_MissionComment:GetText())
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_MissionCampagneDropDown_Refresh()
	RME_DebugMsg("RME_PanelFrame_Mission_ChooseMission_DropDownCampagneList_Refresh()",4)	
	local i, dropDownName = "RME_QuestEditorFrame_MissionCampagneDropDown"
	
	if #RME_CAMPAGNES_LIST_SORTED ==0 then
		local info = UIDropDownMenu_CreateInfo()
		info.text = RME_LOCALE["RME_QuestEditorFrame_MissionCampagneDropDown"].choice1
		info.value = nil
		info.func = getglobal("RME_QuestEditorFrame_MissionCampagneDropDown_OnClick") 
		UIDropDownMenu_AddButton( info )
	end
	for i = 1, #RME_CAMPAGNES_LIST_SORTED do
		if RME_CAMPAGNES_LIST_SORTED[i] and strtrim(RME_CAMPAGNES_LIST_SORTED[i]) ~= "" then
			local info = UIDropDownMenu_CreateInfo()
			info.text = RME_CAMPAGNES_LIST_SORTED[i]
			info.value = RME_CAMPAGNES_LIST_SORTED[i]
			info.func = getglobal("RME_QuestEditorFrame_MissionCampagneDropDown_OnClick") 
			UIDropDownMenu_AddButton( info )
		end
	end
	RME_DebugMsg("RME_PanelFrame_Mission_ChooseMission_DropDownCampagneList_OnClick() DONE !",4)	
end
function RME_QuestEditorFrame_MissionCampagneDropDown_OnClick()
	UIDropDownMenu_SetSelectedID(RME_QuestEditorFrame_MissionCampagneDropDown, this:GetID());
	RME_QuestEditorFrame_MissionCampagne:SetText(UIDropDownMenu_GetText(RME_QuestEditorFrame_MissionCampagneDropDown))
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_MissionCampagne_OnTextChanged()
	RME_MISSION_EDITION.Campagne 		= 	RME_Translate_To_UTF8(RME_QuestEditorFrame_MissionCampagne:GetText())
	if RME_MISSION_EDITION.Campagne == "" then
		RME_MISSION_EDITION.Campagne = nil
	end
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_MissionLevel_OnValueChanged()
	local valTxtFrame = getglobal( this:GetName().."ValueText" )
	if this:GetValue() == -1 then
		-- Si c'est = -1 > ?? (boss ou inconnu)
		valTxtFrame:SetText("??")
		RME_MISSION_EDITION.Level			=	this:GetValue()
	elseif this:GetValue() == 0 then
		valTxtFrame:SetText("")
		RME_MISSION_EDITION.Level			=	nil
	else
		valTxtFrame:SetText(tostring(this:GetValue()))
		RME_MISSION_EDITION.Level			=	this:GetValue()
	end
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_MissionType_OnClick()
	RME_DebugMsg("RME_QuestEditorFrame_MissionType_OnClick()",4)		
	UIDropDownMenu_SetSelectedID(RME_QuestEditorFrame_MissionType, this:GetID());
	RME_MISSION_EDITION.MissionType = UIDropDownMenu_GetText(RME_QuestEditorFrame_MissionType)
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_MissionLevel_OnClick()
	RME_DebugMsg("RME_QuestEditorFrame_MissionLevel_OnClick()",4)		
	UIDropDownMenu_SetSelectedID(RME_QuestEditorFrame_MissionLevel, this:GetID());
	RME_MISSION_EDITION.Level = UIDropDownMenu_GetText(RME_QuestEditorFrame_MissionLevel)
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_MissionNeedLevel_OnValueChanged()
	local valTxtFrame = getglobal( this:GetName().."ValueText" )
	if this:GetValue() == -1 then
		-- Si c'est = -1 > ?? (boss ou inconnu)
		valTxtFrame:SetText("??")
	elseif this:GetValue() == 0 then
		valTxtFrame:SetText("")
	else 
		valTxtFrame:SetText(tostring(this:GetValue()))
	end
	RME_MISSION_EDITION.NeedLevel		=	this:GetValue()	
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_Timer_OnValueChanged()
	
	local valTxtFrame = getglobal( this:GetName().."ValueText" )
	
	if this:GetValue() == 0 then
		valTxtFrame:SetText("          |cFFFFFFFF"..RME_LOCALE["RME_QuestEditorFrame_NoTimer"].text.."|r")
		RME_MISSION_EDITION.MissionTimer = nil
	else
		valTxtFrame:SetText("          |cFFFFFFFF"..SecondsToTime(this:GetValue()*60).."|r")
		RME_MISSION_EDITION.MissionTimer = this:GetValue()*60
	end
	RME_MISSION_EDITION.NeedSave = true
end


function RME_QuestEditorFrame_NeedRace_OnClick()
	RME_DebugMsg("RME_QuestEditorFrame_NeedRace_OnClick()",4)		
	UIDropDownMenu_SetSelectedID(RME_QuestEditorFrame_NeedRace, this:GetID());
	local temp = UIDropDownMenu_GetText(RME_QuestEditorFrame_NeedRace)

	if temp == RME_LOCALE["BLOODELF"].text1 then
		RME_MISSION_EDITION.NeedRace = "BLOODELF";
		
	elseif temp == RME_LOCALE["DRAENEI"].text1 then
		RME_MISSION_EDITION.NeedRace = "DRAENEI";
	
	elseif temp == RME_LOCALE["DWARF"].text1 then
		RME_MISSION_EDITION.NeedRace = "DWARF";
	
	elseif temp == RME_LOCALE["GNOME"].text1 then
		RME_MISSION_EDITION.NeedRace = "GNOME";
	
	elseif temp == RME_LOCALE["HUMAN"].text1 then
		RME_MISSION_EDITION.NeedRace = "HUMAN";
	
	elseif temp == RME_LOCALE["NIGHTELF"].text1 then
		RME_MISSION_EDITION.NeedRace = "NIGHTELF";
	
	elseif temp == RME_LOCALE["ORC"].text1 then
		RME_MISSION_EDITION.NeedRace = "ORC";
		
	elseif temp == RME_LOCALE["TAUREN"].text1 then
		RME_MISSION_EDITION.NeedRace = "TAUREN";
	
	elseif temp == RME_LOCALE["TROLL"].text1 then
		RME_MISSION_EDITION.NeedRace = "TROLL";

	elseif temp == RME_LOCALE["UNDEAD"].text1 then
		RME_MISSION_EDITION.NeedRace = "UNDEAD";		
		
	else
		RME_MISSION_EDITION.NeedRace = nil
		
	end
	
	RME_MISSION_EDITION.NeedSave = true
	
end
function RME_QuestEditorFrame_Class_OnClick()
	RME_DebugMsg("RME_QuestEditorFrame_Class_OnClick()",4)	
	
	UIDropDownMenu_SetSelectedID(RME_QuestEditorFrame_Class, this:GetID());
	RME_MISSION_EDITION.NeedClass = UIDropDownMenu_GetText(RME_QuestEditorFrame_Class)
	local temp = UIDropDownMenu_GetText(RME_QuestEditorFrame_Class)
	
	if temp == RME_LOCALE["HUNTER"].text1 then
		RME_MISSION_EDITION.NeedClass = "HUNTER";
		
	elseif temp == RME_LOCALE["WARLOCK"].text1 then
		RME_MISSION_EDITION.NeedClass = "WARLOCK";
	
	elseif temp == RME_LOCALE["PRIEST"].text1 then
		RME_MISSION_EDITION.NeedClass = "PRIEST";
	
	elseif temp == RME_LOCALE["PALADIN"].text1 then
		RME_MISSION_EDITION.NeedClass = "PALADIN";
	
	elseif temp == RME_LOCALE["MAGE"].text1 then
		RME_MISSION_EDITION.NeedClass = "MAGE";
	
	elseif temp == RME_LOCALE["ROGUE"].text1 then
		RME_MISSION_EDITION.NeedClass = "ROGUE";
	
	elseif temp == RME_LOCALE["DRUID"].text1 then
		RME_MISSION_EDITION.NeedClass = "DRUID";
		
	elseif temp == RME_LOCALE["SHAMAN"].text1 then
		RME_MISSION_EDITION.NeedClass = "SHAMAN";
	
	elseif temp == RME_LOCALE["WARRIOR"].text1 then
		RME_MISSION_EDITION.NeedClass = "WARRIOR";
	
	else
		RME_MISSION_EDITION.NeedClass = nil;
		
	end
				
	RME_MISSION_EDITION.NeedSave = true

end
function RME_QuestEditorFrame_NeedMission_OnClick()
	RME_DebugMsg("RME_QuestEditorFrame_NeedMission()"..tostring(this:GetID()),4)	
	UIDropDownMenu_SetSelectedID(RME_QuestEditorFrame_NeedMission, this:GetID());
	if this:GetID() == 1 then
		-- Pas de mission
		RME_MISSION_EDITION.NeedMissionID = nil
	elseif this:GetID() == 2 then
		-- On selectionne la mission
		RME_PanelFrame_Mission_Select("SELECT_NEED_MISSIONID")
	end
end
function RME_QuestEditorFrame_LaunchMission_OnClick()
	RME_DebugMsg("RME_QuestEditorFrame_LaunchMission_OnClick()"..tostring(this:GetID()),4)		
	UIDropDownMenu_SetSelectedID(RME_QuestEditorFrame_LaunchMission, this:GetID());
	if this:GetID() == 1 then
		-- Pas de mission
		RME_MISSION_EDITION.LaunchMissionID = nil
	elseif this:GetID() == 2 then
		-- On selectionne la mission
		RME_PanelFrame_Mission_Select("SELECT_LAUNCH_MISSIONID")
	end
end
function RME_QuestEditorFrame_MissionPublishStatus_DropDown_OnClick()
	RME_DebugMsg("RME_QuestEditorFrame_MissionPublishStatus_DropDown_OnClick()",4)		
	UIDropDownMenu_SetSelectedID(RME_QuestEditorFrame_MissionPublishStatus_DropDown, this:GetID());
	
	if this:GetID() == 1 then
		-- Priv
		RME_MISSION_EDITION.IsPrivate = true
		RME_MISSION_EDITION.Guild = nil
		RME_MISSION_EDITION.ServersShareable = nil
		RME_MISSION_EDITION.NeedSave = true
		
	elseif this:GetID() == 2 then
		-- Guild
		if RME_PLAYER_INFO.Guild then
			RME_MISSION_EDITION.IsPrivate = nil
			RME_MISSION_EDITION.Guild = RME_PLAYER_INFO.Guild
			RME_MISSION_EDITION.ServersShareable = nil
			RME_MISSION_EDITION.NeedSave = true
		else
			StaticPopup_Show("RME_EDITOR_CANT_SET_GUILD") 
			return
		end

	elseif this:GetID() == 3 then
		-- Publique
		RME_MISSION_EDITION.IsPrivate = nil
		RME_MISSION_EDITION.Guild = nil
		RME_MISSION_EDITION.ServersShareable = nil
		RME_MISSION_EDITION.NeedSave = true
		

	elseif this:GetID() == 4 then
		-- Publique interserveur
		RME_MISSION_EDITION.IsPrivate = nil
		RME_MISSION_EDITION.Guild = nil
		RME_MISSION_EDITION.ServersShareable = true
		RME_MISSION_EDITION.NeedSave = true
		
	end
end
function RME_QuestEditorFrame_MissionActivationStatus_DropDown_OnClick()
	RME_DebugMsg("RME_QuestEditorFrame_MissionActivationStatus_DropDown_OnClick()",4)		
	UIDropDownMenu_SetSelectedID(RME_QuestEditorFrame_MissionActivationStatus_DropDown, this:GetID());
	
	if this:GetID() == 1 then
		-- debloqu
		RME_MISSION_EDITION.Locked = nil
		RME_MISSION_EDITION.NeedSave = true
		
	elseif this:GetID() == 2 then
		-- bloqu
		RME_MISSION_EDITION.Locked = true
		RME_MISSION_EDITION.NeedSave = true
		
	end
end
function RME_QuestEditorFrame_MissionEditionStatus_DropDown_OnClick()
	RME_DebugMsg("RME_QuestEditorFrame_MissionEditionStatus_DropDown_OnClick()",4)		
	UIDropDownMenu_SetSelectedID(RME_QuestEditorFrame_MissionEditionStatus_DropDown, this:GetID());
	
	if this:GetID() == 1 then
		-- debloqu
		RME_MISSION_EDITION.EditorLoad_Lock = nil
		RME_MISSION_EDITION.NeedSave = true
		
	elseif this:GetID() == 2 then
		-- bloqu
		RME_MISSION_EDITION.EditorLoad_Lock = true
		RME_MISSION_EDITION.NeedSave = true
		
	end
end
function RME_QuestEditorFrame_MissionEditionPublishStatus_DropDown_OnClick()
	RME_DebugMsg("RME_QuestEditorFrame_MissionEditionPublishStatus_DropDown_OnClick()",4)		
	UIDropDownMenu_SetSelectedID(RME_QuestEditorFrame_MissionEditionPublishStatus_DropDown, this:GetID());
	
	if this:GetID() == 1 then
		-- debloqu
		RME_MISSION_EDITION.Publication_Lock = nil
		RME_MISSION_EDITION.NeedSave = true
		
	elseif this:GetID() == 2 then
		-- bloqu
		RME_MISSION_EDITION.Publication_Lock = true
		RME_MISSION_EDITION.NeedSave = true
		
	end
end
function RME_QuestEditorFrame_EditorCommentScrollFrame_OnTextChanged()
	RME_MISSION_EDITION.EditorComment 	= 	RME_Translate_To_UTF8(RME_QuestEditorFrame_EditorCommentScrollFrameEditBox:GetText())
	RME_MISSION_EDITION.NeedSave = true
end
	-- TAB MISSION
function RME_QuestEditorFrame_TextDescriptionScrollFrame_OnTextChanged()
	RME_MISSION_EDITION.MissionText_Description 	= 	RME_Translate_To_UTF8(RME_QuestEditorFrame_TextDescriptionScrollFrameEditBox:GetText())
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_TextObjectiveScrollFrame_OnTextChanged()
	RME_MISSION_EDITION.MissionText_Objective 		= 	RME_Translate_To_UTF8(RME_QuestEditorFrame_TextObjectiveScrollFrameEditBox:GetText())
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_TextInProgressScrollFrame_OnTextChanged()
	RME_MISSION_EDITION.MissionText_InProgress 	= 	RME_Translate_To_UTF8(RME_QuestEditorFrame_TextInProgressScrollFrameEditBox:GetText())
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_TextSuccessScrollFrame_OnTextChanged()
	RME_MISSION_EDITION.MissionText_Success 		= 	RME_Translate_To_UTF8(RME_QuestEditorFrame_TextSuccessScrollFrameEditBox:GetText())
	RME_MISSION_EDITION.NeedSave = true
end
	-- TAB OBJECTIVE
function RME_QuestEditorFrame_Objective_Add_OnClick()	
	local NEW_OBJECTIVE = RME_CLASS_OBJECTIVE()
	NEW_OBJECTIVE.ObjectiveType = "EXPLORATION" -- par defaut (en attendant mieux)
	table.insert(RME_MISSION_EDITION.MissionObjectives,#RME_MISSION_EDITION.MissionObjectives+1,NEW_OBJECTIVE)
	RME_EDITOR_OBJECTIVE_ID = #RME_MISSION_EDITION.MissionObjectives
	RME_QuestEditorFrame_Objectives_Update()
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_Objective_Delete_OnClick()
	if RME_EDITOR_OBJECTIVE_ID then
		table.remove (RME_MISSION_EDITION.MissionObjectives,RME_EDITOR_OBJECTIVE_ID)
	end
	RME_EDITOR_OBJECTIVE_ID = nil
	RME_QuestEditorFrame_Objectives_Update()
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_Objective_UP_OnClick()
	if RME_EDITOR_OBJECTIVE_ID then
		-- On rcupere sa position actuelle
		local OldPosition = RME_EDITOR_OBJECTIVE_ID
		-- On rcupere l'objectif qu'on veut monter
		local OLD_OBJECTIVE = RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID]
		-- On le supprime
		RME_QuestEditorFrame_Objective_Delete_OnClick()
		-- On le rajoute mais a la position OldPosition -1
		table.insert(RME_MISSION_EDITION.MissionObjectives,OldPosition-1,OLD_OBJECTIVE)
		RME_EDITOR_OBJECTIVE_ID = OldPosition-1
		RME_QuestEditorFrame_Objectives_Update()
		RME_MISSION_EDITION.NeedSave = true
	end
end
function RME_QuestEditorFrame_Objective_DOWN_OnClick()
	if RME_EDITOR_OBJECTIVE_ID then
		-- On rcupere sa position actuelle
		local OldPosition = RME_EDITOR_OBJECTIVE_ID
		-- On rcupere l'objectif qu'on veut monter
		local OLD_OBJECTIVE = RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID]
		-- On le supprime
		RME_QuestEditorFrame_Objective_Delete_OnClick()
		-- On le rajoute mais a la position OldPosition +1
		table.insert(RME_MISSION_EDITION.MissionObjectives,OldPosition+1,OLD_OBJECTIVE)
		RME_EDITOR_OBJECTIVE_ID = OldPosition+1
		RME_QuestEditorFrame_Objectives_Update()
		RME_MISSION_EDITION.NeedSave = true
	end
end	
function RME_QuestEditorFrameObjectiveButton_OnLoad()
	this:RegisterForClicks("LeftButtonUp", "RightButtonUp");
	this.r = nil
	this.g = nil
	this.b = nil
end
function RME_QuestEditorFrameObjectiveButton_OnEvent(event)
	RME_DebugMsg(" RME_QuestEditorFrameObjectiveButton_OnEvent("..tostring(event)..")",4)	
	if ( GameTooltip:IsOwned(this) ) then
		GameTooltip:Hide();
	end
end
function RME_QuestEditorFrameObjectiveButton_OnEnter()
	-- Pourra etre utilis pour afficher les info sup de l'objectif	
	return;
end
function RME_QuestEditorFrameObjectiveButton_OnLeave()
	if (this:GetID() ~= RME_EDITOR_OBJECTIVE_ID) then
		getglobal(this:GetName().."Tag"):SetTextColor(this.r, this.g, this.b);
	end
	GameTooltip:Hide();
end
function RME_QuestEditorFrameObjectiveButton_OnClick()
	RME_DebugMsg("RME_QuestEditorFrameObjectiveButton_OnClick("..tostring(arg2)..")",4)	
	if FauxScrollFrame_GetOffset(RME_QuestEditorFrame_Objective_ScrollFrame) then
		RME_EDITOR_OBJECTIVE_ID = this:GetID() + FauxScrollFrame_GetOffset(RME_QuestEditorFrame_Objective_ScrollFrame);
	else
		RME_EDITOR_OBJECTIVE_ID = this:GetID()
	end
	RME_QuestEditorFrame_Objectives_Update()
end
function RME_QuestEditorFrame_Objective_Type_OnClick()
	RME_DebugMsg("RME_QuestEditorFrame_Objective_Type_OnClick()"..tostring(this:GetID()),4)		
	UIDropDownMenu_SetSelectedID(RME_QuestEditorFrame_Objective_Type, this:GetID());
	RME_QuestEditorFrame_Objective_Type_ShowFrame(this:GetID())
	RME_QuestEditorFrame_Objectives_Update()
end
function RME_QuestEditorFrame_Objective_Type_ShowFrame(id)
	RME_DebugMsg("RME_QuestEditorFrame_Objective_Type_ShowFrame()"..tostring(id),4)		

	-- On cache les frames
	local count = 1
	while RME_LOCALE["RME_QuestEditorFrame_Objective_Type"]["tag"..tostring(count)] do
		getglobal("RME_QuestEditorFrame_Objective_Type_"..RME_LOCALE["RME_QuestEditorFrame_Objective_Type"]["tag"..tostring(count)]):Hide()
		count = count + 1
	end
	-- Maintenant on affiche la bonne frames
	if id then
		local frame = getglobal("RME_QuestEditorFrame_Objective_Type_"..RME_LOCALE["RME_QuestEditorFrame_Objective_Type"]["tag"..tostring(id)])
		frame:Show()
	end
end		
function RME_QuestEditorFrame_Objectives_Update()
	RME_DebugMsg("RME_QuestEditorFrame_Objectives_Update()",4)	
		
	if not RME_EDITOR_OBJECTIVE_ID and #RME_MISSION_EDITION.MissionObjectives > 0 then
		RME_EDITOR_OBJECTIVE_ID = 1
		RME_QuestEditorFrame_Objective_ScrollFrame:SetVerticalScroll(0)
	end
	
	if not RME_EDITOR_OBJECTIVE_ID then
		-- Aucune ligne slectionn > on disable tout les boutons 
		RME_QuestEditorFrame_Objective_Delete:Disable()
		RME_QuestEditorFrame_Objective_UP:Disable()
		RME_QuestEditorFrame_Objective_DOWN:Disable()
		RME_QuestEditorFrame_Objective_Type:Hide()
		-- On cache les frames (sans donner de id > hide tout)
		RME_QuestEditorFrame_Objective_Type_ShowFrame()
	else
		-- On a une ligne selectionne, on met a jour les boutons
			-- Est il possible de rajouter un nouvel objectif
			if #RME_MISSION_EDITION.MissionObjectives >= RME_MAX_OBJECTIVES then
				RME_QuestEditorFrame_Objective_Add:Disable()
			else
				RME_QuestEditorFrame_Objective_Add:Enable()
			end		
			-- Activation delete
			RME_QuestEditorFrame_Objective_Delete:Enable()
			-- Si 1ere ligne > disabled UP
			if RME_EDITOR_OBJECTIVE_ID == 1 then
				RME_QuestEditorFrame_Objective_UP:Disable()
			else
				RME_QuestEditorFrame_Objective_UP:Enable()
			end
			-- Si derniere ligne > disabled DOWN
			if RME_EDITOR_OBJECTIVE_ID == #RME_MISSION_EDITION.MissionObjectives then
				RME_QuestEditorFrame_Objective_DOWN:Disable()
			else
				RME_QuestEditorFrame_Objective_DOWN:Enable()
			end
			RME_QuestEditorFrame_Objective_Type:Show()
		-- Rcupration de l'objectif en cours
			local LOCAL_OBJECTIVE = RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID]
			-- on affiche la frame li a l'objectif
			RME_QuestEditorFrame_Objective_Type_ShowFrame()
			
			if LOCAL_OBJECTIVE.ObjectiveType then
				local frame = getglobal("RME_QuestEditorFrame_Objective_Type_"..LOCAL_OBJECTIVE.ObjectiveType):Show()
			end
	end
	
	-- On update le fauxscroll qui liste les noms de mission	
	if RME_MISSION_EDITION.MissionObjectives and #RME_MISSION_EDITION.MissionObjectives > RME_MISSION_DISPLAYED then
		FauxScrollFrame_Update(RME_QuestEditorFrame_Objective_ScrollFrame,#RME_MISSION_EDITION.MissionObjectives, RME_MISSION_DISPLAYED, RME_QUESTLOG_QUEST_HEIGHT, nil, nil, nil, RME_QuestEditorFrame_Objectives_HighlightFrame, 293, 316 )		
	elseif #RME_MISSION_EDITION.MissionObjectives then
		FauxScrollFrame_Update(RME_QuestEditorFrame_Objective_ScrollFrame,#RME_MISSION_EDITION.MissionObjectives, RME_MISSION_DISPLAYED, RME_QUESTLOG_QUEST_HEIGHT, nil, nil, nil, RME_QuestEditorFrame_Objectives_HighlightFrame, 293, 316 )		
	end

	-- Update the objective listing
	RME_QuestEditorFrame_ObjectivesHighlightFrame:Hide();
	local questIndex, questLogTitle, questTitleTag, questNumGroupMates, questNormalText, questHighlight, questCheck;
	local questLogTitleText, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily, color;
	local numPartyMembers, partyMembersOnQuest, tempWidth, textWidth;
	local LOCAL_OBJECTIVE
	
	for i=1, RME_MISSION_DISPLAYED, 1 do
	
		if FauxScrollFrame_GetOffset(RME_QuestEditorFrame_Objective_ScrollFrame) then
			questIndex = i + FauxScrollFrame_GetOffset(RME_QuestEditorFrame_Objective_ScrollFrame);
		else
			questIndex = i
		end

		questLogTitle = getglobal("RME_QuestEditorFrame_Objectives"..i);
		questTitleTag = getglobal("RME_QuestEditorFrame_Objectives"..i.."Tag");
		questNumGroupMates = getglobal("RME_QuestEditorFrame_Objectives"..i.."GroupMates");
		questCheck = getglobal("RME_QuestEditorFrame_Objectives"..i.."Check");
		questNormalText = getglobal("RME_QuestEditorFrame_Objectives"..i.."NormalText");
		questHighlight = getglobal("RME_QuestEditorFrame_Objectives"..i.."Highlight");

		if ( questIndex <= #RME_MISSION_EDITION.MissionObjectives)  then

			local LOCAL_OBJECTIVE = RME_MISSION_EDITION.MissionObjectives[questIndex]

			questLogTitle:SetText(LOCAL_OBJECTIVE:ObjectiveStatus(RME_MISSION_EDITION,true));
			QuestLogDummyText:SetText(LOCAL_OBJECTIVE:ObjectiveStatus(RME_MISSION_EDITION,true));
			questLogTitle:SetNormalTexture("");
			questHighlight:SetTexture("");
			questTitleTag:SetText("");
			questNormalText:SetWidth(275);
			questCheck:Hide();

			color = RME_GetObjectiveColor(LOCAL_OBJECTIVE.ObjectiveType);
			questTitleTag:SetTextColor(color.r, color.g, color.b);
			questLogTitle:SetTextColor(color.r, color.g, color.b);
			questNumGroupMates:SetTextColor(color.r, color.g, color.b);
			questLogTitle.r = color.r;
			questLogTitle.g = color.g;
			questLogTitle.b = color.b;
			questLogTitle:Show();


			-- Place the highlight and lock the highlight state
			if  RME_EDITOR_OBJECTIVE_ID == questIndex then
				RME_QuestEditorFrame_ObjectivesHighlightFrame:SetPoint("TOPLEFT", "RME_QuestEditorFrame_Objectives"..i, "TOPLEFT", 0, 0);
				RME_QuestEditorFrame_ObjectivesSkillHighlight:SetVertexColor(color.r, color.g, color.b);
				RME_QuestEditorFrame_ObjectivesHighlightFrame:Show();
				questTitleTag:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
				questLogTitle:LockHighlight();				
				UIDropDownMenu_SetText(RME_LOCALE["RME_QuestEditorFrame_Objective_Type_List"][RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID].ObjectiveType],RME_QuestEditorFrame_Objective_Type)
				
			else
				questLogTitle:UnlockHighlight();
			end
	
		else
			questLogTitle:Hide();
		end
	end

	RME_DebugMsg("RME_QuestEditorFrame_Objectives_Update() Done !",4)	

end
		-- TAB OBJECTIVE: EXPLORATION
function RME_QuestEditorFrame_Objective_Type_EXPLORATION_OnLoad()
	RME_DebugMsg("RME_QuestEditorFrame_Objective_EXPLORATION_OnLoad()",4)	
	this:SetBackdropColor(0.1,0.1,0.1,1)
	-- Si l'addon judgehype est install, il faudra charger les zone via JHD_Map
	-- 	for i=1, getn(JHD_Map), 1 do 		 JHD_Map[i]["fr"]
end
function RME_QuestEditorFrame_Objective_Type_EXPLORATION_OnShow()
	RME_DebugMsg("RME_QuestEditorFrame_Objective_EXPLORATION_OnShow()",4)	
	--Mise a jour menu droulant
	RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID].ObjectiveType = "EXPLORATION"
	UIDropDownMenu_SetSelectedName(RME_QuestEditorFrame_Objective_Type,RME_LOCALE["RME_QuestEditorFrame_Objective_Type_List"]["EXPLORATION"])
	local LOCAL_OBJECTIVE = RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID]
	
	-- On charge le texte de la zone a visiter
	if LOCAL_OBJECTIVE.Exploration_ZoneName then
		RME_QuestEditorFrame_Objective_Type_EXPLORATION_Zone:SetText(LOCAL_OBJECTIVE.Exploration_ZoneName)
	else
		RME_QuestEditorFrame_Objective_Type_EXPLORATION_Zone:SetText(RME_LOCALE["RME_LOCALE_EDITOR_NEED_ZONENAME"].text)
	end
end	
function RME_QuestEditorFrame_Objective_Type_EXPLORATION_Zone_OnTextChanged()
	RME_DebugMsg("RME_QuestEditorFrame_Objectives_EXPLORATION_Zone_OnTextChanged()",4)	
	RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID].Exploration_ZoneName = RME_Translate_To_UTF8(this:GetText())
	RME_EventManager_AddEvent("RME_QuestEditorFrame_Objectives_Update",5,"RME_QuestEditorFrame_Objectives_Update()",true)
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_Objective_Type_EXPLORATION_SelectZone_OnClick()
	-- on prend la zone actuelle comme objectif
	RME_PLAYER_INFO:Update("player")
	RME_QuestEditorFrame_Objective_Type_EXPLORATION_Zone:SetText(RME_PLAYER_INFO.Location_RealZone)
end
function RME_QuestEditorFrame_Objective_Type_EXPLORATION_SelectSubZone_OnClick()
	-- on prend la sous-zone actuelle comme objectif 
	RME_PLAYER_INFO:Update("player")
	RME_QuestEditorFrame_Objective_Type_EXPLORATION_Zone:SetText(RME_PLAYER_INFO.Location_SubZone)
end	
function RME_QuestEditorFrame_Objective_Type_EXPLORATION_SelectMinimapZone_OnClick()
	-- on prend la minimap actuelle comme objectif 
	RME_PLAYER_INFO:Update("player")
	RME_QuestEditorFrame_Objective_Type_EXPLORATION_Zone:SetText(RME_PLAYER_INFO.Location_MinimapZone)
end
		-- TAB OBJECTIVE: KILL_MOB
function RME_QuestEditorFrame_Objective_Type_KILL_MOB_OnLoad()
	RME_DebugMsg("RME_QuestEditorFrame_Objectives_EXPLORATION_OnLoad()",4)	
	this:SetBackdropColor(0.1,0.1,0.1,1)
	-- Possibilit de charger la liste des mobs du jeu ? a risque d'etre sacrment lourd comme liste
end
function RME_QuestEditorFrame_Objective_Type_KILL_MOB_OnShow()
	RME_DebugMsg("RME_QuestEditorFrame_Objectives_KILL_MOB_OnShow()",4)	
	--Mise a jour menu droulant
	RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID].ObjectiveType = "KILL_MOB"
	UIDropDownMenu_SetSelectedName(RME_QuestEditorFrame_Objective_Type,RME_LOCALE["RME_QuestEditorFrame_Objective_Type_List"][RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID].ObjectiveType])
	-- On charge le texte du mob a tuer
	local LOCAL_OBJECTIVE = RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID]
	if LOCAL_OBJECTIVE.Kill_MobName then
		RME_QuestEditorFrame_Objective_Type_KILL_MOB_Name:SetText(LOCAL_OBJECTIVE.Kill_MobName)
	else
		RME_QuestEditorFrame_Objective_Type_KILL_MOB_Name:SetText(RME_LOCALE["RME_LOCALE_EDITOR_NEED_MOBNAME"].text)
	end
	if LOCAL_OBJECTIVE.Kill_KillObjective then
		RME_QuestEditorFrame_Objective_Type_KILL_MOB_Number:SetValue(LOCAL_OBJECTIVE.Kill_KillObjective)
	else
		RME_QuestEditorFrame_Objective_Type_KILL_MOB_Number:SetValue(1)
	end
	
end	
function RME_QuestEditorFrame_Objective_Type_KILL_MOB_Name_OnTextChanged()	
	RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID].Kill_MobName = RME_Translate_To_UTF8(this:GetText())
	RME_EventManager_AddEvent("RME_QuestEditorFrame_Objectives_Update",5,"RME_QuestEditorFrame_Objectives_Update()",true)	
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_Objective_Type_KILL_MOB_Number_OnValueChanged()	
	if RME_EDITOR_OBJECTIVE_ID then
		RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID].Kill_KillObjective = RME_QuestEditorFrame_Objective_Type_KILL_MOB_Number:GetValue()
	end
	RME_QuestEditorFrame_Objective_Type_KILL_MOB_NumberValueText:SetText(tostring(RME_QuestEditorFrame_Objective_Type_KILL_MOB_Number:GetValue()))
	RME_EventManager_AddEvent("RME_QuestEditorFrame_Objectives_Update",5,"RME_QuestEditorFrame_Objectives_Update()",true)	
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_Objective_Type_KILL_MOB_SelectTarget_OnClick()
	RME_QuestEditorFrame_Objective_Type_KILL_MOB_Name:SetText(RME_TARGET_INFO.Name)
end
		-- TAB OBJECTIVE: NEED_ITEM
function RME_QuestEditorFrame_Objective_Type_NEED_ITEM_OnLoad()
	RME_DebugMsg("RME_QuestEditorFrame_Objective_Type_NEED_ITEM_OnLoad()",4)	
	this:SetBackdropColor(0.1,0.1,0.1,1)
end
function RME_QuestEditorFrame_Objective_Type_NEED_ITEM_OnShow()
	RME_DebugMsg("RME_QuestEditorFrame_Objective_Type_NEED_ITEM_OnShow()",4)	
	--Mise a jour menu droulant
	RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID].ObjectiveType = "NEED_ITEM"
	UIDropDownMenu_SetSelectedName(RME_QuestEditorFrame_Objective_Type,RME_LOCALE["RME_QuestEditorFrame_Objective_Type_List"][RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID].ObjectiveType])
	-- On met  jour le menu droulant
	UIDropDownMenu_Initialize(RME_QuestEditorFrame_Objective_Type_NEED_ITEM_DropDownObjectsList, RME_QuestEditorFrame_Objective_Type_NEED_ITEM_DropDownObjectsList_Refresh)
	-- Mise a jour des champs
	local LOCAL_OBJECTIVE = RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID]	
	if LOCAL_OBJECTIVE.Need_Item_QuantityNeeded then
		RME_QuestEditorFrame_Objective_Type_NEED_ITEM_Number:SetValue(LOCAL_OBJECTIVE.Need_Item_QuantityNeeded)
	else
		RME_QuestEditorFrame_Objective_Type_NEED_ITEM_Number:SetValue(1)
	end
end
function RME_QuestEditorFrame_Objective_Type_NEED_ITEM_Number_OnValueChanged()
	if RME_EDITOR_OBJECTIVE_ID then
		RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID].Need_Item_QuantityNeeded = RME_QuestEditorFrame_Objective_Type_NEED_ITEM_Number:GetValue()
	end
	RME_QuestEditorFrame_Objective_Type_NEED_ITEM_NumberValueText:SetText(tostring(RME_QuestEditorFrame_Objective_Type_NEED_ITEM_Number:GetValue()))
	RME_EventManager_AddEvent("RME_QuestEditorFrame_Objectives_Update",5,"RME_QuestEditorFrame_Objectives_Update()",true)
end
function RME_QuestEditorFrame_Objective_Type_NEED_ITEM_DropDownObjectsList_OnClick()
	RME_DebugMsg("RME_QuestEditorFrame_Objective_Type_NEED_ITEM_DropDownObjectsList_OnClick()"..tostring(this:GetID()),4)	
	UIDropDownMenu_SetSelectedID(RME_QuestEditorFrame_Objective_Type_NEED_ITEM_DropDownObjectsList, this:GetID());
	-- vu que la fonction 'UIDropDownMenu_GetValue' bug, on boucle sur la liste d'objet en cherchant le nom de l'objet
	local LOCAL_ITEM, LOCAL_ITEM_ID
	for LOCAL_ITEM_ID,LOCAL_ITEM in pairs(RME_MISSION_EDITION.MissionItemsList) do -- LOCAL_ITEM est du style RME_CLASS_ITEM
		
		if LOCAL_ITEM.NameHex == UIDropDownMenu_GetText(RME_QuestEditorFrame_Objective_Type_NEED_ITEM_DropDownObjectsList) then
			-- Trouv
			RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID].Need_Item_ItemNeeded = LOCAL_ITEM.ID
			break
		end
	end
	RME_QuestEditorFrame_Objectives_Update()
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_Objective_Type_NEED_ITEM_DropDownObjectsList_Refresh()
	RME_DebugMsg("RME_QuestEditorFrame_Objective_Type_NEED_ITEM_DropDownObjectsList_Refresh()",4)	

	local dropDownName = "RME_QuestEditorFrame_Objective_Type_NEED_ITEM_DropDownObjectsList"
	
	if RME_getn(RME_MISSION_EDITION.MissionItemsList) == 0 then
		-- Aucun objet encore cre
			local info = UIDropDownMenu_CreateInfo()
			local choice = RME_LOCALE[dropDownName].choice1
			local tag = RME_LOCALE[dropDownName].tag1
			info.text = choice
			info.value = tag
			info.func = nil
			UIDropDownMenu_AddButton( info )
			RME_DebugMsg("RME_QuestEditorFrame_Objective_Type_NEED_ITEM_DropDownObjectsList_Refresh() DONE !",4)	
		return
	end
	
	-- On charge les objets
	local LOCAL_ITEM, LOCAL_ITEM_ID
	for LOCAL_ITEM_ID,LOCAL_ITEM in pairs(RME_MISSION_EDITION.MissionItemsList) do -- LOCAL_ITEM est du style RME_CLASS_ITEM
		local info = UIDropDownMenu_CreateInfo()
		info.text = tostring(LOCAL_ITEM.NameHex)
		info.value = LOCAL_ITEM.ID
		info.func = getglobal(dropDownName.."_OnClick") 
		UIDropDownMenu_AddButton( info )
	end
	
	-- On selectionne l'objet 
	if RME_EDITOR_OBJECTIVE_ID then 
		local LOCAL_OBJECTIVE = RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID]
		if LOCAL_OBJECTIVE.Need_Item_ItemNeeded then
			UIDropDownMenu_SetSelectedName(RME_QuestEditorFrame_Objective_Type_NEED_ITEM_DropDownObjectsList,RME_MISSION_EDITION.MissionItemsList[LOCAL_OBJECTIVE.Need_Item_ItemNeeded].NameHex)
		end
	end
	
	RME_DebugMsg("RME_QuestEditorFrame_Objective_Type_NEED_ITEM_DropDownObjectsList_Refresh() DONE !",4)	
end
		-- TAB OBJECTIVE: CONDITION
function RME_QuestEditorFrame_Objective_Type_CONDITION_OnLoad()
	RME_DebugMsg("RME_QuestEditorFrame_Objective_Type_CONDITION_OnLoad()",4)	
	this:SetBackdropColor(0.1,0.1,0.1,1)
end
function RME_QuestEditorFrame_Objective_Type_CONDITION_OnShow()
	RME_DebugMsg("RME_QuestEditorFrame_Objective_Type_CONDITION_OnShow()",4)	
	--Mise a jour menu droulant
	RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID].ObjectiveType = "CONDITION"
	UIDropDownMenu_SetSelectedName(RME_QuestEditorFrame_Objective_Type,RME_LOCALE["RME_QuestEditorFrame_Objective_Type_List"][RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID].ObjectiveType])
	-- On charge les checkbox
	local LOCAL_OBJECTIVE = RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID]
	RME_QuestEditorFrame_Objective_Type_CONDITION_Mount_NotTaxi:SetChecked(LOCAL_OBJECTIVE.Mount_NotTaxi)
	RME_QuestEditorFrame_Objective_Type_CONDITION_Mount_NotMount:SetChecked(LOCAL_OBJECTIVE.Mount_NotMount)
	RME_QuestEditorFrame_Objective_Type_CONDITION_Mount_NeedMount:SetChecked(LOCAL_OBJECTIVE.Mount_NeedMount)
	RME_QuestEditorFrame_Objective_Type_CONDITION_Player_MustBeAlive:SetChecked(LOCAL_OBJECTIVE.Player_MustBeAlive)
	if  LOCAL_OBJECTIVE.Escort_VIP then
		RME_QuestEditorFrame_Objective_Type_CONDITION_Escort_VIP:SetChecked(1)	
		RME_QuestEditorFrame_Objective_Type_CONDITION_Escort_VIP_Name:SetText(tostring(LOCAL_OBJECTIVE.Escort_VIP))
		RME_QuestEditorFrame_Objective_Type_CONDITION_Escort_VIP_Name:Show()
		RME_QuestEditorFrame_Objective_Type_CONDITION_Escort_VIP_SelectTarget:Show()
	else
		RME_QuestEditorFrame_Objective_Type_CONDITION_Escort_VIP:SetChecked(nil)	
		RME_QuestEditorFrame_Objective_Type_CONDITION_Escort_VIP_Name:Hide()
		RME_QuestEditorFrame_Objective_Type_CONDITION_Escort_VIP_SelectTarget:Hide()
	end
end	
function RME_QuestEditorFrame_Objective_Type_CONDITION_CheckButton_OnClick()
	RME_DebugMsg("RME_QuestEditorFrame_Objective_Type_CONDITION_CheckButton_OnClick() "..tostring(this:GetName()),4)	
	local CheckBoxName = this:GetName()
	
	RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID].Mount_NotTaxi = nil
	RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID].Mount_NotMount = nil
	RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID].Mount_NeedMount = nil
	RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID].Player_MustBeAlive = nil
	RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID].Escort_VIP = nil
	PlaySound("igMainMenuOptionCheckBoxOn");
	
	if CheckBoxName == "RME_QuestEditorFrame_Objective_Type_CONDITION_Mount_NotTaxi" then
		RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID].Mount_NotTaxi = true
	end
	
	if CheckBoxName == "RME_QuestEditorFrame_Objective_Type_CONDITION_Mount_NotMount" then
		RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID].Mount_NotMount = true
	end
	
	if CheckBoxName == "RME_QuestEditorFrame_Objective_Type_CONDITION_Mount_NeedMount" then
		RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID].Mount_NeedMount = true
	end
	
	if CheckBoxName == "RME_QuestEditorFrame_Objective_Type_CONDITION_Player_MustBeAlive" then
		RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID].Player_MustBeAlive = true
	end
	
	
	if CheckBoxName == "RME_QuestEditorFrame_Objective_Type_CONDITION_Escort_VIP" then
		RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID].Escort_VIP = tostring(RME_QuestEditorFrame_Objective_Type_CONDITION_Escort_VIP_Name:GetText())
	end
	
	RME_QuestEditorFrame_Objective_Type_CONDITION_OnShow()
	RME_QuestEditorFrame_Objectives_Update()
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_Objective_Type_CONDITION_Escort_VIP_Name_OnTextChanged()
	RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID].Escort_VIP = RME_Translate_To_UTF8(this:GetText())
	RME_EventManager_AddEvent("RME_QuestEditorFrame_Objectives_Update",5,"RME_QuestEditorFrame_Objectives_Update()",true)
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_Objective_Type_CONDITION_Escort_VIP_Name_OnClick()
	RME_QuestEditorFrame_Objective_Type_CONDITION_Escort_VIP_Name:SetText(RME_TARGET_INFO.Name)
end
		--TAB OBJECTIVE: NEED_EVENT
function RME_QuestEditorFrame_Objective_Type_NEED_EVENT_OnLoad()
	RME_DebugMsg("RME_QuestEditorFrame_Objective_Type_NEED_EVENT_OnLoad()",4)	
	this:SetBackdropColor(0.1,0.1,0.1,1)
end
function RME_QuestEditorFrame_Objective_Type_NEED_EVENT_OnShow()
	RME_DebugMsg("RME_QuestEditorFrame_Objective_Type_NEED_EVENT_OnShow()",4)	
	--Mise a jour menu droulant
	RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID].ObjectiveType = "NEED_EVENT"
	UIDropDownMenu_SetSelectedName(RME_QuestEditorFrame_Objective_Type,RME_LOCALE["RME_QuestEditorFrame_Objective_Type_List"][RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID].ObjectiveType])
	-- On met  jour le menu droulant
	UIDropDownMenu_Initialize(RME_QuestEditorFrame_Objective_Type_NEED_EVENT_DropDownEventsList, RME_QuestEditorFrame_Objective_Type_NEED_EVENT_DropDownEventsList_Refresh)
	-- Mise a jour des champs
	local LOCAL_OBJECTIVE = RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID]	
	if LOCAL_OBJECTIVE.Need_Event_ObjectiveName then
		RME_QuestEditorFrame_Objective_Type_NEED_EVENT_ObjectiveName:SetText(LOCAL_OBJECTIVE.Need_Event_ObjectiveName)
	else
		RME_QuestEditorFrame_Objective_Type_NEED_EVENT_ObjectiveName:SetText (RME_LOCALE["RME_QuestEditorFrame_Objective_Type_NEED_EVENT_ObjectiveName"].text)
	end
end
function RME_QuestEditorFrame_Objective_Type_NEED_EVENT_ObjectiveName_OnTextChanged()
	if RME_EDITOR_OBJECTIVE_ID then
		RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID].Need_Event_ObjectiveName = RME_QuestEditorFrame_Objective_Type_NEED_EVENT_ObjectiveName:GetText()
	end
	RME_EventManager_AddEvent("RME_QuestEditorFrame_Objectives_Update",5,"RME_QuestEditorFrame_Objectives_Update()",true)
end
function RME_QuestEditorFrame_Objective_Type_NEED_EVENT_DropDownEventsList_OnClick()
	RME_DebugMsg("RME_QuestEditorFrame_Objective_Type_NEED_EVENT_DropDownEventsList_OnClick()"..tostring(this:GetID()),4)	
	UIDropDownMenu_SetSelectedID(RME_QuestEditorFrame_Objective_Type_NEED_EVENT_DropDownEventsList, this:GetID());
	-- vu que la fonction 'UIDropDownMenu_GetValue' bug, on boucle sur la liste d'objet en cherchant le nom de l'objet
	local nb
	for nb = 1, #RME_MISSION_EDITION.MissionEvents do 
		local LOCAL_EVENT = RME_MISSION_EDITION.MissionEvents[nb]
		if LOCAL_EVENT.ReadItem_EventName == UIDropDownMenu_GetText(RME_QuestEditorFrame_Objective_Type_NEED_EVENT_DropDownEventsList) then
			RME_MISSION_EDITION.MissionObjectives[RME_EDITOR_OBJECTIVE_ID].Need_Event_EventID = LOCAL_EVENT.EventID
		end
	end
	RME_QuestEditorFrame_Objectives_Update()
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_Objective_Type_NEED_EVENT_DropDownEventsList_Refresh()
	RME_DebugMsg("RME_QuestEditorFrame_Objective_Type_NEED_EVENT_DropDownEventsList_Refresh()",4)	

	local dropDownName = "RME_QuestEditorFrame_Objective_Type_NEED_EVENT_DropDownEventsList"
		
	-- On charge les events slectionnable
	local nb,nbadded
	nbadded = 0
	for nb = 1, #RME_MISSION_EDITION.MissionEvents do 
		local LOCAL_EVENT = RME_MISSION_EDITION.MissionEvents[nb]
		if LOCAL_EVENT.EventType == "READ_ITEM" then -- On ne rajoute que les event particuliers
			local info = UIDropDownMenu_CreateInfo()
			info.text = tostring(LOCAL_EVENT.ReadItem_EventName)
			info.value = LOCAL_EVENT.EventID
			info.func = getglobal(dropDownName.."_OnClick") 
			UIDropDownMenu_AddButton( info )
			nbadded = nbadded + 1
		end
	end
	
	if nbadded == 0 then
		-- Aucun objet encore cre
			local info = UIDropDownMenu_CreateInfo()
			local choice = RME_LOCALE[dropDownName].choice1
			local tag = RME_LOCALE[dropDownName].tag1
			info.text = choice
			info.value = tag
			info.func = nil
			UIDropDownMenu_AddButton( info )
			RME_DebugMsg("RME_QuestEditorFrame_Objective_Type_NEED_EVENT_DropDownEventsList_Refresh() DONE !",4)	
		return
	end
	
	-- On selectionne l'objet 
	if RME_EDITOR_OBJECTIVE_ID then 
		local nb
		for nb = 1, #RME_MISSION_EDITION.MissionEvents do 
			local LOCAL_EVENT = RME_MISSION_EDITION.MissionEvents[nb]
			if LOCAL_EVENT.ReadItem_EventName == UIDropDownMenu_GetText(RME_QuestEditorFrame_Objective_Type_NEED_EVENT_DropDownEventsList) then
				UIDropDownMenu_SetSelectedName(RME_QuestEditorFrame_Objective_Type_NEED_EVENT_DropDownEventsList,LOCAL_EVENT.ReadItem_EventName)
			end
		end		
	end
	
	RME_DebugMsg("RME_QuestEditorFrame_Objective_Type_NEED_EVENT_DropDownObjectsList_Refresh() DONE !",4)	
end
		-- TAB NPC
function RME_QuestEditorFrameNPCButton_OnLoad()
	this:RegisterForClicks("LeftButtonUp", "RightButtonUp");
	this.r = nil
	this.g = nil
	this.b = nil
	this.NPC_ID = nil
end
function RME_QuestEditorFrameNPCButton_OnEvent(event)
	RME_DebugMsg(" RME_QuestEditorFrameNPCButton_OnEvent("..tostring(event)..")",4)	
	if ( GameTooltip:IsOwned(this) ) then
		GameTooltip:Hide();
	end
end
function RME_QuestEditorFrameNPCButton_OnEnter()
	-- Pourra etre utilis pour afficher les info sup de l'objectif	
	return;
end
function RME_QuestEditorFrameNPCButton_OnLeave()
	if (this.NPC_ID ~= RME_EDITOR_NPC_ID) then
		getglobal(this:GetName().."Tag"):SetTextColor(this.r, this.g, this.b);
	end
	GameTooltip:Hide();
end
function RME_QuestEditorFrameNPCButton_OnClick()
	RME_DebugMsg("RME_QuestEditorFrameNPCButton_OnClick()"..tostring(this.NPC_ID),4)	
	RME_EDITOR_NPC_ID = this.NPC_ID
	RME_QuestEditorFrame_NPCs_Update()
end
function RME_QuestEditorFrame_NPC_Add_OnClick()	
	RME_TARGET_INFO:Update("target")
	-- On regarde si cette cible n'est pas dja dans la liste
	if RME_MISSION_EDITION.NPC_List[string.lower(RME_TARGET_INFO.Name)] then
		RME_PlayerNotify(RME_LOCALE["RME_LOCALE_EDITOR_NPC_ALREADY_ADDED"].text,0.2)
		PlaySound("igQuestLogAbandonQuest")
		return
	end

	-- On regarde si on est assez pret
	if not RME_TARGET_INFO.CanInteract and RME_TARGET_INFO.IsNPC then
		RME_PlayerNotify(RME_LOCALE["RME_LOCALE_EDITOR_NPC_TOO_FAR"].text,0.5)
		PlaySound("igQuestLogAbandonQuest")
		return
	end
	-- On regarde si on a pas atteint le maximum autoris
	if RME_getn(RME_MISSION_EDITION.NPC_List) >= RME_MAX_NPCS then
		RME_PlayerNotify(RME_LOCALE["RME_LOCALE_EDITOR_NPC_LIST_FULL"].text,0)
		PlaySound("igQuestLogAbandonQuest")
		return
	end		
	local RME_EDITOR_NPC_ID
	local NEW_NPC = RME_CLASS_NPC()
	NEW_NPC.Name = RME_TARGET_INFO.Name
	-- Si la cible est un pnj, on rcupere ses infos
	if RME_TARGET_INFO.IsNPC then
		NEW_NPC.RealZone 		=	RME_TARGET_INFO.Location_RealZone
		NEW_NPC.SubZone 			= 	RME_TARGET_INFO.Location_SubZone
		NEW_NPC.MinimapZone 		= 	RME_TARGET_INFO.Location_MinimapZone
		NEW_NPC.MapID 			= 	GetCurrentMapContinent()
		NEW_NPC.ZoneID 			= 	GetCurrentMapZone()
		NEW_NPC.X 				= 	RME_TARGET_INFO.X
		NEW_NPC.Y 				= 	RME_TARGET_INFO.Y
	else -- c'est un joueur, on ne peut donc pas se fier a la zone et a sa position
		NEW_NPC.RealZone 		= 	"<all>"
		NEW_NPC.SubZone 			= 	"<all>"
		NEW_NPC.MinimapZone 		= 	"<all>"
		NEW_NPC.X 				= 	0
		NEW_NPC.Y 				= 	0
	end
	NEW_NPC.FromMissionID = RME_MISSION_EDITION.ID
	RME_EDITOR_NPC_ID = string.lower(NEW_NPC.Name)	
	RME_MISSION_EDITION.NPC_List[RME_EDITOR_NPC_ID] = NEW_NPC
	RME_QuestEditorFrame_NPCs_Update()
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_NPC_Delete_OnClick()
	if RME_EDITOR_NPC_ID then
		RME_MISSION_EDITION.NPC_List[RME_EDITOR_NPC_ID] = nil
	end
	RME_EDITOR_NPC_ID = nil
	RME_QuestEditorFrame_NPCs_Update()
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_NPCs_Update()
	RME_DebugMsg("RME_QuestEditorFrame_NPCs_Update()",4)	
	
	if not RME_EDITOR_NPC_ID and RME_getn(RME_MISSION_EDITION.NPC_List) > 0 then
		RME_EDITOR_NPC_ID = RME_getkey(RME_MISSION_EDITION.NPC_List,1)
		RME_QuestEditorFrame_NPC_ScrollFrame:SetVerticalScroll(0)
	end
	
	if not RME_EDITOR_NPC_ID then
		-- Aucune ligne slectionn > on disable tout les boutons 
		RME_QuestEditorFrame_NPC_Delete:Disable()
		RME_QuestEditorFrame_NPC_Status:Hide()
	else
		-- On a une ligne selectionne, on met a jour les boutons
			-- Est il possible de rajouter un nouvel objectif
			-- Activation delete
			RME_QuestEditorFrame_NPC_Status:Show()
			RME_QuestEditorFrame_NPC_Delete:Enable()
		-- Rcupration de l'objectif en cours
			local LOCAL_NPC = RME_MISSION_EDITION.NPC_List[RME_EDITOR_NPC_ID]
	end
	
	-- On update le fauxscroll qui liste les noms de mission	
	if RME_MISSION_EDITION.NPC_List and RME_getn(RME_MISSION_EDITION.NPC_List) > RME_MISSION_DISPLAYED then
		FauxScrollFrame_Update(RME_QuestEditorFrame_NPC_ScrollFrame,RME_getn(RME_MISSION_EDITION.NPC_List), RME_MISSION_DISPLAYED, RME_QUESTLOG_QUEST_HEIGHT, nil, nil, nil, RME_QuestEditorFrame_NPCs_HighlightFrame, 293, 316 )		
	else
		FauxScrollFrame_Update(RME_QuestEditorFrame_NPC_ScrollFrame,RME_getn(RME_MISSION_EDITION.NPC_List), RME_MISSION_DISPLAYED, RME_QUESTLOG_QUEST_HEIGHT, nil, nil, nil, RME_QuestEditorFrame_NPCs_HighlightFrame, 293, 316 )		
	end

	-- Update the quest listing
	RME_QuestEditorFrame_NPCsHighlightFrame:Hide();
	local questIndex, questLogTitle, questTitleTag, questNumGroupMates, questNormalText, questHighlight, questCheck;
	local questLogTitleText, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily, color;
	local numPartyMembers, partyMembersOnQuest, tempWidth, textWidth;
	local LOCAL_NPC
	
	for i=1, RME_MISSION_DISPLAYED, 1 do
	
		if FauxScrollFrame_GetOffset(RME_QuestEditorFrame_NPC_ScrollFrame) then
			questIndex = i + FauxScrollFrame_GetOffset(RME_QuestEditorFrame_NPC_ScrollFrame);
		else
			questIndex = i
		end

		questLogTitle = getglobal("RME_QuestEditorFrame_NPCs"..i);
		questTitleTag = getglobal("RME_QuestEditorFrame_NPCs"..i.."Tag");
		questNumGroupMates = getglobal("RME_QuestEditorFrame_NPCs"..i.."GroupMates");
		questCheck = getglobal("RME_QuestEditorFrame_NPCs"..i.."Check");
		questNormalText = getglobal("RME_QuestEditorFrame_NPCs"..i.."NormalText");
		questHighlight = getglobal("RME_QuestEditorFrame_NPCs"..i.."Highlight");

		
		if ( questIndex <= RME_getn(RME_MISSION_EDITION.NPC_List))  then


			local LOCAL_NPC = RME_MISSION_EDITION.NPC_List[RME_getkey(RME_MISSION_EDITION.NPC_List,questIndex)]
			questLogTitle:SetText(LOCAL_NPC.Name);
			QuestLogDummyText:SetText(LOCAL_NPC.Name);
			questLogTitle:SetNormalTexture("");
			questHighlight:SetTexture("");
			questTitleTag:SetText("");
			questNormalText:SetWidth(275);
			questCheck:Hide();

			color = {r = 0.7; g = 0.9; b = 0.4}
			questTitleTag:SetTextColor(color.r, color.g, color.b);
			questLogTitle:SetTextColor(color.r, color.g, color.b);
			questNumGroupMates:SetTextColor(color.r, color.g, color.b);
			questLogTitle.r = color.r;
			questLogTitle.g = color.g;
			questLogTitle.b = color.b;
			questLogTitle.NPC_ID = string.lower(LOCAL_NPC.Name)
			questLogTitle:Show();


			-- Place the highlight and lock the highlight state
			if  RME_EDITOR_NPC_ID ==  string.lower(LOCAL_NPC.Name) then
				RME_QuestEditorFrame_NPCsHighlightFrame:SetPoint("TOPLEFT", "RME_QuestEditorFrame_NPCs"..i, "TOPLEFT", 0, 0);
				RME_QuestEditorFrame_NPCsSkillHighlight:SetVertexColor(color.r, color.g, color.b);
				RME_QuestEditorFrame_NPCsHighlightFrame:Show();
				questTitleTag:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
				questLogTitle:LockHighlight();
				RME_QuestEditorFrame_NPC_Status_StartMission:SetChecked(LOCAL_NPC.StartMission)
				RME_QuestEditorFrame_NPC_Status_EndMission:SetChecked(LOCAL_NPC.EndMission)
				
			else
				questLogTitle:UnlockHighlight();
			end
	
		else
			questLogTitle:Hide();
		end
	end

	RME_DebugMsg("RME_QuestEditorFrame_NPCs_Update() Done !",4)	

end
function RME_QuestEditorFrame_NPC_Status_OnLoad()
	RME_DebugMsg("RME_QuestEditorFrame_NPC_Status_OnLoad()",4)	
	this:SetBackdropColor(0.1,0.1,0.1,1)
end
function RME_QuestEditorFrame_NPC_Status_OnShow()
	RME_DebugMsg("RME_QuestEditorFrame_NPC_Status_OnShow()",4)	
	-- On charge les checkbox
	if RME_EDITOR_NPC_ID then
		local LOCAL_NPC = RME_MISSION_EDITION.NPC_List[RME_EDITOR_NPC_ID]
		RME_QuestEditorFrame_NPC_Status_StartMission:SetChecked(LOCAL_NPC.StartMission)
		RME_QuestEditorFrame_NPC_Status_EndMission:SetChecked(LOCAL_NPC.EndMission)
	end
end	
function RME_QuestEditorFrame_NPC_Status_OnClick()
	RME_DebugMsg("RME_QuestEditorFrame_NPC_Status_OnClick() "..tostring(this:GetName()).." - "..tostring(this:GetChecked()),4)	
	local CheckBoxName = this:GetName()
	PlaySound("igMainMenuOptionCheckBoxOn");
	if CheckBoxName == "RME_QuestEditorFrame_NPC_Status_StartMission" then
		if this:GetChecked() then
			RME_MISSION_EDITION.NPC_List[RME_EDITOR_NPC_ID].StartMission = true
		else
			RME_MISSION_EDITION.NPC_List[RME_EDITOR_NPC_ID].StartMission = nil
		end
	end
	if CheckBoxName == "RME_QuestEditorFrame_NPC_Status_EndMission" then
		if this:GetChecked() then
			RME_MISSION_EDITION.NPC_List[RME_EDITOR_NPC_ID].EndMission = true
		else
			RME_MISSION_EDITION.NPC_List[RME_EDITOR_NPC_ID].EndMission = nil
		end
	end
	RME_QuestEditorFrame_NPCs_Update()
	RME_MISSION_EDITION.NeedSave = true
end
		-- TAB Item
function RME_QuestEditorFrameItemButton_OnLoad()
	this:RegisterForClicks("LeftButtonUp", "RightButtonUp");
	this.r = nil
	this.g = nil
	this.b = nil
	this.ITEM_ID = nil
end
function RME_QuestEditorFrameItemButton_OnEvent(event)
	RME_DebugMsg(" RME_QuestEditorFrameItemButton_OnEvent("..tostring(event)..")",4)	
	if ( GameTooltip:IsOwned(this) ) then
		GameTooltip:Hide();
	end
end
function RME_QuestEditorFrameItemButton_OnEnter()
	-- Pourra etre utilis pour afficher les info sup de l'objectif	
	return;
end
function RME_QuestEditorFrameItemButton_OnLeave()
	if (this.Item_ID ~= RME_EDITOR_ITEM_ID) then
		getglobal(this:GetName().."Tag"):SetTextColor(this.r, this.g, this.b);
	end
	GameTooltip:Hide();
end
function RME_QuestEditorFrameItemButton_OnClick()
	RME_DebugMsg("RME_QuestEditorFrameItemButton_OnClick()"..tostring(this.Item_ID),4)	
	RME_EDITOR_ITEM_ID = this.ITEM_ID
	RME_QuestEditorFrame_Item_ScrollFrame2:SetVerticalScroll(0)
	RME_QuestEditorFrame_Item_Update()
end
function RME_QuestEditorFrame_Item_Add_OnClick()	
--RME_QuestEditorFrame_QualityList
	RME_EDITOR_ITEM_ID= nil
	local LOCAL_ITEM = RME_CLASS_ITEM()
	LOCAL_ITEM.ID 					= RME_Generate_New_GUID()
	LOCAL_ITEM.Name				= RME_LOCALE["RME_QuestEditorFrame_Item_NeedName"].text
	LOCAL_ITEM.Quality 				= 1	-- Commun
	LOCAL_ITEM:GenerateNameHex()
	LOCAL_ITEM.Description			= 	""			-- Description de l'objet
	LOCAL_ITEM.Texture 				=	"Interface\\Icons\\INV_Misc_QuestionMark" -- "?" par dfaut
	LOCAL_ITEM.Quantity				=	1			--
	LOCAL_ITEM.MaxCarried			= 	nil			-- Nombre maximum pouvant etre port / joueur. nil = pas de limite
	--LOCAL_ITEM.HaveCoolDown			=	nil			-- Temps de recharge de l'objet (spcifi par l'utilisateur)
		-- Li au mission
	LOCAL_ITEM.FromMissionId		=	RME_MISSION_EDITION.ID		-- Provient de la mission ID. Permet la destruction de l'object en cas d'annulation de la mission
	LOCAL_ITEM.GivenAtStart			=	nil			-- Objet donn au debut de la mission ? (si mission annul, on s'en sert pour supprimer les objets)
	LOCAL_ITEM.DestroyAtEnd			=	nil			-- Objet retir a la fin de la mission ?
		-- Type de l'object
	LOCAL_ITEM.Type				=	"DEFAULT"		-- DEFAULT, LETTER, MISSION, USEONMOB
	
	RME_QuestEditorFrame_Item_DescriptionScrollFrameEditBox:SetText("")
	
	RME_MISSION_EDITION.MissionItemsList[LOCAL_ITEM.ID] = LOCAL_ITEM
	RME_EDITOR_ITEM_ID = LOCAL_ITEM.ID
	RME_QuestEditorFrame_Item_Update()
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_Item_Delete_OnClick(forcedeleteitem,forcedeleteitem2)

	if RME_EDITOR_ITEM_ID then
		-- On vrifie :
		
		-- les objectifs de mission
		for i=1, #RME_MISSION_EDITION.MissionObjectives do
			local LOCAL_OBJECTIVE = RME_MISSION_EDITION.MissionObjectives[i]
			if LOCAL_OBJECTIVE.ObjectiveType == "NEED_ITEM" then
				-- On regarde si il s'agit de l'objet concern
				if LOCAL_OBJECTIVE.Need_Item_ItemNeeded == RME_EDITOR_ITEM_ID and not forcedeleteitem then
					StaticPopup_Show("RME_EDITOR_CONFIRM_DELETE_ITEM_OBJECTIVE_NEED_ITEM") 
					return
				elseif LOCAL_OBJECTIVE.Need_Item_ItemNeeded == RME_EDITOR_ITEM_ID and forcedeleteitem then
					-- On supprime l'objectif
					RME_EDITOR_OBJECTIVE_ID = i
					RME_QuestEditorFrame_Objective_Delete_OnClick()
					RME_EventManager_AddEvent("RME_QuestEditorFrame_Objectives_Update",1,"RME_QuestEditorFrame_Objectives_Update()",true)	
				end
			end
		end
		
		-- Les objets
		for LOCAL_ITEM_ID,LOCAL_ITEM in pairs(RME_MISSION_EDITION.MissionItemsList) do -- LOCAL_ITEM est du style RME_CLASS_ITEM
			if LOCAL_ITEM.Type == "USE_ITEM" then
				if LOCAL_ITEM.UseItem_CreateObjectID == RME_EDITOR_ITEM_ID and not forcedeleteitem2 then
					StaticPopup_Show("RME_EDITOR_CONFIRM_DELETE_ITEM_CREATE_ITEM") 
					return
				else
					RME_MISSION_EDITION.MissionItemsList[LOCAL_ITEM_ID].UseItem_CreateObjectID = nil
					RME_EventManager_AddEvent("RME_QuestEditorFrame_Item_Update",1,"RME_QuestEditorFrame_Item_Update()",true)	
				end
			end
			if LOCAL_ITEM.Type == "USE_ON_MOB" then
				if LOCAL_ITEM.UseOnMob_CreateObjectID == RME_EDITOR_ITEM_ID and not forcedeleteitem2 then
					StaticPopup_Show("RME_EDITOR_CONFIRM_DELETE_ITEM_CREATE_ITEM") 
					return
				else
					--On supprime l'objet (on repasse a nil)
					RME_MISSION_EDITION.MissionItemsList[LOCAL_ITEM_ID].UseOnMob_CreateObjectID = nil
					RME_EventManager_AddEvent("RME_QuestEditorFrame_Item_Update",1,"RME_QuestEditorFrame_Item_Update()",true)	
				end
			end
		end

		
		
		-- des event
		
		-- des rewards
		RME_QuestEditorFrame_Item_RemoveReward(RME_EDITOR_ITEM_ID,"RewardChoice")
		RME_QuestEditorFrame_Item_RemoveReward(RME_EDITOR_ITEM_ID,"Reward")

		-- de la mission

		-- Finalement on supprime
		RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID] = nil

	end
	RME_EDITOR_ITEM_ID = nil
	RME_QuestEditorFrame_Item_Update()
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_Item_Import_OnClick()
		RME_PanelFrame_Mission_Select("SELECT_ITEM_FROM_MISSIONID")
		--RME_QuestEditorFrame:Hide()
end
function RME_QuestEditorFrame_Item_OnLoad()
	RME_DebugMsg("RME_QuestEditorFrame_Item_PropertiesOnLoad()",4)	
	this:SetBackdropColor(0.1,0.1,0.1,1)
end
function RME_QuestEditorFrame_Item_OnShow()
	RME_DebugMsg("RME_QuestEditorFrame_Item_PropertiesOnShow()",4)	
	-- On charge les checkbox
	local LOCAL_ITEM = RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID]
	--RME_QuestEditorFrame_Item_PropertiesStartMission:SetChecked(LOCAL_Item.StartMission)
	--RME_QuestEditorFrame_Item_PropertiesEndMission:SetChecked(LOCAL_Item.EndMission)
end	
function RME_QuestEditorFrame_Item_Name_OnTextChanged()
	if RME_EDITOR_ITEM_ID then
		RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].Name = RME_Translate_To_UTF8(RME_QuestEditorFrame_Item_Name:GetText())
		RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID]:GenerateNameHex()
	end
	RME_EventManager_AddEvent("RME_QuestEditorFrame_Item_Update",5,"RME_QuestEditorFrame_Item_Update()",true)	
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_Item_DescriptionScrollFrame_OnTextChanged()
	if RME_EDITOR_ITEM_ID then
		RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].Description = RME_Translate_To_UTF8(RME_QuestEditorFrame_Item_DescriptionScrollFrameEditBox:GetText())
	end
	RME_EventManager_AddEvent("RME_QuestEditorFrame_Item_Update",5,"RME_QuestEditorFrame_Item_Update()",true)	
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_Item_CheckBox_OnClick()
	RME_DebugMsg("RME_QuestEditorFrame_Item_CheckBox_OnClick() "..tostring(this:GetName()).." - "..tostring(this:GetChecked()),4)	
	local CheckBoxName = this:GetName()
	if not RME_EDITOR_ITEM_ID then return end
	PlaySound("igMainMenuOptionCheckBoxOn");
	if CheckBoxName == "RME_QuestEditorFrame_Item_GivenAtStart" then
		if this:GetChecked() then
			RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].GivenAtStart = true
		else
			RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].GivenAtStart = nil
		end

	elseif CheckBoxName == "RME_QuestEditorFrame_Item_MaxCarried" then
		if this:GetChecked()  then
			RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].MaxCarried = 1
			RME_QuestEditorFrame_Item_Quantity:SetValue(1)
		else
			RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].MaxCarried = nil
		end
		
	elseif CheckBoxName == "RME_QuestEditorFrame_Item_Reward" then
		if this:GetChecked()  then
			RME_QuestEditorFrame_Item_AddReward(RME_EDITOR_ITEM_ID,"Reward")
		else
			RME_QuestEditorFrame_Item_RemoveReward(RME_EDITOR_ITEM_ID,"Reward")
		end
		
	elseif CheckBoxName == "RME_QuestEditorFrame_Item_RewardChoice" then
		if this:GetChecked()  then
			RME_QuestEditorFrame_Item_AddReward(RME_EDITOR_ITEM_ID,"RewardChoice")
		else
			RME_QuestEditorFrame_Item_RemoveReward(RME_EDITOR_ITEM_ID,"RewardChoice")
		end	
		
	end

	RME_MISSION_EDITION.NeedSave = true
	RME_DebugMsg("RME_QuestEditorFrame_Item_CheckBox_OnClick() "..tostring(this:GetName()).." - "..tostring(this:GetChecked()).." DONE !",4)	
	RME_QuestEditorFrame_Item_Update()
end
function RME_QuestEditorFrame_Item_AddReward(Item_ID,Type)
	RME_DebugMsg("RME_QuestEditorFrame_Item_AddReward() "..tostring(Item_ID).." - "..tostring(Type),4)	

	-- On regarde si on a pas dja atteint la limite de 10 objets en rcompense
	if #RME_MISSION_EDITION.MissionReward +  #RME_MISSION_EDITION.MissionRewardChoice >= 10 then
		--Limite atteinte !
		RME_PlayerNotify(RME_LOCALE["RME_QuestEditorFrame_Item_MaxReward"].text,0.1)
		PlaySound("igQuestLogAbandonQuest")		
		return
	end
		
	--1er chose a faire, retirer cet objet des listes (comme a on vite de l'avoir a deux endroits en meme temps ou deux fois dans la meme liste
	RME_QuestEditorFrame_Item_RemoveReward(Item_ID,"RewardChoice")
	RME_QuestEditorFrame_Item_RemoveReward(Item_ID,"Reward")
	-- Maintenant on le rajoute dans la bonne liste
	if Type == "Reward" then
		table.insert(RME_MISSION_EDITION.MissionReward,#(RME_MISSION_EDITION.MissionReward)+1,Item_ID)
	else
		table.insert(RME_MISSION_EDITION.MissionRewardChoice,#(RME_MISSION_EDITION.MissionRewardChoice)+1,Item_ID)
	end
end
function RME_QuestEditorFrame_Item_RemoveReward(Item_ID,Type)
	RME_DebugMsg("RME_QuestEditorFrame_Item_RemoveReward() "..tostring(Item_ID).." - "..tostring(Type),4)	
	if  Type == "Reward" then
		for i=1,#(RME_MISSION_EDITION.MissionReward) do
			if RME_MISSION_EDITION.MissionReward[i] == Item_ID then
				table.remove (RME_MISSION_EDITION.MissionReward,i)
				return
			end
		end
	else
		for i=1,#(RME_MISSION_EDITION.MissionRewardChoice) do
			if RME_MISSION_EDITION.MissionRewardChoice[i] == Item_ID then
				table.remove (RME_MISSION_EDITION.MissionRewardChoice,i)
				return
			end		
		end
	end
end
function RME_QuestEditorFrame_Item_IsReward(Item_ID,Type)
	RME_DebugMsg("RME_QuestEditorFrame_Item_IsReward() "..tostring(Item_ID).." - "..tostring(Type),4)	

	if  Type == "Reward" then
		for i=1,#(RME_MISSION_EDITION.MissionReward) do
			if RME_MISSION_EDITION.MissionReward[i] == Item_ID then
				RME_DebugMsg("RME_QuestEditorFrame_Item_IsReward() "..tostring(Item_ID).." - "..tostring(Type).."=true",4)	
				return true
			end
		end
	else
		for i=1,#(RME_MISSION_EDITION.MissionRewardChoice) do
			if RME_MISSION_EDITION.MissionRewardChoice[i] == Item_ID then
				RME_DebugMsg("RME_QuestEditorFrame_Item_IsReward() "..tostring(Item_ID).." - "..tostring(Type).."=true",4)	
				return true
			end		
		end
	end
	RME_DebugMsg("RME_QuestEditorFrame_Item_IsReward() "..tostring(Item_ID).." - "..tostring(Type).."=nil",4)	
	return nil
end
function RME_QuestEditorFrame_Item_QualityList_OnClick()
	RME_DebugMsg("RME_QuestEditorFrame_Item_QualityList_OnClick()"..tostring(this:GetID()),4)		
	UIDropDownMenu_SetSelectedID(RME_QuestEditorFrame_Item_QualityList, this:GetID());
	if RME_EDITOR_ITEM_ID then
		RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].Quality = this:GetID() - 1
		RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID]:GenerateNameHex()
	end
	RME_QuestEditorFrame_Item_Update()
end
function RME_QuestEditorFrame_Item_OnLoad()
	RME_DebugMsg("RME_QuestEditorFrame_Item_PropertiesOnLoad()",4)	
	this:SetBackdropColor(0.1,0.1,0.1,1)
end
function RME_QuestEditorFrame_Item_OnShow()
end	
function RME_QuestEditorFrame_Item_Image_OnClick()
	if RME_EDITOR_ITEM_ID then
	
		if ( IsShiftKeyDown() ) then
			-- On place l'objet actuellement slectionn dans le sac de l'user		
			local LOCAL_ITEM
			LOCAL_ITEM = RME_CLASS_ITEM()
			LOCAL_ITEM:Load(RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID])
			RME_AddInBag(LOCAL_ITEM,1)
			return
		end
		-- On affiche la selection de l'image
		RME_QuestEditorFrame_SelectItemTexture:Show()
	end
end
function RME_QuestEditorFrame_Item_Quantity_OnValueChanged()	
	if RME_EDITOR_ITEM_ID then
		RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].Quantity = RME_QuestEditorFrame_Item_Quantity:GetValue()
		if RME_QuestEditorFrame_Item_Quantity:GetValue() > 1 then
			RME_QuestEditorFrame_Item_MaxCarried:SetChecked(nil)
		end
	end
	RME_QuestEditorFrame_Item_QuantityValueText:SetText(tostring(RME_QuestEditorFrame_Item_Quantity:GetValue()))
	RME_EventManager_AddEvent("RME_QuestEditorFrame_Item_Update",5,"RME_QuestEditorFrame_Item_Update()",true)	
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_Item_Type_OnClick()
	RME_DebugMsg("RME_QuestEditorFrame_Item_Type_OnClick()"..tostring(this:GetID()),4)		
	UIDropDownMenu_SetSelectedID(RME_QuestEditorFrame_Item_Type, this:GetID());
	RME_QuestEditorFrame_Item_Type_ShowFrame(this:GetID())
	RME_QuestEditorFrame_Item_Update()
end
function RME_QuestEditorFrame_Item_Type_ShowFrame(id)
	RME_DebugMsg("RME_QuestEditorFrame_Item_Type_ShowFrame()"..tostring(id),4)		

	-- On cache les frames
	local count = 1
	while RME_LOCALE["RME_QuestEditorFrame_Item_Type"]["tag"..tostring(count)] do
		getglobal("RME_QuestEditorFrame_Item_Type_"..RME_LOCALE["RME_QuestEditorFrame_Item_Type"]["tag"..tostring(count)]):Hide()
		count = count + 1
	end
	-- Maintenant on affiche la bonne frames
	if id then
		local frame = getglobal("RME_QuestEditorFrame_Item_Type_"..RME_LOCALE["RME_QuestEditorFrame_Item_Type"]["tag"..tostring(id)])
		frame:Show()
		if id == 1 then
			RME_QuestEditorFrame_Item_ScrollFrame2:SetVerticalScroll(0)
		else
			RME_QuestEditorFrame_Item_ScrollFrame2:SetVerticalScroll(242)
		end
	end
	RME_MISSION_EDITION.NeedSave = true
end		
function RME_QuestEditorFrame_Item_Type_DEFAULT_OnLoad()
	RME_DebugMsg("RME_QuestEditorFrame_Item_Type_DEFAULT_OnLoad()",4)	
	this:SetBackdropColor(0.1,0.1,0.1,1)
end
function RME_QuestEditorFrame_Item_Type_DEFAULT_OnShow()
	RME_DebugMsg("RME_QuestEditorFrame_Item_Type_DEFAULT_OnShow()",4)	
	if RME_EDITOR_ITEM_ID then
		RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].Type = "DEFAULT"
		UIDropDownMenu_SetSelectedName(RME_QuestEditorFrame_Item_Type,RME_LOCALE["RME_QuestEditorFrame_Item_Type_List"]["DEFAULT"])
		UIDropDownMenu_SetText(RME_LOCALE["RME_QuestEditorFrame_Item_Type_List"]["DEFAULT"],RME_QuestEditorFrame_Item_Type)
	end
end	
function RME_QuestEditorFrame_Item_Type_MISSION_OnLoad()
	RME_DebugMsg("RME_QuestEditorFrame_Item_Type_MISSION_OnLoad()",4)	
	this:SetBackdropColor(0.1,0.1,0.1,1)
end
function RME_QuestEditorFrame_Item_Type_MISSION_OnShow()
	RME_DebugMsg("RME_QuestEditorFrame_Item_Type_MISSION_OnShow()",4)	
	--Mise a jour type item
	if RME_EDITOR_ITEM_ID then

		RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].Type = "MISSION"
		UIDropDownMenu_SetSelectedName(RME_QuestEditorFrame_Item_Type,RME_LOCALE["RME_QuestEditorFrame_Item_Type_List"]["MISSION"])
		UIDropDownMenu_SetText(RME_LOCALE["RME_QuestEditorFrame_Item_Type_List"]["MISSION"],RME_QuestEditorFrame_Item_Type)
		
		local LOCAL_ITEM = RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID]
		
		if LOCAL_ITEM.Mission_LaunchID then
			if RME_MISSIONS_LIST[LOCAL_ITEM.Mission_LaunchID] then
				UIDropDownMenu_SetText(RME_MISSIONS_LIST[LOCAL_ITEM.Mission_LaunchID].Title,RME_QuestEditorFrame_Item_Type_MISSION_SelectMission)
			else
				UIDropDownMenu_SetText("",RME_QuestEditorFrame_Item_Type_MISSION_SelectMission)
			end
		else
			UIDropDownMenu_SetText(RME_LOCALE["RME_QuestEditorFrame_Item_Type_MISSION_SelectMission"]["choice1"],RME_QuestEditorFrame_Item_Type_MISSION_SelectMission)
		end
		
		-- Si mission, l'objet lanant la mission ne peut etre prsent qu'en 1 exemplaire dans le sac
		RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].MaxCarried = 1
		RME_QuestEditorFrame_Item_Quantity:SetValue(1)

		
	end
end	
function RME_QuestEditorFrame_Item_Type_MISSION_SelectMission_OnClick()
	RME_DebugMsg("RME_QuestEditorFrame_Item_Type_MISSION_SelectMission_OnClick()"..tostring(this:GetID()),4)	
	UIDropDownMenu_SetSelectedID(RME_QuestEditorFrame_Item_Type_MISSION_SelectMission, this:GetID());
	if this:GetID() == 1 then
		-- Pas de mission
		RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].Mission_LaunchID = nil
	elseif this:GetID() == 2 then
		-- On selectionne la mission
		RME_PanelFrame_Mission_Select("SELECT_ITEM_LAUNCH_MISSIONID")
		--RME_QuestEditorFrame:Hide()
	end
end
function RME_QuestEditorFrame_Item_Type_MISSION_Select()
	RME_PanelFrame_Mission_Select("SELECT_ITEM_MISSIONID")
end
function RME_QuestEditorFrame_Item_Type_USE_ITEM_OnLoad()
	RME_DebugMsg("RME_QuestEditorFrame_Item_Type_USE_ITEM_OnLoad()",4)	
	this:SetBackdropColor(0.1,0.1,0.1,1)
end
function RME_QuestEditorFrame_Item_Type_USE_ITEM_OnShow()
	RME_DebugMsg("RME_QuestEditorFrame_Item_Type_USE_ITEM_OnShow()",4)	
	if RME_EDITOR_ITEM_ID then
		RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].Type = "USE_ITEM"
		UIDropDownMenu_SetSelectedName(RME_QuestEditorFrame_Item_Type,RME_LOCALE["RME_QuestEditorFrame_Item_Type_List"]["USE_ITEM"])
		UIDropDownMenu_SetText(RME_LOCALE["RME_QuestEditorFrame_Item_Type_List"]["USE_ITEM"],RME_QuestEditorFrame_Item_Type)
		if RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseItem_Timer_Text then
			RME_QuestEditorFrame_Item_Type_USE_ITEM_Timer_Text:SetText(RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseItem_Timer_Text)
		else
			RME_QuestEditorFrame_Item_Type_USE_ITEM_Timer_Text:SetText(format(RME_LOCALE["RME_QuestEditorFrame_Item_Type_USE_ITEM_Timer_NeedText"].text,RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].Name))
		end
		if RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseItem_Action_Timer then
			RME_QuestEditorFrame_Item_Type_USE_ITEM_Action_Timer:SetValue(RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseItem_Action_Timer)
		else
			RME_QuestEditorFrame_Item_Type_USE_ITEM_Action_Timer:SetValue(5)
		end
		
		if RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].CoolDown then
			RME_QuestEditorFrame_Item_Type_USE_ITEM_Cooldown:SetValue(RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].CoolDown)
		else
			RME_QuestEditorFrame_Item_Type_USE_ITEM_Cooldown:SetValue(5)
		end
		
		UIDropDownMenu_Initialize(RME_QuestEditorFrame_Item_Type_USE_ITEM_DropDownObjectsList, RME_QuestEditorFrame_Item_Type_USE_ITEM_DropDownObjectsList_Refresh)

		RME_QuestEditorFrame_Item_Type_USE_ITEM_DestroyOnSuccess:SetChecked(RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseItem_DestroyOnSuccess)
		if RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseItem_Use_Text then 
			RME_QuestEditorFrame_Item_Type_USE_ITEM_DescriptionScrollFrameEditBox:SetText(RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseItem_Use_Text)
		else
			RME_QuestEditorFrame_Item_Type_USE_ITEM_DescriptionScrollFrameEditBox:SetText(RME_LOCALE["RME_QuestEditorFrame_Item_Type_USE_ITEM_Description_NeedText"].text)
		end
	end
end	
function RME_QuestEditorFrame_Item_Type_USE_ITEM_Timer_Text_OnTextChanged()
	RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseItem_Timer_Text = RME_Translate_To_UTF8(RME_QuestEditorFrame_Item_Type_USE_ITEM_Timer_Text:GetText())
	RME_MISSION_EDITION.NeedSave = true	
end
function RME_QuestEditorFrame_Item_Type_USE_ITEM_Action_Timer_OnValueChanged()
	if RME_EDITOR_ITEM_ID then
		RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseItem_Action_Timer = RME_QuestEditorFrame_Item_Type_USE_ITEM_Action_Timer:GetValue()
		RME_MISSION_EDITION.NeedSave = true	
	end
	RME_QuestEditorFrame_Item_Type_USE_ITEM_Action_TimerValueText:SetText(SecondsToTime(RME_QuestEditorFrame_Item_Type_USE_ITEM_Action_Timer:GetValue()))
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_Item_Type_USE_ITEM_DropDownObjectsList_OnClick()
	RME_DebugMsg("RME_QuestEditorFrame_Item_Type_USE_ITEM_DropDownObjectsList_OnClick()"..tostring(this:GetID()),4)	
	UIDropDownMenu_SetSelectedID(RME_QuestEditorFrame_Item_Type_USE_ITEM_DropDownObjectsList, this:GetID());
	-- vu que la fonction 'UIDropDownMenu_GetValue' bug, on boucle sur la liste d'objet en cherchant le nom de l'objet
	local LOCAL_ITEM, LOCAL_ITEM_ID
	for LOCAL_ITEM_ID,LOCAL_ITEM in pairs(RME_MISSION_EDITION.MissionItemsList) do -- LOCAL_ITEM est du style RME_CLASS_ITEM
		
		if LOCAL_ITEM.NameHex == UIDropDownMenu_GetText(RME_QuestEditorFrame_Item_Type_USE_ITEM_DropDownObjectsList) then
			-- Trouv
			RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseItem_CreateObjectID = LOCAL_ITEM.ID
			break
		end
	end
	RME_QuestEditorFrame_Item_Update()
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_Item_Type_USE_ITEM_DropDownObjectsList_Refresh()
	RME_DebugMsg("RME_QuestEditorFrame_Item_Type_USE_ITEM_DropDownObjectsList_Refresh()",4)	

	local dropDownName = "RME_QuestEditorFrame_Item_Type_USE_ITEM_DropDownObjectsList"
	
	local info = UIDropDownMenu_CreateInfo()
	info.text = RME_LOCALE["RME_QuestEditorFrame_Item_NoItemCreation"].text
	info.value = nil
	info.func = getglobal(dropDownName.."_OnClick") 
	UIDropDownMenu_AddButton( info )

	local LOCAL_ITEM, LOCAL_ITEM_ID
	for LOCAL_ITEM_ID,LOCAL_ITEM in pairs(RME_MISSION_EDITION.MissionItemsList) do -- LOCAL_ITEM est du style RME_CLASS_ITEM
		local info = UIDropDownMenu_CreateInfo()
		info.text = tostring(LOCAL_ITEM.NameHex)
		info.value = LOCAL_ITEM.ID
		info.func = getglobal(dropDownName.."_OnClick") 
		UIDropDownMenu_AddButton( info )
	end
	
	RME_DebugMsg("RME_QuestEditorFrame_Item_Type_USE_ITEM_DropDownObjectsList_Refresh()",2)	
	
	-- On selectionne l'objet 
	if RME_EDITOR_ITEM_ID then 
		if RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseItem_CreateObjectID then
			UIDropDownMenu_SetSelectedName(RME_QuestEditorFrame_Item_Type_USE_ITEM_DropDownObjectsList,RME_MISSION_EDITION.MissionItemsList[RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseItem_CreateObjectID].NameHex)
		else
			UIDropDownMenu_SetSelectedName(RME_QuestEditorFrame_Item_Type_USE_ITEM_DropDownObjectsList,RME_LOCALE["RME_QuestEditorFrame_Item_NoItemCreation"].text)
		end
	end
	
	RME_DebugMsg("RME_QuestEditorFrame_Item_Type_USE_ITEM_DropDownObjectsList_Refresh() DONE !",4)	
end
function RME_QuestEditorFrame_Item_Type_USE_ITEM_DestroyOnSuccess_OnClick()
	if this:GetChecked() then
		RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseItem_DestroyOnSuccess = true
	else
		RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseItem_DestroyOnSuccess = nil
	end
	RME_MISSION_EDITION.NeedSave = true	
end
function RME_QuestEditorFrame_Item_Type_USE_ITEM_DescriptionScrollFrame_OnTextChanged()
	if RME_EDITOR_ITEM_ID then
		RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseItem_Use_Text = RME_Translate_To_UTF8(RME_QuestEditorFrame_Item_Type_USE_ITEM_DescriptionScrollFrameEditBox:GetText())
	end
	RME_EventManager_AddEvent("RME_QuestEditorFrame_Item_Update",5,"RME_QuestEditorFrame_Item_Update()",true)	
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_Item_Type_USE_ITEM_Cooldown_OnValueChanged()
	if RME_EDITOR_ITEM_ID then
		RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].CoolDown = RME_QuestEditorFrame_Item_Type_USE_ITEM_Cooldown:GetValue()
		RME_MISSION_EDITION.NeedSave = true	
	end
	RME_QuestEditorFrame_Item_Type_USE_ITEM_CooldownValueText:SetText(SecondsToTime(RME_QuestEditorFrame_Item_Type_USE_ITEM_Cooldown:GetValue()))
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_Item_Type_USE_ON_MOB_OnLoad()
	RME_DebugMsg("RME_QuestEditorFrame_Item_Type_USE_ON_MOB_OnLoad()",4)	
	this:SetBackdropColor(0.1,0.1,0.1,1)
end
function RME_QuestEditorFrame_Item_Type_USE_ON_MOB_OnShow()
	RME_DebugMsg("RME_QuestEditorFrame_Item_Type_USE_ON_MOB_OnShow()",4)	
	if RME_EDITOR_ITEM_ID then
		RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].Type = "USE_ON_MOB"
		UIDropDownMenu_SetSelectedName(RME_QuestEditorFrame_Item_Type,RME_LOCALE["RME_QuestEditorFrame_Item_Type_List"]["USE_ON_MOB"])
		UIDropDownMenu_SetText(RME_LOCALE["RME_QuestEditorFrame_Item_Type_List"]["USE_ON_MOB"],RME_QuestEditorFrame_Item_Type)
		
		if RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseOnMob_MobName then
			RME_QuestEditorFrame_Item_Type_USE_ON_MOB_MobName:SetText(RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseOnMob_MobName)
		else
			RME_QuestEditorFrame_Item_Type_USE_ON_MOB_MobName:SetText(RME_LOCALE["RME_QuestEditorFrame_Item_Type_USE_ON_MOB_NeedMobName"].text)
		end
		RME_QuestEditorFrame_Item_Type_USE_ON_MOB_NeedMobDead:SetChecked(RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseOnMob_NeedMobDead)
		if RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseOnMob_Timer_Text then
			RME_QuestEditorFrame_Item_Type_USE_ON_MOB_Timer_Text:SetText(RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseOnMob_Timer_Text)
		else
			RME_QuestEditorFrame_Item_Type_USE_ON_MOB_Timer_Text:SetText(format(RME_LOCALE["RME_QuestEditorFrame_Item_Type_USE_ON_MOB_Timer_NeedText"].text,RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].Name))
		end
		if RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseOnMob_Action_Timer then
			RME_QuestEditorFrame_Item_Type_USE_ON_MOB_Action_Timer:SetValue(RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseOnMob_Action_Timer)
		else
			RME_QuestEditorFrame_Item_Type_USE_ON_MOB_Action_Timer:SetValue(5)
		end
		if RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].CoolDown then
			RME_QuestEditorFrame_Item_Type_USE_ON_MOB_Cooldown:SetValue(RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].CoolDown)
		else
			RME_QuestEditorFrame_Item_Type_USE_ON_MOB_Cooldown:SetValue(5)
		end		
		UIDropDownMenu_Initialize(RME_QuestEditorFrame_Item_Type_USE_ON_MOB_DropDownObjectsList, RME_QuestEditorFrame_Item_Type_USE_ON_MOB_DropDownObjectsList_Refresh)
		RME_QuestEditorFrame_Item_Type_USE_ON_MOB_DestroyOnSuccess:SetChecked(RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseOnMob_DestroyOnSuccess)
		if RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseOnMob_Use_Text then 
			RME_QuestEditorFrame_Item_Type_USE_ON_MOB_DescriptionScrollFrameEditBox:SetText(RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseOnMob_Use_Text)
		else
			RME_QuestEditorFrame_Item_Type_USE_ON_MOB_DescriptionScrollFrameEditBox:SetText(RME_LOCALE["RME_QuestEditorFrame_Item_Type_USE_ON_MOB_Description_NeedText"].text)
		end
	end
end	
function RME_QuestEditorFrame_Item_Type_USE_ON_MOB_MobName_OnTextChanged()
	if RME_EDITOR_ITEM_ID then
		RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseOnMob_MobName = RME_Translate_To_UTF8(RME_QuestEditorFrame_Item_Type_USE_ON_MOB_MobName:GetText())
	end
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_Item_Type_USE_ON_MOB_MobName_SelectTarget_OnClick()
	RME_QuestEditorFrame_Item_Type_USE_ON_MOB_MobName:SetText(RME_TARGET_INFO.Name)
end
function RME_QuestEditorFrame_Item_Type_USE_ON_MOB_NeedMobDead_OnClick()
	PlaySound("igMainMenuOptionCheckBoxOn");
	if this:GetChecked() then
		RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseOnMob_NeedMobDead = true
	else
		RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseOnMob_NeedMobDead = nil
	end
	RME_MISSION_EDITION.NeedSave = true	
end
function RME_QuestEditorFrame_Item_Type_USE_ON_MOB_Timer_Text_OnTextChanged()
	RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseOnMob_Timer_Text = RME_Translate_To_UTF8(RME_QuestEditorFrame_Item_Type_USE_ON_MOB_Timer_Text:GetText())
	RME_MISSION_EDITION.NeedSave = true	
end
function RME_QuestEditorFrame_Item_Type_USE_ON_MOB_Action_Timer_OnValueChanged()
	if RME_EDITOR_ITEM_ID then
		RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseOnMob_Action_Timer = RME_QuestEditorFrame_Item_Type_USE_ON_MOB_Action_Timer:GetValue()
		RME_MISSION_EDITION.NeedSave = true	
	end
	RME_QuestEditorFrame_Item_Type_USE_ON_MOB_Action_TimerValueText:SetText(SecondsToTime(RME_QuestEditorFrame_Item_Type_USE_ON_MOB_Action_Timer:GetValue()))
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_Item_Type_USE_ON_MOB_DropDownObjectsList_OnClick()
	RME_DebugMsg("RME_QuestEditorFrame_Item_Type_USE_ON_MOB_DropDownObjectsList_OnClick()"..tostring(this:GetID()),4)	
	UIDropDownMenu_SetSelectedID(RME_QuestEditorFrame_Item_Type_USE_ON_MOB_DropDownObjectsList, this:GetID());
	-- vu que la fonction 'UIDropDownMenu_GetValue' bug, on boucle sur la liste d'objet en cherchant le nom de l'objet
	local LOCAL_ITEM, LOCAL_ITEM_ID
	for LOCAL_ITEM_ID,LOCAL_ITEM in pairs(RME_MISSION_EDITION.MissionItemsList) do -- LOCAL_ITEM est du style RME_CLASS_ITEM
		
		if LOCAL_ITEM.NameHex == UIDropDownMenu_GetText(RME_QuestEditorFrame_Item_Type_USE_ON_MOB_DropDownObjectsList) then
			-- Trouv
			RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseOnMob_CreateObjectID = LOCAL_ITEM.ID
			break
		end
	end
	RME_QuestEditorFrame_Item_Update()
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_Item_Type_USE_ON_MOB_DropDownObjectsList_Refresh()
	RME_DebugMsg("RME_QuestEditorFrame_Item_Type_USE_ON_MOB_DropDownObjectsList_Refresh()",4)	

	local dropDownName = "RME_QuestEditorFrame_Item_Type_USE_ON_MOB_DropDownObjectsList"

	local info = UIDropDownMenu_CreateInfo()
	info.text = RME_LOCALE["RME_QuestEditorFrame_Item_NoItemCreation"].text
	info.value = nil
	info.func = getglobal(dropDownName.."_OnClick") 
	UIDropDownMenu_AddButton( info )

	-- On charge les objets
	local LOCAL_ITEM, LOCAL_ITEM_ID
	for LOCAL_ITEM_ID,LOCAL_ITEM in pairs(RME_MISSION_EDITION.MissionItemsList) do -- LOCAL_ITEM est du style RME_CLASS_ITEM
		local info = UIDropDownMenu_CreateInfo()
		info.text = tostring(LOCAL_ITEM.NameHex)
		info.value = LOCAL_ITEM.ID
		info.func = getglobal(dropDownName.."_OnClick") 
		UIDropDownMenu_AddButton( info )
	end
	
	RME_DebugMsg("RME_QuestEditorFrame_Item_Type_USE_ON_MOB_DropDownObjectsList_Refresh()",2)	
	
	-- On selectionne l'objet 
	if RME_EDITOR_ITEM_ID then 
		if RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseOnMob_CreateObjectID then
			UIDropDownMenu_SetSelectedName(RME_QuestEditorFrame_Item_Type_USE_ON_MOB_DropDownObjectsList,RME_MISSION_EDITION.MissionItemsList[RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseOnMob_CreateObjectID].NameHex)
		else
			UIDropDownMenu_SetSelectedName(RME_QuestEditorFrame_Item_Type_USE_ON_MOB_DropDownObjectsList,RME_LOCALE["RME_QuestEditorFrame_Item_NoItemCreation"].text)
		end
	end
	
	RME_DebugMsg("RME_QuestEditorFrame_Item_Type_USE_ON_MOB_DropDownObjectsList_Refresh() DONE !",4)	
end
function RME_QuestEditorFrame_Item_Type_USE_ON_MOB_DestroyOnSuccess_OnClick()
	if this:GetChecked() then
		RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseOnMob_DestroyOnSuccess = true
	else
		RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseOnMob_DestroyOnSuccess = nil
	end
	RME_MISSION_EDITION.NeedSave = true	
end
function RME_QuestEditorFrame_Item_Type_USE_ON_MOB_DescriptionScrollFrame_OnTextChanged()
	if RME_EDITOR_ITEM_ID then
		RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].UseOnMob_Use_Text = RME_Translate_To_UTF8(RME_QuestEditorFrame_Item_Type_USE_ON_MOB_DescriptionScrollFrameEditBox:GetText())
	end
	RME_EventManager_AddEvent("RME_QuestEditorFrame_Item_Update",5,"RME_QuestEditorFrame_Item_Update()",true)	
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_Item_Type_USE_ON_MOB_Cooldown_OnValueChanged()
	if RME_EDITOR_ITEM_ID then
		RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].CoolDown = RME_QuestEditorFrame_Item_Type_USE_ON_MOB_Cooldown:GetValue()
		RME_MISSION_EDITION.NeedSave = true	
	end
	RME_QuestEditorFrame_Item_Type_USE_ON_MOB_CooldownValueText:SetText(SecondsToTime(RME_QuestEditorFrame_Item_Type_USE_ON_MOB_Cooldown:GetValue()))
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_Item_Type_LETTER_OnLoad()
	RME_DebugMsg("RME_QuestEditorFrame_Item_Type_LETTER_OnLoad()",4)	
	this:SetBackdropColor(0.1,0.1,0.1,1)
end
function RME_QuestEditorFrame_Item_Type_LETTER_OnShow()
	RME_DebugMsg("RME_QuestEditorFrame_Item_Type_LETTER_OnShow()",4)	
	if RME_EDITOR_ITEM_ID then
		RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].Type = "LETTER"
		UIDropDownMenu_SetSelectedName(RME_QuestEditorFrame_Item_Type,RME_LOCALE["RME_QuestEditorFrame_Item_Type_List"]["LETTER"])
		UIDropDownMenu_SetText(RME_LOCALE["RME_QuestEditorFrame_Item_Type_List"]["LETTER"],RME_QuestEditorFrame_Item_Type)
	end
end	
function RME_QuestEditorFrame_Item_Update()
	RME_DebugMsg("RME_QuestEditorFrame_Item_Update()",4)	
	
	if not RME_EDITOR_ITEM_ID and RME_getn(RME_MISSION_EDITION.MissionItemsList) > 0 then
		RME_EDITOR_ITEM_ID = RME_getkey(RME_MISSION_EDITION.MissionItemsList,1)
		RME_QuestEditorFrame_Item_ScrollFrame:SetVerticalScroll(0)
	end
	if not RME_EDITOR_ITEM_ID then
		-- Aucune ligne slectionn > on disable tout les boutons 
		RME_QuestEditorFrame_Item_Delete:Disable()
		RME_QuestEditorFrame_Item:Hide()
		RME_QuestEditorFrame_Item_ScrollFrame2:Hide()
		RME_QuestEditorFrame_Item_Image:Hide()
	else
		-- On a une ligne selectionne, on met a jour les boutons
		RME_QuestEditorFrame_Item:Show()
		RME_QuestEditorFrame_Item_ScrollFrame2:Show()
		RME_QuestEditorFrame_Item_Delete:Enable()	
		RME_QuestEditorFrame_Item_Image:Show()			
	end
	-- On update le fauxscroll qui liste les noms de mission	
	if RME_MISSION_EDITION.MissionItemsList and RME_getn(RME_MISSION_EDITION.MissionItemsList) > RME_MISSION_DISPLAYED then
		FauxScrollFrame_Update(RME_QuestEditorFrame_Item_ScrollFrame,RME_getn(RME_MISSION_EDITION.MissionItemsList), RME_MISSION_DISPLAYED, RME_QUESTLOG_QUEST_HEIGHT, nil, nil, nil, RME_QuestEditorFrame_Item_HighlightFrame, 293, 316 )		
	else
		FauxScrollFrame_Update(RME_QuestEditorFrame_Item_ScrollFrame,RME_getn(RME_MISSION_EDITION.MissionItemsList), RME_MISSION_DISPLAYED, RME_QUESTLOG_QUEST_HEIGHT, nil, nil, nil, RME_QuestEditorFrame_Item_HighlightFrame, 293, 316 )		
	end
	-- Update the quest listing
	RME_QuestEditorFrame_ItemHighlightFrame:Hide();
	local questIndex, questLogTitle, questTitleTag, questNumGroupMates, questNormalText, questHighlight, questCheck;
	local questLogTitleText, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily, color;
	local numPartyMembers, partyMembersOnQuest, tempWidth, textWidth;
	local LOCAL_Item
	
	for i=1, RME_MISSION_DISPLAYED, 1 do
		if FauxScrollFrame_GetOffset(RME_QuestEditorFrame_Item_ScrollFrame) then
			questIndex = i + FauxScrollFrame_GetOffset(RME_QuestEditorFrame_Item_ScrollFrame);
		else
			questIndex = i
		end

		questLogTitle = getglobal("RME_QuestEditorFrame_Item"..i);
		questTitleTag = getglobal("RME_QuestEditorFrame_Item"..i.."Tag");
		questNumGroupMates = getglobal("RME_QuestEditorFrame_Item"..i.."GroupMates");
		questCheck = getglobal("RME_QuestEditorFrame_Item"..i.."Check");
		questNormalText = getglobal("RME_QuestEditorFrame_Item"..i.."NormalText");
		questHighlight = getglobal("RME_QuestEditorFrame_Item"..i.."Highlight");

		if ( questIndex <= RME_getn(RME_MISSION_EDITION.MissionItemsList))  then

			local LOCAL_ITEM = RME_MISSION_EDITION.MissionItemsList[RME_getkey(RME_MISSION_EDITION.MissionItemsList,questIndex)]
			questLogTitle:SetText(LOCAL_ITEM.Name);
			QuestLogDummyText:SetText(LOCAL_ITEM.Name);
			questLogTitle:SetNormalTexture("");
			questHighlight:SetTexture("");
			questTitleTag:SetText("");
			questNormalText:SetWidth(275);
			questCheck:Hide();
			local qr, qg, qb, hex = GetItemQualityColor(LOCAL_ITEM.Quality)
			color = {r = qr; g = qg; b = qb}
			questTitleTag:SetTextColor(color.r, color.g, color.b);
			questLogTitle:SetTextColor(color.r, color.g, color.b);
			questNumGroupMates:SetTextColor(color.r, color.g, color.b);
			questLogTitle.r = color.r;
			questLogTitle.g = color.g;
			questLogTitle.b = color.b;
			questLogTitle.ITEM_ID = LOCAL_ITEM.ID
			questLogTitle:Show();

			-- Place the highlight and lock the highlight state
			if  RME_EDITOR_ITEM_ID ==  LOCAL_ITEM.ID then
				RME_QuestEditorFrame_ItemHighlightFrame:SetPoint("TOPLEFT", "RME_QuestEditorFrame_Item"..i, "TOPLEFT", 0, 0);
				RME_QuestEditorFrame_ItemSkillHighlight:SetVertexColor(color.r, color.g, color.b);
				RME_QuestEditorFrame_ItemHighlightFrame:Show();
				questTitleTag:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
				questLogTitle:LockHighlight();			
				RME_QuestEditorFrame_Item_Image:SetNormalTexture(LOCAL_ITEM.Texture)
				RME_QuestEditorFrame_Item_Image:SetPushedTexture(LOCAL_ITEM.Texture)	
				RME_QuestEditorFrame_Item_Name:SetText(LOCAL_ITEM.Name)
				UIDropDownMenu_SetSelectedID(RME_QuestEditorFrame_Item_QualityList, LOCAL_ITEM.Quality+1);
				UIDropDownMenu_SetText(RME_LOCALE["RME_QuestEditorFrame_Item_QualityList"]["choice"..tostring(LOCAL_ITEM.Quality+1)],RME_QuestEditorFrame_Item_QualityList)			
				if LOCAL_ITEM.Description then
					RME_QuestEditorFrame_Item_DescriptionScrollFrameEditBox:SetText(LOCAL_ITEM.Description)
				end		
				RME_QuestEditorFrame_Item_Quantity:SetValue(LOCAL_ITEM.Quantity)
				RME_QuestEditorFrame_Item_GivenAtStart:SetChecked(LOCAL_ITEM.GivenAtStart)
				RME_QuestEditorFrame_Item_MaxCarried:SetChecked(LOCAL_ITEM.MaxCarried)
				RME_QuestEditorFrame_Item_Reward:SetChecked(RME_QuestEditorFrame_Item_IsReward(LOCAL_ITEM.ID,"Reward"))
				RME_QuestEditorFrame_Item_RewardChoice:SetChecked(RME_QuestEditorFrame_Item_IsReward(LOCAL_ITEM.ID,"RewardChoice"))
				RME_DebugMsg("RME_QuestEditorFrame_Item_Update() type="..tostring(LOCAL_ITEM.Type),2)					
				RME_QuestEditorFrame_Item_Type_ShowFrame()
				-- DEFAULT
				if LOCAL_ITEM.Type then
					local frame = getglobal("RME_QuestEditorFrame_Item_Type_"..LOCAL_ITEM.Type):Show()
				end				
								
				RME_DebugMsg("RME_QuestEditorFrame_Item_Update()",1)	
				
			else 
				questLogTitle:UnlockHighlight();
			end
	
		else
			questLogTitle:Hide();
		end
	end

	RME_DebugMsg("RME_QuestEditorFrame_Item_Update() Done !",4)	
end
	-- TAB EVENT
function RME_QuestEditorFrame_Event_Add_OnClick()	
	local NEW_EVENT = RME_CLASS_EVENT()
	NEW_EVENT.EventType		= "LOOT_WHEN_KILL_MOB" -- par defaut (en attendant mieux)
	NEW_EVENT.TriggerWhen 		= NEW_EVENT.Loot_TriggerWhen
	NEW_EVENT.Loot_Probability	= 100
	NEW_EVENT.Loot_Quantity		= 1
	NEW_EVENT.EventID 			= RME_Generate_New_GUID()
	table.insert(RME_MISSION_EDITION.MissionEvents,#RME_MISSION_EDITION.MissionEvents+1,NEW_EVENT)
	RME_EDITOR_EVENT_ID = #RME_MISSION_EDITION.MissionEvents
	RME_QuestEditorFrame_Events_Update()
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_Event_Delete_OnClick()
	if RME_EDITOR_EVENT_ID then
		table.remove (RME_MISSION_EDITION.MissionEvents,RME_EDITOR_EVENT_ID)
	end
	RME_EDITOR_EVENT_ID = nil
	RME_QuestEditorFrame_Events_Update()
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_Event_UP_OnClick()
	if RME_EDITOR_EVENT_ID then
		-- On rcupere sa position actuelle
		local OldPosition = RME_EDITOR_EVENT_ID
		-- On rcupere l'objectif qu'on veut monter
		local OLD_EVENT = RME_MISSION_EDITION.MissionEvents[RME_EDITOR_EVENT_ID]
		-- On le supprime
		RME_QuestEditorFrame_Event_Delete_OnClick()
		-- On le rajoute mais a la position OldPosition -1
		table.insert(RME_MISSION_EDITION.MissionEvents,OldPosition-1,OLD_EVENT)
		RME_EDITOR_EVENT_ID = OldPosition-1
		RME_QuestEditorFrame_Events_Update()
		RME_MISSION_EDITION.NeedSave = true
	end
end
function RME_QuestEditorFrame_Event_DOWN_OnClick()
	if RME_EDITOR_EVENT_ID then
		-- On rcupere sa position actuelle
		local OldPosition = RME_EDITOR_EVENT_ID
		-- On rcupere l'objectif qu'on veut monter
		local OLD_EVENT = RME_MISSION_EDITION.MissionEvents[RME_EDITOR_EVENT_ID]
		-- On le supprime
		RME_QuestEditorFrame_Event_Delete_OnClick()
		-- On le rajoute mais a la position OldPosition +1
		table.insert(RME_MISSION_EDITION.MissionEvents,OldPosition+1,OLD_EVENT)
		RME_EDITOR_EVENT_ID = OldPosition+1
		RME_QuestEditorFrame_Events_Update()
		RME_MISSION_EDITION.NeedSave = true
	end
end	
function RME_QuestEditorFrameEventButton_OnLoad()
	this:RegisterForClicks("LeftButtonUp", "RightButtonUp");
	this.r = nil
	this.g = nil
	this.b = nil
end
function RME_QuestEditorFrameEventButton_OnEvent(event)
	RME_DebugMsg(" RME_QuestEditorFrameObjectiveButton_OnEvent("..tostring(event)..")",4)	
	if ( GameTooltip:IsOwned(this) ) then
		GameTooltip:Hide();
	end
end
function RME_QuestEditorFrameEventButton_OnEnter()
	-- Pourra etre utilis pour afficher les info sup de l'event	
	return;
end
function RME_QuestEditorFrameEventButton_OnLeave()
	if (this:GetID() ~= RME_EDITOR_EVENT_ID) then
		getglobal(this:GetName().."Tag"):SetTextColor(this.r, this.g, this.b);
	end
	GameTooltip:Hide();
end
function RME_QuestEditorFrameEventButton_OnClick()
	RME_DebugMsg("RME_QuestEditorFrameEventButton_OnClick("..tostring(arg2)..")",4)	
	if FauxScrollFrame_GetOffset(RME_QuestEditorFrame_Event_ScrollFrame) then
		RME_EDITOR_EVENT_ID = this:GetID() + FauxScrollFrame_GetOffset(RME_QuestEditorFrame_Event_ScrollFrame);
	else
		RME_EDITOR_EVENT_ID = this:GetID()
	end
	RME_QuestEditorFrame_Events_Update()
end
function RME_QuestEditorFrame_Event_Type_OnClick()
	RME_DebugMsg("RME_QuestEditorFrame_Event_Type_OnClick()"..tostring(this:GetID()),4)		
	UIDropDownMenu_SetSelectedID(RME_QuestEditorFrame_Event_Type, this:GetID());
	RME_QuestEditorFrame_Event_Type_ShowFrame(this:GetID())
	RME_QuestEditorFrame_Events_Update()
end
function RME_QuestEditorFrame_Event_Type_ShowFrame(id)
	RME_DebugMsg("RME_QuestEditorFrame_Event_Type_ShowFrame()"..tostring(id),4)		

	-- On cache les frames
	local count = 1
	while RME_LOCALE["RME_QuestEditorFrame_Event_Type"]["tag"..tostring(count)] do
		getglobal("RME_QuestEditorFrame_Event_Type_"..RME_LOCALE["RME_QuestEditorFrame_Event_Type"]["tag"..tostring(count)]):Hide()
		count = count + 1
	end
	-- Maintenant on affiche la bonne frames
	if id then
		local frame = getglobal("RME_QuestEditorFrame_Event_Type_"..RME_LOCALE["RME_QuestEditorFrame_Event_Type"]["tag"..tostring(id)])
		frame:Show()
	end
end		
function RME_QuestEditorFrame_Events_Update()
	RME_DebugMsg("RME_QuestEditorFrame_Events_Update()",4)	
		
	if not RME_EDITOR_EVENT_ID and #RME_MISSION_EDITION.MissionEvents > 0 then
		RME_EDITOR_EVENT_ID = 1
		RME_QuestEditorFrame_Event_ScrollFrame:SetVerticalScroll(0)
	end
	
	if not RME_EDITOR_EVENT_ID then
		-- Aucune ligne slectionn > on disable tout les boutons 
		RME_QuestEditorFrame_Event_Delete:Disable()
		RME_QuestEditorFrame_Event_UP:Disable()
		RME_QuestEditorFrame_Event_DOWN:Disable()
		RME_QuestEditorFrame_Event_Type:Hide()
		-- On cache les frames (sans donner de id > hide tout)
		RME_QuestEditorFrame_Event_Type_ShowFrame()
	else
		-- On a une ligne selectionne, on met a jour les boutons
			-- Est il possible de rajouter un nouvel objectif
			if #RME_MISSION_EDITION.MissionEvents >= RME_MAX_EVENTS then
				RME_QuestEditorFrame_Event_Add:Disable()
			else
				RME_QuestEditorFrame_Event_Add:Enable()
			end		
			-- Activation delete
			RME_QuestEditorFrame_Event_Delete:Enable()
			-- Si 1ere ligne > disabled UP
			if RME_EDITOR_EVENT_ID == 1 then
				RME_QuestEditorFrame_Event_UP:Disable()
			else
				RME_QuestEditorFrame_Event_UP:Enable()
			end
			-- Si derniere ligne > disabled DOWN
			if RME_EDITOR_EVENT_ID == #RME_MISSION_EDITION.MissionEvents then
				RME_QuestEditorFrame_Event_DOWN:Disable()
			else
				RME_QuestEditorFrame_Event_DOWN:Enable()
			end
			RME_QuestEditorFrame_Event_Type:Show()
		-- Rcupration de l'objectif en cours
			local LOCAL_EVENT = RME_MISSION_EDITION.MissionEvents[RME_EDITOR_EVENT_ID]
			-- on affiche la frame li a l'objectif
			RME_QuestEditorFrame_Event_Type_ShowFrame()
			
			if LOCAL_EVENT.EventType then
				local frame = getglobal("RME_QuestEditorFrame_Event_Type_"..LOCAL_EVENT.EventType):Show()
			end
	end
	
	-- On update le fauxscroll qui liste les noms de mission	
	if RME_MISSION_EDITION.MissionEvents and #RME_MISSION_EDITION.MissionEvents > RME_MISSION_DISPLAYED then
		FauxScrollFrame_Update(RME_QuestEditorFrame_Event_ScrollFrame,#RME_MISSION_EDITION.MissionEvents, RME_MISSION_DISPLAYED, RME_QUESTLOG_QUEST_HEIGHT, nil, nil, nil, RME_QuestEditorFrame_Events_HighlightFrame, 293, 316 )		
	elseif #RME_MISSION_EDITION.MissionEvents then
		FauxScrollFrame_Update(RME_QuestEditorFrame_Event_ScrollFrame,#RME_MISSION_EDITION.MissionEvents, RME_MISSION_DISPLAYED, RME_QUESTLOG_QUEST_HEIGHT, nil, nil, nil, RME_QuestEditorFrame_Events_HighlightFrame, 293, 316 )		
	end

	-- Update the quest listing
	RME_QuestEditorFrame_EventsHighlightFrame:Hide();
	local questIndex, questLogTitle, questTitleTag, questNumGroupMates, questNormalText, questHighlight, questCheck;
	local questLogTitleText, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily, color;
	local numPartyMembers, partyMembersOnQuest, tempWidth, textWidth;
	local LOCAL_EVENT
	
	for i=1, RME_MISSION_DISPLAYED, 1 do
	
		if FauxScrollFrame_GetOffset(RME_QuestEditorFrame_Event_ScrollFrame) then
			questIndex = i + FauxScrollFrame_GetOffset(RME_QuestEditorFrame_Event_ScrollFrame);
		else
			questIndex = i
		end

		questLogTitle = getglobal("RME_QuestEditorFrame_Events"..i);
		questTitleTag = getglobal("RME_QuestEditorFrame_Events"..i.."Tag");
		questNumGroupMates = getglobal("RME_QuestEditorFrame_Events"..i.."GroupMates");
		questCheck = getglobal("RME_QuestEditorFrame_Events"..i.."Check");
		questNormalText = getglobal("RME_QuestEditorFrame_Events"..i.."NormalText");
		questHighlight = getglobal("RME_QuestEditorFrame_Events"..i.."Highlight");

		if ( questIndex <= #RME_MISSION_EDITION.MissionEvents)  then

			local LOCAL_EVENT = RME_MISSION_EDITION.MissionEvents[questIndex]

			questLogTitle:SetText(LOCAL_EVENT:EventStatus(RME_MISSION_EDITION));
			QuestLogDummyText:SetText(LOCAL_EVENT:EventStatus(RME_MISSION_EDITION));
			questLogTitle:SetNormalTexture("");
			questHighlight:SetTexture("");
			questTitleTag:SetText("");
			questNormalText:SetWidth(275);
			questCheck:Hide();

			color = RME_GetEventColor(LOCAL_EVENT.EventType);
			questTitleTag:SetTextColor(color.r, color.g, color.b);
			questLogTitle:SetTextColor(color.r, color.g, color.b);
			questNumGroupMates:SetTextColor(color.r, color.g, color.b);
			questLogTitle.r = color.r;
			questLogTitle.g = color.g;
			questLogTitle.b = color.b;
			questLogTitle:Show();


			-- Place the highlight and lock the highlight state
			if  RME_EDITOR_EVENT_ID == questIndex then
				RME_QuestEditorFrame_EventsHighlightFrame:SetPoint("TOPLEFT", "RME_QuestEditorFrame_Events"..i, "TOPLEFT", 0, 0);
				RME_QuestEditorFrame_EventsSkillHighlight:SetVertexColor(color.r, color.g, color.b);
				RME_QuestEditorFrame_EventsHighlightFrame:Show();
				questTitleTag:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
				questLogTitle:LockHighlight();				
				UIDropDownMenu_SetText(RME_LOCALE["RME_QuestEditorFrame_Event_Type_List"][RME_MISSION_EDITION.MissionEvents[RME_EDITOR_EVENT_ID].EventType],RME_QuestEditorFrame_Event_Type)
				
				
				
				
			else
				questLogTitle:UnlockHighlight();
			end
	
		else
			questLogTitle:Hide();
		end
	end

	RME_DebugMsg("RME_QuestEditorFrame_Events_Update() Done !",4)	

end
		-- TAB EVENT: LOOT_WHEN_KILL_MOB
function RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_OnLoad()
	RME_DebugMsg("RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_OnLoad()",4)	
	this:SetBackdropColor(0.1,0.1,0.1,1)
end
function RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_OnShow()
	RME_DebugMsg("RME_QuestEditorFrame_Events_KILL_MOB_OnShow()",4)	
	--Mise a jour menu droulant
	RME_MISSION_EDITION.MissionEvents[RME_EDITOR_EVENT_ID].EventType = "LOOT_WHEN_KILL_MOB"
	UIDropDownMenu_SetSelectedName(RME_QuestEditorFrame_Event_Type,RME_LOCALE["RME_QuestEditorFrame_Event_Type_List"][RME_MISSION_EDITION.MissionEvents[RME_EDITOR_EVENT_ID].EventType])
	-- On met  jour le menu droulant
	UIDropDownMenu_Initialize(RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_DropDownObjectsList, RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_DropDownObjectsList_Refresh)
	
	-- On charge le texte du mob a tuer
	local LOCAL_EVENT = RME_MISSION_EDITION.MissionEvents[RME_EDITOR_EVENT_ID]

	if LOCAL_EVENT.Loot_ItemID then
		UIDropDownMenu_SetSelectedName(RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_DropDownObjectsList,RME_MISSION_EDITION.MissionItemsList[LOCAL_EVENT.Loot_ItemID].NameHex)
	end	
	if LOCAL_EVENT.Loot_On_Mob then
		RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_Name:SetText(LOCAL_EVENT.Loot_On_Mob)
	else
		RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_Name:SetText(RME_LOCALE["RME_LOCALE_EDITOR_NEED_MOBNAME"].text)
	end
	if LOCAL_EVENT.Loot_Quantity then
		RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_Number:SetValue(LOCAL_EVENT.Loot_Quantity)
	else
		RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_Number:SetValue(1)
	end
	if LOCAL_EVENT.Loot_Probability then
		RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_Probability:SetValue(LOCAL_EVENT.Loot_Probability)
	else
		RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_Probability:SetValue(100)
	end	
	
end	
function RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_Name_OnTextChanged()	
	RME_MISSION_EDITION.MissionEvents[RME_EDITOR_EVENT_ID].Loot_On_Mob = RME_Translate_To_UTF8(this:GetText())
	RME_EventManager_AddEvent("RME_QuestEditorFrame_Events_Update",5,"RME_QuestEditorFrame_Events_Update()",true)	
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_SelectTarget_OnClick()
	RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_Name:SetText(RME_TARGET_INFO.Name)
end
function RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_DropDownObjectsList_OnClick()
	RME_DebugMsg("RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_DropDownObjectsList_OnClick()"..tostring(this:GetID()),4)	
	UIDropDownMenu_SetSelectedID(RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_DropDownObjectsList, this:GetID());
	-- vu que la fonction 'UIDropDownMenu_GetValue' bug, on boucle sur la liste d'objet en cherchant le nom de l'objet
	local LOCAL_ITEM, LOCAL_ITEM_ID
	for LOCAL_ITEM_ID,LOCAL_ITEM in pairs(RME_MISSION_EDITION.MissionItemsList) do -- LOCAL_ITEM est du style RME_CLASS_ITEM
		
		if LOCAL_ITEM.NameHex == UIDropDownMenu_GetText(RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_DropDownObjectsList) then
			-- Trouv
			RME_MISSION_EDITION.MissionEvents[RME_EDITOR_EVENT_ID].Loot_ItemID = LOCAL_ITEM.ID
			break
		end
	end
	RME_QuestEditorFrame_Events_Update()
	RME_MISSION_EDITION.NeedSave = true
end
function RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_DropDownObjectsList_Refresh()
	RME_DebugMsg("RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_DropDownObjectsList_Refresh()",4)	

	local dropDownName = "RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_DropDownObjectsList"
	
	if RME_getn(RME_MISSION_EDITION.MissionItemsList) == 0 then
		-- Aucun objet encore cre
			local info = UIDropDownMenu_CreateInfo()
			local choice = RME_LOCALE[dropDownName].choice1
			local tag = RME_LOCALE[dropDownName].tag1
			info.text = choice
			info.value = tag
			info.func = nil
			UIDropDownMenu_AddButton( info )
			RME_DebugMsg("RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_DropDownObjectsList_Refresh() DONE !",4)	
		return
	end
	
	-- On charge les objets
	local LOCAL_ITEM, LOCAL_ITEM_ID
	for LOCAL_ITEM_ID,LOCAL_ITEM in pairs(RME_MISSION_EDITION.MissionItemsList) do -- LOCAL_ITEM est du style RME_CLASS_ITEM
		local info = UIDropDownMenu_CreateInfo()
		info.text = tostring(LOCAL_ITEM.NameHex)
		info.value = LOCAL_ITEM.ID
		info.func = getglobal(dropDownName.."_OnClick") 
		UIDropDownMenu_AddButton( info )
	end
	
	-- On selectionne l'objet 
	if RME_EDITOR_EVENT_ID then 
		local LOCAL_EVENT = RME_MISSION_EDITION.MissionEvents[RME_EDITOR_EVENT_ID]
		if LOCAL_EVENT.Loot_ItemID then
			UIDropDownMenu_SetSelectedName(RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_DropDownObjectsList,RME_MISSION_EDITION.MissionItemsList[LOCAL_EVENT.Loot_ItemID].NameHex)
		end
	end
	
	RME_DebugMsg("RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_DropDownObjectsList_Refresh() DONE !",4)	
end
function RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_Number_OnValueChanged()
	if RME_EDITOR_EVENT_ID then
		RME_MISSION_EDITION.MissionEvents[RME_EDITOR_EVENT_ID].Loot_Quantity = RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_Number:GetValue()
	end
	RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_NumberValueText:SetText(tostring(RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_Number:GetValue()))
	RME_EventManager_AddEvent("RME_QuestEditorFrame_Events_Update",5,"RME_QuestEditorFrame_Events_Update()",true)
end
function RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_Probability_OnValueChanged()
	if RME_EDITOR_EVENT_ID then
		RME_MISSION_EDITION.MissionEvents[RME_EDITOR_EVENT_ID].Loot_Probability = RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_Probability:GetValue()
	end
	RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_ProbabilityValueText:SetText(tostring(RME_QuestEditorFrame_Event_Type_LOOT_WHEN_KILL_MOB_Probability:GetValue()).."%")
	RME_EventManager_AddEvent("RME_QuestEditorFrame_Events_Update",5,"RME_QuestEditorFrame_Events_Update()",true)
end
--GM--
function RME_PanelFrame_GM_OnLoad()
end
function RME_PanelFrame_GM_OnShow()
end
function RME_PanelFrame_GM_PlayerLine_OnLoad()
	this:RegisterForClicks("LeftButtonUp", "RightButtonUp");
	this.r = nil
	this.g = nil
	this.b = nil
	this.PLAYER_ID = nil
end
function RME_PanelFrame_GM_PlayerLine_OnClick(arg1,ID)
	RME_DebugMsg("RME_PanelFrame_MissionLine_OnClick()"..tostring(this.MISSION_ID),4)	
	RME_PLAYER_SELECTED = this.PLAYER_ID
	local LOCAL_USER = RME_COMM_ADDON_USERS_LIST[RME_PLAYER_SELECTED]
	if LOCAL_USER and LOCAL_USER.MissionsData then
		local Data = LOCAL_USER.MissionsData[RME_MISSIONID_SELECTED]
		if Data and Data.LastUpdate and Data.LastAsk then
			if time() - Data.LastUpdate > 60 and time() - Data.LastAsk > 60 then
				RME_Comm_SEND_GM_GET_MISSION_STATUS("WHISPER",this.PLAYER_ID,RME_MISSIONID_SELECTED)
			end
		end
	end
end
function RME_PanelFrame_GM_PlayerLine_OnEnter()
	return
end
function RME_PanelFrame_GM_PlayerLine_OnLeave()
	if (this.PLAYER_ID ~= RME_PLAYER_SELECTED) then
		getglobal(this:GetName().."Tag"):SetTextColor(this.r, this.g, this.b);
	end
	GameTooltip:Hide();
end
function RME_PanelFrame_GM_ChoosePlayer_OnLoad()
	this:SetBackdropColor(0.1,0.1,0.1,1)
end
function RME_PanelFrame_GM_ChoosePlayer_OnShow()
	RME_PanelFrame_GM_Players_Update_Listing()
	RME_PanelFrame_GM_Players_Update()
end
function RME_PanelFrame_GM_Players_Update()
	RME_DebugMsg("RME_PanelFrame_GM_Players_Update()",4)	
	if not RME_PLAYER_SELECTED and #RME_PARTY_PLAYERS > 0 then
		RME_PLAYER_SELECTED = RME_PARTY_PLAYERS[1]
	end
	
	-- On relance l'update si fenetre visible
	if RME_PanelFrame_GM_ChoosePlayer:IsShown() and #RME_PARTY_PLAYERS > 0 then
		RME_EventManager_AddEvent("RME_PanelFrame_GM_Players_Update",1,"RME_PanelFrame_GM_Players_Update()")
	end

	-- On update le fauxscroll qui liste les noms des joueur dans l'equipe	
	if RME_PARTY_PLAYERS and #RME_PARTY_PLAYERS > RME_PANNELFRAME_MISSION_DISPLAYED then
		FauxScrollFrame_Update(RME_PanelFrame_GM_ChoosePlayer_ScrollFrame,#RME_PARTY_PLAYERS, RME_PANNELFRAME_MISSION_DISPLAYED, RME_QUESTLOG_QUEST_HEIGHT, nil, nil, nil, RME_PanelFrame_GM_ChoosePlayer_HighlightFrame, 293, 316 )		
	else
		FauxScrollFrame_Update(RME_PanelFrame_GM_ChoosePlayer_ScrollFrame,#RME_PARTY_PLAYERS, RME_PANNELFRAME_MISSION_DISPLAYED, RME_QUESTLOG_QUEST_HEIGHT, nil, nil, nil, RME_PanelFrame_GM_ChoosePlayer_HighlightFrame, 293, 316 )		
	end
	
	if RME_MISSIONID_SELECTED then
		UIDropDownMenu_SetText(RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].Title,RME_PanelFrame_GM_ChoosePlayer_DropDownMissionList)
	else
		UIDropDownMenu_SetText("<No Mission>",RME_PanelFrame_GM_ChoosePlayer_DropDownMissionList)
	end

	-- Update the quest listing
	RME_PanelFrame_GM_ChoosePlayer_ScrollFrameHighlightFrame_Highlight:Hide();
	local questIndex, questLogTitle, questTitleTag, questNumGroupMates, questNormalText, questHighlight, questCheck;
	local questLogTitleText, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily, color;
	local numPartyMembers, partyMembersOnQuest, tempWidth, textWidth;
	
	for i=1, RME_PANNELFRAME_MISSION_DISPLAYED do
		
		if FauxScrollFrame_GetOffset(RME_PanelFrame_GM_ChoosePlayer_ScrollFrame) then
			questIndex = i + FauxScrollFrame_GetOffset(RME_PanelFrame_GM_ChoosePlayer_ScrollFrame);
		else
			questIndex = i
		end

		questLogTitle = getglobal("RME_PanelFrame_GM_ChoosePlayer_ScrollFrame_Line"..i);
		questTitleTag = getglobal("RME_PanelFrame_GM_ChoosePlayer_ScrollFrame_Line"..i.."Tag");
		questNumGroupMates = getglobal("RME_PanelFrame_GM_ChoosePlayer_ScrollFrame_Line"..i.."GroupMates");
		questCheck = getglobal("RME_PanelFrame_GM_ChoosePlayer_ScrollFrame_Line"..i.."Check");
		questNormalText = getglobal("RME_PanelFrame_GM_ChoosePlayer_ScrollFrame_Line"..i.."NormalText");
		questHighlight = getglobal("RME_PanelFrame_GM_ChoosePlayer_ScrollFrame_Line"..i.."Highlight");
		
		if ( questIndex <= #RME_PARTY_PLAYERS)  then

			local LOCAL_USER = RME_COMM_ADDON_USERS_LIST[RME_PARTY_PLAYERS[questIndex]]
			
			questLogTitle:SetNormalTexture("");
			questHighlight:SetTexture("");
			questNormalText:SetWidth(275);
			-- Joueur n'ayant donn de signe de vie depuis longtemps ? (3minutes)
			if time() - LOCAL_USER.LastPing > 60*3 then
				questLogTitle:SetText(LOCAL_USER.ID);
				QuestLogDummyText:SetText(LOCAL_USER.ID);	
				color = {r = 0.3; g = 0.3; b = 0.3}
			else
				questLogTitle:SetText(LOCAL_USER.ID);
				QuestLogDummyText:SetText(LOCAL_USER.ID);
				color = {r = 0.7; g = 0.9; b = 0.4}
			end
						
			-- On rcupere les infos de la mission selectionne
			
			if RME_MISSIONID_SELECTED and not RME_COMM_ADDON_USERS_LIST[RME_PARTY_PLAYERS[questIndex]].MissionsData[RME_MISSIONID_SELECTED]  then
				RME_COMM_ADDON_USERS_LIST[RME_PARTY_PLAYERS[questIndex]].MissionsData[RME_MISSIONID_SELECTED] = {}
				RME_COMM_ADDON_USERS_LIST[RME_PARTY_PLAYERS[questIndex]].MissionsData[RME_MISSIONID_SELECTED] = {
					LastAsk	= time();
					LastUpdate = 0;
				}	
				if RME_COMM_ADDON_USERS_LIST[RME_PARTY_PLAYERS[questIndex]].Version then
					RME_Comm_SEND_GM_GET_MISSION_STATUS("WHISPER",RME_PARTY_PLAYERS[questIndex],RME_MISSIONID_SELECTED)
				end
				-- Couleur grise pour "inconnu"
				questCheck:Show();
				questCheck:SetVertexColor(0.3,0.3,0.3)	
				questCheck:SetTexture("Interface\\GossipFrame\\AvailableQuestIcon")	

				
			elseif LOCAL_USER.MissionsData[RME_MISSIONID_SELECTED] then
				-- On a des infos sur la mission
				questCheck:Hide();

				local Data = LOCAL_USER.MissionsData[RME_MISSIONID_SELECTED]
				
				if Data.MissionData_MissionFailed then
					questLogTitle:SetText(LOCAL_USER.ID.." ["..FAILED.."]");
				
				elseif Data.MissionData_MissionSuccess then
					questLogTitle:SetText(LOCAL_USER.ID.." ["..COMPLETE.."]");		

				elseif Data.MissionData_MissionCompleted then
					questLogTitle:SetText(LOCAL_USER.ID.." ["..RME_LOCALE["RME_FINISHED"].text.."]");		
				
				elseif Data.MissionData_MissionInProgress then
					questLogTitle:SetText(LOCAL_USER.ID.." ["..RME_LOCALE["RME_IN_PROGRESS"].text.."]");		
					
				end
				
				-- y a t il eu rponse et si oui ; depuis quand ?
				if Data.LastUpdate and ((time() - Data.LastUpdate) > 0 and time() - Data.LastUpdate < 60*60*24*30*12)then
					questTitleTag:SetText("["..SecondsToTime(time() - Data.LastUpdate).."]");
				else
					questTitleTag:SetText("");
				end
				
				if not Data.LastAsk then
					RME_COMM_ADDON_USERS_LIST[RME_PARTY_PLAYERS[questIndex]].MissionsData[RME_MISSIONID_SELECTED].LastAsk = time()
				end
				
				-- On fait une demande (uniquement si il n'y en a pas dja une en cours)
				if time() - Data.LastUpdate > 60 and time() - Data.LastAsk > 60 then
				
					RME_COMM_ADDON_USERS_LIST[RME_PARTY_PLAYERS[questIndex]].MissionsData[RME_MISSIONID_SELECTED].LastAsk = time()
					RME_Comm_SEND_GM_GET_MISSION_STATUS("WHISPER",RME_PARTY_PLAYERS[questIndex],RME_MISSIONID_SELECTED)
					-- on attend
					questCheck:Show();
					questCheck:SetVertexColor(0,1,0)	
					questCheck:SetTexture("Interface\\GossipFrame\\AvailableQuestIcon")	
					
				end
				
				if time() - Data.LastUpdate > 80 then -- la demande date de plus de 70s !
					questCheck:Show();
					questCheck:SetVertexColor(1,0,0)	
					questCheck:SetTexture("Interface\\GossipFrame\\AvailableQuestIcon")	
					color = {r = 0.9; g = 0.2; b = 0.2}
				end
				
			else
				
				color = {r = 0.3; g = 0.3; b = 0.3}
				questCheck:Hide();
				
			end			
			
			questTitleTag:SetTextColor(color.r, color.g, color.b);
			questLogTitle:SetTextColor(color.r, color.g, color.b);
			questNumGroupMates:SetTextColor(color.r, color.g, color.b);
			questLogTitle.r = color.r;
			questLogTitle.g = color.g;
			questLogTitle.b = color.b;
			questLogTitle.PLAYER_ID = LOCAL_USER.ID
			questLogTitle:Show();
			
			-- Place the highlight and lock the highlight state
			if  RME_PLAYER_SELECTED ==  LOCAL_USER.ID then
				RME_PanelFrame_GM_ChoosePlayer_ScrollFrameHighlightFrame:SetPoint("TOPLEFT", "RME_PanelFrame_GM_ChoosePlayer_ScrollFrame_Line"..i, "TOPLEFT", 0, 0);
				RME_PanelFrame_GM_ChoosePlayer_ScrollFrameHighlightFrame_Highlight:SetVertexColor(color.r, color.g, color.b);
				RME_PanelFrame_GM_ChoosePlayer_ScrollFrameHighlightFrame_Highlight:Show();
				questTitleTag:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
				questLogTitle:LockHighlight();	
				RME_PanelFrame_GM_Players_Update_Infos()
			else
				questLogTitle:UnlockHighlight();
			end
		else
			questLogTitle:Hide();
		end
	end
	RME_DebugMsg("RME_PanelFrame_GM_Players_Update() Done !",4)	
end
function RME_PanelFrame_GM_Players_Update_Infos()
	if not RME_PLAYER_SELECTED or not RME_MISSIONID_SELECTED then
		RME_PanelFrame_GM_InfoPlayer_HTML:SetText(RME_LOCALE["RME_PANNELFRAME_NOMISSION"].text)
		return
	end
	
	local Data = RME_COMM_ADDON_USERS_LIST[RME_PLAYER_SELECTED].MissionsData[RME_MISSIONID_SELECTED]

	local Text
	Text = format(RME_LOCALE["RME_PANNELGM_TITLE"].text,RME_HTML_Replace_Tag(RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].Title))
		
	if Data.Mission_Exist then -- Mission Existe ?
		Text = Text..format(RME_LOCALE["RME_PANNELGM_MISSION_EXIST"].text,Data.Mission_Version1)
		
		if Data.Locked then --Verrouille ?
			Text = Text..RME_LOCALE["RME_PANNELFRAME_HTML_MISSION_UNAVAILABLE"].text
		else
			Text = Text..RME_LOCALE["RME_PANNELFRAME_HTML_MISSION_AVAILABLE"].text
		end

		if Data.Mission_Finish then --Termin ?
			Text = Text..RME_LOCALE["RME_PANNELFRAME_HTML_MISSION_PLAYER_UNAVAILABLE_COMPLETED"].text
		else
			-- En cours ?
			if Data.Mission_InProgress then
				-- En cours  la version x? 
				if Data.Mission_Version2 < RME_MISSIONS_LIST[RME_MISSIONID_SELECTED].Version then
					Text = Text..RME_LOCALE["RME_PANNELFRAME_HTML_MISSION_PLAYER_INPROGRESS_EXPIRED"].text
				else
					Text = Text..RME_LOCALE["RME_PANNELFRAME_HTML_MISSION_PLAYER_INPROGRESS"].text
				end
				
				-- Statut de la mission
				local statut = ""
				if Data.MissionData_MissionFailed then
					statut = " [|cFFFF1100"..FAILED.."|r]"
				
				elseif Data.MissionData_MissionSuccess then --Termine
					statut = " [|cFF11FF00"..COMPLETE.."|r]"
						
				elseif Data.MissionData_MissionCompleted then --Clotur
					statut = " [|cFF11FF00"..RME_LOCALE["RME_FINISHED"].text.."|r]"
				
				elseif Data.MissionData_MissionInProgress then
					statut = " ["..RME_LOCALE["RME_IN_PROGRESS"].text.."|r]"
					
				end
				
				-- Statut du Timer
				if Data.MissionData_Timer then
					local temp = Data.MissionData_Timer - (time() - Data.LastUpdate)
					if temp > 0 then
						Text = Text..format(RME_LOCALE["RME_PANNELGM_MISSION_TIMER"].text,SecondsToTime(temp))
					else
						Text = Text..format(RME_LOCALE["RME_PANNELGM_MISSION_TIMER"].text,"?")
					end
					
				end
				
				local temp = ""
				for i = 1, #Data.MissionData_Objectives do
					temp = temp.."|cFFFFFFFF"..RME_HTML_Replace_Tag(Data.MissionData_Objectives[i]).."|r<br/>"
				end
				Text = Text..format(RME_LOCALE["RME_PANNELGM_MISSION_OBJECTIVE"].text,statut,temp)
			
			else -- Disponible mais pas lance
				Text = Text..RME_LOCALE["RME_PANNELFRAME_HTML_MISSION_PLAYER_NOTINPROGRESS"].text
			end
		end
	else
		Text = Text..RME_LOCALE["RME_PANNELGM_MISSION_NOT_EXIST"].text
	end

	Text = Text.."</p></body></html>"

	RME_PanelFrame_GM_InfoPlayer_HTML:SetText(Text)
end
function RME_PanelFrame_GM_Players_Update_Listing()
	RME_PARTY_PLAYERS = {}
	if GetNumRaidMembers() > 0 then -- On est dans un raid
		for i=1, 40 do
			local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(i);
			if name then
				if string.find(name, "-") then
					local name, Server = strsplit("-", name)
				end
				if RME_COMM_ADDON_USERS_LIST[RME_Translate_To_UTF8(name)] then
					if RME_COMM_ADDON_USERS_LIST[RME_Translate_To_UTF8(name)].Version < 134  then
						-- Impossible
					else
						table.insert(RME_PARTY_PLAYERS,#RME_PARTY_PLAYERS+1,RME_Translate_To_UTF8(name))		
					end
				end
			end
		end	
	elseif GetNumPartyMembers() > 0 then -- on est dans un groupe
		table.insert(RME_PARTY_PLAYERS,#RME_PARTY_PLAYERS+1,RME_PLAYER_INFO.Name)
		for i=1, MAX_PARTY_MEMBERS, 1 do
			if ( GetPartyMember(i) ) then
				if RME_COMM_ADDON_USERS_LIST[RME_Translate_To_UTF8(UnitName("party"..i))] then
					if RME_COMM_ADDON_USERS_LIST[RME_Translate_To_UTF8(UnitName("party"..i))].Version < 134  then
					-- Impossible
					else
						table.insert(RME_PARTY_PLAYERS,#RME_PARTY_PLAYERS+1,RME_Translate_To_UTF8(UnitName("party"..i)))
					end
				end
			end
		end
	else
		--table.insert(RME_PARTY_PLAYERS,#RME_PARTY_PLAYERS+1,RME_PLAYER_INFO.Name)
	end
		
end	
function RME_PanelFrame_GM_ChoosePlayer_DropDownMissionList_OnClick()
	RME_DebugMsg("RME_PanelFrame_GM_ChoosePlayer_DropDownMissionList()"..tostring(this:GetID()),4)	
	UIDropDownMenu_SetSelectedID(RME_PanelFrame_GM_ChoosePlayer_DropDownMissionList, this:GetID());
	if this:GetID() == 1 then
		-- Pas de mission
		RME_MISSION_EDITION.NeedMissionID = nil
	elseif this:GetID() == 2 then
		-- On selectionne la mission
		RME_PanelFrame_Mission_Select("SELECT_GM_MISSION_MISSIONID")
	end
end
--[[RME_QuestEditorFrame_SelectItemTexture]]--
function RME_QuestEditorFrame_SelectItemTexture_OnLoad()
	tinsert(UISpecialFrames,this:GetName());
	RME_QuestEditorFrame_SelectItemTexture_Title:SetText(RME_LOCALE['RME_LOCALE_ITEM_TEXTURE'].text)
	
	RME_IMAGE_LIST_MAINCAT = "INVENTORY"
	RME_IMAGE_LIST_SUBCAT = "DEFAULT"
	
	RME_QuestEditorFrame_SelectItemTexture_MainCatDropDownMenu = CreateFrame("Frame", "RME_QuestEditorFrame_SelectItemTexture_MainCatDropDownMenu", RME_QuestEditorFrame_SelectItemTexture, "UIDropDownMenuTemplate"); 
	RME_QuestEditorFrame_SelectItemTexture_MainCatDropDownMenu:SetPoint("TOPLEFT","RME_QuestEditorFrame_SelectItemTexture","TOPLEFT",20,-30); 
	UIDropDownMenu_SetWidth(150, RME_QuestEditorFrame_SelectItemTexture_MainCatDropDownMenu) 
	UIDropDownMenu_SetButtonWidth(20, RME_QuestEditorFrame_SelectItemTexture_MainCatDropDownMenu)
	UIDropDownMenu_Initialize(RME_QuestEditorFrame_SelectItemTexture_MainCatDropDownMenu, RME_QuestEditorFrame_SelectItemTexture_MainCatDropDownMenu_Initialise); 
	
	-- SubCat
	RME_QuestEditorFrame_SelectItemTexture_SubCatDropDownMenu = CreateFrame("Frame", "RME_QuestEditorFrame_SelectItemTexture_SubCatDropDownMenu", RME_QuestEditorFrame_SelectItemTexture, "UIDropDownMenuTemplate"); 
	RME_QuestEditorFrame_SelectItemTexture_SubCatDropDownMenu:SetPoint("TOPLEFT","RME_QuestEditorFrame_SelectItemTexture_MainCatDropDownMenu","TOPRIGHT",0,0);
	UIDropDownMenu_SetWidth(280, RME_QuestEditorFrame_SelectItemTexture_SubCatDropDownMenu) 
	UIDropDownMenu_SetButtonWidth(20, RME_QuestEditorFrame_SelectItemTexture_SubCatDropDownMenu) 
	UIDropDownMenu_Initialize(RME_QuestEditorFrame_SelectItemTexture_SubCatDropDownMenu, RME_QuestEditorFrame_SelectItemTexture_SubCatDropDownMenu_Initialise);
	
	
end
function RME_QuestEditorFrame_SelectItemTexture_MainCatDropDownMenu_Initialise()
	local MAINCAT
	for MAINCAT in pairs(RME_IMAGE_LIST) do 
		
		local info = nil
		info = UIDropDownMenu_CreateInfo(); 
		info.text = MAINCAT; 													
		info.value = MAINCAT; 													
		info.func = RME_QuestEditorFrame_SelectItemTexture_MainCatDropDownMenu_OnClick
		info.owner = this:GetParent(); 											
		if RME_IMAGE_LIST_MAINCAT == MAINCAT then
			info.checked = true; 														
		else
			info.checked = false; 														
		end
		info.icon = nil 															
		info.notCheckable = false
		UIDropDownMenu_AddButton(info, level);									
		
	end
end
function RME_QuestEditorFrame_SelectItemTexture_MainCatDropDownMenu_OnClick()
	UIDropDownMenu_SetSelectedID(RME_QuestEditorFrame_SelectItemTexture_MainCatDropDownMenu, this:GetID());
	RME_IMAGE_LIST_MAINCAT = UIDropDownMenu_GetText(RME_QuestEditorFrame_SelectItemTexture_MainCatDropDownMenu)
	RME_IMAGE_LIST_SUBCAT = "DEFAULT"
	UIDropDownMenu_Initialize(RME_QuestEditorFrame_SelectItemTexture_SubCatDropDownMenu, RME_QuestEditorFrame_SelectItemTexture_SubCatDropDownMenu_Initialise);
	RME_QuestEditorFrame_SelectItemTexture_ScrollFrame:SetVerticalScroll(0)
	FauxScrollFrame_SetOffset(RME_QuestEditorFrame_SelectItemTexture_ScrollFrame,0)
	RME_QuestEditorFrame_SelectItemTexture_Update()
end
function RME_QuestEditorFrame_SelectItemTexture_SubCatDropDownMenu_Initialise()
	local SUBCAT
	for SUBCAT in pairs(RME_IMAGE_LIST[RME_IMAGE_LIST_MAINCAT]) do 
		local info = nil
		info = UIDropDownMenu_CreateInfo(); 
		info.text = SUBCAT; 													
		info.value = SUBCAT; 												
		info.func = RME_QuestEditorFrame_SelectItemTexture_SubCatDropDownMenu_OnClick; 		
		info.owner = this:GetParent(); 											
		if RME_IMAGE_LIST_SUBCAT == SUBCAT then
			info.checked = true; 												
		else
			info.checked = false; 									
		end
		info.icon = nil 											
		info.notCheckable = false
		UIDropDownMenu_AddButton(info, level);					
	end
end
function RME_QuestEditorFrame_SelectItemTexture_SubCatDropDownMenu_OnClick()
	UIDropDownMenu_SetSelectedID(RME_QuestEditorFrame_SelectItemTexture_SubCatDropDownMenu, this:GetID());
	RME_IMAGE_LIST_SUBCAT = UIDropDownMenu_GetText(RME_QuestEditorFrame_SelectItemTexture_SubCatDropDownMenu)
	UIDropDownMenu_SetSelectedValue(RME_QuestEditorFrame_SelectItemTexture_SubCatDropDownMenu,RME_IMAGE_LIST_SUBCAT)
	RME_QuestEditorFrame_SelectItemTexture_ScrollFrame:SetVerticalScroll(0)
	FauxScrollFrame_SetOffset(RME_QuestEditorFrame_SelectItemTexture_ScrollFrame,0)
	RME_QuestEditorFrame_SelectItemTexture_Update()
end
function RME_QuestEditorFrame_SelectItemTexture_OnShow()
	-- On cache l'diteur
	if  RME_PanelFrame:IsShown() then
		HideUIPanel(RME_PanelFrame);
	end		
	RME_QuestEditorFrame_SelectItemTexture_Update()
	PlaySound("igCharacterInfoOpen");
end
function RME_QuestEditorFrame_SelectItemTexture_OnHide()
	-- On reaffiche l'diteur
	--RME_QuestEditorFrame:Show()
	RME_PanelFrame:Show()
end
function RME_QuestEditorFrame_SelectItemTexture_Button_OnLoad()
	this.TextureID = nil
end
function RME_QuestEditorFrame_SelectItemTexture_Button_OnClick()
	RME_DebugMsg("RME_QuestEditorFrame_SelectItemTexture_Button_OnClick() TextureID="..tostring(this.TextureID),4)	
	if this.TextureID then
		RME_QuestEditorFrame_SelectItemTexture_BigTexture:SetNormalTexture(this.TextureID)
		RME_QuestEditorFrame_SelectItemTexture_BigTexture:SetPushedTexture(this.TextureID)
		RME_QuestEditorFrame_Item_Image:SetNormalTexture(this.TextureID)
		RME_QuestEditorFrame_Item_Image:SetPushedTexture(this.TextureID)
		RME_MISSION_EDITION.MissionItemsList[RME_EDITOR_ITEM_ID].Texture = this.TextureID
		RME_MISSION_EDITION.NeedSave = true
		RME_QUESTEDITORFRAME_SELECTITEMTEXTURE = this.TextureID
		RME_QuestEditorFrame_SelectItemTexture_Update()
	end
end
function RME_QuestEditorFrame_SelectItemTexture_Update()

	UIDropDownMenu_SetText(RME_IMAGE_LIST_MAINCAT,RME_QuestEditorFrame_SelectItemTexture_MainCatDropDownMenu)			
	UIDropDownMenu_SetText(RME_IMAGE_LIST_SUBCAT,RME_QuestEditorFrame_SelectItemTexture_SubCatDropDownMenu)			

	local i, item, texture, idx
	local offset = FauxScrollFrame_GetOffset(RME_QuestEditorFrame_SelectItemTexture_ScrollFrame)

	FauxScrollFrame_Update(RME_QuestEditorFrame_SelectItemTexture_ScrollFrame, ceil(#RME_IMAGE_LIST[RME_IMAGE_LIST_MAINCAT][RME_IMAGE_LIST_SUBCAT] / 15) ,5, 35 )
	
	for i=1,75 do
		item = getglobal("RME_QuestEditorFrame_SelectItemTexture_Icon"..i)
		idx = (offset*15) + i
		if idx<=#RME_IMAGE_LIST[RME_IMAGE_LIST_MAINCAT][RME_IMAGE_LIST_SUBCAT] then
			local texture = RME_IMAGE_LIST[RME_IMAGE_LIST_MAINCAT][RME_IMAGE_LIST_SUBCAT][idx]
			item.TextureID = texture
			item:SetNormalTexture(texture)
			item:SetPushedTexture(texture)
			if RME_QUESTEDITORFRAME_SELECTITEMTEXTURE == texture then
				item:LockHighlight()
			else
				item:UnlockHighlight()
			end			
			item:Show()
		else
			item:Hide()
		end
	end

end
--[[RME_Minimap_Menu]]--
function RME_Minimap_Button_Button_OnLoad()
	RME_DebugMsg("RME_Minimap_Button_Button_OnLoad()",4)
	getglobal(this:GetName()):SetText(RME_LOCALE[this:GetName()].text); 
	this:SetNormalTexture(RME_LOCALE[this:GetName()].texture)
	this:SetPushedTexture(RME_LOCALE[this:GetName()].texture)
end
function RME_Minimap_Button_Button_OnClick()
	RME_DebugMsg("Minimap RME_Minimap_Button_Button_OnClick() "..tostring(this:GetID()),4);
	RME_Minimap_Menu:Hide()
	RME_Minimap_Menu_HideMenu = nil
	if this:GetID() == 1 then --Sac
		RME_BagFrame_Toggle()
		
	elseif this:GetID() == 2 then -- Journal
		RME_ToggleQuestLog()
		
	elseif this:GetID() == 3 then --Editor
		RME_PanelFrame_Toggle()
	end
end
function RME_Minimap_Button_Button_OnEnter()
	RME_Legend_OnEnter(RME_LOCALE[this:GetName()]);
	RME_Minimap_Menu_HideMenu = nil
end
function RME_Minimap_Button_Button_OnLeave()
	RME_Legend_OnLeave();
	RME_Minimap_Menu_HideMenu = true
end
function RME_Minimap_Button_IconFrame_Load()
	this:RegisterForClicks("LeftButtonUp","RightButtonUp");
	this:RegisterForDrag("LeftButton");
end
function RME_Minimap_Button_IconFrame_OnClick(button)
	RME_DebugMsg("Minimap button OnClick",4);
		
	-- On affiche le menu 
	if button == "LeftButton" then
		if RME_TARGET_INFO and RME_TARGET_INFO.IsAnNpcMission then
			RME_ToggleGossipFrame()
			return
		end
	end
	-- Left Button ou droit
	if RME_Minimap_Menu:IsShown() then
		RME_Minimap_Menu:Hide()
	else
		RME_Minimap_Menu:Show()
	end
end
function RME_Minimap_Button_DraggingFrame_OnUpdate(arg1)
	local xpos,ypos = GetCursorPosition()
	local xmin,ymin = Minimap:GetLeft(), Minimap:GetBottom()

	xpos = xmin-xpos/Minimap:GetEffectiveScale()+70
	ypos = ypos/Minimap:GetEffectiveScale()-ymin-70

	RME_CONFIG["MinimapIconPos"] = math.deg(math.atan2(ypos,xpos))
	RME_Minimap_Button_IconFrame_MoveIcon()
end
function RME_Minimap_Button_IconFrame_MoveIcon()
	RME_Minimap_Button_IconFrame:SetPoint("TOPLEFT", "Minimap", "TOPLEFT", 52-(80*cos(RME_GLOBAL_CONFIG["MinimapIconPos"] or -27)),(80*sin(RME_CONFIG["MinimapIconPos"] or -27))-52)
end
function RME_Minimap_Menu_OnShow()
	RME_Minimap_Menu_CheckFrame()
end
function RME_Minimap_Menu_OnHide()
	RME_EventManager_AddEvent("RME_Minimap_Menu_CheckFrame",1,"RME_Minimap_Menu_CheckFrame()",true)
end
function RME_Minimap_Menu_CheckFrame()
	if RME_Minimap_Menu:IsShown() then
		RME_EventManager_AddEvent("RME_Minimap_Menu_CheckFrame",2,"RME_Minimap_Menu_CheckFrame()",true)
	end
	if RME_Minimap_Menu_HideMenu then
		RME_Minimap_Menu:Hide()
		RME_Minimap_Menu_HideMenu = nil
	end
end
--[[ RME_Minimap_Button ]]--
function RME_Minimap_Button_Update()
	
	RME_PLAYER_INFO.X, RME_PLAYER_INFO.Y = GetPlayerMapPosition("player")
	RME_Minimap_Button_UpdateMiniMap()
	if WorldMapFrame:IsVisible() then
		RME_Minimap_Button_UpdateMap()
	end
	if RME_getn(RME_NPC_INTERACTION_LIST) > 0 then
		RME_EventManager_AddEvent("RME_Minimap_Button_Update",250,"RME_Minimap_Button_Update()",nil,true)	
	end
	
end
function RME_Minimap_Button_UpdateMiniMap()

	local currFrame = 1;	
	if (RME_PLAYER_INFO.MapID < 1 or RME_PLAYER_INFO.MapID > 3) or RME_PLAYER_INFO.ZoneID ~= GetCurrentMapZone() then
		for i = 1, RME_MINIMAP_MAX_MINIMAP_ICONS do
			local poi = getglobal("RME_Minimap_Button_Mini" .. i);
			poi:Hide();		
		end
		return;
	end
	for NPC_ID, LOCAL_NPC_LIST in pairs(RME_NPC_INTERACTION_LIST) do	
		LOCAL_NPC = LOCAL_NPC_LIST[1]		
		if LOCAL_NPC.MapID and LOCAL_NPC.ZoneID and not LOCAL_NPC.NPC_Hidden then
			if RME_AVAILABLE_MISSIONS_LIST[LOCAL_NPC.FromMissionID] and (RME_AVAILABLE_MISSIONS_LIST[LOCAL_NPC.FromMissionID].Locked or RME_AVAILABLE_MISSIONS_LIST[LOCAL_NPC.FromMissionID].GM_MissionLocked) then
				-- Mission verrouill, on ignore
			else
				local distFromCenter, deltax, deltay = RME_Astrolabe:ComputeMiniMapDistance(RME_PLAYER_INFO.MapID, RME_PLAYER_INFO.ZoneID, RME_PLAYER_INFO.X, RME_PLAYER_INFO.Y, LOCAL_NPC.MapID, LOCAL_NPC.ZoneID, LOCAL_NPC.X, LOCAL_NPC.Y);
				if (distFromCenter) then
					local poi = getglobal("RME_Minimap_Button_Mini" .. currFrame);
					local poiTexture = getglobal("RME_Minimap_Button_Mini" .. currFrame .. "Texture");
					local inSight = false;
					if (Squeenix) then
						-- rectangular map
						inSight = abs(deltax) < 64 and abs(deltay) < 64;
					else
						inSight = distFromCenter <= 56.5;
					end
					if (inSight) then
						-- On calcul quel icone montrer
						local texture,color = RME_Minimap_Button_IconTexture(NPC_ID)
						poiTexture:SetTexture(texture);
						poiTexture:SetVertexColor(color[1],color[2],color[3])
						
						poi:SetPoint("CENTER", "Minimap", "CENTER", deltax, deltay);
						poi:Show();
						poi.unit = NPC_ID;
						currFrame = currFrame + 1;
					elseif (distFromCenter < 400) then
						local roundDeltax = deltax * 56.5 / distFromCenter;
						local roundDeltay = deltay * 56.5 / distFromCenter;
						if (Squeenix) then
							if (deltax > 64) then 
								deltax = 64;
							elseif (deltax < -64) then
								deltax = -64;
							end

							if (deltay > 64) then 
								deltay = 64;
							elseif (deltay < -64) then
								deltay = -64;
							end
						else
							deltax = roundDeltax;
							deltay = roundDeltay;
						end					
						poiTexture:SetTexture(RME_Minimap_Button_Angle(roundDeltax, roundDeltay));
						poiTexture:SetVertexColor(1,1,1)
						
						poi:SetPoint("CENTER", "Minimap", "CENTER", deltax, deltay);
						poi:Show();
						poi.unit = NPC_ID;
						currFrame = currFrame + 1;
					end
				end
			end
		end
		-- no more than 75 players on mini map
		if (currFrame == RME_MINIMAP_MAX_MINIMAP_ICONS) then
			break;
		end
	end
	for i = currFrame, RME_MINIMAP_MAX_MINIMAP_ICONS do
		local poi = getglobal("RME_Minimap_Button_Mini" .. i);
		poi:Hide();		
	end
end
function RME_Minimap_Button_UpdateMap()
	local currFrame = 1;	
	-- there was a crash for battlegrounds (which return -1 for continent I think)
	if (RME_PLAYER_INFO.MapID < 0 or RME_PLAYER_INFO.MapID > 3) or RME_PLAYER_INFO.ZoneID ~= GetCurrentMapZone() then
		for i = 1, RME_MINIMAP_MAX_WORLDMAP_ICONS do
			local poi = getglobal("RME_Minimap_Button_Map" .. i);
			poi:Hide();		
		end
		return;
	end
	for NPC_ID, LOCAL_NPC_LIST in pairs(RME_NPC_INTERACTION_LIST) do	
		LOCAL_NPC = LOCAL_NPC_LIST[1]	
		if LOCAL_NPC.MapID and LOCAL_NPC.ZoneID and not LOCAL_NPC.NPC_Hidden then
			if RME_AVAILABLE_MISSIONS_LIST[LOCAL_NPC.FromMissionID] and (RME_AVAILABLE_MISSIONS_LIST[LOCAL_NPC.FromMissionID].Locked or RME_AVAILABLE_MISSIONS_LIST[LOCAL_NPC.FromMissionID].GM_MissionLocked) then
				-- Mission verrouill, on ignore
			else
				local mapx, mapy = RME_Astrolabe:TranslateWorldMapPosition(LOCAL_NPC.MapID, LOCAL_NPC.ZoneID, LOCAL_NPC.X, LOCAL_NPC.Y, RME_PLAYER_INFO.MapID, RME_PLAYER_INFO.ZoneID);
				if (mapx and mapy and mapx >= 0 and mapx <= 1 and mapy >= 0 and mapy <= 1) then 
					local mnX = mapx * WorldMapDetailFrame:GetWidth();
					local mnY = -mapy * WorldMapDetailFrame:GetHeight();
					local poi = getglobal("RME_Minimap_Button_Map" .. currFrame);
					local poiTexture = getglobal("RME_Minimap_Button_Map" .. currFrame .. "Texture");
					poi:SetPoint("CENTER", "WorldMapDetailFrame", "TOPLEFT", mnX, mnY);
					
					-- On calcul quel icone montrer
					local texture,color = RME_Minimap_Button_IconTexture(NPC_ID)
					poiTexture:SetTexture(texture);
					poiTexture:SetVertexColor(color[1],color[2],color[3])
					poi:Show();
					poi.unit = NPC_ID;
					currFrame = currFrame + 1;		
				end
			end
		end
		-- no more than 250 players on world map
		if (currFrame == RME_MINIMAP_MAX_WORLDMAP_ICONS) then
			break;
		end
	end
	for i = currFrame, RME_MINIMAP_MAX_WORLDMAP_ICONS do
		local poi = getglobal("RME_Minimap_Button_Map" .. i);
		poi:Hide();		
	end
end
function RME_Minimap_Button_Angle(x, y)
	local angle = asin(x / 56.5);
	if (x <= 0 and y <= 0) then
		angle = 180 - angle;
	elseif (x <= 0 and y > 0) then
		angle = 360 + angle;
	elseif (x > 0 and y >= 0) then
		angle = angle;
	else
		angle = 180 - angle;
	end
	local fileNumber = RME_Minimap_Button_Round(angle / 10) * 10;
	if (fileNumber == 360) then
		fileNumber = 0;
	end
	
	return "Interface\\Addons\\RME\\images\\MiniMapArrow" .. fileNumber;
end
function RME_Minimap_Button_Round(x)
	return floor(x + 0.5);
end
function RME_Minimap_Button_IconTexture(NPC_ID)
	--RME_NPC_INTERACTION_LIST
	
	local Mission_Available, Mission_NotAvailable, WaitMission_NotComplete, WaitMission_Complete
	local Texture = "Interface\\AddOns\\RME\\Images\\MiniMapIcon" 
	local color = { 0 , 0 , 0 }
	
	for i = 1, #RME_NPC_INTERACTION_LIST[NPC_ID] do
		local LOCAL_NPC = RME_NPC_INTERACTION_LIST[NPC_ID][i]
		if RME_IN_PROGRESS_MISSIONS_LIST[LOCAL_NPC.FromMissionID] then -- Mission en cours
			
			if RME_IN_PROGRESS_MISSIONS_LIST[LOCAL_NPC.FromMissionID].MissionSuccess then -- Mission finissable (? vert)
				WaitMission_Complete = true
			else -- Mission non termine (? gris)
				WaitMission_NotComplete = true
			end
			
		elseif RME_AVAILABLE_MISSIONS_LIST[LOCAL_NPC.FromMissionID] then -- Mission disponible
			
			if RME_AVAILABLE_MISSIONS_LIST[LOCAL_NPC.FromMissionID].Locked or RME_AVAILABLE_MISSIONS_LIST[LOCAL_NPC.FromMissionID].GM_MissionLocked then -- Mission non disponible ( ! rouge)
				Mission_NotAvailable = true
			else -- Mission disponible ( ! jaune)
				Mission_Available = true
			end
		end
	end
	-- On renvoit la texture en choisissant en 1er la plus importante
	if Mission_NotAvailable then
		Texture = "Interface\\GossipFrame\\AvailableQuestIcon"
		color = { 1 , 0 , 0 }
	end
	if WaitMission_NotComplete then
		Texture =  "Interface\\GossipFrame\\ActiveQuestIcon"
		color = { 0.5 , 0.5 , 0.5 }
	end
	if Mission_Available then
		Texture =  "Interface\\GossipFrame\\AvailableQuestIcon"
		color = { 1 , 1 , 1 }
	end	
	if WaitMission_Complete then
		Texture = "Interface\\GossipFrame\\ActiveQuestIcon"
		color = { 0 , 1 , 0 }
	end
	return Texture, color
end
function RME_Minimap_Button_ShowMiniMapToolTip()
	
	GameTooltip:SetOwner(this, "ANCHOR_BOTTOMLEFT");
	local unitButton;
	local newLineString = "";
	local tooltipText = "";
	for i=1, 25 do
		unitButton = getglobal("RME_Minimap_Button_Mini"..i);
		if ( unitButton:IsVisible() and MouseIsOver(unitButton) ) then
			tooltipText = tooltipText .. newLineString .. RME_NPC_INTERACTION_LIST[unitButton.unit][1].Name;
			newLineString = "\n";
		elseif (not unitButton:IsVisible()) then
			break;
		end
	end
	GameTooltip:SetText(tooltipText, 1.0, 0.82, 0.0, 1,1);
	GameTooltip:Show();	
end
function RME_Minimap_Button_MiniMap_OnClick()
	RME_DebugMsg("RME_Minimap_Button_MiniMap_OnClick()",4);
	local x, y = GetCursorPosition();
	x = x / Minimap:GetEffectiveScale();
	y = y / Minimap:GetEffectiveScale();

	local cx, cy = Minimap:GetCenter();
	x = x + CURSOR_OFFSET_X - cx;
	y = y + CURSOR_OFFSET_Y - cy;
	Minimap:PingLocation(x, y);	
end
function RME_Minimap_Button_ShowWorldMapToolTip()
	-- determine tooltip anchor
	local x, y = this:GetCenter();
	local parentX, parentY = this:GetParent():GetCenter();
	if ( x > parentX ) then
		WorldMapTooltip:SetOwner(this, "ANCHOR_LEFT");
	else
		WorldMapTooltip:SetOwner(this, "ANCHOR_RIGHT");
	end	
	local unitButton;
	local newLineString = "";
	local tooltipText = "";
	for i=1, 250 do
		unitButton = getglobal("RME_Minimap_Button_Map"..i);
		if ( unitButton:IsVisible() and MouseIsOver(unitButton) ) then
		
			if RME_NPC_INTERACTION_LIST[unitButton.unit] then
				if RME_NPC_INTERACTION_LIST[unitButton.unit][1] then
					tooltipText = tooltipText .. newLineString .. RME_NPC_INTERACTION_LIST[unitButton.unit][1].Name;
					newLineString = "\n";
				else
					RME_Minimap_Button_UpdateMap()
				end
			else
				RME_Minimap_Button_UpdateMap()
			end
		elseif (not unitButton:IsVisible()) then
			break;
		end
	end
	WorldMapTooltip:SetText(tooltipText, 1.0, 0.82, 0.0, 1,1);
	WorldMapTooltip:Show();
end
--[[ RME_QuestFrame]]--
function RME_QuestFrame_OnLoad()
	RME_DebugMsg("RME_QuestFrame_OnLoad()",4)
	RME_QuestFrameIgnoreButton:SetText(RME_LOCALE["RME_LOCALE_MISSION_IGNORE_BUTTON"].text);
end 
function RME_QuestFrame_OnEvent(event)
end
function RME_QuestFrame_OnShow()

	RME_DebugMsg("RME_QuestFrame_OnShow()",4)	
	if ( UnitExists("npc") ) then
		RME_QuestFrameNpcNameText:SetText(UnitName("npc"));
		SetPortraitTexture(RME_QuestFramePortrait, "npc");
	elseif (UnitExists("target") ) then
		RME_QuestFrameNpcNameText:SetText(UnitName("target"));
		SetPortraitTexture(RME_QuestFramePortrait, "target");
	else
		RME_QuestFrameNpcNameText:SetText("Mission");
		RME_QuestFramePortrait:SetTexture("Interface\\QuestFrame\\UI-QuestLog-BookIcon");
	end	
	if  RME_GossipFrame:IsShown() then
		HideUIPanel(RME_GossipFrame);
	end
	RME_QuestFrame_CheckDistance()
end
function RME_QuestFrame_CheckDistance()
	-- On regarde 
	if not UnitExists("npc") and not UnitExists("target") then
		return
	end
	if not CheckInteractDistance("target", 2) then
		RME_QuestFrame:Hide()
	end
	if RME_QuestFrame:IsShown() then
		RME_EventManager_AddEvent("RME_QuestFrame_CheckDistance",1,"RME_QuestFrame_CheckDistance()",true)
	end
end
function RME_QuestFrame_OnHide()

	--RME_QuestFrameDetailPanel:Hide()
	--RME_QuestFrameRewardPanel:Hide()
	--RME_QuestFrameRewardPanel:Hide()
	
	if RME_getn(RME_PLAYER_WAIT_MISSIONID) > 0 then -- On regarde si on a une mission en attente d'affichage
		RME_QuestFrame_ShowMissionDetails()
	end
	PlaySound("igQuestListClose");
end
	--[[DETAIL-- (Proposition de la mission]]--
	function RME_QuestFrame_ShowMissionDetails(MISSION_ID)
		RME_DebugMsg("RME_QuestFrame_ShowMissionDetails("..tostring(MISSION_ID)..")",4)	

		-- On souhaite afficher la fenetre de proposition de mission (accepter, refuser)
		-- on regarde d'abord si il n'y a pas dja une fenetre affich
		if RME_QuestFrame:IsShown() and MISSION_ID then
			-- Dja affich, on enregistre la demande d'affichage et on la met en attente
			RME_PLAYER_WAIT_MISSIONID[MISSION_ID] = "WAIT_SHOW"
			return
		end
		
		if not MISSION_ID then
			-- Si on a pas de mission ID fournit c'est qu'on vient de fermer la fenetre RME_QuestFrameDetailPanel
			-- On regarde donc si il n'y a pas une mission a afficher
			local MISSION_ID, LOCAL_TAG
			for MISSION_ID,LOCAL_TAG in pairs(RME_PLAYER_WAIT_MISSIONID) do
				if RME_PLAYER_WAIT_MISSIONID[MISSION_ID] == "WAIT_SHOW" then
					-- On affiche cette mission
					RME_QuestFrame_ShowMissionDetails(MISSION_ID)
					RME_PLAYER_WAIT_MISSIONID[MISSION_ID] = nil
				end
			end
			return
		end
		
		if MISSION_ID then -- La fenetre n'est pas visible, pas d'attente donc >> on affiche
			RME_QUESTFRAME_MISSION_ID = MISSION_ID
			RME_QuestFrameProgressPanel:Hide()
			RME_QuestFrameRewardPanel:Hide()
			RME_QuestFrameDetailPanel:Show()
			RME_QuestFrame:Show()			
		end
		
	end
	function RME_QuestFrameDetailPanel_OnShow()
		PlaySound("igQuestListOpen");
		--On rcupere la mission
		local LOCAL_MISSION = RME_MISSIONS_LIST[RME_QUESTFRAME_MISSION_ID]
		
		-- Bouton Ignore
		if not LOCAL_MISSION.IsIgnore then
			RME_QuestFrameIgnoreButton:Show()
		else
			RME_QuestFrameIgnoreButton:Hide()
		end
		
		-- Titre
		RME_QuestTitleText:SetText(LOCAL_MISSION.Title)
		-- Description
		RME_QuestDescription:SetText(RME_Replace_Text(LOCAL_MISSION.MissionText_Description))
		-- Objectif
		RME_QuestObjectiveText:SetText(RME_Replace_Text(LOCAL_MISSION.MissionText_Objective).."\n\n ")
		
		-- Y a t il une rcompense ? (reward choice et/ou reward)
		if (#LOCAL_MISSION.MissionRewardChoice + #LOCAL_MISSION.MissionReward) > 0   then
			
			-- texte rcompense
			RME_QuestDetailRewardTitleText:Show()
			
			--[[MissionRewardChoice]]--
			-- Affichage des rcompenses slectionnables (normalement au moins 2)
			if #LOCAL_MISSION.MissionRewardChoice > 0 then
				-- On propose aux joueurs de choisir sa rcompense, on affiche donc la phrase
				RME_QuestDetailItemChooseText:Show()
				RME_QuestLogFrame_SetAsLastShown(RME_QuestDetailItemChooseText,RME_QuestSpacerFrame)			
					
				-- On place le 1er item sous la phrase de choix
				RME_QuestDetailItem1:SetPoint("TOPLEFT", "RME_QuestDetailItemChooseText", "BOTTOMLEFT", 0, -10);
					
				
				-- On boucle sur la liste des items "choix"
				for i = 1, #LOCAL_MISSION.MissionRewardChoice do
					-- On charge l'item
					local LOCAL_ITEM = LOCAL_MISSION.MissionItemsList[LOCAL_MISSION.MissionRewardChoice[i]]
					-- On met a jour l'affichage
					local questItem = getglobal("RME_QuestDetailItem"..i);
					questItem.type = "reward"			-- Sera utilis pour la gestion de l'objet (clic, etc)
					questItem.LOCAL_ITEM = LOCAL_ITEM
					-- Mise a jour affichage
					getglobal("RME_QuestDetailItem"..i.."Name"):SetText(LOCAL_ITEM.Name);
					getglobal("RME_QuestDetailItem"..i.."IconTexture"):SetTexture(LOCAL_ITEM.Texture);
					if LOCAL_ITEM.Quantity > 1 then
						getglobal("RME_QuestDetailItem"..i.."Count"):SetText(tostring(LOCAL_ITEM.Quantity));
					else
						getglobal("RME_QuestDetailItem"..i.."Count"):SetText("");
					end
					
					---LOCAL_MISSION.MissionRewardChoice[i]:isUsable()
					-- L'utilisateur saura l'utiliser ?
					if (true) then
						SetItemButtonTextureVertexColor(questItem, 1.0, 1.0, 1.0);
						SetItemButtonNameFrameVertexColor(questItem, 1.0, 1.0, 1.0);
					else
						SetItemButtonTextureVertexColor(questItem, 0.9, 0, 0);
						SetItemButtonNameFrameVertexColor(questItem, 0.9, 0, 0);
					end
					-- Placement (ils sont affichs 2 par ligne		
					if ( i > 1 ) then
						if ( mod(i,2) == 1 ) then
							questItem:SetPoint("TOPLEFT", "RME_QuestDetailItem"..(i - 2), "BOTTOMLEFT", 0, -2);
						else
							questItem:SetPoint("TOPLEFT", "RME_QuestDetailItem"..(i - 1), "TOPRIGHT", 1, 0);
						end
					else
						questItem:SetPoint("TOPLEFT", "RME_QuestDetailItemChooseText", "BOTTOMLEFT", -3, -5);
					end
					-- On affiche l'item
					questItem:Show();
					RME_QuestLogFrame_SetAsLastShown(questItem, RME_QuestSpacerFrame);
					
					-- Erase suite a bug
					LOCAL_ITEM = nil
				end
			else
				-- Pas de rcompense slectionnable, on cache la phrase
				RME_QuestDetailItemChooseText:Hide()				
			end
			
			--[[MissionReward]]--
			if ( table.getn(LOCAL_MISSION.MissionReward) > 0  ) then
				-- On annonce au joueurs qu'il recevra de(s) objet(s)
				-- Mais suivant si il y a eu ou non des choix de rcompense (au dessus) la phrase change
				if table.getn(LOCAL_MISSION.MissionRewardChoice) > 0 then
					-- Il y a eu des rcompenses a choisir, on met a jour le texte en consquence et on s'accroche donc en dessous du dernier objectif (derniere ligne, cot gauche)
					RME_QuestDetailItemReceiveText:SetText(REWARD_ITEMS);
						-- Calcul du numro d'objectif se trouvant a la derniere ligne a gauche
						local index = table.getn(LOCAL_MISSION.MissionRewardChoice);
						if ( mod(index, 2) == 0 ) then
							index = index - 1;
						end
						RME_QuestDetailItemReceiveText:SetPoint("TOPLEFT", "RME_QuestDetailItem"..index, "BOTTOMLEFT", 3, -5);
				else
					-- il n'y a que ces rcompenses, on met a jour le texte et on s'accroche donc a la suite du titre "recompense"
					RME_QuestDetailItemReceiveText:SetText(REWARD_ITEMS_ONLY);
					RME_QuestDetailItemReceiveText:SetPoint("TOPLEFT", "RME_QuestDetailRewardTitleText", "BOTTOMLEFT", 3, -5);
					
				end
				-- On affiche a prsent le bon texte
				RME_QuestDetailItemReceiveText:Show();
				RME_QuestLogFrame_SetAsLastShown(RME_QuestDetailItemReceiveText, RME_QuestSpacerFrame);
				
				-- On boucle sur la liste des items "rcompense"
				for i=1, table.getn(LOCAL_MISSION.MissionReward), 1 do
					-- On charge l'item
					local LOCAL_ITEM = LOCAL_MISSION.MissionItemsList[LOCAL_MISSION.MissionReward[i]]
					index = i + table.getn(LOCAL_MISSION.MissionRewardChoice) -- On utilise le 1er item non utilis
					local questItem = getglobal("RME_QuestDetailItem"..index);
					questItem.type = "reward"			-- Sera utilis pour la gestion de l'objet (clic, etc)
					questItem.LOCAL_ITEM = LOCAL_ITEM
					-- Mise a jour affichage
					getglobal("RME_QuestDetailItem"..index.."Name"):SetText(LOCAL_ITEM.Name);
					getglobal("RME_QuestDetailItem"..index.."IconTexture"):SetTexture(LOCAL_ITEM.Texture);
					if LOCAL_ITEM.Quantity > 1 then
						getglobal("RME_QuestDetailItem"..index.."Count"):SetText(tostring(LOCAL_ITEM.Quantity));
					else
						getglobal("RME_QuestDetailItem"..index.."Count"):SetText("");
					end
					-- L'utilisateur saura l'utiliser ?
					--LOCAL_MISSION.MissionReward[i]:isUsable()
					if (true) then
						SetItemButtonTextureVertexColor(questItem, 1.0, 1.0, 1.0);
						SetItemButtonNameFrameVertexColor(questItem, 1.0, 1.0, 1.0);
					else
						SetItemButtonTextureVertexColor(questItem, 0.9, 0, 0);
						SetItemButtonNameFrameVertexColor(questItem, 0.9, 0, 0);
					end
					-- Placement (ils sont affichs 2 par ligne		
					if ( i >  1 ) then
						if ( mod(i,2) == 1 ) then
							questItem:SetPoint("TOPLEFT", "RME_QuestDetailItem"..(index - 2), "BOTTOMLEFT", 0, -2);
						else
							questItem:SetPoint("TOPLEFT", "RME_QuestDetailItem"..(index - 1), "TOPRIGHT", 1, 0);
						end
					else
						questItem:SetPoint("TOPLEFT", "RME_QuestDetailItemReceiveText", "BOTTOMLEFT", -3, -5);
					end
					-- On affiche l'item
					questItem:Show();
					RME_QuestLogFrame_SetAsLastShown(questItem, RME_QuestSpacerFrame);
					-- Erase suite a bug
					LOCAL_ITEM = nil
				end -- End for
				
			else
				-- Pas de rcompense slectionnable, on cache la phrase
				RME_QuestDetailItemReceiveText:Hide()				
			end
			
			-- On cache les item non utiliss
			for i=tonumber(table.getn(LOCAL_MISSION.MissionReward) + table.getn(LOCAL_MISSION.MissionRewardChoice) + 1), RME_MAX_ITEMS, 1 do
				getglobal("RME_QuestDetailItem"..i):Hide();
			end
			
		else
			-- Pas de rcompenses du tout pour cette mission, on cache tout
			RME_QuestDetailRewardTitleText:Hide()
			RME_QuestDetailItemReceiveText:Hide()
			RME_QuestDetailItemChooseText:Hide()

			for i=tonumber(table.getn(LOCAL_MISSION.MissionReward) + table.getn(LOCAL_MISSION.MissionRewardChoice) + 1), RME_MAX_ITEMS, 1 do
				getglobal("RME_QuestDetailItem"..i):Hide();
			end
		end
		
		if RME_QuestDetailScrollFrame:GetVerticalScrollRange() > 0 then
			RME_QuestDetailScrollFrame:SetVerticalScroll(0);
		end
	end
	function RME_QuestDetailDeclineButton_OnClick()
		RME_QuestFrame:Hide()
	end
	function RME_QuestDetailAcceptButton_OnClick()
		RME_QuestFrame:Hide()
		RME_QuestFrame_CheckDistance()
		RME_Take_Mission(RME_QUESTFRAME_MISSION_ID)
		-- Si la mission que l'on vient de prendre est dja termine on regarde si le pnj - qui vient de me donner cette mission - termine aussi cette mission
		--Auquel cas on raffiche directement la suite du texte pour terminer la mission sans obliger l'utilisateur a recliquer sur le bouton rme
		if RME_IN_PROGRESS_MISSIONS_LIST[RME_QUESTFRAME_MISSION_ID] and RME_IN_PROGRESS_MISSIONS_LIST[RME_QUESTFRAME_MISSION_ID].MissionSuccess and RME_TARGET_INFO.Name and RME_NPC_INTERACTION_LIST[string.lower(RME_TARGET_INFO.Name)] then
			-- On rcupere rapidement 
			for i= 1, #RME_NPC_INTERACTION_LIST[string.lower(RME_TARGET_INFO.Name)] do
				local LOCAL_NPC = RME_NPC_INTERACTION_LIST[string.lower(RME_TARGET_INFO.Name)][i]
				if LOCAL_NPC.FromMissionID == RME_QUESTFRAME_MISSION_ID and LOCAL_NPC.EndMission then
					RME_QuestFrame_ShowMissionProgress(RME_QUESTFRAME_MISSION_ID)
					return
				end
			end
		end
	end
	function RME_QuestFrameIgnoreButton_OnClick(force)
		if not force then
			StaticPopup_Show("RME_CONFIRM_IGNORE_MISSION") 	
			return
		end
		-- On ignore cette mission
		if RME_MISSIONS_LIST[RME_QUESTFRAME_MISSION_ID] then
			RME_MISSIONS_LIST[RME_QUESTFRAME_MISSION_ID].IsIgnore = true
			RME_Mega_Update(true)
		end
		RME_QuestFrame:Hide()
	end
	--[[ PROGRESS -- Attente objectif / validation objectif ]]--
	function RME_QuestFrame_ShowMissionProgress(MISSION_ID)
	RME_DebugMsg("RME_QuestFrame_ShowMissionProgress("..tostring(MISSION_ID)..")",4)	
		RME_QUESTFRAME_MISSION_ID = MISSION_ID
		RME_QuestFrameDetailPanel:Hide()
		RME_QuestFrameRewardPanel:Hide()
		RME_QuestFrameProgressPanel:Show()
		RME_QuestFrame:Show()
	end
	function RME_QuestFrameProgressPanel_OnShow()
		--On rcupere la mission
		PlaySound("igQuestListOpen");
		local LOCAL_MISSION = RME_IN_PROGRESS_MISSIONS_LIST[RME_QUESTFRAME_MISSION_ID]
		-- Titre
		RME_QuestProgressTitleText:SetText(LOCAL_MISSION.Title)
		-- Bouton Continuer (il faut avoir russi tout les objetctifs)
		if LOCAL_MISSION.MissionSuccess then
			RME_QuestFrameCompleteButton:Enable()
		else
			RME_QuestFrameCompleteButton:Disable()	
		end

		local RequiredItemText = ""
		local NbItem = 0
		for i=1,table.getn(LOCAL_MISSION.MissionObjectives) do
			local LOCAL_OBJECTIVE=LOCAL_MISSION.MissionObjectives[i]; -- LOCAL_EVENT est du style RME_CLASS_EVENTMANAGER
			
			if LOCAL_OBJECTIVE.ObjectiveType == "NEED_ITEM" then
				NbItem = NbItem + 1
				local LOCAL_ITEM = LOCAL_MISSION.MissionItemsList[LOCAL_MISSION.MissionObjectives[i].Need_Item_ItemNeeded]
				-- On met a jour la quantit d'objet (pour viter de finir une mission demandant un objet alors que celui ci a tait supprim entre temps
				local Quantity = 0
				local	ObjetExist, Quantity, Position = RME_Bag_ItemCount(LOCAL_ITEM)
				LOCAL_OBJECTIVE.Need_Item_QuantityInBag = Quantity				
				local requiredItem = getglobal("RME_QuestProgressItem"..NbItem);
				requiredItem.type = "required"
				requiredItem.LOCAL_ITEM = LOCAL_ITEM
				-- Mise a jour affichage
				getglobal("RME_QuestProgressItem"..NbItem.."Name"):SetText(LOCAL_ITEM.Name);
				getglobal("RME_QuestProgressItem"..NbItem.."IconTexture"):SetTexture(LOCAL_ITEM.Texture);
				
				if LOCAL_MISSION.MissionObjectives[i].Need_Item_QuantityNeeded > 1 then
					getglobal("RME_QuestProgressItem"..NbItem.."Count"):SetText(tostring(LOCAL_MISSION.MissionObjectives[i].Need_Item_QuantityNeeded));
				else
					getglobal("RME_QuestProgressItem"..NbItem.."Count"):SetText("");
				end

				-- Le joueur a t il tout rcolt ?
				if LOCAL_OBJECTIVE.Need_Item_QuantityInBag >= LOCAL_OBJECTIVE.Need_Item_QuantityNeeded then
					-- oui 				
					SetDesaturation(getglobal("RME_QuestProgressItem"..NbItem.."IconTexture"), nil)				
				else
					-- non
					SetDesaturation(getglobal("RME_QuestProgressItem"..NbItem.."IconTexture"), 1)			
					RME_QuestFrameCompleteButton:Disable()					
				end
				
				requiredItem:Show()
			else
				RequiredItemText = RequiredItemText.."   "..LOCAL_OBJECTIVE:ObjectiveStatus(LOCAL_MISSION).."\n"
			end
		end
		
		-- On cache le reste
		for i=NbItem + 1,10 do
			local requiredItem = getglobal("RME_QuestProgressItem"..i);
			requiredItem:Hide()
		end
		if NbItem == 0 then
			RME_QuestProgressRequiredItemsText:Hide()
		else
			RME_QuestProgressRequiredItemsText:Show()
		end

		--QuestProgress
		if RequiredItemText ~= "" then
			RME_QuestProgressText:SetText(RME_Replace_Text(LOCAL_MISSION.MissionText_InProgress).."\n\n"..RME_LOCALE["RME_LOCALE_QUEST_YOUMUST"].text.."\n\n"..RequiredItemText)
		else
			RME_QuestProgressText:SetText(RME_Replace_Text(LOCAL_MISSION.MissionText_InProgress))	
		end
		
		if RME_QuestProgressScrollFrame:GetVerticalScrollRange() > 0 then
			RME_QuestProgressScrollFrame:SetVerticalScroll(0);
		end
		
	end
	function RME_QuestGoodbyeButton_OnClick()
		RME_QuestFrame:Hide()
	end
	function RME_QuestProgressCompleteButton_OnClick()
		RME_QuestFrame_ShowMissionRewards(RME_QUESTFRAME_MISSION_ID)
		RME_QuestFrame_CheckDistance()
	end
	--[[ REWARD -- Fin de la mission, rcompense ]]--
	function RME_QuestFrame_ShowMissionRewards(MISSION_ID)
		RME_DebugMsg("RME_QuestFrame_ShowMissionRewards("..tostring(MISSION_ID)..")",4)	
		RME_QUESTFRAME_MISSION_ID = MISSION_ID
		RME_QuestFrameDetailPanel:Hide()
		RME_QuestFrameProgressPanel:Hide()
		RME_QuestFrameRewardPanel:Show()
		RME_QuestFrame:Show()
	end
	function RME_QuestFrameRewardPanel_OnShow()
		PlaySound("igQuestListOpen");
		--On rcupere la mission
		local LOCAL_MISSION = RME_IN_PROGRESS_MISSIONS_LIST[RME_QUESTFRAME_MISSION_ID]
		-- Titre
		RME_QuestRewardTitleText:SetText(LOCAL_MISSION.Title)
		-- Texte Rcompense // success
		RME_QuestRewardText:SetText(RME_Replace_Text(LOCAL_MISSION.MissionText_Success))
		
		-- Y a t il une rcompense ? (reward choice et/ou reward)
		if (table.getn(LOCAL_MISSION.MissionRewardChoice) + table.getn(LOCAL_MISSION.MissionReward)) > 0   then
			
			-- texte rcompense
			RME_QuestRewardRewardTitleText:Show()
			
			--[[MissionRewardChoice]]--
			-- Affichage des rcompenses slectionnables (normalement au moins 2)
			if table.getn(LOCAL_MISSION.MissionRewardChoice) > 0 then
				-- On propose aux joueurs de choisir sa rcompense, on affiche donc la phrase
				RME_QuestRewardItemChooseText:Show()
				RME_QuestLogFrame_SetAsLastShown(RME_QuestRewardItemChooseText)			
					
				-- On place le 1er item sous la phrase de choix
				RME_QuestRewardItem1:SetPoint("TOPLEFT", "RME_QuestRewardItemChooseText", "BOTTOMLEFT", 0, -10);
					
					
				-- On boucle sur la liste des items "choix"
				for i = 1, table.getn(LOCAL_MISSION.MissionRewardChoice) do
					-- On charge l'item
					local LOCAL_ITEM = LOCAL_MISSION.MissionItemsList[LOCAL_MISSION.MissionRewardChoice[i]]
					-- On met a jour l'affichage
					local questItem = getglobal("RME_QuestRewardItem"..i);
					questItem.type = "choice"			-- Sera utilis pour la gestion de l'objet (clic, etc)
					questItem.LOCAL_ITEM = LOCAL_ITEM
					-- Mise a jour affichage
					getglobal("RME_QuestRewardItem"..i.."Name"):SetText(LOCAL_ITEM.Name);
					getglobal("RME_QuestRewardItem"..i.."IconTexture"):SetTexture(LOCAL_ITEM.Texture);
					if LOCAL_ITEM.Quantity > 1 then
						getglobal("RME_QuestRewardItem"..i.."Count"):SetText(tostring(LOCAL_ITEM.Quantity));
					else
						getglobal("RME_QuestRewardItem"..i.."Count"):SetText("");
					end
					---LOCAL_MISSION.MissionRewardChoice[i]:isUsable()
					-- L'utilisateur saura l'utiliser ?
					if (true) then
						SetItemButtonTextureVertexColor(questItem, 1.0, 1.0, 1.0);
						SetItemButtonNameFrameVertexColor(questItem, 1.0, 1.0, 1.0);
					else
						SetItemButtonTextureVertexColor(questItem, 0.9, 0, 0);
						SetItemButtonNameFrameVertexColor(questItem, 0.9, 0, 0);
					end
					-- Placement (ils sont affichs 2 par ligne		
					if ( i > 1 ) then
						if ( mod(i,2) == 1 ) then
							questItem:SetPoint("TOPLEFT", "RME_QuestRewardItem"..(i - 2), "BOTTOMLEFT", 0, -2);
						else
							questItem:SetPoint("TOPLEFT", "RME_QuestRewardItem"..(i - 1), "TOPRIGHT", 1, 0);
						end
					else
						questItem:SetPoint("TOPLEFT", "RME_QuestRewardItemChooseText", "BOTTOMLEFT", -3, -5);
					end
					-- On affiche l'item
					questItem:Show();
					--RME_QuestLogFrame_SetAsLastShown(questItem, RME_QuestSpacerFrame);
					
					-- Erase suite a bug
					LOCAL_ITEM = nil
				end
			else
				-- Pas de rcompense slectionnable, on cache la phrase
				RME_QuestRewardItemChooseText:Hide()				
			end
			
			--[[MissionReward]]--
			if ( table.getn(LOCAL_MISSION.MissionReward) > 0  ) then
				-- On annonce au joueurs qu'il recevra de(s) objet(s)
				-- Mais suivant si il y a eu ou non des choix de rcompense (au dessus) la phrase change
				if table.getn(LOCAL_MISSION.MissionRewardChoice) > 0 then
					-- Il y a eu des rcompenses a choisir, on met a jour le texte en consquence et on s'accroche donc en dessous du dernier objectif (derniere ligne, cot gauche)
					RME_QuestRewardItemReceiveText:SetText(REWARD_ITEMS);
						-- Calcul du numro d'objectif se trouvant a la derniere ligne a gauche
						local index = table.getn(LOCAL_MISSION.MissionRewardChoice);
							if ( mod(index, 2) == 0 ) then
								index = index - 1;
						end
						RME_QuestRewardItemReceiveText:SetPoint("TOPLEFT", "RME_QuestRewardItem"..index, "BOTTOMLEFT", 3, -5);
				else
					-- il n'y a que ces rcompenses, on met a jour le texte et on s'accroche donc a la suite du titre "recompense"
					RME_QuestRewardItemReceiveText:SetText(REWARD_ITEMS_ONLY);
					RME_QuestRewardItemReceiveText:SetPoint("TOPLEFT", "RME_QuestRewardRewardTitleText", "BOTTOMLEFT", 3, -5);
					
				end
				-- On affiche a prsent le bon texte
				RME_QuestRewardItemReceiveText:Show();
				RME_QuestLogFrame_SetAsLastShown(RME_QuestRewardItemReceiveText, RME_QuestSpacerFrame);
				
				-- On boucle sur la liste des items "rcompense"
				for i=1, table.getn(LOCAL_MISSION.MissionReward), 1 do
					-- On charge l'item
					local LOCAL_ITEM = LOCAL_MISSION.MissionItemsList[LOCAL_MISSION.MissionReward[i]]
					index = i + table.getn(LOCAL_MISSION.MissionRewardChoice) -- On utilise le 1er item non utilis
					local questItem = getglobal("RME_QuestRewardItem"..index);
					questItem.type = "reward"			-- Sera utilis pour la gestion de l'objet (clic, etc)
					questItem.LOCAL_ITEM = LOCAL_ITEM
					-- Mise a jour affichage
					getglobal("RME_QuestRewardItem"..index.."Name"):SetText(LOCAL_ITEM.Name);
					getglobal("RME_QuestRewardItem"..index.."IconTexture"):SetTexture(LOCAL_ITEM.Texture);
					if LOCAL_ITEM.Quantity > 1 then
						getglobal("RME_QuestRewardItem"..index.."Count"):SetText(tostring(LOCAL_ITEM.Quantity));
					else
						getglobal("RME_QuestRewardItem"..index.."Count"):SetText("");
					end
					-- L'utilisateur saura l'utiliser ?
					--LOCAL_MISSION.MissionReward[i]:isUsable()
					if (true) then
						SetItemButtonTextureVertexColor(questItem, 1.0, 1.0, 1.0);
						SetItemButtonNameFrameVertexColor(questItem, 1.0, 1.0, 1.0);
					else
						SetItemButtonTextureVertexColor(questItem, 0.9, 0, 0);
						SetItemButtonNameFrameVertexColor(questItem, 0.9, 0, 0);
					end
					-- Placement (ils sont affichs 2 par ligne		
					if ( i >  1 ) then
						if ( mod(i,2) == 1 ) then
							questItem:SetPoint("TOPLEFT", "RME_QuestRewardItem"..(index - 2), "BOTTOMLEFT", 0, -2);
						else
							questItem:SetPoint("TOPLEFT", "RME_QuestRewardItem"..(index - 1), "TOPRIGHT", 1, 0);
						end
					else
						questItem:SetPoint("TOPLEFT", "RME_QuestRewardItemReceiveText", "BOTTOMLEFT", -3, -5);
					end
					-- On affiche l'item
					questItem:Show();
					RME_QuestLogFrame_SetAsLastShown(questItem, RME_QuestSpacerFrame);
					-- Erase suite a bug
					LOCAL_ITEM = nil
				end -- End for
				
			else
				-- Pas de rcompense slectionnable, on cache la phrase
				RME_QuestRewardItemReceiveText:Hide()				
			end
			
			-- On cache les item non utiliss
			for i=tonumber(table.getn(LOCAL_MISSION.MissionReward) + table.getn(LOCAL_MISSION.MissionRewardChoice) + 1), RME_MAX_ITEMS, 1 do
				getglobal("RME_QuestRewardItem"..i):Hide();
			end
			
		else
			-- Pas de rcompenses du tout pour cette mission, on cache tout
			RME_QuestRewardRewardTitleText:Hide()
			RME_QuestRewardItemChooseText:Hide()
			RME_QuestRewardItemReceiveText:Hide()
			for i=tonumber(table.getn(LOCAL_MISSION.MissionReward) + table.getn(LOCAL_MISSION.MissionRewardChoice) + 1), RME_MAX_ITEMS, 1 do
				getglobal("RME_QuestRewardItem"..i):Hide();
			end
		end
	
		-- On rinit les choix possible
		if table.getn(LOCAL_MISSION.MissionRewardChoice) > 0 then
			RME_QuestFrameCompleteQuestButton:Disable()
			RME_ITEM_CHOICE = 0
			RME_QuestRewardItemHighlight:Hide()
		else
			RME_QuestFrameCompleteQuestButton:Enable()
			RME_ITEM_CHOICE = 0
			RME_QuestRewardItemHighlight:Hide()
		end
		
		if RME_QuestRewardScrollFrame:GetVerticalScrollRange() > 0 then
			RME_QuestRewardScrollFrame:SetVerticalScroll(0);
		end

	end
	function RME_QuestRewardCancelButton_OnClick()
		RME_QuestFrame_ShowMissionProgress(RME_QUESTFRAME_MISSION_ID)
	end
	function RME_QuestRewardCompleteButton_OnClick()
	
		RME_QuestFrame:Hide()
	
		--On rcupere la mission
		local LOCAL_MISSION = RME_IN_PROGRESS_MISSIONS_LIST[RME_QUESTFRAME_MISSION_ID]
		--On finalise la fin de la mission
		RME_Completed_Mission(RME_QUESTFRAME_MISSION_ID)
		
	end
--[[ RME_QuestLogRewardItemTemplate]]
function RME_QuestLogRewardItemTemplate_OnLoad()
	this.LOCAL_ITEM = {}
	this.type = ""
	this.NextCheck = 0;	
	this.isMoving = nil
	this.isLocked = nil
	this.Cooldown = nil
	this.Cooldown_Start = nil
	this:RegisterForClicks("LeftButtonUp", "RightButtonUp");
	--this:RegisterForDrag("LeftButton");
end
function RME_QuestLogRewardItemTemplate_OnDragStart(this)
	-- verrouillage de this, Copie de this vers le buttonondrag
	--
	this:StartMoving();
	this.isMoving = true;
	
end
function RME_QuestLogRewardItemTemplate_OnDragStop(this)
	this:StopMovingOrSizing();
	this.isMoving = nil
end
function RME_QuestLogRewardItemTemplate_OnEnter()

	if ( this:GetAlpha() == 0) then
		return
	end

	if not this.LOCAL_ITEM then
		RME_DebugMsg("RME_QuestLogRewardItemTemplate_OnEnter() - Pas d'info tooltip",1)	
		return
	end
	
	-- On rcupre les info de la tooltip
	local LOCAL_ITEM =  this.LOCAL_ITEM --RME_QUESTLOG_ITEMS_DISPLAYED[this:GetID()]

	
	GameTooltip:SetOwner(this, "ANCHOR_RIGHT")
	GameTooltip:ClearLines()
	
	-- rcupration couleur de l'objet en fonction de sa qualit
	local r, g, b, hex
	r, g, b, hex = GetItemQualityColor(LOCAL_ITEM.Quality)
	
	-- Affichage
	GameTooltip:AddLine(LOCAL_ITEM.Name,r,g,b,nil)
	if LOCAL_ITEM.Description and LOCAL_ITEM.Description ~= "" then
		GameTooltip:AddLine("|cAAAAFF33"..LOCAL_ITEM.Description.."|r",1,1,1,1)
	end
	
	-- suivant le type de l'objet, on ajoute des lignes
	if LOCAL_ITEM.Type == "LETTER" and this.type == "item" then
		GameTooltip:AddLine(ITEM_READABLE,GREEN_FONT_COLOR.r,GREEN_FONT_COLOR.g,GREEN_FONT_COLOR.b,1)	
		
	elseif LOCAL_ITEM.Type == "MISSION" and this.type == "item" then
		GameTooltip:AddLine(ITEM_STARTS_QUEST,NORMAL_FONT_COLOR.r,NORMAL_FONT_COLOR.g,NORMAL_FONT_COLOR.b,1)	
		
	elseif LOCAL_ITEM.Type == "USE_ON_MOB" and LOCAL_ITEM.UseOnMob_Use_Text and this.type == "item" then
		if LOCAL_ITEM.CoolDown then
			GameTooltip:AddLine(USE_ITEM.." : "..LOCAL_ITEM.UseOnMob_Use_Text.." "..format(RME_LOCALE["RME_TOOLTIP_COOLDOWN"].text,SecondsToTime(LOCAL_ITEM.CoolDown)),GREEN_FONT_COLOR.r,GREEN_FONT_COLOR.g,GREEN_FONT_COLOR.b,1)
		else
			GameTooltip:AddLine(USE_ITEM.." : "..LOCAL_ITEM.UseOnMob_Use_Text,GREEN_FONT_COLOR.r,GREEN_FONT_COLOR.g,GREEN_FONT_COLOR.b,1)
		end
		
	elseif LOCAL_ITEM.Type == "USE_ITEM" and LOCAL_ITEM.UseItem_Use_Text and this.type == "item" then
		if LOCAL_ITEM.CoolDown then
			GameTooltip:AddLine(USE_ITEM.." : "..LOCAL_ITEM.UseItem_Use_Text.." "..format(RME_LOCALE["RME_TOOLTIP_COOLDOWN"].text,SecondsToTime(LOCAL_ITEM.CoolDown)),GREEN_FONT_COLOR.r,GREEN_FONT_COLOR.g,GREEN_FONT_COLOR.b,1)
		else
			GameTooltip:AddLine(USE_ITEM.." : "..LOCAL_ITEM.UseItem_Use_Text,GREEN_FONT_COLOR.r,GREEN_FONT_COLOR.g,GREEN_FONT_COLOR.b,1)
		end
	end
	
		--ITEM_OPENABLE 
		--ITEM_WRITTEN_BY 
		
	-- affichage tooltip
	GameTooltip:Show()
end
function RME_QuestLogRewardItemTemplate_OnLeave()
		GameTooltip:Hide();
end

local register_timer = 0
function RME_QuestLogRewardItemTemplate_OnUpdate(this)

	if not this.Cooldown or not this.Cooldown_Start then return end

	register_timer = register_timer + arg1		
	if register_timer > 0.15 then
		register_timer = 0
		local cooldown = getglobal(this:GetName().."Cooldown");	
		CooldownFrame_SetTimer(cooldown,this.Cooldown_Start,this.Cooldown, 1);

		if GetTime() >= this.Cooldown_Start + this.Cooldown then
			this.Cooldown_Start = nil
			this.Cooldown = nil
		end
	end

end
function RME_QuestLogRewardItemTemplate_OnClick(arg1,forcedeleteitem)
RME_DebugMsg("RME_QuestLogRewardItemTemplate_OnClick("..arg1..")",4)	

	if not this.LOCAL_ITEM then
		RME_DebugMsg("RME_QuestLogRewardItemTemplate_OnClick() - Pas d'info tooltip",1)	
		return
	end

	-- Objet sur frame reward
	if this.type == "choice" then -- l'user a cliqu sur un item de rcompense a choisir, on active donc le bouton de validation
		RME_ITEM_CHOICE = this:GetID();
		RME_QuestFrameCompleteQuestButton:Enable()
		getglobal("RME_QuestRewardItemHighlight"):SetPoint("TOPLEFT", "RME_QuestRewardItem"..tostring(this:GetID()) , "TOPLEFT", -8, 7);
		getglobal("RME_QuestRewardItemHighlight"):Show()
		return
	end
	
	if this.type == "reward" or this.type == "required" then -- l'user est au dessus d'un item de rcompense (dans sa page de mission, on ne fait donc rien avec)
		return
	end
	
	local LOCAL_ITEM = this.LOCAL_ITEM
	
	-- Si on arrive ici, c'est qu'on est au dessus d'un item dans le sac
	-- Clic gauche
	if arg1 == "LeftButton" then
		
		
		-- Si on SHIFT+CTRL+CLIC GAUCHE: on supprime l'objet
		if ( IsShiftKeyDown() and IsControlKeyDown()) then -- Demande de suppression de l'objet !!!
			-- On demande confirmation
			if not forcedeleteitem then
				-- popup de confirmation
				--StaticPopup_Show("RME_CONFIRM_DELETE_ITEM") 				
				--return
			end
			-- On supprime l'objet
			RME_RemoveInBag(LOCAL_ITEM,1)
			return
		end		
			
		if ( IsShiftKeyDown() ) then
			-- On partage cet objet
			RME_Comm_SHARE_ITEM(LOCAL_ITEM.ID,"PARTY")		
			return
		end		
		
		-- On gere les events de l'objet
		
		-- Si il s'agit d'un bouton a utiliser sur un mob
		if LOCAL_ITEM.Type == "USE_ON_MOB"  then		
			-- Utilisation d'un objet sur un mob
			RME_ITEM_Use_On_Mob(LOCAL_ITEM,this)
			return
		end		
		
		if LOCAL_ITEM.Type == "USE_ITEM"  then		
			-- Utilisation d'un objet sur un mob
			RME_ITEM_Use_Item(LOCAL_ITEM,this)
			return
		end		
	
		return --fin clic gauche
	end
		
	if arg1 == "RightButton" then
		
		-- On regarde
		if LOCAL_ITEM.Type == "LETTER" then
			
			RME_PlayerNotify("Lecture d'une lettre non active.\nUtilisez la description de l'objet en attendant",0.5)
			PlaySound("igQuestLogAbandonQuest")
			return
		end
		
		-- Si il s'agit d'un bouton a utiliser sur un mob
		if LOCAL_ITEM.Type == "USE_ON_MOB"  then		
			-- Utilisation d'un objet sur un mob
			RME_ITEM_Use_On_Mob(LOCAL_ITEM,this)
			return
		end		
		
		if LOCAL_ITEM.Type == "USE_ITEM"  then		
			-- Utilisation d'un objet sur un mob
			RME_ITEM_Use_Item(LOCAL_ITEM,this)
			return
		end		

		if LOCAL_ITEM.Type == "MISSION" then
		--Check si cette mission est possible
			
			
			if not LOCAL_ITEM.Mission_LaunchID then
				--Aucune mission ID n'a t spcifi par le crateur de l'objet !
				RME_PlayerNotify(RME_LOCALE["RME_LOCALE_MISSION_NOT_FOUND"].text,0)		
				PlaySound("igQuestLogAbandonQuest")				
				return
			end
		
			-- On vrifie si cette mission n'a pas dja t termine par le joueur ou si elle n'est pas dja en cours 
			if RME_IN_PROGRESS_MISSIONS_LIST[LOCAL_ITEM.Mission_LaunchID] then
				PlaySound("igQuestLogAbandonQuest")
				RME_PlayerNotify(ERR_QUEST_ALREADY_ON,0)
				return
			end
			if RME_COMPLETED_MISSIONS_LIST[LOCAL_ITEM.Mission_LaunchID] then
				RME_PlayerNotify(RME_LOCALE["RME_LOCALE_MISSION_ALREADY_DONE"].text,0.5)		
				PlaySound("igQuestLogAbandonQuest")
				return
				
			end
			
			-- On regarde si on connait cette mission !
			if RME_MISSIONS_LIST[LOCAL_ITEM.Mission_LaunchID] then -- oui
				RME_QuestFrame_ShowMissionDetails(LOCAL_ITEM.Mission_LaunchID)
				return
				
			else --non
				-- On a l'objet mais pas la mission, on regarde qui nous a donn cette mission et on lui demande (seulement si cette mission n'est pas dja demand)
				if LOCAL_ITEM.FromPlayer and not RME_COMM_RESULT_NEED_MISSION[LOCAL_ITEM.Mission_LaunchID] then
					RME_Comm_ASK_MISSION(ID_MISSION,LOCAL_ITEM.FromPlayer) -- on demande directement au joueur ayant partag l'objet
					RME_PlayerNotify(RME_LOCALE["RME_LOCALE_COMM_WAIT_MISSION_DATA"].text,0.5)					
					RME_PLAYER_WAIT_MISSIONID[LOCAL_ITEM.Mission_LaunchID] = "WAIT_MISSION"
					return
					
				elseif RME_COMM_RESULT_NEED_MISSION[LOCAL_ITEM.Mission_LaunchID] then -- Mission demand et en attente de rcption
					RME_PlayerNotify(RME_LOCALE["RME_LOCALE_COMM_WAIT_MISSION_DATA"].text,0.5)
					RME_PLAYER_WAIT_MISSIONID[LOCAL_ITEM.Mission_LaunchID] = "WAIT_MISSION"
					return
					
				else
					RME_PlayerNotify(RME_LOCALE["RME_LOCALE_COMM_CANT_LAUNCH_MISSION_NO_DATA"].text,0)									
					return
					
				end
			end
			
			return
			
		end
	end
	
end
--[[ RME_Bag]]--
function RME_BagFrame_OnLoad()
	RME_DebugMsg("RME_BagFrame_OnLoad()",4)
	RME_BAG_TxtOptionsTitle:SetText(RME_LOCALE["RME_LOCALE_BAG"].text)
end
function RME_BagFrame_OnShow()
	RME_BagFrame_ScrollFrame_Update()
end
function RME_BagFrame_OnHide()
end
function RME_BagFrame_ScrollFrame_Update()

	local i, item, texture, idx
	local offset = FauxScrollFrame_GetOffset(RME_BagFrame_ScrollFrame)

	if table.getn(RME_PLAYER_BAG) < 25 then
		FauxScrollFrame_Update(RME_BagFrame_ScrollFrame, ceil(table.getn(RME_PLAYER_BAG) / 5) , 5, 45 )
	else
		FauxScrollFrame_Update(RME_BagFrame_ScrollFrame,6 , 5, 45 )
		RME_BagFrame_ScrollFrameScrollBarScrollUpButton:Disable()
		RME_BagFrame_ScrollFrameScrollBarScrollDownButton:Disable()			
	end
		
	for i=1,25 do
		item = getglobal("RME_BagFrame_Icon"..i)
		idx = (offset*5) + i
		if idx<=table.getn(RME_PLAYER_BAG) then
		
			local LOCAL_ITEM = RME_PLAYER_BAG[idx]
			texture = LOCAL_ITEM.Texture
			item:SetNormalTexture(texture)
			item:SetPushedTexture(texture)
			item.LOCAL_ITEM = LOCAL_ITEM
			item2 = getglobal("RME_BagFrame_Icon"..i.."Count")
			if LOCAL_ITEM.Quantity > 1 then
				item2:SetText(tostring(LOCAL_ITEM.Quantity))
				item2:Show()
			else
				item2:Hide()
			end
			item.type = "item"
			
			-- On met a jour le graphique en fonction de son statut
			if LOCAL_ITEM.Desactivated then
				-- Il est desactiv
				item:SetVertexColor(0.4, 0.4, 0.4);
				
			elseif LOCAL_ITEM.CoolDown then
				-- Un cooldown est en cours
				cooldown = getglobal("RME_BagFrame_Icon"..i.."Cooldown")
				-- On calcule cb de temps encore le cooldown est actif:
					-- LOCAL_ITEM.CoolDown contient l'heure a laquel l'objet est a nouveau disponible
					-- donc pour savoir le nb de secondes restante, il suffit de faire CoolDown-
				CooldownFrame_SetTimer(cooldown, time(), LOCAL_ITEM.CoolDown - time(), true);
			end
			
			item:Show()
		else
			item.LOCAL_ITEM = nil
			item.type = nil
			item:Hide()
		end
		if RME_SELECTEDITEMICON_NUMBER==idx then
			item:LockHighlight()
		else
			item:UnlockHighlight()
		end
	end
	
end
function RME_Bag_Update()
	RME_BagFrame_ScrollFrame_Update()
end
function RME_BagIconTemplate_OnLoad()
	--gr par RME_QuestLogRewardItemTemplate_OnLoad()
end
function RME_BagIconTemplate_OnEnter()
	--gr par RME_QuestLogRewardItemTemplate_OnEnter()
end
function RME_BagIconTemplate_OnLeave()
	--gr par RME_QuestLogRewardItemTemplate_OnLeave()
end
function RME_BagIconTemplate_OnClick()
	--gr par RME_QuestLogRewardItemTemplate_OnClick
end
function RME_BagFrame_Toggle()
	if ( RME_BagFrame:IsShown() ) then
		HideUIPanel(RME_BagFrame);
	else
		ShowUIPanel(RME_BagFrame);
	end
	PlaySound("igCharacterInfoTab");
end
--[[RME_GossipOnglet]]--
function RME_UpdateGossipOnglets()
	RME_DebugMsg("RME_UpdateGossipOnglets()",4)
	
	--Deja : est ce que la target actuel a une ou plusieurs mission RME ?
	
	if not RME_TARGET_INFO.NpcMissionsList then
		RME_GossipTabs1UP:Hide(); 
		RME_GossipTabs1DOWN:Hide();
		RME_GossipTabs2UP:Hide(); 
		RME_GossipTabs2DOWN:Hide();		
		return
	end

	if table.getn(RME_TARGET_INFO.NpcMissionsList) < 1 then
		-- Rien du tout, on cache tout
		RME_GossipTabs1UP:Hide(); 
		RME_GossipTabs1DOWN:Hide();
		RME_GossipTabs2UP:Hide(); 
		RME_GossipTabs2DOWN:Hide();		
		return
	end

	-- Ok il a au moins une interaction possible
	
	-- y a t il un gossip wow visible ?
	if GossipFrame:IsShown() then -- Oui ! on ajout un onglet wow (actif) et un onglet RME (desactiv) (on sait donc que la distance est ok)
		RME_GossipTabs1UP:Show();
		RME_GossipTabs1DOWN:Hide();
		RME_GossipTabs2UP:Hide();
		RME_GossipTabs2DOWN:Show();

	else -- Non !
		-- y a t il un RME Gossip visible ?
		if RME_GossipFrame:IsShown() and GossipGreetingText:GetText() ~= "Filler Text" then -- Oui ! on ajoute un onglet wow (desactiv) et un onglet RME (actif)		
			RME_GossipTabs1UP:Hide(); 
			RME_GossipTabs1DOWN:Show();
			RME_GossipTabs2UP:Show(); -- Onglet 2 activ
			RME_GossipTabs2DOWN:Hide();

		
		else -- Non ! (cela peut etre du au fait qu'il est trop loin, ou que ce pnj n'a pas de gossip)
			RME_GossipTabs1UP:Hide(); 
			RME_GossipTabs1DOWN:Hide();
			RME_GossipTabs2UP:Hide(); 
			RME_GossipTabs2DOWN:Hide();	
			
		end
		
	end

end
function RME_Gossip_Onglet_Click(TabNumber)
	RME_DebugMsg("RME_Gossip_Onglet_Click("..tostring(TabNumber)..")",4);
	
	if TabNumber == 1 then
		--On affiche la fenetre gossip normale
		ShowUIPanel(GossipFrame);
		HideUIPanel(RME_GossipFrame);
		-- On actualise les onglets
		RME_UpdateGossipOnglets()
		
	elseif TabNumber == 2 then
		--On affiche la fenetre de quete RME > RME_QuestLogFrame <
		HideUIPanel(GossipFrame);
		ShowUIPanel(RME_GossipFrame);
		-- On actualise les onglets
		RME_UpdateGossipOnglets()
		
	end
end
function RME_ToggleGossipFrame()
	RME_DebugMsg("RME_ToggleGossipFrame()",4)	
	if not CheckInteractDistance("target", 2) or not RME_TARGET_INFO or not RME_TARGET_INFO.IsAnNpcMission then
		return
	end
	
	if ( RME_GossipFrame:IsShown() ) then
		HideUIPanel(RME_GossipFrame);
		if ( GossipFrame:IsShown() ) then
			HideUIPanel(GossipFrame);
		end
	else
		ShowUIPanel(RME_GossipFrame);
		if ( GossipFrame:IsShown() ) then
			HideUIPanel(GossipFrame);
		end
	end
	RME_UpdateGossipOnglets()
	PlaySound("igCharacterInfoTab");

end
--[[RME_GossipFrame]]--
function RME_GossipFrame_OnLoad ()
	RME_DebugMsg("RME_GossipFrame_OnLoad()",4)
	this:RegisterEvent("GOSSIP_SHOW"); -- Si le npc dont on affiche le gossip a une mission on affichera les onglets
	this:RegisterEvent("GOSSIP_CLOSED"); -- Si le npc dont on affiche le gossip a une mission on masquera les onglets (si notre frame est aussi masqu)
end
function RME_GossipFrame_OnShow()
	PlaySound("igQuestListOpen");
	RME_GossipFrameUpdate()	
	if  RME_QuestLogFrame:IsShown() then
		HideUIPanel(RME_QuestLogFrame);
	end
	RME_GossipFrame_CheckDistance()
end
function RME_GossipFrame_CheckDistance()
	-- On regarde 
	if RME_GossipFrame:IsShown() then
		RME_EventManager_AddEvent("RME_GossipFrame_CheckDistance",1,"RME_GossipFrame_CheckDistance()",true)
	end
	-- Le joueur est trop loin ou le joueur s'est slectionn ou le joueur peut attaquer la cible (donc mob, pnj hostile qui ne pourront donner de mission)
	-- FIX: UnitIsUnit("target","player") > le joueur peut maintenant se slectionner vu qu'il peut proposer une mission
	if not CheckInteractDistance("target", 2) or UnitCanAttack("player", "target") then
		RME_GossipFrame:Hide()
	end
end
function RME_GossipFrame_OnEvent()
	if ( event == "GOSSIP_SHOW" ) then -- Si le joueur veut afficher le vrai gossip
		if (  RME_GossipFrame:IsShown() ) then
			RME_GossipFrame:Hide()
		end
		if  RME_PanelFrame:IsShown() then
			HideUIPanel(RME_PanelFrame);
		end		
		if  RME_QuestLogFrame:IsShown() then
			HideUIPanel(RME_QuestLogFrame);
		end		
	elseif (event == "GOSSIP_CLOSED" ) then
		-- On arrete de regarde la distance ?
		
	end
	RME_UpdateGossipOnglets()
end
function RME_GossipFrame_OnHide()
	PlaySound("igQuestListClose");
	RME_UpdateGossipOnglets()
end
function RME_GossipTitleButton_OnClick(arg1,arg2)
	RME_DebugMsg("RME_GossipTitleButton_OnClick()",4)	

	local LOCAL_MISSION, ID_MISSION
	ID_MISSION = RME_TARGET_INFO.NpcMissionsList[arg2]
	
	if RME_IN_PROGRESS_MISSIONS_LIST[ID_MISSION] then
		LOCAL_MISSION = RME_IN_PROGRESS_MISSIONS_LIST[ID_MISSION]
		RME_DebugMsg("RME_GossipTitleButton_OnClick() RME_IN_PROGRESS_MISSIONS_LIST",4)	
		
	elseif RME_AVAILABLE_MISSIONS_LIST[ID_MISSION] then
		LOCAL_MISSION = RME_AVAILABLE_MISSIONS_LIST[ID_MISSION]
		RME_DebugMsg("RME_GossipTitleButton_OnClick() RME_AVAILABLE_MISSIONS_LIST",4)	
		
	elseif RME_MISSIONS_LIST[ID_MISSION] then -- Normalement impossible car la mission n'apparaitrai pas dans NpcMissionsList
		LOCAL_MISSION = RME_MISSIONS_LIST[ID_MISSION]
		RME_DebugMsg("RME_GossipTitleButton_OnClick() IRME_MISSIONS_LIST",4)	
		
	else
		RME_DebugMsg("RME_GossipTitleButton_OnClick() ID_MISSION unknown in all DB !",1)	
		return
		
	end
	
	if not LOCAL_MISSION.MissionInProgress then -- Mission disponible pour le joueur
		--on affiche le contenu de la mission pour debuter
		RME_GossipFrame:Hide()
		RME_QuestFrame_ShowMissionDetails(LOCAL_MISSION.ID)
	elseif LOCAL_MISSION.MissionInProgress then
		--on affiche l'cran success de la mission (si tout est ok on pourra passer a la suite, sinon on rappelle se qu'on attend)
		RME_GossipFrame:Hide()
		RME_QuestFrame_ShowMissionProgress(LOCAL_MISSION.ID)
	else
		RME_GossipFrameUpdate()
	end
end
function RME_GossipFrameUpdate()

	if not RME_TARGET_INFO then
		return
	end

	RME_GossipGreetingText:SetText(RME_LOCALE["RME_LOCALE_GOSSIP_WELCOME"].text);
	
	if UnitExists("npc") then
		RME_GossipFrameNpcNameText:SetText(UnitName("npc"));
		SetPortraitTexture(RME_GossipFramePortrait, "npc");
	elseif UnitExists("target")  then
		RME_GossipFrameNpcNameText:SetText(UnitName("target"));
		SetPortraitTexture(RME_GossipFramePortrait, "target");
	else
		RME_GossipFrameNpcNameText:SetText("")
		RME_GossipFramePortrait:SetTexture("Interface\\QuestFrame\\UI-QuestLog-BookIcon");
		RME_PlayerNotify(RME_LOCALE["RME_LOCALE_GOSSIP_NOTARGET"].text,0)
	end
	
	local NB_LINE_USED = 0
	-- On rcupere les missions disponible et les missions active et on les affiche
	for i = 1, #RME_TARGET_INFO.NpcMissionsList do
	
		local LOCAL_MISSION, ID_MISSION
		ID_MISSION = RME_TARGET_INFO.NpcMissionsList[i]
		
		-- On rcupere la mission
		if RME_IN_PROGRESS_MISSIONS_LIST[ID_MISSION] then
			LOCAL_MISSION = RME_IN_PROGRESS_MISSIONS_LIST[ID_MISSION]
			RME_DebugMsg("RME_GossipFrameUpdate() RME_IN_PROGRESS_MISSIONS_LIST",4)	
			
		elseif RME_AVAILABLE_MISSIONS_LIST[ID_MISSION] then
			LOCAL_MISSION = RME_AVAILABLE_MISSIONS_LIST[ID_MISSION]
			RME_DebugMsg("RME_GossipFrameUpdate() RME_AVAILABLE_MISSIONS_LIST",4)	
			
		else
			-- On cache le reste des options non utilis
			for i= NB_LINE_USED + 1, RME_NUMGOSSIPBUTTONS do
				getglobal("RME_GossipTitleButton" .. i):Hide();
				getglobal("RME_GossipTitleButton" .. i).ID_MISSION = nil
			end
			return
		end
		
			RME_DebugMsg(LOCAL_MISSION.ID,2)	
		
		if not LOCAL_MISSION.MissionCompleted then -- On n'affiche que les missions non compltes
			
			NB_LINE_USED = NB_LINE_USED + 1
			getglobal("RME_GossipTitleButton" .. NB_LINE_USED):SetText(LOCAL_MISSION.Title)
			-- Type et Icone
			if not LOCAL_MISSION.MissionInProgress then -- Mission peut etre disponible pour le joueur
				-- Check si il rpond au critre
				if LOCAL_MISSION:MissionCanBeTaken() and not LOCAL_MISSION.Locked and not LOCAL_MISSION.GM_MissionLocked then
					-- Ok ! on l'affichera disponible
					--Available
					getglobal("RME_GossipTitleButton" .. NB_LINE_USED.."GossipIcon"):SetTexture("Interface\\GossipFrame\\AvailableQuestIcon")
					getglobal("RME_GossipTitleButton" .. NB_LINE_USED):SetTextColor(0, 0, 0);
					getglobal("RME_GossipTitleButton" .. NB_LINE_USED.."GossipIcon"):SetVertexColor(1,1,1)
					getglobal("RME_GossipTitleButton" .. NB_LINE_USED):Enable()
					getglobal("RME_GossipTitleButton" .. NB_LINE_USED):SetText(LOCAL_MISSION.Title)

				else
					-- Ok ! on l'affichera indisponible
					
					--NotAvailable
					getglobal("RME_GossipTitleButton" .. NB_LINE_USED.."GossipIcon"):SetTexture("Interface\\GossipFrame\\AvailableQuestIcon")
					getglobal("RME_GossipTitleButton" .. NB_LINE_USED):SetTextColor(0.5, 0, 0);
					getglobal("RME_GossipTitleButton" .. NB_LINE_USED.."GossipIcon"):SetVertexColor(0.5,0,0)
					getglobal("RME_GossipTitleButton" .. NB_LINE_USED):SetText(LOCAL_MISSION.Title.." ("..RME_LOCALE["RME_LOCALE_MISSION_LOCKED"].text..")")					
					
					if LOCAL_MISSION.CreateBy ~= RME_PLAYER_INFO.Name then
						getglobal("RME_GossipTitleButton" .. NB_LINE_USED):Disable()
					else --Si c'est le crateur de la mission, on permet qu'elle soit prise (utile pour tester une mission sans la debloquer)
						getglobal("RME_GossipTitleButton" .. NB_LINE_USED):Enable()
					end
				end
			else
			
				if LOCAL_MISSION.MissionSuccess then -- Mission fini
					--Success
					getglobal("RME_GossipTitleButton" .. NB_LINE_USED.."GossipIcon"):SetTexture("Interface\\GossipFrame\\ActiveQuestIcon")
					getglobal("RME_GossipTitleButton" .. NB_LINE_USED):SetTextColor(0, 0.5, 0);
					getglobal("RME_GossipTitleButton" .. NB_LINE_USED.."GossipIcon"):SetVertexColor(1,1,1)
					getglobal("RME_GossipTitleButton" .. NB_LINE_USED):Enable()
					getglobal("RME_GossipTitleButton" .. NB_LINE_USED):SetText(LOCAL_MISSION.Title)
				
				else -- Mission en cours ou chou
					--Active
					getglobal("RME_GossipTitleButton" .. NB_LINE_USED.."GossipIcon"):SetTexture("Interface\\GossipFrame\\ActiveQuestIcon")
					getglobal("RME_GossipTitleButton" .. NB_LINE_USED):SetTextColor(0.3, 0.3, 0.3);
					getglobal("RME_GossipTitleButton" .. NB_LINE_USED.."GossipIcon"):SetVertexColor(0,0,0)
					getglobal("RME_GossipTitleButton" .. NB_LINE_USED):Enable()
					getglobal("RME_GossipTitleButton" .. NB_LINE_USED):SetText(LOCAL_MISSION.Title)
					
				end
				
			end
			getglobal("RME_GossipTitleButton" .. NB_LINE_USED):Show()
			
		end
		-- GossipFrame\AvailableQuestIcon
		-- GossipFrame\ActiveQuestIcon
		-- GossipFrame\ActiveQuestIcon
		
		LOCAL_MISSION = nil
		
	end
	
	-- On cache le reste des options non utilis
	for i= NB_LINE_USED + 1, RME_NUMGOSSIPBUTTONS do
		getglobal("RME_GossipTitleButton" .. i):Hide();
		getglobal("RME_GossipTitleButton" .. i).ID_MISSION = nil
	end
	
	-- Set Spacer
	if ( NB_LINE_USED > 1 ) then
		RME_GossipSpacerFrame:SetPoint("TOP", "RME_GossipTitleButton"..NB_LINE_USED-1, "BOTTOM", 0, 0);
		RME_GossipSpacerFrame:Show();
	else
		RME_GossipSpacerFrame:Hide();
	end

	-- Update scrollframe
	RME_GossipGreetingScrollFrame:SetVerticalScroll(0);
	RME_GossipGreetingScrollFrame:UpdateScrollChildRect();
end
--[[ RME_CastingBarFrame --]]
function RME_CastingBarFrame_OnLoad()
	RME_DebugMsg("RME_CastingBarFrame_OnLoad()",4)
	this.LOCAL_ITEM = nil
	this.startTime = nil
	this.maxValue = nil
	this.casting = nil
	this.holdTime = nil
	this.fadeOut = nil
	this.flash	= nil
	this.nextcheck = nil
	this.PlayerX = nil
	this.PlayerY = nil
end
function RME_CastingBarFrame_OnShow()
end
function RME_CastingBarFrame_OnHide()
end
function RME_CastingBarFrame_OnUpdate()

	local barSpark = getglobal(this:GetName().."Spark");
	local barFlash = getglobal(this:GetName().."Flash");

	if ( this.casting ) then
		local status = GetTime() * 1000;
		if ( status > this.maxValue ) then
			status = this.maxValue;
		end
		if ( status == this.maxValue ) then
			this:SetValue(this.maxValue);
			barFlash:Show()
			RME_CastingBarFrame_OnEvent("FINISH_CASTING")
			return;
		end
		if this.flash then
			barFlash:Show()
		else
			barFlash:Hide()
		end
		this:SetValue(status);
		local sparkPosition = ((status - this.startTime) / (this.maxValue - this.startTime)) * this:GetWidth();
		if ( sparkPosition < 0 ) then
			sparkPosition = 0;
		end
		if ( barSpark ) then
			barSpark:SetPoint("CENTER", this, "LEFT", sparkPosition, 2);
		end
		
		--On vrifie si le joueur ne bouge pas ou si il n'est pas attaqu
		if (GetTime() * 1000) > this.nextcheck then
			RME_PLAYER_INFO:Update("player")
			if this.PlayerX ~= RME_PLAYER_INFO.X or this.PlayerY ~= RME_PLAYER_INFO.Y or RME_PLAYER_INFO.IsAggro or not RME_PLAYER_INFO.IsAlive or RME_PLAYER_INFO.UnitOnMount then
				RME_CastingBarFrame_OnEvent("STOP_CASTING")
			end
			this.nextcheck =  GetTime()  * 1000 + 100
		end
		
	elseif ( GetTime() * 1000 < this.holdTime ) then
		return;
	elseif ( this.fadeOut ) then
		local alpha = this:GetAlpha() - CASTING_BAR_ALPHA_STEP;
		if ( alpha > 0 ) then
			this:SetAlpha(alpha);
		else
			this.fadeOut = nil;
			this:Hide();
		end
	end
	
end
function RME_CastingBarFrame_OnEvent(event)
	RME_DebugMsg("RME_CastingBarFrame_OnEvent("..tostring(event)..")",4);
	
	local LOCAL_ITEM = this.LOCAL_ITEM
	local bar = getglobal("RME_CastingBarFrame");
	local barSpark = getglobal("RME_CastingBarFrameSpark");
	local barText =getglobal("RME_CastingBarFrameText");  
	local barFlash = getglobal("RME_CastingBarFrameFlash");
	local barIcon =getglobal("RME_CastingBarFrameIcon"); 
	
	
	if event == "START_CASTING" then
		-- On lance le cast
		if LOCAL_ITEM.UseOnMob_Timer_Text then
			barText:SetText(LOCAL_ITEM.UseOnMob_Timer_Text);
		end
		if LOCAL_ITEM.UseItem_Timer_Text then
			barText:SetText(LOCAL_ITEM.UseItem_Timer_Text);
		end
		bar:SetStatusBarColor(1.0, 0.7, 0.0);
		barSpark:Show();
		barFlash:Hide();
		bar.startTime = GetTime()  * 1000;
		if LOCAL_ITEM.UseOnMob_Action_Timer then
			bar.maxValue = (GetTime() + LOCAL_ITEM.UseOnMob_Action_Timer) * 1000;
		elseif LOCAL_ITEM.UseItem_Action_Timer then
			bar.maxValue = (GetTime() + LOCAL_ITEM.UseItem_Action_Timer) * 1000;	
		else
			bar.maxValue = (GetTime() + 10) * 1000;	
		end
		bar:SetMinMaxValues(bar.startTime, bar.maxValue);
		bar:SetValue(bar.startTime);
		bar:SetAlpha(1.0);
		bar.holdTime = 0;
		bar.casting = 1;
		bar.fadeOut = nil;
		bar.flash = nil
		bar:Show()
		RME_PLAYER_INFO:Update("player")
		bar.PlayerX = RME_PLAYER_INFO.X
		bar.PlayerY = RME_PLAYER_INFO.Y
		bar.nextcheck =  GetTime()  * 1000 + 500
		
	elseif event == "FINISH_CASTING" then
			
		bar:SetStatusBarColor(0.0, 1.0, 0.0);
		barSpark:Hide();
		bar.flash = 1;
		bar.fadeOut = 1;
		bar.holdTime =  (GetTime() + CASTING_BAR_HOLD_TIME ) * 1000
		bar.casting = nil;	
		if LOCAL_ITEM.Type == "USE_ON_MOB" then
			RME_ITEM_Use_On_Mob(LOCAL_ITEM,nil,true)
		elseif LOCAL_ITEM.Type == "USE_ITEM" then
			RME_ITEM_Use_Item(LOCAL_ITEM,nil,true)
		end
		
	elseif event == "STOP_CASTING" then

		bar:SetValue(bar.maxValue);
		bar:SetStatusBarColor(1.0, 0.0, 0.0);
		barSpark:Hide();
		if not  RME_PLAYER_INFO.IsAggro then
			barText:SetText(FAILED);
		else
			barText:SetText(INTERRUPTED);
		end
		bar.flash = 1;
		bar.fadeOut = 1;
		bar.holdTime =  (GetTime() + CASTING_BAR_HOLD_TIME ) * 1000
		bar.casting = nil;	

	end

end
--[[ RME_QuestTimerFrame --]]
function RME_QuestTimerFrame_OnLoad()
	RME_DebugMsg("RME_QuestTimerFrame_OnLoad()",4)
	this.MISSION_ID = nil;
	this.NextCheck = 0;
	this:SetHeight(45 + (16 * 1));
	RME_QuestTimerFrame_QuestTimer1:Show()
end
function RME_QuestTimerFrame_OnUpdate()
	if this.MISSION_ID then
		if time() > this.NextCheck then
			local LOCAL_MISSION = RME_IN_PROGRESS_MISSIONS_LIST[this.MISSION_ID]
			RME_QuestTimerFrame_QuestTimer1Text:SetText(tostring(SecondsToTime(LOCAL_MISSION.MissionTimerExpiration-time())));
			if RME_QuestLogFrame:IsShown() and RME_QUESTLOG_MISSIONID == this.MISSION_ID then
				RME_QuestLogTimerText:SetText(TIME_REMAINING.." "..tostring(SecondsToTime(LOCAL_MISSION.MissionTimerExpiration-time())))
			end
			this.NextCheck = time()
		end
	end
end
function RME_QuestTimerFrame_OnEvent()
end
function RME_QuestTimerFrame_OnShow()
end
function RME_QuestTimerFrame_OnHide()
end
function RME_QuestTimerButton_OnClick()
	RME_QUESTLOG_MISSIONID = this.MISSION_ID
	RME_QuestLogFrame:Show()
end
RME_DebugMsg("<LOAD>RME_Frames.lua() "..RME_Return_ColoredText("DONE !","ok"),3)